#include "applet-application-button.h"
#include "applet-menu.h"

G_DEFINE_TYPE (AppletApplicationButton, applet_application_button, APPLET_TYPE_GENERIC_APPLICATION_BUTTON);

/*"所有应用程序"列表项按钮*/

/*用于访问私有结构*/
#define APPLET_APPLICATION_BUTTON_GET_PRIVATE(obj) \
  (G_TYPE_INSTANCE_GET_PRIVATE ((obj), APPLET_TYPE_APPLICATION_BUTTON, AppletApplicationButtonPrivate))

struct _AppletApplicationButtonPrivate
{

};

static void
applet_application_button_finalize (GObject *object)
{
	AppletApplicationButton *application_button;
	
	application_button = APPLET_APPLICATION_BUTTON (object);
	
	G_OBJECT_CLASS (applet_application_button_parent_class)->finalize (object);
}

static void
applet_application_button_class_init (AppletApplicationButtonClass *klass)
{
	GObjectClass *object_class;
	
	object_class = G_OBJECT_CLASS (klass);
	
	object_class->finalize = applet_application_button_finalize;
}

static void
applet_application_button_init (AppletApplicationButton *self)
{

}

//zhangdj start
static gboolean
on_button_press_event (ClutterActor *actor,
                       ClutterEvent *event,
                       gpointer user_data)
{
    st_widget_add_style_pseudo_class (ST_WIDGET(actor), "click");
    
    return TRUE;
}

static gboolean
on_button_release_event (ClutterActor *actor,
                         ClutterEvent *event,
                         gpointer user_data)
{
    st_widget_remove_style_pseudo_class (ST_WIDGET(actor), "click");
    
    return TRUE;
}
//zhangdj end

AppletApplicationButton *
applet_application_button_new (AppletMenu *apps_menu_button,  //menu完成时再加入
                               CdosApp *app)
{
	AppletApplicationButton *application_button;
	StWidget *actor;
	const gchar *name;
	ActorChild params;
	
	application_button = g_object_new (APPLET_TYPE_APPLICATION_BUTTON, NULL);
	applet_generic_application_button_constructor(application_button, apps_menu_button, app, TRUE);
//	APPLET_GENERIC_APPLICATION_BUTTON (application_button)->applet_button = apps_menu_button;    //menu完成时再加入
//	APPLET_GENERIC_APPLICATION_BUTTON (application_button)->app = app;
//	APPLET_GENERIC_APPLICATION_BUTTON (application_button)->with_menu = TRUE;

	actor = ST_WIDGET(cdos_popup_base_menu_item_get_actor (CDOS_POPUP_BASE_MENU_ITEM (application_button)));
	st_widget_add_style_class_name (actor, "menu-application-button");
	
	application_button->icon = cdos_app_create_icon_texture (applet_button_get_app(application_button), APPLICATION_ICON_SIZE);

//      name = cdos_app_get_name (APPLET_GENERIC_APPLICATION_BUTTON (application_button)->app);	
	name = cdos_app_get_name (applet_button_get_app(application_button));
	application_button->label = ST_LABEL(st_label_new (name));
	st_widget_add_style_class_name (ST_WIDGET(application_button->label), "menu-application-button-label");

	clutter_text_set_ellipsize(CLUTTER_TEXT(st_label_get_clutter_text(application_button->label)), PANGO_ELLIPSIZE_END);
    	st_widget_set_style(ST_WIDGET(application_button->label), "max-width:14em;");
	
	cdos_popup_base_menu_item_get_actor_child (&params);
	cdos_popup_base_menu_item_add_actor (CDOS_POPUP_BASE_MENU_ITEM(application_button), application_button->icon, &params);
	cdos_popup_base_menu_item_add_actor (CDOS_POPUP_BASE_MENU_ITEM(application_button), CLUTTER_ACTOR(application_button->label), &params);
	
	//zhangdj start
	g_signal_connect (actor,
	                  "button-press-event",
	                  G_CALLBACK(on_button_press_event),
	                  NULL);
	                  
    g_signal_connect (actor,
	                  "button-release-event",
	                  G_CALLBACK(on_button_release_event),
	                  NULL);
    //zhangdj end
	
	return application_button;
}

const char *
applet_application_button_get_id (CdosApp *app)
{
	const char *id;
	
	id = cdos_app_get_id (app);
	
	return id;
}

/*
ClutterActor *
applet_application_button_get_drag_actor (AppletApplicationButton *application_button)
{
	//未完成
}
*/

ClutterActor *
applet_application_button_get_drag_actor_source (AppletApplicationButton *application_button)
{
	ClutterActor *source;
	
	source = CLUTTER_ACTOR(cdos_popup_base_menu_item_get_actor (CDOS_POPUP_BASE_MENU_ITEM (application_button)));
	
	return source;
}
