#ifndef __APPLET_APPLICATION_BUTTON_H__
#define __APPLET_APPLICATION_BUTTON_H__

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include "applet-generic-application-button.h"
#include "st.h"
#include "applet-menu.h"

#define APPLET_TYPE_APPLICATION_BUTTON                (applet_application_button_get_type ())

#define APPLET_APPLICATION_BUTTON(obj) \
	(G_TYPE_CHECK_INSTANCE_CAST((obj), APPLET_TYPE_APPLICATION_BUTTON, AppletApplicationButton))
	
#define CDOS_IS_APPLICATION_BUTTON(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_APPLICATION_BUTTON))

#define APPLET_APPLICATION_BUTTON_CLASS(klass) \
	(G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_APPLICATION_BUTTON, AppletApplicationButtonClass))
	
#define CDOS_IS_APPLICATION_BUTTON_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_APPLICATION_BUTTON))

#define APPLET_APPLICATION_BUTTON_GET_CLASS(obj) \
	(G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_APPLICATION_BUTTON, AppletApplicationButtonClass))
	

typedef struct _AppletApplicationButton AppletApplicationButton;
typedef struct _AppletApplicationButtonPrivate AppletApplicationButtonPrivate;
typedef struct _AppletApplicationButtonClass AppletApplicationButtonClass;

/*实例结构*/
struct _AppletApplicationButton
{
	AppletGenericApplicationButton parent_instance;
	
	ClutterActor *icon;
	StLabel *label;
};

/*类结构*/
struct _AppletApplicationButtonClass
{
	AppletGenericApplicationButtonClass parent_class;
};

GType applet_application_button_get_type (void);

AppletApplicationButton *applet_application_button_new (AppletMenu *apps_menu_button,  //menu完成时再加入
                                                    CdosApp *app);

const char * applet_application_button_get_id (CdosApp *app);

//ClutterActor *applet_application_button_get_drag_actor (AppletApplicationButton *application_button);

ClutterActor *applet_application_button_get_drag_actor_source (AppletApplicationButton *application_button);

#endif /* __APPLET_APPLICATION_BUTTON_H__ */
