#include "applet-application-contextmenu-item.h"
#include "st.h"
#include "cdos-util.h"
#include "cdos-message-tray.h"

/*应用程序按钮右键菜单项*/

G_DEFINE_TYPE(AppletApplicationContextmenuItem, applet_application_contextmenu_item, CDOS_TYPE_POPUP_MENU_ITEM);

#define APPLET_APPLICATION_CONTEXTMENU_ITEM_GET_PRIVATE(obj)\
	    (G_TYPE_INSTANCE_GET_PRIVATE ((obj), APPLET_TYPE_APPLICATION_CONTEXTMENU_ITEM, AppletApplicationContextmenuItemPrivate))

struct _AppletApplicationContextmenuItemPrivate 
{
    AppletAppAction action;
    //StLabel *label;
    AppletButton *app_button;
    GSettings *settings;
};

enum {
    PROP_0,
};

enum
{
    LAST_SIGNAL
};

static void
applet_application_contextmenu_item_finalize(GObject *object)
{
     AppletApplicationContextmenuItemPrivate *priv = APPLET_APPLICATION_CONTEXTMENU_ITEM(object)->priv;
     //g_object_unref(priv->label);
     g_object_unref(priv->app_button);
     //g_object_unref(priv->applet);
     g_object_unref(priv->settings);
     	 
     G_OBJECT_CLASS(applet_application_contextmenu_item_parent_class)->finalize(object);
}

static void
applet_application_contextmenu_item_set_property(GObject * gobject,
                guint prop_id,
                const GValue * value, GParamSpec * pspec)
{
    AppletApplicationContextmenuItem *obj = APPLET_APPLICATION_CONTEXTMENU_ITEM(gobject);

    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_application_contextmenu_item_get_property(GObject * gobject,
                guint prop_id, GValue * value, GParamSpec * pspec)
{
    AppletApplicationContextmenuItemPrivate *priv = APPLET_APPLICATION_CONTEXTMENU_ITEM(gobject)->priv;
    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_application_contextmenu_item_class_init(AppletApplicationContextmenuItemClass * klass)
{
    GObjectClass *gobject_class = G_OBJECT_CLASS(klass);
    GParamSpec *pspec;
    gobject_class->set_property = applet_application_contextmenu_item_set_property;
    gobject_class->get_property = applet_application_contextmenu_item_get_property;

    g_type_class_add_private(klass, sizeof (AppletApplicationContextmenuItemPrivate));

}


static gchar **
strv_remove_node(gchar **src, gchar *node)
{
    if (!node)
        return src;

    guint len = g_strv_length(src) + 1;
    gchar **des = g_malloc(sizeof(gchar *)*len);

    gchar **src_tmp = src;
    gchar **des_tmp = des;

    while(*src_tmp) {

        if (g_strcmp0(*src_tmp, node)) {

        	*des_tmp = *src_tmp;
        	des_tmp++;
        }
        src_tmp++;
    }

    *(des_tmp ) = '\0';

    return des;
}


static gchar **
strv_add_node(gchar **src, gchar *node)
{
    if (!node)
        return src;

    guint len = g_strv_length(src) + 2;

    gchar **des = g_malloc(sizeof(gchar *)*len);

    gchar **src_tmp = src;
    gchar **des_tmp = des;
    while(*src_tmp) {
        *des_tmp = *src_tmp;
        des_tmp++;
        src_tmp++;
    }

    *(des_tmp) = g_strdup(node);
    *(des_tmp +1 ) = NULL;

    return des;
}


static gchar **
strv_add_node_limit(gchar **src, gchar *node)
{
    if (!node)
        return src;

    gboolean flag = FALSE;
    guint len = g_strv_length(src);

    if (len < 4)
    {
        len += 2;
    } else {
        //len += 1;
        len = 5;
        flag = TRUE;
    }

    //g_print("len-late: %d\n", len);

    gchar **des = g_malloc(sizeof(gchar *)*len);

    gchar **src_tmp = src;
    gchar **des_tmp = des;

    while(*src_tmp) {
        if (flag) {
            src_tmp++;
            flag = FALSE;
        }
        *des_tmp = *src_tmp;
        des_tmp++;
        src_tmp++;
    }

    *(des_tmp) = g_strdup(node);
    *(des_tmp +1 ) = NULL;

    return des;
}


static void
applet_application_contextmenu_item_init(AppletApplicationContextmenuItem * self)
{
    AppletApplicationContextmenuItemPrivate *priv;
    priv = self->priv = APPLET_APPLICATION_CONTEXTMENU_ITEM_GET_PRIVATE(self);

    priv->settings = g_settings_new("org.cdos");
}

static gboolean
_applet_application_contextmenu_item_activate(AppletApplicationContextmenuItem *self, gpointer event, gboolean keep, gpointer data)
{
    //g_print ("---->in %s\n", __func__);   //////调试
    AppletApplicationContextmenuItemPrivate *priv;
    AppletButton *app_buton = data;
    gchar ** apps;
    CdosApp *app;
    gchar *app_id;
    GFile *file;
    GFile *dest_file;
    gchar *paths;
    gchar *home_dir= NULL;
    gchar *path = NULL;
    gchar *order = NULL;
	
    
    priv = self->priv;
    CdosDocInfo *file_info;

    file_info = applet_button_get_file(app_buton);


 //   cdos_popup_menu_base_toggle(app_buton->menu);
    app = applet_button_get_app(priv->app_button);
    cdos_popup_menu_base_toggle(applet_button_get_popup_menu(app_buton));
    GtkRecentManager *manager = gtk_recent_manager_get_default();
    //cdos_popup_menu_close(priv->applet->menu, TRUE);
    switch(priv->action)
        {
    		case ADD_TO_PANEL :
    			apps = g_settings_get_strv(priv->settings, "panel-launchers");
                guint max_apps = g_settings_get_int(priv->settings, "panel-launchers-max-number");
    			if(g_strv_length(apps) < max_apps)
    			{
    				app_id = cdos_app_get_id(app);
    				apps = strv_add_node(apps, app_id);
    				g_settings_set_strv(priv->settings, "panel-launchers", apps);
    			} else {
                    g_print("too many favoritr application, please delete some first\n");
                    gchar *msg = g_strconcat("notify-send ","'",_("Too many applications added"),"' '",_("The max number is 8"),"' ",NULL);
                    cdos_util_spawn_command_line(msg);
                    cdos_message_tray_want_send_to_applet(FALSE);
    			}
    		break;
            case REMOVE_FROM_PANEL:
                 apps = g_settings_get_strv(priv->settings, "panel-launchers");
                 app_id = cdos_app_get_id(app);
                 apps = strv_remove_node(apps, app_id);
                 g_settings_set_strv(priv->settings, "panel-launchers", apps);
            break;
            case ADD_TO_DESKTOP :     
            {     
                paths =  g_desktop_app_info_get_filename(cdos_app_get_app_info(app));
           	    file = g_file_new_for_path(paths);
		//g_print ("%s %d\n", __func__, __LINE__);
                //home_dir = util_get_user_desktop_dir();
                util_get_user_desktop_dir(&home_dir);
		//g_print ("%s %d: %s\n", __func__, __LINE__, home_dir);
                app_id = cdos_app_get_id(app);
                path = g_strconcat(home_dir, "/", app_id, NULL);
                dest_file = g_file_new_for_path(path);
                g_file_copy(file, dest_file, G_FILE_COPY_NONE, NULL, NULL, NULL, NULL);
                order = g_strconcat("chmod +x ", home_dir, "/", app_id, NULL);
                cdos_util_spawn_command_line(order);
		g_free (home_dir);
            }
            break;
            //zhangdj
            case REMOVE_FROM_DESKTOP :
                //home_dir = util_get_user_desktop_dir();
                util_get_user_desktop_dir(&home_dir);
                app_id = cdos_app_get_id(app);
                path = g_strconcat(home_dir, "/", app_id, NULL);
                dest_file = g_file_new_for_path(path);
		g_free (home_dir);
                g_file_delete(dest_file, NULL, NULL);
            break;
            case ADD_TO_FAVORITES :
                 apps = g_settings_get_strv(priv->settings, "favorite-apps");
                 app_id = cdos_app_get_id(app);
                 //g_print ("app_id=%s\n", app_id);   //////调试
                 
                 apps = strv_remove_node(apps, app_id);  //若gsettings中已经存在要添加的应用，则先删除，再添加
                 /*
                 g_print ("apps_len1=%u\n", g_strv_length (apps));   //////调试
                 //test
                 gint i = 0;
                 while (*apps)
                 {
                    g_print ("apps-1[%d]=%s\n", i, *apps);
                    i++;
                    apps++;
                 }
                 */
                 
                 apps = strv_add_node(apps, app_id);
                 /*
                 g_print ("apps_len2=%u\n", g_strv_length (apps));   //////调试
                 //test
                 gint i = 0;
                 while (*apps)
                 {
                    g_print ("apps-2[%d]=%s\n", i, *apps);
                    i++;
                    apps++;
                 }
                 */
                 
                 g_settings_set_strv(priv->settings, "favorite-apps", apps);
            break;
            case REMOVE_FROM_FAVORITES :
                 apps = g_settings_get_strv(priv->settings, "favorite-apps");
                 app_id = cdos_app_get_id(app);
                 apps = strv_remove_node(apps, app_id);
                 g_settings_set_strv(priv->settings, "favorite-apps", apps);
            break;
            case REMOVE_RECENT_ALL :
                  gtk_recent_manager_purge_items(manager, NULL);            
                  break;
            case REMOVE_RECENT_ITEM :
                  gtk_recent_manager_remove_item(manager, cdos_doc_info_get_uri(file_info), NULL);
            break;
            default:
                g_print("error!\n");
            break;
    	}

        return FALSE;
}

//zhangdj start
static gboolean
_applet_application_contextmenu_item_enter_event (ClutterActor *actor, ClutterEvent *event, gpointer user_data)
{
    st_widget_add_style_pseudo_class (ST_WIDGET(actor), "hover");
    
    return TRUE;
}

static gboolean
_applet_application_contextmenu_item_leave_event (ClutterActor *actor, ClutterEvent *event, gpointer user_data)
{
    st_widget_remove_style_pseudo_class (ST_WIDGET(actor), "hover");
    
    return TRUE;
}

static gboolean
_applet_application_contextmenu_item_button_press_event (ClutterActor *actor, ClutterEvent *event, gpointer user_data)
{
    st_widget_add_style_pseudo_class (ST_WIDGET(actor), "click");
    
    return TRUE;
}

static gboolean
_applet_application_contextmenu_item_button_release_event (ClutterActor *actor, ClutterEvent *event, gpointer user_data)
{
    st_widget_remove_style_pseudo_class (ST_WIDGET(actor), "click");
    
    return TRUE;
}
//zhangdj end

AppletApplicationContextmenuItem *
applet_application_contextmenu_item_new(AppletButton *app_buton,  gchar *label, AppletAppAction action)
{
    AppletApplicationContextmenuItem *item = NULL;
    PopupBaseMenuItemInit params;

    AppletApplicationContextmenuItemPrivate *priv;
    CdosGenericContainer *actor = NULL;

    item = g_object_new(APPLET_TYPE_APPLICATION_CONTEXTMENU_ITEM, NULL);
    priv = item->priv;

    cdos_popup_base_menu_item_get_init_params(&params);
    params.focusOnHover = TRUE;
    cdos_popup_base_menu_item_set_params(item, &params);

    priv->app_button = g_object_ref(app_buton);
    //priv->label = st_label_new(label);
    priv->action = action;

	cdos_popup_menu_item_set_label(item, (const gchar *)label);

    actor = cdos_popup_base_menu_item_get_actor(item);
    st_widget_add_style_class_name(ST_WIDGET(actor),"menu-context-menu-item");

    StLabel *item_label = cdos_popup_menu_item_get_label(CDOS_POPUP_MENU_ITEM(item));
    st_widget_add_style_class_name(ST_WIDGET(item_label),"menu-context-menu-item-label");


    /*
    StThemeNode *theme_node = st_widget_get_theme_node(ST_WIDGET(item_label));
    gdouble margin_left = st_theme_node_get_length(theme_node,"margin-left");
    gdouble w = st_theme_node_get_length(theme_node,"width");
    g_print("\n===================margin-left = %f=======================\n",margin_left);
    g_print("\n===================w = %f=======================\n",w);
    if(margin_left){
        clutter_actor_set_margin_left(CLUTTER_ACTOR(item_label),(float)margin_left);
    }
    */
    g_signal_connect(item, "activate", G_CALLBACK(_applet_application_contextmenu_item_activate), app_buton);
    //zhangdj start
    g_signal_connect (actor,
                      "enter-event",
                      G_CALLBACK(_applet_application_contextmenu_item_enter_event),
                      NULL);
                      
    g_signal_connect (actor,
                      "leave-event",
                      G_CALLBACK(_applet_application_contextmenu_item_leave_event),
                      NULL);
                      
    g_signal_connect (actor,
                      "button-press-event",
                      G_CALLBACK(_applet_application_contextmenu_item_button_press_event),
                      NULL);
                      
    g_signal_connect (actor,
                      "button-release-event",
                      G_CALLBACK(_applet_application_contextmenu_item_button_release_event),
                      NULL);
    //zhangdj end

    return item;
}
