#ifndef __APPLET_APPLICATION_CONTEXTMENU_ITEM_H__
#define __APPLET_APPLICATION_CONTEXTMENU_ITEM_H__

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "st.h"
#include "cdos-popup-menu.h"
#include "cdos-popup-base-menu-item.h"
#include "cdos-util.h"
#include "applet-menu.h"
#include "applet-generic-application-button.h"
#include "applet-button.h"
#include "applet-recent-button.h"

G_BEGIN_DECLS

#define APPLET_TYPE_APPLICATION_CONTEXTMENU_ITEM                   (applet_application_contextmenu_item_get_type ())
#define APPLET_APPLICATION_CONTEXTMENU_ITEM(obj)                   (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_APPLICATION_CONTEXTMENU_ITEM, AppletApplicationContextmenuItem))
#define APPLET_IS_APPLICATION_CONTEXTMENU_ITEM(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_APPLICATION_CONTEXTMENU_ITEM))
#define APPLET_APPLICATION_CONTEXTMENU_ITEM_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_APPLICATION_CONTEXTMENU_ITEM, AppletApplicationContextmenuItemClass))
#define APPLET_IS_APPLICATION_CONTEXTMENU_ITEM_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_APPLICATION_CONTEXTMENU_ITEM))
#define APPLET_APPLICATION_CONTEXTMENU_ITEM_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_APPLICATION_CONTEXTMENU_ITEM, AppletApplicationContextmenuItemClass))

typedef struct _AppletApplicationContextmenuItem AppletApplicationContextmenuItem;
typedef struct _AppletApplicationContextmenuItemPrivate AppletApplicationContextmenuItemPrivate;
typedef struct _AppletApplicationContextmenuItemClass AppletApplicationContextmenuItemClass;

struct _AppletApplicationContextmenuItem 
{
    CdosPopupMenuItem parent_instance;
    AppletApplicationContextmenuItemPrivate *priv;
};

struct _AppletApplicationContextmenuItemClass 
{
	CdosPopupMenuItemClass parent_class;
};

typedef enum
{
    ADD_TO_PANEL,
    REMOVE_FROM_PANEL,
    ADD_TO_DESKTOP,
    REMOVE_FROM_DESKTOP,    //zhangdj
    ADD_TO_FAVORITES,
    REMOVE_FROM_FAVORITES,
    REMOVE_RECENT_ALL,
    REMOVE_RECENT_ITEM
} AppletAppAction;

GType
applet_application_contextmenu_item_get_type(void) G_GNUC_CONST;

AppletApplicationContextmenuItem *
applet_application_contextmenu_item_new(AppletButton *app_buton,  gchar *label, AppletAppAction action);

G_END_DECLS

#endif              /* __UI_BOX_POINTER_H__ */
