#include "applet-application-menu.h"
#include "st.h"

G_DEFINE_TYPE(AppletApplicationMenu, applet_application_menu, CDOS_TYPE_POPUP_MENU_BASE);

static void
applet_application_menu_dispose(GObject *object)
{
    AppletApplicationMenu *self = APPLET_APPLICATION_MENU (object);
    if (self->actor)
    {
        clutter_actor_destroy ((ClutterActor *)self->actor);
        self->actor = NULL;
    }
    G_OBJECT_CLASS(applet_application_menu_parent_class)->dispose(object);
}

/*
static void
applet_application_menu_set_property(GObject * gobject,
                guint prop_id,
                const GValue * value, GParamSpec * pspec)
{
    AppletApplicationMenu *obj = APPLET_APPLICATION_MENU(gobject);

    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_application_menu_get_property(GObject * gobject,
                guint prop_id, GValue * value, GParamSpec * pspec)
{
    AppletApplicationMenuPrivate *priv = APPLET_APPLICATION_MENU(gobject)->priv;
    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}
*/
static void
applet_application_menu_class_init(AppletApplicationMenuClass * klass)
{
    GObjectClass *gobject_class = G_OBJECT_CLASS(klass);
    gobject_class->dispose = applet_application_menu_dispose;
}

static void
applet_application_menu_init(AppletApplicationMenu * self)
{
}

CdosPopupMenu *
applet_application_menu_new(StWidget *stource_actor)
{
	AppletApplicationMenu *object = NULL;
    object = g_object_new(APPLET_TYPE_APPLICATION_MENU, NULL);

    object->actor = g_object_new(ST_TYPE_BOX_LAYOUT, "style-class", "menu-category-sub-menu", "vertical", TRUE, NULL);
    StBoxLayout *box;
    box = cdos_popup_menu_base_get_box(CDOS_POPUP_MENU_BASE(object));
    clutter_container_add_actor((ClutterContainer *)object->actor, (ClutterActor *)box);
    clutter_actor_set_clip_to_allocation(CLUTTER_ACTOR(object->actor), TRUE);
    clutter_actor_hide(CLUTTER_ACTOR(object->actor));

    return (CdosPopupMenu *)object;
}

void
applet_application_menu_togglex(AppletApplicationMenu * self)
{
	if(CDOS_POPUP_MENU_BASE(self)->is_open)
		applet_application_menu_closex(self);
	else
		applet_application_menu_openx(self);
}

void
applet_application_menu_openx(AppletApplicationMenu * self)
{
	if(CDOS_POPUP_MENU_BASE(self)->is_open)
		return;
	CDOS_POPUP_MENU_BASE(self)->is_open = TRUE;
	clutter_actor_show(CLUTTER_ACTOR(self->actor));
}

void
applet_application_menu_closex(AppletApplicationMenu * self)
{
	if(!CDOS_POPUP_MENU_BASE(self)->is_open)
		return;
	CDOS_POPUP_MENU_BASE(self)->is_open = FALSE;
	clutter_actor_hide(CLUTTER_ACTOR(self->actor));
}
