#ifndef __APPLET_BUTTON_H__
#define __APPLET_BUTTON_H__

#include "st.h"
#include "cdos-popup-base-menu-item.h"
#include "applet-menu.h"
#include "cdos-app.h"
#include "cdos-popup-menu.h"
#include "cdos-doc-info.h"
G_BEGIN_DECLS

#define APPLET_TYPE_BUTTON                   (applet_button_get_type ())
#define APPLET_BUTTON(obj)                   (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_BUTTON, AppletButton))
#define APPLET_IS_BUTTON(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_BUTTON))
#define APPLET_BUTTON_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_BUTTON, AppletButtonClass))
#define APPLET_IS_BUTTON_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_BUTTON))
#define APPLET_BUTTON_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_BUTTON, AppletButtonClass))


typedef struct _AppletButton AppletButton;
typedef struct _AppletButtonPrivate AppletButtonPrivate;
typedef struct _AppletButtonClass AppletButtonClass;

struct _AppletButton 
{
        CdosPopupBaseMenuItem parent_instance;
        AppletButtonPrivate *priv;
};

struct _AppletButtonClass 
{

        CdosPopupBaseMenuItemClass parent_class;
};

GType
applet_button_get_type(void) G_GNUC_CONST;


AppletButton *
applet_button_new(void);

AppletButton *
applet_button_set_params(AppletButton *button, 
                        CdosApp *app, 
                        CdosPopupMenu *menu, 
                        AppletMenu *applet_button,
                        CdosDocInfo *file);

AppletMenu *
applet_button_get_applet_menu(AppletButton *button);

void 
applet_button_set_applet_menu(AppletButton *button, AppletMenu *applet_button);


CdosPopupMenu *
applet_button_get_popup_menu(AppletButton *button);

void 
applet_button_set_popup_menu(AppletButton *button, CdosPopupMenu *menu);

void 
applet_button_set_app(AppletButton *button, CdosApp *app);

CdosApp *
applet_button_get_app(AppletButton *button);

void 
applet_button_set_file(AppletButton *button, CdosDocInfo *file);

CdosDocInfo *
applet_button_get_file(AppletButton *button);

G_END_DECLS

#endif              /* __APPLET_BUTTON_H__ */

