#ifndef __APPLET_CATEGORY_BUTTON_H__
#define __APPLET_CATEGORY_BUTTON_H__

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#define GMENU_I_KNOW_THIS_IS_UNSTABLE
#include <gmenu-tree.h>
#include "cdos-popup-submenu-menu-item.h"
#include "cdos-popup-base-menu-item.h"
#include "applet-application-menu.h"
#include "st.h"
#include "config.h"

#define APPLET_TYPE_CATEGORY_BUTTON                (applet_category_button_get_type ())

#define APPLET_CATEGORY_BUTTON(obj) \
	(G_TYPE_CHECK_INSTANCE_CAST((obj), APPLET_TYPE_CATEGORY_BUTTON, AppletCategoryButton))
	
#define APPLET_IS_CATEGORY_BUTTON(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_CATEGORY_BUTTON))

#define APPLET_CATEGORY_BUTTON_CLASS(klass) \
	(G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_CATEGORY_BUTTON, AppletCategoryButtonClass))
	
#define APPLET_IS_CATEGORY_BUTTON_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_CATEGORY_BUTTON))

#define APPLET_CATEGORY_BUTTON_GET_CLASS(obj) \
	(G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_CATEGORY_BUTTON, AppletCategoryButtonClass))
	
/*用于访问私有结构*/
#define APPLET_CATEGORY_BUTTON_GET_PRIVATE(obj) \
  (G_TYPE_INSTANCE_GET_PRIVATE ((obj), APPLET_TYPE_CATEGORY_BUTTON, AppletCategoryButtonPrivate))

typedef struct _AppletCategoryButton AppletCategoryButton;
typedef struct _AppletCategoryButtonClass AppletCategoryButtonClass;

struct _AppletCategoryButton
{
	CdosPopupSubmenuMenuItem parent_instance;
	
	gchar *icon_name;
	StLabel *label;
	StIcon *icon;
	AppletApplicationMenu *menu;
};

struct _AppletCategoryButtonClass
{
	CdosPopupSubmenuMenuItemClass parent_class;
};

GType applet_category_button_get_type (void);

void applet_category_button_activate (AppletCategoryButton *category_button, gpointer event, gboolean keep, gpointer data);

void applet_category_button_remove_items (AppletCategoryButton *category_button);

void applet_category_button_destroy (AppletCategoryButton *category_button);

AppletCategoryButton *applet_category_button_new (GMenuTreeDirectory *category);

#endif /* __APPLET_CATEGORY_BUTTON_H__ */
