#include "applet-contextmenu.h"
#include "st.h"

G_DEFINE_TYPE(AppletContextMenu, applet_contextmenu, CDOS_TYPE_POPUP_MENU);

#define APPLET_CONTEXTMENU_GET_PRIVATE(obj)\
	    (G_TYPE_INSTANCE_GET_PRIVATE ((obj), APPLET_TYPE_CONTEXTMENU, AppletContextMenuPrivate))

struct _AppletContextMenuPrivate {
	AppletGenericApplicationButton *source_buton;
};

enum {
    PROP_0
};

enum
{
    LAST_SIGNAL
};

static void
applet_contextmenu_finalize(GObject *object)
{
     AppletContextMenuPrivate *priv = APPLET_CONTEXTMENU(object)->priv;
     g_object_unref(APPLET_CONTEXTMENU(object)->actor);
     g_object_unref(priv->source_buton);
     G_OBJECT_CLASS(applet_contextmenu_parent_class)->finalize(object);
}

static void
applet_contextmenu_set_property(GObject * gobject,
                guint prop_id,
                const GValue * value, GParamSpec * pspec)
{
    AppletContextMenu *obj = APPLET_CONTEXTMENU(gobject);

    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_contextmenu_get_property(GObject * gobject,
                guint prop_id, GValue * value, GParamSpec * pspec)
{
    AppletContextMenuPrivate *priv = APPLET_CONTEXTMENU(gobject)->priv;
    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_contextmenu_class_init(AppletContextMenuClass * klass)
{
    GObjectClass *gobject_class = G_OBJECT_CLASS(klass);
    GParamSpec *pspec;

    CdosPopupMenuBaseClass *parent_class = CDOS_POPUP_MENU_BASE_CLASS(klass);
    parent_class->open = applet_contextmenu_open;

    gobject_class->set_property = applet_contextmenu_set_property;
    gobject_class->get_property = applet_contextmenu_get_property;

    g_type_class_add_private(klass, sizeof (AppletContextMenuPrivate));
}

static void
applet_contextmenu_init(AppletContextMenu * self)
{
    AppletContextMenuPrivate *priv;
    priv = self->priv = APPLET_CONTEXTMENU_GET_PRIVATE(self);
}

static gint
_timeout(gpointer data)
{
    AppletMenu *applet_menu = data;
    CdosGlobal *global = cdos_global_get();
    ClutterStage *stage = cdos_global_get_stage(global);
    clutter_stage_set_key_focus(stage, applet_menu->actor);
    return 0;
}
static void
_on_contextmenu_open_state_changed(CdosPopupMenu *object, gboolean open, gpointer data)
{
    g_timeout_add(300, _timeout, data);
}

CdosPopupMenu *
applet_contextmenu_new(AppletButton *button)
{
    CdosPopupMenu *object = NULL;
    AppletContextMenuPrivate *priv;
    StBoxLayout *box;
    CdosGenericContainer *source_actor;

    source_actor = cdos_popup_base_menu_item_get_actor(button);
    object = g_object_new(APPLET_TYPE_CONTEXTMENU, NULL);
    priv = object->priv;
    cdos_popup_menu_constructor(object, source_actor, 0, 3);

    g_signal_connect(object, "open-state-changed", G_CALLBACK(_on_contextmenu_open_state_changed), applet_button_get_applet_menu(button));
    return object;
}


void
applet_contextmenu_open(CdosPopupMenuBase *obj, gboolean animate)
{
	AppletContextMenu *self = APPLET_CONTEXTMENU(obj);
	cdos_popup_menu_open_to_x_y(obj, animate, self->x + 2, self->y - 2);
}

