#include "applet-favorites-button.h"
#include "cdos-popup-base-menu-item.h"
#include "applet-menu.h"   //menu完成时再加入
#include "cdos-app.h"

G_DEFINE_TYPE (AppletFavoritesButton, applet_favorites_button, APPLET_TYPE_GENERIC_APPLICATION_BUTTON);

/*“快捷操作”按钮*/

/*用于访问私有结构*/
#define APPLET_FAVORITES_BUTTON_GET_PRIVATE(obj) \
  (G_TYPE_INSTANCE_GET_PRIVATE ((obj), APPLET_TYPE_FAVORITES_BUTTON, AppletFavoritesButtonPrivate))


struct _AppletFavoritesButtonPrivate
{

};

static void
applet_favorites_button_finalize (GObject *object)
{
	AppletFavoritesButton *favorites_button;
	
	favorites_button = APPLET_FAVORITES_BUTTON (object);
	
	g_clear_object (&favorites_button->label);
	
	G_OBJECT_CLASS (applet_favorites_button_parent_class)->finalize (object);
}

static void
applet_favorites_button_class_init (AppletFavoritesButtonClass *klass)
{
	GObjectClass *object_class;
	
	object_class = G_OBJECT_CLASS (klass);
	
	object_class->finalize = applet_favorites_button_finalize;
}

static void
applet_favorites_button_init (AppletFavoritesButton *self)
{
	self->icon_size = 36;//MAX_FAV_ICON_SIZE;
}

//added
static gboolean
on_favorites_button_button_press_event (ClutterActor *actor,
                                        ClutterEvent *event,
                                        gpointer user_data)
{
    st_widget_add_style_pseudo_class (ST_WIDGET(actor), "click");
    
    return TRUE;
}

static gboolean
on_favorites_button_button_release_event (ClutterActor *actor,
                                          ClutterEvent *event,
                                          gpointer user_data)
{
    st_widget_remove_style_pseudo_class (ST_WIDGET(actor), "click");
    
    return TRUE;
}

AppletFavoritesButton *
applet_favorites_button_new (AppletMenu *apps_menu_button,    //menu完成时再加入
                           CdosApp *app)
{
	AppletFavoritesButton *favorites_button;
	StWidget *actor;
	ClutterActor *child;
	ActorChild params_icon;
	const gchar *text;

	favorites_button = g_object_new (APPLET_TYPE_FAVORITES_BUTTON, NULL);
	applet_generic_application_button_constructor(favorites_button, apps_menu_button, app, TRUE);
//	APPLET_GENERIC_APPLICATION_BUTTON (favorites_button)->apps_menu_button = apps_menu_button;    //menu完成时再加入
//	APPLET_GENERIC_APPLICATION_BUTTON (favorites_button)->app = app;
//	APPLET_GENERIC_APPLICATION_BUTTON (favorites_button)->with_menu = TRUE;
	
	favorites_button->icon_size = MAX_FAV_ICON_SIZE;
	
	actor = ST_WIDGET(cdos_popup_base_menu_item_get_actor (CDOS_POPUP_BASE_MENU_ITEM (favorites_button)));
	st_widget_add_style_class_name (actor, "menu-favorites-button");
	//added
	g_signal_connect (actor,
	                  "button-press-event",
	                  G_CALLBACK(on_favorites_button_button_press_event),
	                  NULL);
	                  
    g_signal_connect (actor,
	                  "button-release-event",
	                  G_CALLBACK(on_favorites_button_button_release_event),
	                  NULL);

	child = cdos_app_create_icon_texture (applet_button_get_app(favorites_button), favorites_button->icon_size);
	cdos_popup_base_menu_item_get_actor_child (&params_icon);	
	cdos_popup_base_menu_item_add_actor (CDOS_POPUP_BASE_MENU_ITEM(favorites_button), child, &params_icon);

	text = cdos_app_get_name(applet_button_get_app(favorites_button));
	//st_label_set_text (self->label, text);
	//st_widget_add_style_class_name (ST_WIDGET(self->label), "menu-favorites-button-label");
	favorites_button->label = g_object_new(ST_TYPE_LABEL,"text", text,"style-class", "menu-favorites-button-label", NULL);
	st_widget_set_style(ST_WIDGET(favorites_button->label), "max-width:14em;");

	cdos_popup_base_menu_item_add_actor (CDOS_POPUP_BASE_MENU_ITEM(favorites_button), CLUTTER_ACTOR(favorites_button->label), &params_icon);


	return favorites_button;
}

const char *
applet_favorites_button_get_id (CdosApp *app)
{
	const char *id;
	
	id = cdos_app_get_id (app);
	
	return id;
}

ClutterActor *
applet_favorites_button_get_drag_actor (AppletFavoritesButton *favorites_button)
{
	ClutterActor *source;

	//获取父类CdosPopupBaseMenuItem的actor
	source = CLUTTER_ACTOR(cdos_popup_base_menu_item_get_actor (CDOS_POPUP_BASE_MENU_ITEM (favorites_button)));

	return clutter_clone_new (source);
}

ClutterActor *   //返回类型?
applet_favorites_button_get_drag_actor_source (AppletFavoritesButton *favorites_button)
{
	ClutterActor *source;

	//获取父类CdosPopupBaseMenuItem的actor
	source = CLUTTER_ACTOR(cdos_popup_base_menu_item_get_actor (CDOS_POPUP_BASE_MENU_ITEM (favorites_button)));

	return source;
}
