#ifndef __APPLET_FAVORITES_BUTTON_H__
#define __APPLET_FAVORITES_BUTTON_H__

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include "applet-generic-application-button.h"
#include "cdos-app.h"
#include "st.h"

#define APPLET_TYPE_FAVORITES_BUTTON                (applet_favorites_button_get_type ())

#define APPLET_FAVORITES_BUTTON(obj) \
	(G_TYPE_CHECK_INSTANCE_CAST((obj), APPLET_TYPE_FAVORITES_BUTTON, AppletFavoritesButton))
	
#define APPLET_IS_FAVORITES_BUTTON(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_FAVORITES_BUTTON))

#define APPLET_FAVORITES_BUTTON_CLASS(klass) \
	(G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_FAVORITES_BUTTON, AppletFavoritesButtonClass))
	
#define APPLET_IS_FAVORITES_BUTTON_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_FAVORITES_BUTTON))

#define APPLET_FAVORITES_BUTTON_GET_CLASS(obj) \
	(G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_FAVORITES_BUTTON, AppletFavoritesButtonClass))

typedef struct _AppletFavoritesButton AppletFavoritesButton;
typedef struct _AppletFavoritesButtonPrivate AppletFavoritesButtonPrivate;
typedef struct _AppletFavoritesButtonClass AppletFavoritesButtonClass;

struct _AppletFavoritesButton
{
	AppletGenericApplicationButton parent_instance;
	
	gint icon_size;
	StLabel *label;
	//monitorHeight未确定
	AppletFavoritesButtonPrivate *priv;
};

struct _AppletFavoritesButtonClass
{
	AppletGenericApplicationButtonClass parent_class;
};

GType applet_favorites_button_get_type (void);

AppletFavoritesButton * applet_favorites_button_new (AppletMenu *apps_menu_button,     //menu完成时再加入
                                                 CdosApp *app);

const char * applet_favorites_button_get_id (CdosApp *app);

ClutterActor * applet_favorites_button_get_drag_actor (AppletFavoritesButton *favorites_button);

ClutterActor * applet_favorites_button_get_drag_actor_source (AppletFavoritesButton *favorites_button);

#endif /* __APPLET_FAVORITES_BUTTON_H__ */
