#ifndef __APPLET_HOVER_ICON_H__
#define __APPLET_HOVER_ICON_H__

#include <gio/gio.h>
#include <glib.h>
#include <act/act.h>
#include <clutter/clutter.h>
#include "st.h"
#include "cdos-util.h"
#include "applet-menu.h"

#define APPLET_TYPE_HOVER_ICON                (applet_hover_icon_get_type ())

#define APPLET_HOVER_ICON(obj) \
	(G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_HOVER_ICON, AppletHoverIcon))
	
#define APPLET_IS_HOVER_ICON(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_HOVER_ICON))

#define APPLET_HOVER_ICON_CLASS(klass) \
	(G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_HOVER_ICON, AppletHoverIconClass))
	
#define APPLET_IS_HOVER_ICON_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_HOVER_ICON))

#define APPLET_HOVER_ICON_GET_CLASS(obj) \
	(G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_HOVER_ICON, AppletHoverIconClass))
	

#define APPLET_HOVER_ICON_GET_PRIVATE(obj) \
  (G_TYPE_INSTANCE_GET_PRIVATE ((obj), APPLET_TYPE_HOVER_ICON, AppletHoverIconPrivate))

typedef struct _AppletHoverIcon AppletHoverIcon;
typedef struct _AppletHoverIconClass AppletHoverIconClass;
typedef struct _AppletHoverIconPrivate AppletHoverIconPrivate;


struct _AppletHoverIcon
{
	GObject 		parent_instance;	
	StBoxLayout 		*user_box;
	StLabel 		*user_label;
	StBin 			*actor;
	ClutterActor		*image;
	AppletHoverIconPrivate 	*priv;
};


struct _AppletHoverIconClass
{
	GObjectClass parent_class;
};

GType applet_hover_icon_get_type (void);

void applet_hover_icon_refresh (AppletHoverIcon *hover_icon, const gchar *icon_name);

AppletHoverIcon * applet_hover_icon_new (AppletMenu *menu);

#endif /* __APPLET_HOVER_ICON_H__ */
