#include "applet-menu-switchs.h"

/*"所有程序"和“返回”按钮*/

G_DEFINE_TYPE(AppletMenuSwitchs, applet_menu_switchs, \
    CDOS_TYPE_POPUP_BASE_MENU_ITEM);

#define APPLET_MENU_SWITCHS_GET_PRIVATE(obj)\
	(G_TYPE_INSTANCE_GET_PRIVATE ((obj), \
        APPLET_TYPE_MENU_SWITCHS, AppletMenuSwitchsPrivate))

struct _AppletMenuSwitchsPrivate 
{
    StBin           *icon;
    StLabel         *label;
    ClutterActor    *forward_icon;
    ClutterActor    *back_icon;
    guint            status;
    ClutterActor    *actor;
};

enum {
    PROP_0
};

enum
{
	  STATE_CHANGED,

    LAST_SIGNAL
};

enum{
	BACK,
	ALL
};

static guint applet_menu_switchs_signals[LAST_SIGNAL] = { 0, };

static void
applet_menu_switchs_finalize(GObject *object)
{
     AppletMenuSwitchsPrivate *priv = APPLET_MENU_SWITCHS(object)->priv;

     if (priv->forward_icon) {
        clutter_actor_destroy(priv->forward_icon);
     }

     if (priv->back_icon) {
        clutter_actor_destroy(priv->back_icon);
     }

     if (priv->label) {
        clutter_actor_destroy(priv->label);
     }

     if (priv->actor) {
        clutter_actor_destroy(priv->actor);
     }

     if (priv->icon) {
        clutter_actor_destroy(priv->icon);
     }
     
     G_OBJECT_CLASS(applet_menu_switchs_parent_class)->finalize(object);
}

static void
applet_menu_switchs_set_property(GObject * gobject,
                            guint prop_id,
                            const GValue * value, GParamSpec * pspec)
{
    AppletMenuSwitchs *obj = APPLET_MENU_SWITCHS(gobject);

    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_menu_switchs_get_property(GObject * gobject,
                                guint prop_id, 
                                GValue * value, 
                                GParamSpec * pspec)
{
    AppletMenuSwitchsPrivate *priv = APPLET_MENU_SWITCHS(gobject)->priv;
    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_menu_switchs_class_init(AppletMenuSwitchsClass * klass)
{
    GObjectClass *gobject_class = G_OBJECT_CLASS(klass);
    GParamSpec *pspec;
    gobject_class->set_property = applet_menu_switchs_set_property;
    gobject_class->get_property = applet_menu_switchs_get_property;
    gobject_class->finalize = applet_menu_switchs_finalize;

    g_type_class_add_private(klass, sizeof (AppletMenuSwitchsPrivate));

    applet_menu_switchs_signals[STATE_CHANGED] = g_signal_new (
                "state-changed", 
                G_TYPE_FROM_CLASS(klass), 
                G_SIGNAL_RUN_LAST,
                G_STRUCT_OFFSET(AppletMenuSwitchsClass, state_changed),
                NULL,
                NULL, 
                g_cclosure_marshal_VOID__UINT,
                G_TYPE_NONE,
  	  	        1,
                G_TYPE_UINT);
}

static void
applet_menu_switchs_init(AppletMenuSwitchs * self)
{
    AppletMenuSwitchsPrivate *priv;
    priv = self->priv = APPLET_MENU_SWITCHS_GET_PRIVATE(self);

    priv->icon = NULL;
    priv->label = NULL;
    priv->forward_icon = NULL;
    priv->back_icon = NULL;
    priv->actor = NULL;
    priv->status = ALL;
}

//zhangdj start
static gboolean
on_button_press_event (CdosGenericContainer *actor,
                       ClutterEvent *event,
                       gpointer user_data)
{
    st_widget_add_style_class_name (ST_WIDGET(actor), "menu-category-button-selected");
    
    return TRUE;
}

static gboolean
on_button_release_event (CdosGenericContainer *actor,
                       ClutterEvent *event,
                       gpointer user_data)
{
    st_widget_remove_style_class_name (ST_WIDGET(actor), "menu-category-button-selected");
    
    return TRUE;
}
//zhangdj end

static void
on_active_changed(AppletMenuSwitchs *object, gboolean active)
{
	if(active)
		st_widget_add_style_class_name(ST_WIDGET(object->priv->actor), "menu-category-button-hover");
	else
		st_widget_remove_style_class_name(ST_WIDGET(object->priv->actor), "menu-category-button-hover");
}

static void
on_activate (AppletMenuSwitchs *object, 
              gpointer           event, 
              gboolean           keep, 
              gpointer           data)
{
	AppletMenuSwitchsPrivate *priv;
	guint event_type = clutter_event_get_button((ClutterEvent *)event);
	priv = object->priv;

	if(event_type == 1){
		if(priv->status == ALL){
            g_object_ref(priv->forward_icon);
			st_bin_set_child(priv->icon, priv->back_icon);
			st_label_set_text(priv->label, _("Back"));
			priv->status = BACK;

		    g_signal_emit(object, applet_menu_switchs_signals[STATE_CHANGED], 0, BACK, NULL);
        } else {
            g_object_ref(priv->back_icon);
			st_bin_set_child(priv->icon, priv->forward_icon);
			st_label_set_text(priv->label, _("All Programs"));
			priv->status = ALL;

			g_signal_emit(object, applet_menu_switchs_signals[STATE_CHANGED], 0, ALL, NULL);
		}
	}
}

AppletMenuSwitchs *
applet_menu_switchs_new(void)
{
    AppletMenuSwitchs           *object;
    AppletMenuSwitchsPrivate    *priv;
    PopupBaseMenuItemInit        params;
    CdosGenericContainer        *actor;
    StTextureCache              *texture_cache;
    ActorChild                   actor_params;
    
    object = g_object_new(APPLET_TYPE_MENU_SWITCHS, NULL);
    priv = object->priv;
    cdos_popup_base_menu_item_get_init_params(&params);
    params.reactive = TRUE;
    
    cdos_popup_base_menu_item_set_params(object, &params);

    actor = cdos_popup_base_menu_item_get_actor(object);
    //st_widget_set_style_class_name(ST_WIDGET(actor),"menu-allprogram-item menu-category-button");
    //st_widget_add_style_class_name(ST_WIDGET(actor), "menu-category-button-selected");

    const gchar *datadir = g_getenv("CINNAMON_DATADIR");
    texture_cache = st_texture_cache_get_default();

    gchar *path_icon1 = "/usr/share/cdos-desktop/theme/icon-002.png";
    GFile *iconFile1 = g_file_new_for_path(path_icon1);
    GIcon *icon1 = g_file_icon_new(iconFile1);
    priv->forward_icon = st_texture_cache_load_gicon(texture_cache, NULL, icon1, IMAGE_ICON_SIZE);
    
    g_file_delete (iconFile1, NULL, NULL);
    g_clear_object (&icon1);
    
    gchar *path_icon2 = "/usr/share/cdos-desktop/theme/icon-003.png";
    GFile *iconFile2 = g_file_new_for_path(path_icon2);
    GIcon *icon2 = g_file_icon_new(iconFile2);
    priv->back_icon = st_texture_cache_load_gicon(texture_cache, NULL, icon2, IMAGE_ICON_SIZE);
    
    g_file_delete (iconFile2, NULL, NULL);
    g_clear_object (&icon2);

    priv->icon = g_object_new(ST_TYPE_BIN, "style-class", "popup-menu-icon", NULL);
    priv->label = g_object_new(ST_TYPE_LABEL, "text", _("All Programs"),
                         "style-class", "menu-application-button-label", NULL);

    st_bin_set_child(priv->icon, priv->forward_icon);

    cdos_popup_base_menu_item_get_actor_child(&actor_params);
    cdos_popup_base_menu_item_add_actor(object, priv->icon, &actor_params);
    cdos_popup_base_menu_item_add_actor(object, priv->label, &actor_params);

    object->priv->actor = CLUTTER_ACTOR(actor);

    //zhangdj start
    g_signal_connect (actor, "button-press-event", G_CALLBACK(on_button_press_event), NULL);
    g_signal_connect (actor, "button-release-event", G_CALLBACK(on_button_release_event), NULL);
    //zhangdj end
    g_signal_connect(object, "active-changed", G_CALLBACK(on_active_changed), NULL);
    g_signal_connect(object, "activate", G_CALLBACK(on_activate), NULL);

    return object;
}

ClutterActor *
applet_menu_switchs_get_actor(AppletMenuSwitchs *switchs)
{
    if (NULL == switchs)
        return NULL;

    return switchs->priv->actor;
}

