#include "applet-menu.h"
#include "applet-separator.h"
#include "applet-shutdown-contextmenu-item.h"
#include "applet-shortcut-item.h"
#include "applet-favorites-button.h"
#include "applet-hover-icon.h"
#include "cdos-doc-manager.h"
#include "cdos-doc-info.h"
#include "applet-recent-button.h"
#include "applet-menu-switchs.h"
#include "applet-application-button.h"
#include "applet-application-menu.h"
#include "applet-category-button.h"
#include "applet-search-result-button.h"    //zhangdj
#include "cdos-app-favorites.h"
#include "cdos-utils-private.h"
#include "cdos-monkey-plugin.h"
#include <gbcode.h>
#include <libupower-glib/upower.h>

/*开始菜单*/

G_DEFINE_TYPE(AppletMenu, applet_menu, CDOS_TYPE_ICONAPPLET);

#define APPLET_MENU_GET_PRIVATE(obj) \
       (G_TYPE_INSTANCE_GET_PRIVATE ((obj), APPLET_TYPE_MENU, AppletMenuPrivate))
static const gchar *single_wm_class_welcome = "CdosWelcome.py";
static const gchar *single_wm_class_settings = "Cdos-settings.py";
//zhangdj
static gboolean do_search (AppletMenu *self);

static void 
load_recent_box(CdosDocManager *doc_manager, gpointer user_data);

static void
_refresh_favorite_apps(GSettings *settings, gpointer *user_data);

static void
_refresh_recent (AppletMenu *self);

static void applet_menu_clear_recent_list(AppletMenu *self);
static void applet_menu_clear_favorite_list(AppletMenu *self);
static void applet_menu_clear_apps_list(AppletMenu *self);
static void applet_menu_clear_search_result_list(AppletMenu *self);

static gchar *
menu_get_applet_icon(void);

static void 
applet_all_applications_refresh(CdosAppSystem *self, gpointer user_data);

//added
static void
clear_selection (AppletMenu *self);

static GList *
empty_selectable_items_list (GList *selectable_items);

static void
item_activate(CdosPopupBaseMenuItem *item);

static GList *
add_button_actors_to_list (GList *list_with_actors, GList *source_list);

static void
_on_vscroll_scroll_start_callback(ClutterActor *vscroll, gpointer data);

static void
_on_vscroll_scroll_stop_callback(ClutterActor *vscroll, gpointer data);

struct _AppletMenuPrivate {
    gchar *name;
    StBin *applet_icon_box;
    CdosPopupMenuManager *menu_manager;
    StBoxLayout *main_box;
    gchar *icon_file;
    //layout
    CdosPopupMenuSection *section;
    StBin *top;
    StBoxLayout *bottom;
    StBoxLayout *default_view;
    StBoxLayout *left_pane_box;
    StBoxLayout *favs_box;
    StBoxLayout *fav_box;
    StBoxLayout *rec_box;
    StBoxLayout *recent_box;
    StBoxLayout *switch_box;
    StScrollView *favorite_recent_scroll_box;   //zhangdj
    StScrollView *categories_scroll_box;
    StBoxLayout *right_pane_box;
    AppletHoverIcon *hover_icon;
    StBoxLayout *bottom_left_box;
    StBoxLayout *bottom_right_box;
    StBoxLayout *search_view;   //zhangdj
    StBoxLayout *search_result_box;  //zhangdj
    StBoxLayout *shortcut_box;   //zhangdj
    StBoxLayout *shutdown_box;   //zhangdj
    
    GHashTable *applications_by_category;
    GHashTable *results_by_category;   //zhangdj
    //search
    StEntry *search_entry;
    StIcon *_search_inactive_icon;
    StIcon *_search_active_icon;
    gboolean search_active;   //zhangdj
    gint search_icon_clicked_id;   //zhangdj
    gchar *menu_id;   //zhangdj
    //zhangdj
    //shutdown
    StBoxLayout *categories_box;
    StBoxLayout *category_box;
    CdosPopupBaseMenuItem *shutdown_button;
    CdosPopupMenu *contextmenu;  //added
    //对象缓存
    GList *recent_list;
    GList *favorit_list;
    GList *categories_list;
    GList *apps_list;
    GList *search_result_list;
    
    //key choice
    //added
    gint selected_item_index;
    CdosGenericContainer *previous_selected_actor;
    CdosGenericContainer *previous_tree_selected_actor;
    CdosGenericContainer *active_actor;
    GList *left_selectable_items;
    GList *right_selectable_items;
    GList *current_active_list;
    
    gboolean is_in_all_applications;
    enum STATE state;
    
    //zhangdj
    CdosPopupMenu *generic_application_button_popup_menu;
    CdosPopupMenu *recent_button_popup_menu;
};

enum {
    PROP_0,

    PROP_APPLET_ICON_BOX
};

enum
{
    LAST_SIGNAL
};

static AppletMenu *default_menu = NULL;

static void
_add_actor(gpointer container, gpointer actor)
{
	clutter_container_add_actor(CLUTTER_CONTAINER(container), CLUTTER_ACTOR(actor));
}
static void
_remove_actor(gpointer container, gpointer actor)
{
    clutter_container_remove_actor(CLUTTER_CONTAINER(container), CLUTTER_ACTOR(actor));
}

static void
applet_menu_finalize(GObject *object)
{
     AppletMenu *self =  APPLET_MENU(object);
     AppletMenuPrivate *priv = self->priv;

     /*
     g_object_unref(priv->applet_icon_box);
     g_object_unref(priv->icon_file);
     g_object_unref(priv->main_box);
     g_object_unref(priv->section);
     g_object_unref(priv->top);
     g_object_unref(priv->bottom);
     g_object_unref(priv->default_view);
     g_object_unref(priv->left_pane_box);
     g_object_unref(priv->favs_box);
     g_object_unref(priv->categories_scroll_box);
     g_object_unref(priv->right_pane_box);
     g_object_unref(priv->bottom_left_box);
     g_object_unref(priv->bottom_right_box);
     g_object_unref(priv->search_entry);
     g_object_unref(priv->hover_icon);
     g_object_unref(priv->applications_by_category);
     */

      applet_menu_clear_favorite_list(self);
      applet_menu_clear_recent_list(self);
      applet_menu_clear_apps_list(self);

     //zhangdj
     clutter_actor_destroy (APPLET_MENU(object)->actor);
     cdos_popup_menu_base_destroy (CDOS_POPUP_MENU_BASE(APPLET_MENU(object)->menu));
     
     clutter_actor_destroy (CLUTTER_ACTOR(priv->applet_icon_box));
     g_free (priv->icon_file);
     clutter_actor_destroy (CLUTTER_ACTOR(priv->main_box));
     g_clear_object (&priv->section);
     clutter_actor_destroy (CLUTTER_ACTOR(priv->top));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->bottom));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->default_view));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->left_pane_box));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->favorite_recent_scroll_box));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->right_pane_box));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->bottom_left_box));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->bottom_right_box));
     g_clear_object (&priv->hover_icon);
     clutter_actor_destroy (CLUTTER_ACTOR(priv->_search_inactive_icon));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->_search_active_icon));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->categories_box));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->category_box));
     
     //zhangdj
     clutter_actor_destroy (CLUTTER_ACTOR(priv->search_view));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->search_result_box));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->shortcut_box));  //added
     clutter_actor_destroy (CLUTTER_ACTOR(priv->shutdown_box));  //added
     g_hash_table_destroy (priv->applications_by_category);
     g_hash_table_destroy (priv->results_by_category);
     g_free (priv->menu_id);
     cdos_popup_base_menu_item_destroy (priv->shutdown_button);
     cdos_popup_menu_base_destroy ((CdosPopupMenuBase *)priv->contextmenu);  //added
     //added
     clutter_actor_destroy (CLUTTER_ACTOR(priv->previous_selected_actor));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->previous_tree_selected_actor));
     clutter_actor_destroy (CLUTTER_ACTOR(priv->active_actor));
     g_list_free (priv->left_selectable_items);
     g_list_free (priv->right_selectable_items);
     g_list_free (priv->current_active_list);
     
     /*调用父类的finalize()方法*/
     G_OBJECT_CLASS(applet_menu_parent_class)->finalize(object);
}

static void
applet_menu_set_property(GObject * gobject,
                guint prop_id,
                const GValue * value, GParamSpec * pspec)
{
    AppletMenu *obj = APPLET_MENU(gobject);

    switch (prop_id)
    {
        case PROP_APPLET_ICON_BOX:
            applet_menu_set_applet_icon_box (obj, g_value_get_object (value));
            break;
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_menu_get_property(GObject * gobject,
                guint prop_id, GValue * value, GParamSpec * pspec)
{
    AppletMenuPrivate *priv = APPLET_MENU(gobject)->priv;
    switch (prop_id)
    {
        case PROP_APPLET_ICON_BOX:
             g_value_set_object (value, priv->applet_icon_box);
            break;
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_menu_class_init(AppletMenuClass * klass)
{
    GObjectClass *gobject_class = G_OBJECT_CLASS(klass);
    CdosAppletClass *parent_class = CDOS_APPLET_CLASS (klass);
    GParamSpec *pspec;

    gobject_class->set_property = applet_menu_set_property;
    gobject_class->get_property = applet_menu_get_property;
    gobject_class->finalize = applet_menu_finalize;

    //parent_class->on_applet_clicked = applet_menu_on_applet_clicked;

    g_type_class_add_private(klass, sizeof (AppletMenuPrivate));

    pspec = g_param_spec_object ("applet_icon_box",
                   "IconBox",
                   "IconBox of the menu applet",
                   ST_TYPE_BIN,
                   G_PARAM_READWRITE);
    g_object_class_install_property (gobject_class, PROP_APPLET_ICON_BOX, pspec);
}

static void
applet_menu_init(AppletMenu * self)
{
    AppletMenuPrivate *priv;
    priv = self->priv = APPLET_MENU_GET_PRIVATE(self);
    self->actor = NULL;
    priv->name = g_strdup("AppletMenu");
    priv->applet_icon_box = NULL;
    priv->icon_file = menu_get_applet_icon();
    priv->main_box = NULL;
    priv->rec_box = NULL;
    priv->recent_list = NULL;
    priv->favorit_list = NULL;
    priv->categories_list = NULL;
    priv->apps_list = NULL;
    priv->search_result_list = NULL;
    //zhangdj
    priv->menu_id = NULL;
    priv->search_active = FALSE;
    priv->search_icon_clicked_id = 0;
    cdos_applet_set_single_window_mode(CDOS_APPLET(self),single_wm_class_settings,TRUE);
    cdos_applet_set_single_window_mode(CDOS_APPLET(self),single_wm_class_welcome,TRUE);
    
    //added
    priv->is_in_all_applications = FALSE;
    priv->state = EMPTY;

    priv->selected_item_index = -1;
    priv->previous_selected_actor = NULL;
    priv->previous_tree_selected_actor = NULL;
    priv->active_actor = NULL;
    priv->left_selectable_items = NULL;
    priv->right_selectable_items = NULL;
    priv->current_active_list = NULL;

    //zhangdj
    priv->generic_application_button_popup_menu = NULL;
    priv->recent_button_popup_menu = NULL;
}

static void
applet_menu_display(AppletMenu * self){
    AppletMenuPrivate *priv;
    StBoxLayout *_box;
    StBoxLayout *left_panel;
    gfloat width = 424;
    gfloat height = 522;
    gfloat left_width = 262;
    gfloat bottom_height = 44;
    gfloat switch_box_height = 47;
    priv = self->priv;

    priv->section = cdos_popup_menu_section_new();

    priv->main_box = g_object_new(ST_TYPE_BOX_LAYOUT,
                        "style-class", "menu-applications-box",
			            "vertical", TRUE, 
                        NULL);

    
    priv->top = g_object_new(ST_TYPE_BIN, "x-fill", TRUE, NULL);

    priv->default_view = g_object_new(ST_TYPE_BOX_LAYOUT, 
                                "vertical", FALSE, 
                                NULL);

    priv->left_pane_box = g_object_new(ST_TYPE_BOX_LAYOUT,
                                "style-class" , "menu-left-pane",
						        "vertical", TRUE, 
                                NULL);

    left_panel = g_object_new(ST_TYPE_BOX_LAYOUT,"vertical", TRUE, NULL);

     /*
    priv->favs_box = g_object_new(ST_TYPE_BOX_LAYOUT,
                                "style-class" , "menu-favorites-box",
								"vertical", TRUE, 
                                NULL);
     */

    //zhangdj
    priv->favorite_recent_scroll_box = g_object_new(ST_TYPE_SCROLL_VIEW,
                                "style-class" , "vfade menu-applications-scrollbox",
								"x-fill", TRUE,
								"y-fill", FALSE,
								"y-align", ST_ALIGN_START, 
                                NULL);
    
    priv->categories_scroll_box = g_object_new(ST_TYPE_SCROLL_VIEW,
                                "style-class" , "vfade menu-applications-scrollbox",
								"x-fill", TRUE,
								"y-fill", FALSE,
								"y-align", ST_ALIGN_START, 
                                NULL);

    priv->switch_box = g_object_new(ST_TYPE_BOX_LAYOUT, 
                                "vertical", TRUE,
    							"style-class", "menu-appps-button-box", 
                                NULL);

    priv->right_pane_box = g_object_new(ST_TYPE_BOX_LAYOUT,
                            "style-class" , "menu-right-pane",
							"vertical", TRUE, 
                            NULL);

    _add_actor(left_panel, priv->favorite_recent_scroll_box);
    _add_actor(left_panel, priv->categories_scroll_box);
    clutter_actor_show(priv->favorite_recent_scroll_box);
    clutter_actor_hide(priv->categories_scroll_box);
    _add_actor(priv->left_pane_box, left_panel);
    _add_actor(priv->left_pane_box, priv->switch_box);

    st_bin_set_child(priv->top, CLUTTER_ACTOR(priv->default_view));
    _add_actor(priv->default_view, priv->left_pane_box);
    _add_actor(priv->default_view, priv->right_pane_box);
    //clutter_actor_set_size(CLUTTER_ACTOR(priv->left_pane_box), left_width, height-bottom_height);
    clutter_actor_set_size(CLUTTER_ACTOR(left_panel), left_width, (height-bottom_height)-switch_box_height);
    //clutter_actor_set_size(CLUTTER_ACTOR(priv->right_pane_box), width-left_width, height-bottom_height);

    /* bottom */
    priv->bottom = g_object_new(ST_TYPE_BOX_LAYOUT, "vertical", FALSE, NULL);
    priv->bottom_left_box = g_object_new(ST_TYPE_BOX_LAYOUT, "vertical", TRUE, NULL);
    priv->bottom_right_box = g_object_new(ST_TYPE_BOX_LAYOUT, "vertical", FALSE, NULL);
    _add_actor(priv->bottom, priv->bottom_left_box);
    _add_actor(priv->bottom, priv->bottom_right_box);
    clutter_actor_set_size(CLUTTER_ACTOR(priv->bottom_left_box), left_width, bottom_height);
    //clutter_actor_set_size(CLUTTER_ACTOR(priv->bottom_right_box), width-left_width, bottom_height);
    //clutter_actor_set_background_color (CLUTTER_ACTOR(priv->bottom_left_box), clutter_color_new(0xcc, 0xcc, 0xcc, 0x9f));

    //clutter_actor_set_size(CLUTTER_ACTOR(priv->main_box), width, height);
    clutter_actor_set_size(CLUTTER_ACTOR(priv->top), width, height-bottom_height);
    clutter_actor_set_size(CLUTTER_ACTOR(priv->bottom), width, bottom_height);

    _box = cdos_popup_menu_base_get_box(self->menu);
    _add_actor(_box, priv->main_box);
    //_add_actor(section->actor), priv->main_box);
    _add_actor(priv->main_box, priv->top);
    _add_actor(priv->main_box, priv->bottom);
}

//zhangdj
static void
toggle_view (AppletMenu *self, gboolean is_search_view)
{
	//g_print ("---->in toggle_view(%s)\n", is_search_view > 0 ? "TRUE" : "FALSE");      //////调试
	
	AppletMenuPrivate *priv;
	
	priv = self->priv;
	
	if (is_search_view)
	{
		g_object_ref (priv->search_view);
		
		st_bin_set_child (priv->top, CLUTTER_ACTOR(priv->search_view));
		st_bin_set_alignment (priv->top, ST_ALIGN_END, ST_ALIGN_END);    //y_align是什么?
		st_bin_set_fill (priv->top, TRUE, TRUE);   //y_fill是什么?
		
		st_widget_add_style_class_name (ST_WIDGET(priv->bottom_right_box), "light");
		//加入关机按钮的样式
	}
	else
	{
		g_object_ref (priv->default_view);
		
		st_bin_set_child (priv->top, CLUTTER_ACTOR(priv->default_view));
		st_bin_set_alignment (priv->top, ST_ALIGN_END, ST_ALIGN_END);    //y_align是什么?
		st_bin_set_fill (priv->top, TRUE, TRUE);   //y_fill是什么?
		
		st_widget_remove_style_class_name (ST_WIDGET(priv->bottom_right_box), "light");
		//加入关机按钮的样式
	}
	
	//added
	clear_selection (self);
	if (priv->current_active_list)
    {
        priv->current_active_list = empty_selectable_items_list (priv->current_active_list);
    }
    
    if (priv->left_selectable_items)
    {
        priv->left_selectable_items = empty_selectable_items_list (priv->left_selectable_items);
    }
    
    if (priv->right_selectable_items)
    {
        priv->right_selectable_items = empty_selectable_items_list (priv->right_selectable_items);
    }    
    priv->previous_selected_actor = NULL;
    priv->previous_tree_selected_actor = NULL;
    priv->active_actor = NULL;
    priv->selected_item_index = -1;
    priv->state = EMPTY;
}

static void
applet_menu_shutdown_button_activate(CdosPopupBaseMenuItem *shutdown_button, gpointer event, gboolean keep, gpointer data)
{
	//g_print ("---->in %s\n", __func__);   //////调试
	AppletMenu *applet;
	AppletMenuPrivate *priv;
	CdosBoxPointer *box_pointer;
	ClutterActor *shutdown_button_actor;   //added
	ClutterActor *shutdown_box;
	
	applet = data;
	priv = applet->priv;
	
	box_pointer = cdos_popup_menu_get_box_pointer (priv->contextmenu);
	cdos_box_pointer_set_y_offset (box_pointer, -57.0);
	cdos_popup_menu_base_toggle(CDOS_POPUP_MENU_BASE(priv->contextmenu));
	
    //added	
	shutdown_button_actor = (ClutterActor *)cdos_popup_base_menu_item_get_actor (shutdown_button);
	shutdown_box = clutter_actor_get_parent (shutdown_button_actor);
	st_widget_remove_style_pseudo_class (ST_WIDGET(shutdown_box), "hover");
	
    if (priv->current_active_list)
    {
        priv->current_active_list = empty_selectable_items_list (priv->current_active_list);
    }
    priv->previous_selected_actor = NULL;
    priv->previous_tree_selected_actor = NULL;
    priv->selected_item_index = -1;
}

//added
static gboolean
on_shutdown_button_enter_event (ClutterActor *actor,
                                ClutterEvent *event,
                                gpointer user_data)
{
    //g_print ("in %s\n", __func__);  //////调试
    AppletMenu *applet = user_data;
    AppletMenuPrivate *priv = applet->priv;   
    
    clear_previous_selection (applet);   //鼠标hover时，清除之前使用键盘选中的项
    priv->previous_selected_actor = (CdosGenericContainer *)actor;
    priv->active_actor = (CdosGenericContainer *)actor;
    st_widget_add_style_pseudo_class (ST_WIDGET(priv->shutdown_box), "hover");
    
    priv->state = HOVER;
    
    return TRUE;
}

static gboolean
on_shutdown_button_leave_event (ClutterActor *actor,
                                ClutterEvent *event,
                                gpointer user_data)
{
    //g_print ("in %s\n", __func__);  //////调试
    AppletMenu *applet = user_data;
    AppletMenuPrivate *priv = applet->priv;
    st_widget_remove_style_pseudo_class (ST_WIDGET(priv->shutdown_box), "hover");
    
    return TRUE;
}

static gboolean
on_shutdown_button_button_press_event (ClutterActor *actor,
                                       ClutterEvent *event,
                                       gpointer user_data)
{
    AppletMenu *applet = user_data;
    AppletMenuPrivate *priv = applet->priv;
    
    st_widget_add_style_pseudo_class (ST_WIDGET(priv->shutdown_box), "click");
    
    return TRUE;
}

static gboolean
on_shutdown_button_button_release_event (ClutterActor *actor,
                                       ClutterEvent *event,
                                       gpointer user_data)
{
    AppletMenu *applet = user_data;
    AppletMenuPrivate *priv = applet->priv;
    
    st_widget_remove_style_pseudo_class (ST_WIDGET(priv->shutdown_box), "click");
    
    return TRUE;
}

//关机菜单的键盘选择处理
static gboolean
on_contextmenu_key_press_event (ClutterActor *actor,
                                ClutterEvent *event,
                                gpointer user_data)
{
    //g_print ("---->in %s\n", __func__);  //////调试
    AppletMenu *applet;
    AppletMenuPrivate *priv;
    guint symbol;
    GList *shutdown_menu_items;
    GList *shutdown_menu_actors;
    CdosPopupBaseMenuItem *item;
    CdosGenericContainer *item_actor;
    gint index;
    gboolean retval;
    
    applet = user_data;
    priv = applet->priv;
    retval = FALSE;
    
    symbol = clutter_event_get_key_symbol (event);
    
    index = priv->selected_item_index;
    clear_previous_selection (applet);
    
    shutdown_menu_items = cdos_popup_menu_base_get_menu_items ((CdosPopupMenuBase *)priv->contextmenu);
    shutdown_menu_actors = add_button_actors_to_list (shutdown_menu_actors, shutdown_menu_items);
    priv->current_active_list = g_list_copy_deep (shutdown_menu_actors, (GCopyFunc) g_object_ref, NULL);
    g_list_free (shutdown_menu_items);
    g_list_free (shutdown_menu_actors);
    
    if (priv->current_active_list == NULL && symbol == CLUTTER_KEY_Up)
    {
        item_actor = (CdosGenericContainer *)g_list_last (priv->current_active_list)->data;
        index = g_list_index (priv->current_active_list, item_actor);
        
        priv->state = KEY;
    }
    else if (priv->current_active_list == NULL && symbol == CLUTTER_KEY_Down)
    {
        item_actor = (CdosGenericContainer *)g_list_first (priv->current_active_list)->data;
        index = g_list_index (priv->current_active_list, item_actor);
        
        priv->state = KEY;
    }
    else if (priv->current_active_list == NULL && symbol == CLUTTER_KEY_Right)
    {
        item_actor = (CdosGenericContainer *)g_list_first (priv->current_active_list)->data;
        index = g_list_index (priv->current_active_list, item_actor);
        
        priv->state = KEY;
    }
    else if (symbol == CLUTTER_KEY_Up)
    {
        priv->previous_selected_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, index);
        index--;
        item_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, index);
        
        if (index < 0)
        {
            item_actor = (CdosGenericContainer *)g_list_last (priv->current_active_list)->data;
            index = g_list_index (priv->current_active_list, item_actor);
        }
        
        priv->state = KEY;
    }
    else if (symbol == CLUTTER_KEY_Down)
    {
        gint length;
            
        priv->previous_selected_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, index);
        index++;
        item_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, index);
        
        length = g_list_length (priv->current_active_list);
        if (index > length - 1)
        {
            item_actor = (CdosGenericContainer *)g_list_first (priv->current_active_list)->data;
            index = g_list_index (priv->current_active_list, item_actor);
        }
        
        priv->state = KEY;
    }
    else if (symbol == CLUTTER_KEY_Left)
    {
        cdos_popup_menu_base_toggle ((CdosPopupMenuBase *)priv->contextmenu);
        
        priv->state = KEY;
        
        return TRUE;        
    }
    else if (symbol == CLUTTER_KEY_Right)
    {
        priv->previous_selected_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, index);
        
        item_actor = (CdosGenericContainer *)g_list_first (priv->current_active_list)->data;
        index = g_list_index (priv->current_active_list, item_actor);
        
        priv->state = KEY;
    }
    else if (symbol == CLUTTER_KEY_Return || symbol == CLUTTER_KEY_KP_Enter)
    {
        if (priv->state == KEY)
        {
            item_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, priv->selected_item_index);
        }
        
        if (priv->state == HOVER)
        {
            if (priv->active_actor)
            {
                item_actor = priv->active_actor;
            }
        }
        
        if (item_actor)
        {
            item = (CdosPopupBaseMenuItem *)obj_get_delegate (item_actor);
            item_activate (item); 
        }
        
        return TRUE;
    }
    else
    {
        return FALSE;
    }
    
    priv->selected_item_index = index;
    if (item_actor)
    {
        g_signal_emit_by_name (item_actor, "enter-event", event, &retval);
    }
    else
    {
        return FALSE;
    }
    
    priv->state = KEY;
    
    return TRUE;    
}

static gboolean
on_shutdown_contextmenu_item_enter_event (ClutterActor *actor,
                                         ClutterEvent *event,
                                         gpointer user_data)
{
    //g_print ("in %s\n", __func__);   ///////调试
    AppletMenu *applet = user_data;
    AppletMenuPrivate *priv = applet->priv;
    
    clear_previous_selection (applet);
    priv->previous_selected_actor = (CdosGenericContainer *)actor;
    priv->active_actor = (CdosGenericContainer *)actor;
    st_widget_add_style_pseudo_class (ST_WIDGET(actor), "hover");
    
    priv->state = HOVER;
    
    return TRUE;
}

static gboolean
on_shutdown_contextmenu_item_leave_event (ClutterActor *actor,
                                         ClutterEvent *event,
                                         gpointer user_data)
{
    //g_print ("in %s\n", __func__);   ///////调试
    st_widget_remove_style_pseudo_class (ST_WIDGET(actor), "hover");
    
    return TRUE;
}

static CdosPopupBaseMenuItem *
applet_shutdown_contextmenu_item (AppletMenu    *applet, 
                                  CdosPopupMenu *parent,
                                  gchar         *label,
                                  ShutdownAction action)
{
    AppletShutdownContextmenuItem *contextmenu_item;
    CdosGenericContainer *actor;
    
    contextmenu_item = applet_shutdown_contextmenu_item_new (applet, parent, label, action);
    actor = cdos_popup_base_menu_item_get_actor ((CdosPopupBaseMenuItem *)contextmenu_item);
    g_signal_connect(actor, "enter-event", 
                     G_CALLBACK(on_shutdown_contextmenu_item_enter_event), 
                     applet);
                     
    g_signal_connect(actor, "leave-event", 
                     G_CALLBACK(on_shutdown_contextmenu_item_leave_event), 
                     applet);
    
    return (CdosPopupBaseMenuItem *)contextmenu_item;
}

//added
static void
on_contextmenu_open_state_changed (CdosPopupMenuBase *contextmenu,
                                   gboolean open,
                                   gpointer user_data)
{
    //g_print ("in %s\n", __func__);   ///////调试
    AppletMenu *applet;
    AppletMenuPrivate *priv;
    CdosGlobal *global;
    ClutterStage *stage;
   
    applet = user_data;
    priv = applet->priv;

    if (!open)
    {
        clear_selection (applet);
        priv->previous_selected_actor = NULL;
        priv->previous_tree_selected_actor = NULL;
        priv->active_actor = NULL;
        priv->selected_item_index = -1;
        priv->state = EMPTY;
        
        //关机菜单关闭时，焦点回到搜索框
        global = cdos_global_get ();
        stage = cdos_global_get_stage (global);
        clutter_stage_set_key_focus (stage, CLUTTER_ACTOR(priv->search_entry)); 
    } 
}

static gboolean
applet_menu_is_laptop()
{
    UpClient *up_client;
    gboolean ret;
    gint i = 0;
    GPtrArray  *devices;
    gboolean has_battery = FALSE;
    UpDevice *device;
    UpDeviceKind kind;

    up_client = up_client_new ();
//    ret = up_client_enumerate_devices_sync (up_client, NULL, NULL);

    devices = up_client_get_devices (up_client);

    for (i=0; i<devices->len; i++)
    {
        device = g_ptr_array_index (devices, i);
        g_object_get (device, "kind", &kind, NULL);

        if(kind == UP_DEVICE_KIND_BATTERY || kind == UP_DEVICE_KIND_UPS)
        {
            has_battery = TRUE;
        }   
    }
    return has_battery;
}

static void
applet_menu_shutdown_init(AppletMenu * self)
{
		AppletMenuPrivate *priv;
		StBoxLayout *actor = NULL;
		PopupBaseMenuItemInit *params = malloc(sizeof(PopupBaseMenuItemInit));
		CdosPopupBaseMenuItem *shutdown_button = NULL;
		ClutterActor *shutdown_button_actor = NULL;
	//	StLabel *_label = NULL;
	//	StBin *_label_bin = NULL;
		StBin *_icon = NULL;
		ActorChild actor_params; 
		ClutterContainer *uigroup = monkey_plugin_get_ui_group (monkey_plugin_get ());

		priv = self->priv;
		params->activate = TRUE;
		params->focusOnHover = TRUE;
		params->hover = TRUE;
		params->margin_left_label = 29;
		params->margin_left_label_icon = 15;
		params->reactive = TRUE;
		params->sensitive = TRUE;
		params->style_class = "menu-shutdown-button";
		shutdown_button = cdos_popup_base_menu_item_new_with_params(params);
		shutdown_button_actor = cdos_popup_base_menu_item_get_actor(shutdown_button);

		st_widget_set_style_class_name(ST_WIDGET(priv->bottom_right_box),"menu-shutdown-box");
		actor = g_object_new(ST_TYPE_BOX_LAYOUT, "vertical", TRUE, NULL);
		priv->shutdown_box = g_object_new(ST_TYPE_BOX_LAYOUT,
				"style-class", "menu-shutdown",
				"vertical" , FALSE,
				"reactive", TRUE,
				"track-hover", TRUE, NULL);
	//	_label = st_label_new(_("Power Management"));
	//	_label_bin = g_object_new(ST_TYPE_BIN, "x-align", ST_ALIGN_MIDDLE,
	//			"style-class", "menu-shutdown-button-label", NULL);
	//	st_bin_set_child(_label_bin, _label);
		_icon = g_object_new(ST_TYPE_BIN, "style-class", "menu-shutdown-button-icon", NULL);


		cdos_popup_base_menu_item_get_actor_child(&actor_params);
	//	cdos_popup_base_menu_item_add_actor(menu_item, _label_bin, &actor_params);
		
		cdos_popup_base_menu_item_add_actor(shutdown_button, _icon, &actor_params);

		//contextmenu
		priv->contextmenu = cdos_popup_menu_new_with_params(shutdown_button_actor, 0 , ST_SIDE_LEFT);
		//priv->contextmenu = applet_contextmenu_new(ST_WIDGET(shutdown_button_actor));
		st_widget_set_style_class_name(priv->contextmenu->actor, "menu-shutdown-menu-box");
		cdos_popup_menu_base_add_child_menu(self->menu, priv->contextmenu);
		//clutter_actor_set_size(CLUTTER_ACTOR(priv->contextmenu->actor), 160, 260);
		g_signal_connect(shutdown_button, "activate", G_CALLBACK(applet_menu_shutdown_button_activate), self);
		//added
		g_signal_connect (shutdown_button_actor, "enter-event", G_CALLBACK(on_shutdown_button_enter_event), self);
		g_signal_connect (shutdown_button_actor, "leave-event", G_CALLBACK(on_shutdown_button_leave_event), self);
		g_signal_connect (shutdown_button_actor, "button-press-event", G_CALLBACK(on_shutdown_button_button_press_event), self);
		g_signal_connect (shutdown_button_actor, "button-release-event", G_CALLBACK(on_shutdown_button_button_release_event), self);
		g_signal_connect (priv->contextmenu->actor, "key-press-event", G_CALLBACK(on_contextmenu_key_press_event), self);
		g_signal_connect ((CdosPopupMenuBase *)priv->contextmenu,
		                  "open-state-changed",
		                  G_CALLBACK(on_contextmenu_open_state_changed),
		                  self);

		st_container_add_actor ((ClutterContainer *) uigroup, CLUTTER_ACTOR(priv->contextmenu->actor));

		st_container_add_actor(priv->shutdown_box, shutdown_button_actor);
		st_container_add_actor(actor, CLUTTER_ACTOR(priv->shutdown_box));
		st_container_add_actor(priv->bottom_right_box, CLUTTER_ACTOR(actor));
		//contextmenu item
		cdos_popup_menu_base_add_menu_item((CdosPopupMenuBase *)priv->contextmenu,
				applet_shutdown_contextmenu_item(self, priv->contextmenu, _("Switch User"), SWITCH_USER), -1);
		cdos_popup_menu_base_add_menu_item((CdosPopupMenuBase *)priv->contextmenu,
				applet_shutdown_contextmenu_item(self,priv->contextmenu, _("Log Out..."), LOGOUT), -1);
		cdos_popup_menu_base_add_menu_item((CdosPopupMenuBase *)priv->contextmenu,
				applet_shutdown_contextmenu_item(self, priv->contextmenu, _("Lock Screen"), LOCK_SCREEN), -1);
		cdos_popup_menu_base_add_menu_item((CdosPopupMenuBase *)priv->contextmenu,
				applet_shutdown_contextmenu_item(self, priv->contextmenu, _("Reboot"), REBOOT), -1);
		cdos_popup_menu_base_add_menu_item((CdosPopupMenuBase *)priv->contextmenu,
				applet_shutdown_contextmenu_item(self, priv->contextmenu, _("Suspend"), SUSPEND), -1);
        if(applet_menu_is_laptop())
        {    
            cdos_popup_menu_base_add_menu_item((CdosPopupMenuBase *)priv->contextmenu,
                applet_shutdown_contextmenu_item(self, priv->contextmenu, _("Hibernate"), HIBERNATE), -1);
		}
        cdos_popup_menu_base_add_menu_item((CdosPopupMenuBase *)priv->contextmenu,
				applet_shutdown_contextmenu_item(self, priv->contextmenu, _("Power Off..."), SHUTDOWN), -1);
};

//zhangdj
static void
reset_search (AppletMenu *self)
{
	//g_print ("---->in %s\n", __func__);    /////////调试
	
	AppletMenuPrivate *priv;
	CdosGlobal *global;
	ClutterStage *stage;
	
	priv = self->priv;
	
	st_entry_set_text (priv->search_entry, "");
	priv->search_active = FALSE;
	
	global = cdos_global_get ();
	stage = cdos_global_get_stage (global);
	clutter_stage_set_key_focus (stage, CLUTTER_ACTOR(priv->search_entry));
}

//zhangdj
static void
search_entry_secondary_icon_callback (StEntry *entry, gpointer user_data)
{
	//g_print ("---->in search_entry_secondary_icon_callback\n");   ////////调试
	
	AppletMenu *self;
	
	self = user_data;
	
	reset_search (self);
}

static void
_on_search_text_changed(ClutterText *self, gpointer data)
{
	//g_print ("---->in _on_search_text_changed\n");    ///////调试
	
	//zhangdj
	AppletMenu *menu;
	AppletMenuPrivate *priv;
	const gchar *text;
	
	menu = data;
	priv = menu->priv;
	
	//this._clearSelections是否需要?
	text = st_entry_get_text (priv->search_entry);
	//g_print ("---->text=%s\n", text);    /////调试
	priv->search_active = (g_strcmp0 (text, "") == 0) ? FALSE : TRUE;    //判断字符串是否为空
	
	//g_print ("---->priv->search_active=%s\n", priv->search_active > 0 ? "TRUE" : "FALSE");   /////调试
	if (priv->search_active)
	{
		st_entry_set_secondary_icon(priv->search_entry, CLUTTER_ACTOR(priv->_search_active_icon));
		
		if (priv->search_icon_clicked_id == 0)
		{
			priv->search_icon_clicked_id = g_signal_connect (priv->search_entry,
			                                                 "secondary-icon-clicked",
			                                                 G_CALLBACK(search_entry_secondary_icon_callback), menu);
		}
	}
	else
	{
		if (priv->search_icon_clicked_id > 0)
		{
			g_signal_handler_disconnect (priv->search_entry, priv->search_icon_clicked_id);
		}
		
		priv->search_icon_clicked_id = 0;
		
		st_entry_set_secondary_icon(priv->search_entry, CLUTTER_ACTOR(priv->_search_inactive_icon));
	}
	
	if (!priv->search_active)
	{
		toggle_view (menu, FALSE);
		
		return;
	}
	
	do_search (menu);
}

//added
static GList *
get_selectable_items_list (ClutterActor *container, GList *selectable_items)
{
    GList *children;
    GList *l;
    const gchar *name;
    
    children = clutter_actor_get_children (container);
    
    for (l = children; l != NULL; l = l->next)
    {
        name = clutter_actor_get_name (CLUTTER_ACTOR(l->data));
        //g_print ("name=%s\n", name);  //////调试
        if (g_strcmp0 (name, "label") == 0 || g_strcmp0 (name, "separator") == 0)
        {
            continue;
        }
        
        selectable_items = g_list_append (selectable_items, l->data);
    }
    
    g_list_free (children);
    
    return selectable_items;
}

static GList *
empty_selectable_items_list (GList *selectable_items)
{
   guint length;
   guint index;
   
   length = g_list_length (selectable_items);
   for (index = 0; index < length; index++)
   {
        selectable_items = g_list_remove (selectable_items, g_list_nth_data (selectable_items, index));   
   }
   
   g_list_free (selectable_items);
   selectable_items = NULL;
   
   return selectable_items;
}

static void
item_activate(CdosPopupBaseMenuItem *item)
{
    gboolean retval = FALSE;
    ClutterEvent *event = clutter_event_new (CLUTTER_BUTTON_RELEASE);
    clutter_event_set_button (event, 1);
    cdos_popup_base_menu_item_activate (item, event, cdos_popup_base_menu_item_get_keep_menu(item));
    clutter_event_free (event);
}

static GList *
add_button_actors_to_list (GList *list_with_actors, GList *source_list)
{
    guint length;
    GList *l;
    CdosPopupBaseMenuItem *item;
    CdosGenericContainer *actor;
    
    
    length = g_list_length (source_list);
    
    if (length)
    {
        for (l = source_list; l != NULL; l = l->next)
        {
            item = (CdosPopupBaseMenuItem *)l->data;
            actor = cdos_popup_base_menu_item_get_actor (item);
            list_with_actors = g_list_append (list_with_actors, actor);
        }
    }
    
    return list_with_actors;
}

//刷新类别按钮及应用程序菜单的可选择项
static GList *
categories_refresh (GList *categories_list)
{
    GList *l;
    GList *j;
    GList *new_categories_list = NULL;
    GList *application_menu_items = NULL;
    GList *application_menu_actors = NULL;
    AppletCategoryButton *category_button;
    CdosGenericContainer *actor;
    
    for (l = categories_list; l != NULL; l = l->next)
    {
        category_button = (AppletCategoryButton *)l->data;
        actor = cdos_popup_base_menu_item_get_actor ((CdosPopupBaseMenuItem *)category_button);
        new_categories_list = g_list_append (new_categories_list, actor);
        
        if (CDOS_POPUP_MENU_BASE(category_button->menu)->is_open)
        {
            application_menu_items = cdos_popup_menu_base_get_menu_items (CDOS_POPUP_MENU_BASE(category_button->menu));
            application_menu_actors = add_button_actors_to_list (application_menu_actors, application_menu_items);
            g_list_free (application_menu_items);
            
            for (j = application_menu_actors; j != NULL; j = j->next)
            {
                actor = (CdosGenericContainer *)j->data;
                new_categories_list = g_list_append (new_categories_list, actor);
            }
            
            g_list_free (application_menu_actors);
            application_menu_actors = NULL;
        }
    }
    
    g_list_free (l);
    g_list_free (j);
    
    return new_categories_list;
}

//当鼠标点击搜索框，即焦点在搜索框时，函数_on_menu_key_press才会生效
static gboolean
_on_menu_key_press(ClutterActor *actor, ClutterEvent *event, gpointer data)
{
    //g_print ("in %s\n", __func__);  //////调试
    AppletMenu *applet;
    AppletMenuPrivate *priv;
    guint symbol;
    //added
    CdosGenericContainer *item_actor;
    CdosPopupBaseMenuItem *item;
    gint index;
    gboolean retval;
    
    applet = data;
    priv = applet->priv;
    retval = FALSE;
    
    symbol = clutter_event_get_key_symbol (event);
    
    if (symbol == CLUTTER_KEY_Super_L && CDOS_POPUP_MENU_BASE(applet->menu)->is_open)
    {
    	if (priv->search_active)
    	{
    		toggle_view (applet, FALSE);
    		reset_search (applet);
    	}
    	cdos_popup_menu_close (CDOS_POPUP_MENU_BASE(applet->menu), FALSE);
    	
    	return TRUE;
    }
    else if (symbol == CLUTTER_KEY_Escape && CDOS_POPUP_MENU_BASE(applet->menu)->is_open)
	{
		if (priv->search_active)
		{
			toggle_view (applet, FALSE);
			reset_search (applet);
		}
		cdos_popup_menu_close (CDOS_POPUP_MENU_BASE(applet->menu), FALSE);
		
		return TRUE;
	}
    
    //added
    /*键盘按键选择*/
    item = NULL;
    item_actor = NULL;
    index = priv->selected_item_index;
    clear_previous_selection (applet);
    
    //初始化可选菜单项列表
    if (priv->left_selectable_items)
    {
        priv->left_selectable_items = empty_selectable_items_list (priv->left_selectable_items);
    }
    
    if (!priv->is_in_all_applications)   //开始菜单主界面
    {
        priv->left_selectable_items = get_selectable_items_list (CLUTTER_ACTOR(priv->fav_box), priv->left_selectable_items);
        priv->left_selectable_items = get_selectable_items_list (CLUTTER_ACTOR(priv->recent_box), priv->left_selectable_items);
        priv->left_selectable_items = get_selectable_items_list (CLUTTER_ACTOR(priv->switch_box), priv->left_selectable_items);
    }
    else   //"所有应用程序"界面
    {
        GList *category_actors_list = NULL;
        category_actors_list = categories_refresh (priv->categories_list);
        
        priv->left_selectable_items = g_list_copy_deep (category_actors_list, (GCopyFunc) g_object_ref, NULL);
        g_list_free (category_actors_list);
        priv->left_selectable_items = get_selectable_items_list (CLUTTER_ACTOR(priv->switch_box), priv->left_selectable_items);
        
        //使类目按钮在应用程序菜单展开时能够流畅选择
        if (priv->previous_tree_selected_actor)
        {
            //g_print ("priv->previous_tree_selected_actor\n");  //////调试
            priv->current_active_list = g_list_copy_deep (priv->left_selectable_items, (GCopyFunc) g_object_ref, NULL);
            index = g_list_index (priv->current_active_list, priv->previous_tree_selected_actor);
        }
    }
    
    if (priv->right_selectable_items)
    {
        priv->right_selectable_items = empty_selectable_items_list (priv->right_selectable_items);
    }
    priv->right_selectable_items = get_selectable_items_list (CLUTTER_ACTOR(priv->shortcut_box), priv->right_selectable_items);
    priv->right_selectable_items = get_selectable_items_list (CLUTTER_ACTOR(priv->shutdown_box), priv->right_selectable_items);
    
    if (priv->search_active)   //搜索界面
    {
        GList *search_result_actors_list = NULL;
        
        search_result_actors_list = add_button_actors_to_list (search_result_actors_list, priv->search_result_list);
    
        priv->current_active_list = g_list_copy_deep (search_result_actors_list, (GCopyFunc) g_object_ref, NULL);
        g_list_free (search_result_actors_list);
        
        priv->current_active_list = get_selectable_items_list (CLUTTER_ACTOR(priv->shutdown_box), priv->current_active_list);
    }
    
    if (priv->current_active_list == NULL && symbol == CLUTTER_KEY_Up)
    {
        //g_print ("priv->current_active_list == NULL && symbol == CLUTTER_KEY_Up\n");  //////调试
        priv->current_active_list = g_list_copy_deep (priv->left_selectable_items, (GCopyFunc) g_object_ref, NULL);
        item_actor = (CdosGenericContainer *)g_list_last (priv->left_selectable_items)->data;
        index = g_list_index (priv->left_selectable_items, item_actor);
        
        priv->state = KEY;
    }
    else if (priv->current_active_list == NULL && symbol == CLUTTER_KEY_Down)
    {
        //g_print ("priv->current_active_list == NULL && symbol == CLUTTER_KEY_Down\n");  //////调试
        priv->current_active_list = g_list_copy_deep (priv->left_selectable_items, (GCopyFunc) g_object_ref, NULL);
        item_actor = (CdosGenericContainer *)g_list_first (priv->left_selectable_items)->data;
        index = g_list_index (priv->left_selectable_items, item_actor);
        
        priv->state = KEY;
    }
    else if (priv->current_active_list == NULL && symbol == CLUTTER_KEY_Left)
    {
        //g_print ("priv->current_active_list == NULL && symbol == CLUTTER_KEY_Left\n");  //////调试
        priv->current_active_list = g_list_copy_deep (priv->left_selectable_items, (GCopyFunc) g_object_ref, NULL);
        item_actor = (CdosGenericContainer *)g_list_first (priv->left_selectable_items)->data;
        index = g_list_index (priv->left_selectable_items, item_actor);

        priv->state = KEY;
    }
    else if (priv->current_active_list == NULL && symbol == CLUTTER_KEY_Right)
    {
        //g_print ("priv->current_active_list == NULL && symbol == CLUTTER_KEY_Right\n");  //////调试
        priv->current_active_list = g_list_copy_deep (priv->right_selectable_items, (GCopyFunc) g_object_ref, NULL);
        item_actor = (CdosGenericContainer *)g_list_first (priv->right_selectable_items)->data;
        index = g_list_index (priv->right_selectable_items, item_actor);
        
        priv->state = KEY;
    }
    else if (symbol == CLUTTER_KEY_Up)
    {
        //g_print ("symbol == CLUTTER_KEY_Up\n");  //////调试
        priv->previous_selected_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, index);
        priv->previous_tree_selected_actor = NULL;
        index--;
        item_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, index);
        
        if (index < 0)
        {
            item_actor = (CdosGenericContainer *)g_list_last (priv->current_active_list)->data;
            index = g_list_index (priv->current_active_list, item_actor);
        }
        
        priv->state = KEY;
    }
    else if (symbol == CLUTTER_KEY_Down)
    {
        //g_print ("symbol == CLUTTER_KEY_Down\n");  //////调试
        gint length;
        
        priv->previous_selected_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, index);
        priv->previous_tree_selected_actor = NULL;
        index++;
        item_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, index);
        
        length = g_list_length (priv->current_active_list);
        if (index > length - 1)
        {
            item_actor = (CdosGenericContainer *)g_list_first (priv->current_active_list)->data;
            index = g_list_index (priv->current_active_list, item_actor);
        }
        
        priv->state = KEY;
    }
    else if (symbol == CLUTTER_KEY_Left)
    {
        //g_print ("symbol == CLUTTER_KEY_Left\n");  //////调试
        if (priv->search_active)
        {
            return FALSE;   
        }
        
        priv->previous_selected_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, index);
        priv->current_active_list = empty_selectable_items_list (priv->current_active_list);
        priv->current_active_list = g_list_copy_deep (priv->left_selectable_items, (GCopyFunc) g_object_ref, NULL);
        item_actor = (CdosGenericContainer *)g_list_first (priv->current_active_list)->data;
        index = 0;
        
        priv->state = KEY;
    }
    else if (symbol == CLUTTER_KEY_Right)
    {
        //g_print ("symbol == CLUTTER_KEY_Right\n");  //////调试
        if (priv->search_active)
        {
            return FALSE;   
        }
        
        priv->previous_selected_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, index);
        priv->current_active_list = empty_selectable_items_list (priv->current_active_list);
        priv->current_active_list = g_list_copy_deep (priv->right_selectable_items, (GCopyFunc) g_object_ref, NULL);
        item_actor = (CdosGenericContainer *)g_list_first (priv->current_active_list)->data;
        index = 0;
        
        priv->state = KEY;
    }
    else if (symbol == CLUTTER_KEY_Return || symbol == CLUTTER_KEY_KP_Enter)
    {
         //g_print ("in enter\n");  //////调试
         if (priv->state == KEY)
         {
            item_actor = (CdosGenericContainer *)g_list_nth_data (priv->current_active_list, priv->selected_item_index);
         }
         
         if (priv->state == HOVER)
         {
            //g_print ("in HOVER\n");  //////调试
            if (priv->active_actor)
            {
                item_actor = priv->active_actor;   //鼠标hover开始菜单项时，可以按Enter/回车激活该项
            }
         }
         
         if (item_actor)
         {
            //g_print ("#######in item_actor\n");  //////调试
            item = (CdosPopupBaseMenuItem *)obj_get_delegate (item_actor);  //获取CdosPopupBaseMenuItem对象
            item_activate (item);   //激活选中项
         }
         
         if (item)
         {
             //g_print ("#######in item\n");  //////调试
             const gchar *type_name;
             type_name = G_OBJECT_TYPE_NAME(item);
             if (g_strcmp0 (type_name, "AppletCategoryButton") == 0)
             {
                //之前按Enter/回车选中的类目
                priv->previous_tree_selected_actor = item_actor;
                g_signal_emit_by_name (item_actor, "enter-event", event, &retval);
                
                if (priv->current_active_list)
                {
                    priv->current_active_list = empty_selectable_items_list (priv->current_active_list);
                }
             }
         }
         
         return TRUE;
    }
    else
    {
        return FALSE;
    }
    
    priv->selected_item_index = index;
    if (item_actor)
    {
        g_signal_emit_by_name (item_actor, "enter-event", event, &retval);
    }
    else
    {
        return FALSE;
    }
    
    priv->state = KEY;
    
    return TRUE;
}

static void
applet_menu_search_init(AppletMenu * self){
    AppletMenuPrivate *priv;
    ClutterActor *search_entry_text;
    //gfloat width = 424;
    //gfloat height = 522;
    //gfloat bottom_height = 44;
    
    priv = self->priv;

    st_widget_set_style_class_name(priv->bottom_left_box, "menu-search-box");
    priv->search_entry = g_object_new(ST_TYPE_ENTRY,
                    "name", "menu-search-entry",
                    "style-class", "menu-search-entry",
                    "hint-text", _("Type to search..."),
                    "track-hover", FALSE,
                    "can-focus", TRUE, 
                    NULL);

    priv->_search_active_icon = g_object_new(ST_TYPE_ICON,
                    "style-class", "menu-search-entry-icon",
                    "icon-name", "edit-clear",
                    "icon-type", ST_ICON_SYMBOLIC, 
                    NULL);

    priv->_search_inactive_icon = g_object_new(ST_TYPE_ICON,
                        "style-class", "menu-search-entry-icon",
                        "icon-name", "edit-find",
                        "icon-type", ST_ICON_SYMBOLIC, 
                        NULL);
                        
    //zhangdj
    priv->search_view = g_object_new (ST_TYPE_BOX_LAYOUT,
    	"vertical", TRUE, NULL);
    priv->search_result_box = g_object_new (ST_TYPE_BOX_LAYOUT,
    	"style-class", "menu-search-result-box",
    	"vertical", TRUE, NULL);     //应该是白色
    	
    //g_print ("---->search_result_box=%p\n", priv->search_result_box);    //////调试
    
    //clutter_actor_set_size (CLUTTER_ACTOR(priv->search_result_box), width, height - bottom_height);

    st_entry_set_secondary_icon(priv->search_entry, priv->_search_inactive_icon);
    
    search_entry_text = st_entry_get_clutter_text(priv->search_entry);

    g_signal_connect(search_entry_text, 
                    "text-changed", 
                    G_CALLBACK(_on_search_text_changed), 
                    self);

    g_signal_connect(search_entry_text, 
                    "key-press-event", 
                    G_CALLBACK(_on_menu_key_press), 
                    self);

    _add_actor(priv->bottom_left_box, priv->search_entry);
    _add_actor(priv->search_view, priv->search_result_box);    //zhangdj
    //clutter_actor_add_child (CLUTTER_ACTOR(priv->search_view), CLUTTER_ACTOR(priv->search_result_box)); //zhangdj
    
    //zhangdj
    priv->results_by_category = g_hash_table_new (g_str_hash, g_direct_equal);    //第二个参数是否正确？
}

//added
static gboolean
on_shortcut_item_enter_event (ClutterActor *actor,
                              ClutterEvent *event,
                              gpointer user_data)
{
    //g_print ("in %s\n", __func__);  //////调试
    AppletShortcutItem	*item;
    AppletMenu *applet = user_data;
    AppletMenuPrivate *priv = applet->priv;   
    
    clear_previous_selection (applet);
    priv->previous_selected_actor = (CdosGenericContainer *)actor;
    priv->active_actor = (CdosGenericContainer *)actor;
    item = (AppletShortcutItem	*)obj_get_delegate (actor);
    applet_shortcut_item_set_active (item, TRUE);
    
    priv->state = HOVER;
    
    return TRUE;
}

static gboolean
on_shortcut_item_leave_event (ClutterActor *actor,
                              ClutterEvent *event,
                              AppletShortcutItem	*item)
{
    //g_print ("in %s\n", __func__);  //////调试
    applet_shortcut_item_set_active (item, FALSE);
    
    return TRUE;
}

static CdosGenericContainer *
applet_shortcut_item(AppletMenu *applet,
                     const gchar *label,
                     const gchar *icon_name,
                     gchar *command,
                     GObject *parent,
                     AppletHoverIcon *hover_icon)
{
		AppletShortcutItem	*item = applet_shortcut_item_new (label, icon_name , command , parent, hover_icon);
		//added
		CdosGenericContainer *actor = cdos_popup_base_menu_item_get_actor ((CdosPopupBaseMenuItem*)item);
		g_signal_connect (actor,
		                  "enter-event",
		                  G_CALLBACK(on_shortcut_item_enter_event), applet);
		                  
		g_signal_connect (actor,
		                  "leave-event",
		                  G_CALLBACK(on_shortcut_item_leave_event), item);
		
		return actor;
}

static void
applet_shortcut_init(AppletMenu *self)
{
    AppletMenuPrivate *priv;
    AppletSeparator *separator_1;
    AppletSeparator *separator_2;
    StWidget *actor_1;
    StWidget *actor_2;

    priv = self->priv;
    priv->shortcut_box = g_object_new(ST_TYPE_BOX_LAYOUT, "style-class", "right-buttons-box", "vertical", TRUE, NULL);

    priv->hover_icon = applet_hover_icon_new(self);
    _add_actor(priv->right_pane_box, priv->hover_icon->actor);

    _add_actor(priv->shortcut_box, applet_shortcut_item(self, _("Home"),"folder-home", "nemo", self->menu, priv->hover_icon));
    _add_actor(priv->shortcut_box, applet_shortcut_item(self, _("Documents"),"folder-documents", g_strdup_printf("nemo %s", _("Documents")), self->menu, priv->hover_icon));
    _add_actor(priv->shortcut_box, applet_shortcut_item(self, _("Pictures"),"folder-pictures", g_strdup_printf("nemo %s", _("Pictures")), self->menu, priv->hover_icon));
    _add_actor(priv->shortcut_box, applet_shortcut_item(self, _("Music"),"folder-music", g_strdup_printf("nemo %s", _("Music")), self->menu, priv->hover_icon));
    _add_actor(priv->shortcut_box, applet_shortcut_item(self, _("Videos"),"folder-videos", g_strdup_printf("nemo %s", _("Videos")), self->menu, priv->hover_icon));
    separator_1 = applet_separator_new (NULL);
    actor_1 = applet_separator_get_actor (separator_1);
    st_widget_add_style_class_name (actor_1, "menu-separator-item");
    clutter_actor_set_name (CLUTTER_ACTOR(actor_1), "separator");   //zhangdj
    _add_actor(priv->shortcut_box, actor_1);
    _add_actor(priv->shortcut_box, applet_shortcut_item(self, _("Computer"),"computer", "nemo computer:///", self->menu, priv->hover_icon));
    separator_2 = applet_separator_new (NULL);
    actor_2 = applet_separator_get_actor (separator_2);
    st_widget_add_style_class_name (actor_2, "menu-separator-item");
    clutter_actor_set_name (CLUTTER_ACTOR(actor_2), "separator");   //zhangdj
    _add_actor(priv->shortcut_box, actor_2);
    _add_actor(priv->shortcut_box, applet_shortcut_item(self, _("System Settings"),"control-center2", "cdos-settings", self->menu, priv->hover_icon));
    _add_actor(priv->shortcut_box, applet_shortcut_item(self, _("Terminal"),"terminal", "gnome-terminal", self->menu, priv->hover_icon));
    _add_actor(priv->shortcut_box, applet_shortcut_item(self, _("nfswelcome"),"help", "cdos-welcome", self->menu, priv->hover_icon));

    _add_actor(priv->right_pane_box, priv->shortcut_box);
}

static gboolean
on_favorites_button_enter_event (ClutterActor *actor,
                                 ClutterEvent *event,
                                 gpointer user_data)
{
    //g_print ("in %s\n", __func__);   ///////调试
    AppletMenu *applet = user_data;
    AppletMenuPrivate *priv = applet->priv;
    
    clear_previous_selection (applet);
    priv->previous_selected_actor = (CdosGenericContainer *)actor;
    priv->active_actor = (CdosGenericContainer *)actor;
    st_widget_add_style_pseudo_class (ST_WIDGET(actor), "hover");
    
    priv->state = HOVER;
    
    return TRUE;
}

static gboolean
on_favorites_button_leave_event (ClutterActor *actor,
                                 ClutterEvent *event,
                                 gpointer user_data)
{
    //g_print ("in %s\n", __func__);   ///////调试
    AppletMenu *applet = user_data;
    //AppletMenuPrivate *priv = applet->priv;
    
    st_widget_remove_style_pseudo_class (ST_WIDGET(actor), "hover");
    
    return TRUE;
}

static void
_load_favorites_app(AppletMenu *self)
{
    AppletMenuPrivate *priv;
    CdosGlobal *global;
    GSettings *settings;
    gchar **launchers;
    gint max_launchers;   //added
    //gint show_number;    //added
    CdosAppSystem *app_sys;
    CdosApp *app;
    gint len;
    gint start_num;

    GList *l = NULL;
    gint i;

    priv = self->priv;

    global = cdos_global_get();
    settings = cdos_global_get_settings(global);
    launchers = g_settings_get_strv(settings, "favorite-apps");
    max_launchers = g_settings_get_int (settings, "favorite-apps-max-number");  //added
    //g_print ("---->max_launchers=%d\n", max_launchers);   //////调试
    //show_number = g_settings_get_int (settings, "favorite-apps-show-number");  //added
    app_sys = cdos_app_system_get_default();
    applet_menu_clear_favorite_list(self);

    len = g_strv_length (launchers);
    gchar **removed_apps = NULL;
    gchar **temp_launchers = g_strdupv (launchers);
    gboolean has_removed_flag = FALSE;
    
     if (len < max_launchers)
    {
        start_num = 0;
    }
    else
    {
        start_num = len - max_launchers;
    }
    
    for(i = start_num; i < len; i++)
    {
        gchar *launcher_to_show = g_strdup(launchers[i]);
        //g_print ("---->launcher=%s\n", launcher_to_show);   //////调试
        if (launcher_to_show)
        {
        	app = cdos_app_system_lookup_app(app_sys, launcher_to_show);
        
		    if(!app)
		    	  app = cdos_app_system_lookup_settings_app(app_sys, launcher_to_show);
		}
        if(app){
        	  AppletFavoritesButton *button = applet_favorites_button_new(self, app);
              priv->favorit_list = g_list_append(priv->favorit_list,button);
        	  CdosGenericContainer *actor = cdos_popup_base_menu_item_get_actor(button);
        	  _add_actor(priv->fav_box, actor);
        	  g_signal_connect (actor,
        	                    "enter-event",
        	                    G_CALLBACK(on_favorites_button_enter_event),
        	                    self);
        	                    
        	  g_signal_connect (actor,
        	                    "leave-event",
        	                    G_CALLBACK(on_favorites_button_leave_event),
        	                    self);
        }else{
            has_removed_flag = TRUE;
            gchar **temp = temp_launchers;
            temp_launchers = cdos_strv_elem_del_by_str(temp_launchers, launcher_to_show);
            g_free(temp);
        }
        
        g_free (launcher_to_show);  //added
        launcher_to_show = NULL;
    }
    if(has_removed_flag){
        g_settings_set_strv(settings,"favorite-apps",(const gchar *const *)temp_launchers);
        g_free (temp_launchers);
    }else{
        g_strfreev (temp_launchers);
    }
    g_strfreev (launchers);
}

static void
applet_favorites_init(AppletMenu *self)
{
    AppletMenuPrivate *priv;
    StLabel *fav_label;
    StLabel *rec_label;
    AppletSeparator *fav_separator;
    AppletSeparator *rec_separator;
    CdosDocManager *doc_manager;
    GArray *infosByTimestamp;
    CdosAppSystem *appsys;
    ClutterActor *vscroll;    //added

    //gfloat fav_box_height = 220;
    priv = self->priv;
    
    priv->favs_box = g_object_new(ST_TYPE_BOX_LAYOUT,
                                "style-class" , "menu-favorites-box",
								"vertical", TRUE, 
                                NULL);
                                
	 //zhangdj
    vscroll = st_scroll_view_get_vscroll_bar(priv->favorite_recent_scroll_box);
    g_signal_connect(vscroll, "scroll-start", G_CALLBACK(_on_vscroll_scroll_start_callback), self);
    g_signal_connect(vscroll, "scroll-stop", G_CALLBACK(_on_vscroll_scroll_stop_callback), self);
    st_scroll_view_set_policy(vscroll, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
    _add_actor(priv->favorite_recent_scroll_box,  priv->favs_box);
    
    //favs
    priv->fav_box = g_object_new(ST_TYPE_BOX_LAYOUT, "vertical", TRUE, NULL);
    //clutter_actor_set_size(CLUTTER_ACTOR(priv->fav_box), -1, fav_box_height);
    fav_label = g_object_new(ST_TYPE_LABEL, "style-class", "favorites-label", "text", _("Quick Operation"), NULL);
    clutter_actor_set_name (CLUTTER_ACTOR(fav_label), "label");   //zhangdj
    _add_actor(priv->fav_box, fav_label);

	 fav_separator = applet_separator_new ("menu-favorites-separator");   //zhangdj
	 clutter_actor_set_name (applet_separator_get_actor (fav_separator), "separator");   //zhangdj
  	 _add_actor (priv->fav_box, applet_separator_get_actor (fav_separator));

    CdosAppFavorites *fav =  cdos_app_favorites_get_default();
    g_signal_connect(fav, "changed", G_CALLBACK(_refresh_favorite_apps), self);
    appsys = cdos_app_system_get_default();
    g_signal_connect(appsys, "installed-changed", G_CALLBACK(_refresh_favorite_apps), self);    

    _load_favorites_app(self);

    //recents
    doc_manager = cdos_doc_manager_get_default();

    g_signal_connect(doc_manager, "changed", G_CALLBACK(load_recent_box), self);

    priv->rec_box = g_object_new(ST_TYPE_BOX_LAYOUT, "vertical", TRUE, NULL);

    rec_label = g_object_new(ST_TYPE_LABEL, "style-class", "favorites-label", "text", _("Recent Used"), NULL);
    _add_actor(priv->rec_box, rec_label);
    
    rec_separator = applet_separator_new ("menu-favorites-separator");   //zhangdj
    _add_actor (priv->rec_box, applet_separator_get_actor (rec_separator));

    _add_actor(priv->favs_box, priv->fav_box);

    _add_actor(priv->favs_box, priv->rec_box);
}

static gboolean
applet_menu_check_file_exist(CdosDocInfo *file){

    gchar *uri = cdos_doc_info_get_uri(file);
    if (g_strncasecmp (uri, "smb:", 4) == 0){
        return FALSE;
    }
    GFile *g_file = g_file_new_for_uri(uri);
    gboolean check;
    check = g_file_query_exists(g_file,NULL);
    g_object_unref(g_file);
    return check;
}

static gboolean
on_recent_button_enter_event (ClutterActor *actor,
                              ClutterEvent *event,
                              gpointer user_data)
{
    //g_print ("in %s\n", __func__);   ///////调试
    AppletMenu *applet = user_data;
    AppletMenuPrivate *priv = applet->priv;

    //clear_previous_selection (applet);
    priv->previous_selected_actor = (CdosGenericContainer *)actor;
    priv->active_actor = (CdosGenericContainer *)actor;
    st_widget_add_style_pseudo_class (ST_WIDGET(actor), "hover");
    
    priv->state = HOVER;
    
    return FALSE;
}

static void 
load_recent_box(CdosDocManager *doc_manager, gpointer user_data)
{

    StLabel *rec_label;
    GList *infosByTimestamp;
    AppletRecentButton *rec_button = NULL;

    AppletMenu *menu = APPLET_MENU(user_data);
    AppletMenuPrivate *priv = menu->priv;
    if(priv->recent_box == NULL){
        priv->recent_box = g_object_new(ST_TYPE_BOX_LAYOUT, "vertical", TRUE, NULL);
    }
    applet_menu_clear_recent_list(menu);
    infosByTimestamp = cdos_doc_manager_get_time_stamp_ordered_infos(doc_manager);

    //gint len = g_list_length(infosByTimestamp);

    if(infosByTimestamp)
    {
        gint temp = 0;
        while (infosByTimestamp != NULL){
            CdosDocInfo *file = infosByTimestamp->data;
            if (applet_menu_check_file_exist(file)){
                //StLabel *label = applet_recent_button_get_label(rec_button);
                //st_widget_set_style(ST_WIDGET(label),"color:#666;text-decoration:line-through;max-width:14em;");
                temp++;
                if(temp < 8){
                    rec_button = applet_recent_button_new(menu, file);
                    priv->recent_list = g_list_append(priv->recent_list,rec_button);
                    CdosGenericContainer *rec_actor = cdos_popup_base_menu_item_get_actor(rec_button);
                    _add_actor(priv->recent_box, rec_actor);
                    /*
                    g_signal_connect (rec_actor,
        	                    "enter-event",
        	                    G_CALLBACK(on_recent_button_enter_event),
        	                    menu);
        	                    
        	        g_signal_connect (rec_actor,
        	                    "leave-event",
        	                    G_CALLBACK(on_recent_button_leave_event),
        	                    menu);
                    */
                }else{
                    break;
                }
            }
            infosByTimestamp = infosByTimestamp->next;
        }
    }
    _add_actor(priv->rec_box, priv->recent_box);
}

static void
_refresh_recent (AppletMenu *self)
{
	CdosDocManager *doc_manager;
	
	doc_manager = cdos_doc_manager_get_default ();
	
	load_recent_box (doc_manager, self);
}

static void
on_icon_theme_changed (StTextureCache *texture_cache, gpointer user_data)
{
	AppletMenu *applet;
	
	applet = user_data;
	
	applet_all_applications_refresh (NULL, applet);
	_refresh_favorite_apps (NULL, applet);
	_refresh_recent (applet);
}

static void _on_switch_button_state_changed(AppletMenuSwitchs *obj, guint status, gpointer data)
{
	AppletMenu *self = data;
	AppletMenuPrivate *priv = self->priv;
    if(status == 0){
		clutter_actor_hide(priv->favs_box);
		clutter_actor_hide(priv->favorite_recent_scroll_box);  //added
		clutter_actor_show(priv->categories_scroll_box);
		priv->is_in_all_applications = TRUE;
    } else {
        clutter_actor_hide(priv->categories_scroll_box);
        clutter_actor_show(priv->favs_box);
        clutter_actor_show(priv->favorite_recent_scroll_box);  //added
        priv->is_in_all_applications = FALSE;
    }
    
    clear_selection (self);  //added
    if (priv->current_active_list)
    {
        priv->current_active_list = empty_selectable_items_list (priv->current_active_list);
    }
    priv->previous_selected_actor = NULL;
    priv->previous_tree_selected_actor = NULL;
    priv->active_actor = NULL;
    priv->selected_item_index = -1;
    priv->state = EMPTY;
}

//added
static gboolean
on_switch_button_enter_event (ClutterActor *actor,
                              ClutterEvent *event,
                              gpointer user_data)
{
    //g_print ("---->in %s\n", __func__);    ///////调试
    AppletMenu *applet;
    AppletMenuPrivate *priv;
    AppletMenuSwitchs *menu_switch;
    
    applet = user_data;
    priv = applet->priv;
    
    clear_previous_selection (applet);
    priv->previous_selected_actor = (CdosGenericContainer *)actor;
    priv->active_actor = (CdosGenericContainer *)actor;
    menu_switch = (AppletMenuSwitchs *)obj_get_delegate (actor);
    g_signal_emit_by_name(menu_switch, "active-changed", TRUE);
    
    priv->state = HOVER;
    
    return TRUE;
}

static gboolean
on_switch_button_leave_event (ClutterActor *actor,
                              ClutterEvent *event,
                              gpointer user_data)
{
    //g_print ("---->in %s\n", __func__);    ///////调试
    AppletMenuSwitchs *menu_switch;
    
    menu_switch = (AppletMenuSwitchs *)obj_get_delegate (actor);
    g_signal_emit_by_name(menu_switch, "active-changed", FALSE);
    
    return TRUE;
}

static void
applet_menu_switch_init(AppletMenu *self)
{
    AppletMenuPrivate *priv;
    AppletMenuSwitchs *switch_button;
    ClutterActor *actor;
    AppletSeparator *separator;

    priv = self->priv;
    switch_button = applet_menu_switchs_new();
    actor = applet_menu_switchs_get_actor (switch_button);   //zhangdj
    
    separator = applet_separator_new ("menu-favorites-separator");   //zhangdj
    clutter_actor_set_name (applet_separator_get_actor (separator), "separator");   //zhangdj
  	_add_actor(priv->switch_box, applet_separator_get_actor (separator));

    _add_actor(priv->switch_box, applet_menu_switchs_get_actor(switch_button));
    g_signal_connect(switch_button, "state-changed", G_CALLBACK(_on_switch_button_state_changed),self);
    //added
    g_signal_connect (actor, "enter-event", G_CALLBACK(on_switch_button_enter_event), self);
    g_signal_connect (actor, "leave-event", G_CALLBACK(on_switch_button_leave_event), self);
}

static void
_on_vscroll_scroll_start_callback(ClutterActor *vscroll, gpointer data)
{
	AppletMenu *self = data;
	CDOS_POPUP_MENU_BASE(self->menu)->pass_events  = TRUE;
}

static void
_on_vscroll_scroll_stop_callback(ClutterActor *vscroll, gpointer data)
{
	AppletMenu *self = data;
	CDOS_POPUP_MENU_BASE(self->menu)->pass_events  = FALSE;
}

static void
_load_category(AppletMenu *self, GMenuTreeDirectory *dir, GMenuTreeDirectory *top_dir)
{
    AppletMenuPrivate *priv;
    CdosAppSystem *appsys;
    GMenuTreeIter *iter;
    GMenuTreeItemType nextType;
    GMenuTreeEntry *entry;
    GDesktopAppInfo *appInfo;
    CdosApp *app;
    gchar *menu_id;
    GArray *category_apps;

    priv = self->priv;
    appsys = cdos_app_system_get_default();
    iter = gmenu_tree_directory_iter(dir);
    if(!top_dir) top_dir = dir;

    while((nextType = gmenu_tree_iter_next(iter)) != GMENU_TREE_ITEM_INVALID)
    {
    	if(nextType == GMENU_TREE_ITEM_ENTRY)
    	{
    		entry = gmenu_tree_iter_get_entry(iter);
    		appInfo = gmenu_tree_entry_get_app_info(entry);
    		if(!g_desktop_app_info_get_nodisplay(appInfo))
    		{
    			//类目和应用程序列表保存到HashTable   //zhangdj
    			app = cdos_app_system_lookup_app_by_tree_entry(appsys, entry);
    			//menu_id = gmenu_tree_directory_get_menu_id(top_dir);    //是否恢复
    			menu_id = gmenu_tree_directory_get_name(top_dir);
    			//g_print ("---->in _load_category:menu_id=%s\n", menu_id);    ///////调试
    			if(!app)
    				app = cdos_app_system_lookup_settings_app_by_tree_entry(appsys, entry);
    			if(!g_hash_table_contains(priv->applications_by_category, menu_id))
    			{
    				g_hash_table_insert(priv->applications_by_category, menu_id, g_array_new(TRUE, TRUE, sizeof(CdosApp *)));
    			}
    			category_apps = g_hash_table_lookup(priv->applications_by_category, menu_id);
    			g_array_append_val(category_apps, app);
    		}
    	}else if(nextType == GMENU_TREE_ITEM_DIRECTORY)
    	{
    		_load_category(self, gmenu_tree_iter_get_directory(iter), top_dir);
    	}
    }
}

static GArray *
_list_applications(AppletMenu *self, gchar *menu_id)
{
    AppletMenuPrivate *priv;
	GArray *applist = NULL;

    priv = self->priv;
	if(menu_id)
		applist = g_hash_table_lookup(priv->applications_by_category, menu_id);

	return applist;
}

static gboolean
_application_button_enter_event (ClutterActor *actor, ClutterEvent *event, gpointer user_data)
{
	//g_print ("++++++++++++++in %s,    file: %s\n", __func__, __FILE__);    ////////调试
	AppletMenu *applet;
	AppletMenuPrivate *priv;
	
	applet = user_data;
	priv = applet->priv;
	
	clear_previous_selection (applet);
    priv->previous_selected_actor = (CdosGenericContainer *)actor;
	priv->active_actor = (CdosGenericContainer *)actor;
	//st_widget_add_style_class_name(ST_WIDGET(actor), "menu-application-button-selected");
	st_widget_add_style_pseudo_class (ST_WIDGET(actor), "hover");
	
	priv->state = HOVER;
	
	return TRUE;
}

static gboolean
_application_button_leave_event (ClutterActor *actor, ClutterEvent *event, gpointer user_data)
{
	//g_print ("++++++++++++++in %s,    file: %s\n", __func__, __FILE__);    ////////调试
	//AppletApplicationButton *application_button = user_data;
	//st_widget_remove_style_class_name(ST_WIDGET(actor), "menu-application-button-selected");
	st_widget_remove_style_pseudo_class (ST_WIDGET(actor), "hover");
	return TRUE;
}

/*显示应用程序列表*/
static void
_display_buttons (AppletMenu *self, GArray *apps, AppletCategoryButton *category_button, gboolean is_sub)
{
	AppletApplicationButton *application_button;
	gint i;
	CdosApp *app;
	CdosGenericContainer *actor;
    AppletMenuPrivate *priv = self->priv;
	if(apps)
	{
		for(i = 0; i < apps->len; i++)
		{
			app = g_array_index(apps, CdosApp *, i);
			application_button = applet_application_button_new(self, app);
			actor = cdos_popup_base_menu_item_get_actor(CDOS_POPUP_BASE_MENU_ITEM(application_button));
			if(is_sub)
				st_widget_add_style_class_name(ST_WIDGET(actor),"sub");

			g_signal_connect(actor, "enter-event", G_CALLBACK(_application_button_enter_event), self);
			g_signal_connect(actor, "leave-event", G_CALLBACK(_application_button_leave_event), self);
			cdos_popup_menu_base_add_menu_item(CDOS_POPUP_MENU_BASE(category_button->menu), CDOS_POPUP_BASE_MENU_ITEM(application_button), -1);
            priv->apps_list = g_list_append(priv->apps_list,application_button);
		}
	}
}

static gboolean
_category_button_enter_event (ClutterActor *actor, ClutterEvent *event, gpointer user_data)
{
	//g_print ("++++in %s\n", __func__);    ///////调试
	AppletMenu *applet;
	AppletMenuPrivate *priv;
	
	applet = user_data;
	priv = applet->priv;
	
	clear_previous_selection (applet);
    priv->previous_selected_actor = (CdosGenericContainer *)actor;
	priv->active_actor = (CdosGenericContainer *)actor;
	st_widget_add_style_class_name(ST_WIDGET(actor), "menu-category-button-hover");
	
	priv->state = HOVER;
	
	return TRUE;
}

static gboolean
_category_button_leave_event (ClutterActor *actor, ClutterEvent *event, gpointer user_data)
{
	AppletCategoryButton *category_button = user_data;
	st_widget_remove_style_class_name(ST_WIDGET(actor), "menu-category-button-hover");
	return TRUE;
}

/*test*/
static void
show_hash_table (GHashTable *table)
{
	g_print ("\n---->in show_hash_table\n");
	
	GList *keys;
	GList *l;
	gchar *id;
	GArray *apps;
	gint i;
	CdosApp *app;
	gchar *name;
	
	keys = g_hash_table_get_keys (table);
	
	for (l = keys; l != NULL; l = l->next)
	{
		id = (gchar *)l->data;
		//g_print ("id=%s\n", id);
		
		apps = g_hash_table_lookup (table, id);
		
		for (i = 0; i < apps->len; i++)
		{
			app = g_array_index (apps, CdosApp *, i);
			name = cdos_app_get_name  (app);
			//g_print ("name=%s\n", name);
		}
	}
	
	//g_print ("\n");
}

//zhangdj
static void
app_name_to_pinyin (gchar *app_name, gboolean capitalize, char *res, unsigned int size)
{
  if (app_name && size > 0)
	gbcode_get_full_pinyin (app_name, capitalize, res, size);
}

//zhangdj
/*从应用程序名中查找指定字符串*/
static gboolean
from_app_name_match_string (gchar *pattern, gchar *app_name)
{
	GRegex *regex;
	GError *error;
	GMatchInfo *match_info;
	
	error = NULL;
	
	regex = g_regex_new (pattern, G_REGEX_CASELESS, 0, &error);   //忽略大小写
	
	g_regex_match (regex, app_name, 0, &match_info);
	
	if (g_match_info_matches (match_info))
	{
		g_match_info_free (match_info);
		g_regex_unref (regex);
		
		return TRUE;
	}
	else
	{
		g_match_info_free (match_info);
		g_regex_unref (regex);
		
		return FALSE;
	}
}

//zhangdj
/*从HashTable中查找含有指定字符串的应用*/
static GHashTable *
list_applications_group_by_category (AppletMenu *self, gchar *pattern)    //没问题
{
	//g_print ("---->in list_applications_group_by_category\n");     ////////调试
	
	AppletMenuPrivate *priv;
	GList *keys;
	GList *l;
	GArray *category_apps;
	gchar *menu_id;
	gint i;
	CdosApp *app;
	const gchar *name;
	gboolean match;
	gboolean match_pinyin;
	GArray *results_app;
	
	priv = self->priv;
	
	g_hash_table_remove_all (priv->results_by_category);
	
	keys = g_hash_table_get_keys (priv->applications_by_category);
	
	for (l = keys; l != NULL; l = l->next)   //遍历menu_id
	{
		menu_id = (gchar *)l->data;
		//g_print ("---->menu_id=%s\n", menu_id);    ///////调试
		category_apps = g_hash_table_lookup (priv->applications_by_category, menu_id);
		
		for (i = 0; i < category_apps->len; i++)   //遍历GArray
		{
			gchar name_to_pinyin[255] = {0, };
			app = g_array_index (category_apps, CdosApp *, i);
			name = cdos_app_get_name  (app);   //获取应用的名称
			app_name_to_pinyin (name, FALSE, name_to_pinyin, 255);
			//g_print ("---->name=%s\n", name);    ///////调试
			//g_print ("----name_to_pinyin=%s\n", name_to_pinyin);    ///////调试
			//g_print ("pattern1=%s\n", pattern);   ///////调试
			
			match = from_app_name_match_string (pattern, name);
			match_pinyin = from_app_name_match_string (pattern, name_to_pinyin);
			//g_print ("---->match=%s\n", match > 0 ? "TRUE" : "FALSE");     ///////调试
			//g_print ("---->match_pinyin=%s\n", match_pinyin > 0 ? "TRUE" : "FALSE");     ///////调试
			
			//查找到指定字符串
			if (match || match_pinyin)
			{
				//g_print ("---->in match\n");     ///////调试
				/*
				results_app = g_array_new (TRUE, TRUE, sizeof(CdosApp *));
				g_array_append_val (results_app, app);
				*/
				
				if(!g_hash_table_contains(priv->results_by_category, menu_id))
				{
					g_hash_table_insert (priv->results_by_category, menu_id, g_array_new (TRUE, TRUE, sizeof(CdosApp *)));
					//g_print ("---->run g_hash_table_insert\n");     ///////调试
				}
				
				results_app = g_hash_table_lookup (priv->results_by_category, menu_id);
				//g_print ("---->run g_hash_table_lookup\n");     ///////调试
				g_array_append_val (results_app, app);
				//g_print ("---->run g_array_append_val\n");     ///////调试
			}
		}
	}
	
	g_list_free (keys);
	
	//g_print ("\n---->show results_by_category\n");   ///////调试
	//show_hash_table (priv->results_by_category);  ///////调试
	
	return priv->results_by_category;
}

//zhangdj
static void
get_menu_id (gpointer key, gpointer value, gpointer user_data)
{
	//g_print ("---->in get_menu_id\n");      ////////调试
	
	AppletMenu *menu;
	AppletMenuPrivate *priv;
	
	menu = user_data;
	priv = menu->priv;
	
	//g_print ("---->key=%s\n", (gchar *)key);   ////////调试
	
	priv->menu_id = (gchar *)key;
}

//zhangdj
/*去除字符串左右两端的空格*/
static gchar *
remove_left_and_right_spaces (gchar *str)
{
	gint len;
	gint i;
	gchar *new_str;
	
	len = strlen (str);
	//g_print ("---->len=%d\n", len);   /////////调试
	
	i = 0;
	
	while (*(str + i) == ' ')
	{
		i++;
	}
	
	//输入的全是空格
	if (i == len)
	{
		new_str = " ";
		return new_str;
	}
	
    new_str = g_strdup (str);
    new_str = g_strstrip (new_str);
	
	return new_str;
}

static gchar *
applet_menu_get_search_pattern(gchar *pattern) {
    //if(g_str_equal(pattern," ") == TRUE){
        //return pattern;
    //}
    gint i = 0,j = 0,k = 0;
    gint len = strlen (pattern);
    gchar *temp = (gchar *)g_malloc0 (sizeof(gchar) * len * 2 + 3);
    gchar p[] = {'$','(',')','*','+','.','[',']','{','}','?','\\','|','^'};
    
    *(temp + k) = '(';
    k = 1;
    gboolean flag = FALSE;
    while (i<len && *(pattern + i) != '\0'){
    	gchar c = *(pattern+i);
        flag = FALSE;
        j = 0;
        while (j < sizeof(p)){
            gchar t = p[j];
            if(c == t){
                flag = TRUE;
                break;
            }
            j++;
        }
        if(flag == TRUE){
            *(temp+k) = '\\';
            *(temp+k+1) = *(pattern+i);
            k = k+2;
        }else{
            *(temp+k) = *(pattern+i);
            k++;
        }
        i++;
    }
    
    *(temp + k) = ')';
    *(temp + k + 1) = '\0';
    gchar *new_str = g_strdup (temp);
    g_free(temp);
    return new_str;
}

//zhangdj
/*搜索应用程序*/
static gboolean
do_search (AppletMenu *self)
{
    //g_print ("---->in do_search\n");      ////////调试
    
    AppletMenuPrivate *priv;
    const gchar *text;
    gchar *pattern;
    StBoxLayout *vbox;
    gfloat vbox_height;
    gfloat search_result_box_height;
    gfloat max_height;
    gfloat label_height;
    gfloat separator_height;
    gfloat button_height;
    gfloat natural_height;
    GHashTable *search_result;
    StLabel *no_result_label;
    StLabel *label;
    AppletSeparator *separator;
    StBin *bin;
    GList *keys;
    GList *l;
    gchar *category_name;
    GArray *result_apps;
    gint i;
    CdosApp *app;
    AppletSearchResultButton *search_result_button;
    ClutterActor *actor;
    
    priv = self->priv;
    
    //added
	if (priv->search_result_list)
	{
	    priv->search_result_list = empty_selectable_items_list (priv->search_result_list);
	}
    //added end
    
    toggle_view (self, TRUE);
    
    text = st_entry_get_text (priv->search_entry);
    //g_print ("---->text1=%s\n", text);   ////////调试
    
    if (g_strcmp0 (text, " ") ==0)
    {
    	pattern = text;
    }
    else
    {
    	pattern = remove_left_and_right_spaces (text);
    }

    if (g_str_equal(pattern," ") == TRUE) {
        toggle_view (self, FALSE);
    
        return FALSE;
    }

    gchar *new_pattern = applet_menu_get_search_pattern(pattern);
    //g_print ("---->new_pattern = %s\n", new_pattern);   ////////调试


    //g_print ("---->pattern=%s\n", pattern);   ////////调试
    applet_menu_clear_search_result_list(self);
    //clutter_actor_destroy_all_children (CLUTTER_ACTOR(priv->search_result_box));
    
    //输入的英文字符不得超过255
    if (strlen (text) > 255)
    {
    	vbox = g_object_new (ST_TYPE_BOX_LAYOUT,
    	                     "vertical", TRUE, NULL);
    	                     
    	st_box_layout_insert_actor (priv->search_result_box, CLUTTER_ACTOR(vbox), -1);
    	
    	no_result_label = g_object_new (ST_TYPE_LABEL, 
   		                                "text", _("Input characters must less than 255!"), NULL);
   		                                
   		bin = g_object_new (ST_TYPE_BIN, 
   		                    "style-class", "menu-search-result-label", NULL);
   		                    
   		st_bin_set_child (bin, CLUTTER_ACTOR(no_result_label));
   		st_box_layout_insert_actor (vbox, CLUTTER_ACTOR(bin), -1);
   		
   		return FALSE;
    }
    
    vbox = g_object_new (ST_TYPE_BOX_LAYOUT,
    	                 "vertical", TRUE, NULL);
    	                 
   	st_box_layout_insert_actor (priv->search_result_box, CLUTTER_ACTOR(vbox), -1);   //change
   	
   	search_result_box_height = clutter_actor_get_height (CLUTTER_ACTOR(priv->search_result_box));
   	vbox_height = search_result_box_height - 30;
   	
   	priv->menu_id = NULL;
   	
   	search_result = list_applications_group_by_category (self, new_pattern);
   	/*
   	g_print ("\n---->show search_result\n");  ////////调试
   	show_hash_table (search_result);   ////////调试
   	g_print ("\n");   ////////调试
   	*/
   	g_hash_table_foreach (search_result, (GHFunc)get_menu_id, self);
   	
   	//g_print ("---->priv->menu_id=%s\n", priv->menu_id);    ////////调试
   	if (!priv->menu_id)   //无搜索结果
   	{
   		no_result_label = g_object_new (ST_TYPE_LABEL, 
   		                                "text", _("No match for search terms"), NULL);
   		                                
   		bin = g_object_new (ST_TYPE_BIN, 
   		                    "style-class", "menu-search-result-label", NULL);
   		                    
   		st_bin_set_child (bin, CLUTTER_ACTOR(no_result_label));
   		st_box_layout_insert_actor (vbox, CLUTTER_ACTOR(bin), -1);   //change
   		
   		return FALSE;
   	}
   	
   	max_height = vbox_height - 30;
   	label_height = 24;
   	separator_height = 9;
   	button_height = 26;
   	natural_height = 0;
   	
   	//显示搜索结果
   	keys = g_hash_table_get_keys (search_result);
   	
   	for (l = keys; l != NULL; l = l->next)
   	{
   		natural_height += (label_height + separator_height);
   		if (natural_height >= max_height)
   		{
   			break;
   		}
   		
   		//标签
   		category_name = (gchar *)l->data;
   		label = g_object_new (ST_TYPE_LABEL,
   		                      "text", category_name,
   		                      "style-class", "favorites-label", NULL);
   		                      
   		st_box_layout_insert_actor (vbox, CLUTTER_ACTOR(label), -1);   //change
   		
   		separator = applet_separator_new ("menu-favorites-separator");
   		st_box_layout_insert_actor (vbox, CLUTTER_ACTOR(applet_separator_get_actor (separator)), -1);
   		
   		result_apps = g_hash_table_lookup (search_result, category_name);
   		
   		for (i = 0; i < result_apps->len; i++)
   		{
   			natural_height += button_height;
   			if (natural_height >= max_height)
   			{
   				break;
   			}
   			
   			app = g_array_index (result_apps, CdosApp *, i);
   			//g_print ("app name=%s\n", cdos_app_get_name(app));        ////////调试
   			
   			search_result_button = applet_search_result_button_new (self, app);    //应用按钮
   			
   			actor = CLUTTER_ACTOR(cdos_popup_base_menu_item_get_actor (CDOS_POPUP_BASE_MENU_ITEM (search_result_button)));

   			st_box_layout_insert_actor (vbox, actor, -1);   //change
          priv->search_result_list = g_list_append (priv->search_result_list, search_result_button);
   		}
   	}
   	
   	return TRUE;
}

static void 
applet_all_applications_refresh(CdosAppSystem *self, gpointer user_data)
{

	AppletCategoryButton *category_button;

	CdosGenericContainer *actor;

	 AppletMenuPrivate *priv;
    ClutterActor *vscroll;
    StBoxLayout *apps_box;

    CdosAppSystem *appsys;
    GMenuTree *tree;
    GMenuTreeDirectory *root;
    GMenuTreeIter *iter;
    GMenuTreeItemType nextType;
    GMenuTreeDirectory *dir;
    gchar *menu_id;
    GArray *category_apps;
    priv = APPLET_MENU(user_data)->priv;

    if (priv->categories_box == NULL) {
    	//clutter_actor_destroy(priv->categories_box);
        priv->categories_box = g_object_new(ST_TYPE_BOX_LAYOUT,"vertical", TRUE,
                                            "style-class", "menu-categories-box", NULL);
    }
    applet_menu_clear_apps_list(APPLET_MENU(user_data));

    _add_actor(priv->category_box, priv->categories_box);

	appsys = cdos_app_system_get_default();
    tree = cdos_app_system_get_tree(appsys);
    root = gmenu_tree_get_root_directory(tree);
    iter = gmenu_tree_directory_iter(root);
    priv->applications_by_category = g_hash_table_new(g_str_hash, g_direct_equal);
    while((nextType = gmenu_tree_iter_next(iter)) != GMENU_TREE_ITEM_INVALID)
    {
    	if(nextType == GMENU_TREE_ITEM_DIRECTORY)
    	{
    		dir = gmenu_tree_iter_get_directory(iter);
    		menu_id = gmenu_tree_directory_get_name(dir);
    		if(gmenu_tree_directory_get_is_nodisplay(dir) || menu_id == "Preferences")
    			continue;
    		g_hash_table_insert(priv->applications_by_category, menu_id, g_array_new(TRUE, TRUE, sizeof(CdosApp *)));
    		_load_category(user_data, dir, NULL);

    		category_apps = g_hash_table_lookup(priv->applications_by_category, menu_id);

    		if(category_apps->len)
    		{
    			category_button = applet_category_button_new(dir);
    			actor = cdos_popup_base_menu_item_get_actor(CDOS_POPUP_BASE_MENU_ITEM(category_button));
    			g_signal_connect(actor, "enter-event", G_CALLBACK(_category_button_enter_event), user_data);
    			g_signal_connect(actor, "leave-event", G_CALLBACK(_category_button_leave_event), user_data);
    			_add_actor(priv->categories_box, actor);
    			_add_actor( priv->categories_box, category_button->menu->actor);
    			_display_buttons(user_data, _list_applications(user_data, menu_id), category_button, TRUE);
                priv->categories_list = g_list_append(priv->categories_list,category_button);
    		}
    	}
    }
}

static void
applet_all_applications_init(AppletMenu *self)
{
    AppletMenuPrivate *priv;
    ClutterActor *vscroll;
    StBoxLayout *apps_box;
    StLabel *label;
    AppletSeparator *separator;
    CdosAppSystem *appsys;
    //GMenuTreeItemType nextType;
    //GMenuTreeDirectory *dir;
    //gchar *menu_id;
    //GArray *category_apps;



    priv = self->priv;
    priv->category_box = g_object_new(ST_TYPE_BOX_LAYOUT,"vertical", TRUE,
    							"style-class", "menu-categories-box", NULL);

    priv->categories_box = NULL;
    vscroll = st_scroll_view_get_vscroll_bar(priv->categories_scroll_box);
    g_signal_connect(vscroll, "scroll-start", G_CALLBACK(_on_vscroll_scroll_start_callback), self);
    g_signal_connect(vscroll, "scroll-stop", G_CALLBACK(_on_vscroll_scroll_stop_callback), self);
    st_scroll_view_set_policy(vscroll, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
    _add_actor(priv->categories_scroll_box,  priv->category_box);

    
    label = g_object_new(ST_TYPE_LABEL, "text", _("All Applications"),
    		        	"style-class", "favorites-label", NULL);

	apps_box = g_object_new(ST_TYPE_BOX_LAYOUT, "vertical", TRUE, NULL);
    _add_actor(apps_box, label);
    separator = applet_separator_new ("menu-favorites-separator");
    _add_actor(apps_box, applet_separator_get_actor (separator));
    _add_actor(priv->category_box, apps_box);
    

    appsys = cdos_app_system_get_default();
    g_signal_connect(appsys, "installed-changed", G_CALLBACK(applet_all_applications_refresh), self);
    applet_all_applications_refresh(NULL, self);
}

//清除之前选中项
//确保使用鼠标或键盘操作时，只有被操作项处于选中状态
void
clear_previous_selection (AppletMenu *applet)
{
    //g_print ("in %s\n", __func__);  //////调试
    AppletMenuPrivate *priv;
    gboolean retval;
    ClutterEvent *event;
    //gpointer item_selected;
    //const gchar *type_name;
    
    priv = applet->priv;
    
    retval = FALSE;
    event = clutter_event_new (CLUTTER_BUTTON_RELEASE);
    
    if (priv->previous_selected_actor)
    {
        /*
        item_selected = obj_get_delegate (priv->previous_selected_actor);
        type_name = G_OBJECT_TYPE_NAME(item_selected);
        //g_print ("type_name=%s\n", G_OBJECT_TYPE_NAME(item_selected));  //////调试
        
        if (g_strcmp0 (type_name, "AppletFavoritesButton") == 0 || g_strcmp0 (type_name, "AppletRecentButton") == 0)
        {
           st_widget_remove_style_pseudo_class (ST_WIDGET(priv->previous_selected_actor), "hover");
           st_widget_set_style_class_name (ST_WIDGET(priv->previous_selected_actor), "menu-favorites-button"); 
        }
        */
        
        g_signal_emit_by_name (priv->previous_selected_actor, "leave-event", event, &retval);
    }
    
    clutter_event_free (event);
}

//added
//清除键盘当前选中项
static void
clear_selection (AppletMenu *self)
{
    //g_print ("---->in %s\n", __func__);      ////////调试
    ClutterActor *item_actor = NULL;
    gpointer selected = NULL;
    //gpointer item_selected;
    const gchar *type_name;
    
    AppletMenuPrivate *priv = self->priv;
    gboolean retval = FALSE;
    ClutterEvent *event = clutter_event_new (CLUTTER_BUTTON_RELEASE);
    guint length = g_list_length (priv->current_active_list);
    //g_print ("length=%u\n", length);      ////////调试
    //item_actor = (ClutterActor *)g_list_nth_data (priv->current_active_list, priv->selected_item_index);
    selected = g_list_nth_data (priv->current_active_list, priv->selected_item_index);
    if (selected)
    {
        //g_print ("in selected\n");      ////////调试
        item_actor = (ClutterActor *)selected;
    }
    else
    {
        //按过Enter/回车键之后被选中的类目
        if (priv->is_in_all_applications)
        {
            if (priv->previous_tree_selected_actor)
            {
                item_actor = (ClutterActor *)priv->previous_tree_selected_actor;
            }
        }
    }
    
    if (item_actor)
    {
        /*
        item_selected = obj_get_delegate (item_actor);
        type_name = G_OBJECT_TYPE_NAME(item_selected);
        if (g_strcmp0 (type_name, "AppletFavoritesButton") == 0 || g_strcmp0 (type_name, "AppletRecentButton") == 0)
        {
           st_widget_remove_style_pseudo_class (ST_WIDGET(item_actor), "hover");
           st_widget_set_style_class_name (ST_WIDGET(item_actor), "menu-favorites-button"); 
        }
        */
        g_signal_emit_by_name (item_actor, "leave-event", event, &retval);
    }
    
    if (length)
    {
        priv->current_active_list = empty_selectable_items_list (priv->current_active_list);
    }
    
    clutter_event_free (event);
}

static void
_on_menu_open_state_changed(CdosPopupMenu * menu, gboolean open, gpointer user_data)
{
	//g_print ("---->in %s\n", __func__);      ////////调试
	AppletMenu *applet_menu = user_data;
    AppletMenuPrivate *priv;
	CdosGlobal *global = cdos_global_get();
	ClutterStage *stage = cdos_global_get_stage(global);
    priv = applet_menu->priv;
    if(open)
    	clutter_stage_set_key_focus(stage, priv->search_entry);
    	
    clear_selection (applet_menu);  //added
    if (priv->current_active_list)
    {
        priv->current_active_list = empty_selectable_items_list (priv->current_active_list);
    }
    priv->previous_selected_actor = NULL;
    priv->previous_tree_selected_actor = NULL;
    priv->active_actor = NULL;
    priv->selected_item_index = -1;
    priv->state = EMPTY;
}

static void
_on_favorite_apps_changed(GSettings *settings, gchar *key, gpointer *user_data)
{
	AppletMenu *applet = user_data;
	_load_favorites_app(applet);
}

static void
_refresh_favorite_apps(GSettings *settings, gpointer *user_data)
{
	AppletMenu *applet = user_data;
	_load_favorites_app(applet);
}


gboolean
applet_menu_on_applet_clicked(StBoxLayout *actor,  ClutterEvent *event, gpointer data){
    //g_print ("in %s\n", __func__);   ///////调试
    AppletMenu *applet = data;
    AppletMenuPrivate *priv = applet->priv;
    guint event_type;
    gfloat x, y;

    clutter_event_get_coords(event, &x, &y);
    event_type = clutter_event_get_button (event);
    if(event_type == 1){
//        cdos_popup_menu_open_to_x_y(applet->menu, TRUE, 1, 180);
	    if (priv->search_active)
	    {
	        toggle_view (applet, FALSE);  //zhangdj
	        reset_search (applet);  //zhangdj
	    }
	    //cdos_popup_menu_base_toggle(CDOS_POPUP_MENU_BASE(applet->menu));  //zhangdj
    }
	return TRUE;
}

/*
 * overlay-key 也就是 super-L 和 super-R
 * */
static void
_on_overlay_key_pressed (MetaDisplay *display, gpointer user_data)
{
    AppletMenu *applet;
    AppletMenuPrivate *priv;

    //zhangdj
    CdosPopupMenu *generic_application_button_popup;
    CdosPopupMenu *recent_button_popup;

    applet = user_data;
    priv = applet->priv;
    if (cdos_get_action_mode () == CDOS_ACTION_MODE_NONE){
	    if (!CDOS_POPUP_MENU_BASE (applet->menu)->is_open){
		    return;
	    }
	    // 为了过滤其他 NONE 模式，比如其他菜单、overview等
    }


    if (priv->search_active)
    {
	    toggle_view (applet, FALSE);
	    reset_search (applet);
    }

    cdos_popup_menu_base_toggle(CDOS_POPUP_MENU_BASE(applet->menu));
	
	
	//zhangdj	
	if (!CDOS_POPUP_MENU_BASE(applet->menu)->is_open)
	{
	    
        /*右键弹出菜单*/
    	generic_application_button_popup = applet_menu_get_generic_application_button_popup_menu (applet);
    	if (generic_application_button_popup && CDOS_POPUP_MENU_BASE(generic_application_button_popup)->is_open)
    	{
    	    cdos_popup_menu_close (generic_application_button_popup, FALSE);
    	    priv->generic_application_button_popup_menu = NULL;
    	}
    	
    	/*最近使用的右键弹出菜单*/
    	recent_button_popup = applet_menu_get_recent_button_popup_menu (applet);
    	if (recent_button_popup && CDOS_POPUP_MENU_BASE(recent_button_popup)->is_open)
    	{
    	    cdos_popup_menu_close (recent_button_popup, FALSE);
    	    priv->recent_button_popup_menu = NULL;
    	}
    	
    	/*关机菜单*/
    	if (CDOS_POPUP_MENU_BASE(priv->contextmenu)->is_open)
    	{
    	    cdos_popup_menu_close (priv->contextmenu, FALSE);
    	}
    }
}

//zhangdj
static gboolean
_on_source_key_press (ClutterActor *actor, ClutterEvent *event, gpointer user_data)
{
	//g_print ("in %s\n", __func__);  //////调试
	AppletMenu *applet;
	AppletMenuPrivate *priv;
	guint symbol;
	
	applet = user_data;
	priv = applet->priv;
	symbol = clutter_event_get_key_symbol (event);
	
	if (symbol == CLUTTER_KEY_Escape && CDOS_POPUP_MENU_BASE(applet->menu)->is_open)
	{
		if (priv->search_active)
		{
			toggle_view (applet, FALSE);
			reset_search (applet);
		}
		cdos_popup_menu_close (CDOS_POPUP_MENU_BASE(applet->menu), FALSE);
		
		return TRUE;
	}
	
	return TRUE;
}

static gboolean load_menu_in_thread(gpointer user_data){
    AppletMenu *applet = (AppletMenu *)user_data;

    applet_menu_display(applet);
    applet_menu_shutdown_init(applet);
    applet_menu_search_init(applet);
    applet_shortcut_init(applet);
    applet_favorites_init(applet);
    applet_menu_switch_init(applet);
    applet_all_applications_init (applet);
    return FALSE;
}

AppletMenu *
applet_menu_new(guint orientation, gfloat panel_height)
{
    if(default_menu != NULL){
        return default_menu;
    }
    MetaDisplay *display;
    StTextureCache *texture_cache;
    AppletMenu *applet = NULL;
    AppletMenuPrivate *priv;
    StBoxLayout *box = NULL;
    
    ClutterContainer *uigroup = monkey_plugin_get_ui_group (monkey_plugin_get ());
    CdosGlobal *global = cdos_global_get();
    GSettings *settings = cdos_global_get_settings(global);
    display = cdos_global_get_display (global);
    texture_cache = st_texture_cache_get_default ();

    applet = g_object_new(APPLET_TYPE_MENU, "orientation", orientation, "panel-height", panel_height, NULL);
    priv = applet->priv;
    default_menu = applet;

    //st_widget_remove_style_class_name (CDOS_APPLET(applet)->actor,"applet-box");

    priv->applet_icon_box = cdos_iconapplet_get_applet_icon_box (CDOS_ICONAPPLET (applet));

    clutter_actor_set_margin_left(CLUTTER_ACTOR(priv->applet_icon_box),5);
    clutter_actor_set_margin_right(CLUTTER_ACTOR(priv->applet_icon_box),5);

    cdos_applet_set_applet_tooltip(CDOS_APPLET(applet),_("Start"));
    cdos_iconapplet_set_icon_path(CDOS_ICONAPPLET(applet), priv->icon_file);

    applet->menu = cdos_applet_get_popup_menu(CDOS_APPLET(applet));

    box = cdos_popup_menu_base_get_box(CDOS_POPUP_MENU_BASE(applet->menu));
    st_widget_add_style_class_name(ST_WIDGET(box), "menu-background");

    g_timeout_add (2000, load_menu_in_thread, applet);

    st_container_add_actor ((ClutterContainer *) uigroup, CLUTTER_ACTOR(applet->menu->actor));

    g_signal_connect (CDOS_APPLET(applet)->actor, "button-press-event",
                    G_CALLBACK(applet_menu_on_applet_clicked),
                    CDOS_APPLET (applet));
                    
    g_signal_connect (CLUTTER_ACTOR(CDOS_APPLET(applet)->actor), "key-press-event",
                    G_CALLBACK(_on_source_key_press),
                    applet);

    g_signal_connect (applet->menu, "open-state-changed", G_CALLBACK(_on_menu_open_state_changed), applet);

    g_signal_connect (settings, "changed::favorite-apps", G_CALLBACK(_on_favorite_apps_changed), applet);
    g_signal_connect (settings, "changed::favorite-apps-max-number", G_CALLBACK(_on_favorite_apps_changed), applet);   //added
    
    g_signal_connect (display, "overlay-key", G_CALLBACK(_on_overlay_key_pressed), applet);
    
    g_signal_connect (texture_cache, "icon-theme-changed", G_CALLBACK(on_icon_theme_changed), applet);

    return applet;
}

CdosApplet *
applets_menu_main(MetaData *meta, guint orientation,  gfloat panel_height)
{
   static AppletMenu *appletmenu;
	display_current_time ("new main");
	if(appletmenu == NULL){
   		appletmenu = applet_menu_new (orientation, panel_height);
	}
	display_current_time ("new main after");
   return CDOS_APPLET (appletmenu);
}

void
applet_menu_set_applet_icon_box (AppletMenu *self, StBin *box)
{
    AppletMenuPrivate *priv;
    g_return_if_fail(APPLET_IS_MENU(self));
    priv = self->priv;

    clutter_actor_destroy(CLUTTER_ACTOR(priv->applet_icon_box));

    if (box)
        priv->applet_icon_box = box;
    else
        priv->applet_icon_box = NULL;
}

StBin *
applet_menu_get_applet_icon_box (AppletMenu *self)
{
    g_return_val_if_fail(APPLET_IS_MENU(self), NULL);
    return self->priv->applet_icon_box;
}
static gchar *
menu_get_applet_icon(void){
    gchar *icon_file = NULL;
    GSettings *settings = g_settings_new("org.cdos.theme");
    gchar *theme_name = g_settings_get_string(settings,"name");
    if(theme_name){
        icon_file = g_strconcat("/usr/share/themes/",theme_name,"/cdos/menu.png",NULL);
    }
    g_free(theme_name);
    g_object_unref(settings);

    return icon_file;
}

static void
applet_menu_clear_recent_list(AppletMenu *self){
    AppletMenuPrivate *priv = self->priv;
    if(priv->recent_list){
        GList *recent_list = priv->recent_list;
        while (recent_list){
            AppletRecentButton *rec_button = recent_list->data;
            if(rec_button){
                CdosGenericContainer *rec_actor = cdos_popup_base_menu_item_get_actor(CDOS_POPUP_BASE_MENU_ITEM(rec_button));
                _remove_actor(priv->recent_box, rec_actor);
                g_object_unref(rec_button);
            }
            recent_list = recent_list->next;
        }

        g_list_free (priv->recent_list);
        priv->recent_list = NULL;
    }
}
static void
applet_menu_clear_favorite_list(AppletMenu *self){
    AppletMenuPrivate *priv = self->priv;
    if(priv->favorit_list){
        GList *favorit_list = priv->favorit_list;
        while (favorit_list){
            AppletFavoritesButton *button = favorit_list->data;
            if(button){
                CdosGenericContainer *actor = cdos_popup_base_menu_item_get_actor(CDOS_POPUP_BASE_MENU_ITEM(button));
                _remove_actor(priv->fav_box, actor);
                g_object_unref(button);
            }
            favorit_list = favorit_list->next;
        }
        g_list_free(priv->favorit_list);
        priv->favorit_list = NULL;
    }
}
static void
applet_menu_clear_apps_list(AppletMenu *self){
    AppletMenuPrivate *priv = self->priv;

    /* FIXME:
     * VALGRIND shows that _remove_actor has sth. wrong
     * */
    if(priv->categories_list){
        GList *categories_list = priv->categories_list;
        while (categories_list){
            AppletCategoryButton *category_button = categories_list->data;
            if(category_button) {
                /*
                CdosGenericContainer *actor = cdos_popup_base_menu_item_get_actor(CDOS_POPUP_BASE_MENU_ITEM(category_button));
                _remove_actor(priv->categories_box, actor);
                g_object_unref(category_button);
                */
                cdos_popup_base_menu_item_destroy ((CdosPopupBaseMenuItem *)category_button);
            }
            categories_list = categories_list->next;
        }
        g_list_free(priv->categories_list);
        priv->categories_list = NULL;
    }
    if(priv->apps_list){
        GList *apps_list = priv->apps_list;
        while (apps_list){
            AppletApplicationButton *application_button = apps_list->data;
            if(application_button) {
                //g_object_unref(application_button);
                cdos_popup_base_menu_item_destroy ((CdosPopupBaseMenuItem *)application_button);
            }
            apps_list = apps_list->next;
        }
        g_list_free(priv->apps_list);
        priv->apps_list = NULL;
    }
}
static void
applet_menu_clear_search_result_list(AppletMenu *self){
    AppletMenuPrivate *priv = self->priv;
    if(priv->search_result_box){
        clutter_actor_destroy_all_children (CLUTTER_ACTOR(priv->search_result_box));
    }
    if(priv->search_result_list){
        GList *search_result_list = priv->search_result_list;
        while (search_result_list){
            AppletSearchResultButton *search_result_button = search_result_list->data;
            if(search_result_button){
                g_object_unref(search_result_button);
            }
            search_result_list = search_result_list->next;
        }

        g_list_free (priv->search_result_list);
        priv->search_result_list = NULL;
    }
}

CdosApplet *
applet_menu_get_default(void){
    return default_menu;
}
const gchar *
applet_menu_get_wm_class_welcome(void){
    return single_wm_class_welcome;
}

const gchar *
applet_menu_get_wm_class_settings(void){
    return single_wm_class_settings;
}

void
applet_menu_set_active_actor (AppletMenu *menu, CdosGenericContainer *actor)
{
    AppletMenuPrivate *priv = menu->priv;
    
    priv->active_actor = actor;
}

void
applet_menu_set_previous_selected_actor (AppletMenu *menu, CdosGenericContainer *actor)
{
    AppletMenuPrivate *priv = menu->priv;
    
    priv->previous_selected_actor = actor;
}

void
applet_menu_set_state (AppletMenu *menu, enum STATE state)
{
    AppletMenuPrivate *priv = menu->priv;
    
    priv->state = state;
}

//zhangdj
void
applet_menu_set_generic_application_button_popup_menu (AppletMenu *menu, CdosPopupMenu *popup_menu)
{
    AppletMenuPrivate *priv = menu->priv;
    
    priv->generic_application_button_popup_menu = popup_menu;
}

CdosPopupMenu *
applet_menu_get_generic_application_button_popup_menu (AppletMenu *menu)
{
    AppletMenuPrivate *priv = menu->priv;
    
    return priv->generic_application_button_popup_menu;
}

void
applet_menu_set_recent_button_popup_menu (AppletMenu *menu, CdosPopupMenu *popup_menu)
{
    AppletMenuPrivate *priv = menu->priv;
    
    priv->recent_button_popup_menu = popup_menu;
}

CdosPopupMenu *
applet_menu_get_recent_button_popup_menu (AppletMenu *menu)
{
    AppletMenuPrivate *priv = menu->priv;
    
    return priv->recent_button_popup_menu;
}
