#ifndef __APPLET_MENU_H__
#define __APPLET_MENU_H__

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <clutter/clutter.h>
#include <string.h>
#include "config.h"
#include "cdos-applet.h"
#include "cdos-icon-applet.h"
#include "cdos-popup.h"
#include "cdos-global.h"
#include "cdos-app-system.h"
#define GMENU_I_KNOW_THIS_IS_UNSTABLE
#include <gmenu-tree.h>

G_BEGIN_DECLS

#define APPLET_TYPE_MENU                   (applet_menu_get_type ())
#define APPLET_MENU(obj)                   (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_MENU, AppletMenu))
#define APPLET_IS_MENU(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_MENU))
#define APPLET_MENU_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_MENU, AppletMenuClass))
#define APPLET_IS_MENU_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_MENU))
#define APPLET_MENU_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_MENU, AppletMenuClass))

#define MAX_FAV_ICON_SIZE 36
#define HOVER_ICON_SIZE 62
#define IMAGE_ICON_SIZE 10
#define APPLICATION_ICON_SIZE 18
#define CATEGORY_ICON_SIZE 16

typedef struct _AppletMenu AppletMenu;
typedef struct _AppletMenuPrivate AppletMenuPrivate;
typedef struct _AppletMenuClass AppletMenuClass;

struct _AppletMenu {
    /*< private > */
    CdosIconApplet parent_instance;
    CdosPopupMenu *menu;
    ClutterActor *actor;
    AppletMenuPrivate *priv;
};

struct _AppletMenuClass {
    /*< private > */
    CdosIconAppletClass parent_class;
    /* signals */

    /* vfuncs */
};

enum STATE
{
    EMPTY = 0,
    HOVER,
    KEY
};

GType
applet_menu_get_type(void) G_GNUC_CONST;

gboolean
applet_menu_on_applet_clicked(StBoxLayout *actor,  ClutterEvent *event, gpointer data);

AppletMenu *
applet_menu_new(guint orientation, gfloat panel_height);

CdosApplet *
applets_menu_main(MetaData *meta, guint orientation,  gfloat panel_height);

CdosApplet *
applet_menu_get_default(void);

void
applet_menu_set_applet_icon_box (AppletMenu *self, StBin *box);

StBin *
applet_menu_get_applet_icon_box (AppletMenu *self);

const gchar *
applet_menu_get_wm_class_welcome(void);

const gchar *
applet_menu_get_wm_class_settings(void);

//zhangdj
void
clear_previous_selection (AppletMenu *applet);

void
applet_menu_set_active_actor (AppletMenu *menu, CdosGenericContainer *actor);

void
applet_menu_set_previous_selected_actor (AppletMenu *menu, CdosGenericContainer *actor);

void
applet_menu_set_state (AppletMenu *menu, enum STATE state);

//zhangdj
void
applet_menu_set_generic_application_button_popup_menu (AppletMenu *menu, CdosPopupMenu *popup_menu);

CdosPopupMenu *
applet_menu_get_generic_application_button_popup_menu (AppletMenu *menu);

void
applet_menu_set_recent_button_popup_menu (AppletMenu *menu, CdosPopupMenu *popup_menu);

CdosPopupMenu *
applet_menu_get_recent_button_popup_menu (AppletMenu *menu);

G_END_DECLS

#endif              /* __APPLET_MENU_H__ */
