#include "applet-separator.h"

G_DEFINE_TYPE (AppletSeparator, applet_separator, CDOS_TYPE_POPUP_SEPARATOR_MENU_ITEM);

static void
applet_separator_finalize (GObject *object)
{
	AppletSeparator *separator;
	
	separator = APPLET_SEPARATOR (object);
	
	clutter_actor_destroy (CLUTTER_ACTOR(separator->drawing_area));
	
	G_OBJECT_CLASS (applet_separator_parent_class)->finalize (object);
}

static void
applet_separator_class_init (AppletSeparatorClass *klass)
{
	GObjectClass *object_class;
	
	object_class = G_OBJECT_CLASS (klass);
	
	object_class->finalize = applet_separator_finalize;
}

static void
applet_separator_init (AppletSeparator *self)
{
	PopupBaseMenuItemInit  params;
	StWidget *actor;
	
	cdos_popup_base_menu_item_get_init_params (&params);
	params.reactive = FALSE;
	cdos_popup_base_menu_item_set_params (CDOS_POPUP_BASE_MENU_ITEM (self), &params);
	
	actor = ST_WIDGET(cdos_popup_base_menu_item_get_actor (CDOS_POPUP_BASE_MENU_ITEM (self)));
	st_widget_set_style (actor, "padding: 0;");
}

AppletSeparator *
applet_separator_new (gchar *style_class)
{
	AppletSeparator *separator;
	
	separator = g_object_new (APPLET_TYPE_SEPARATOR, NULL);
	
	separator->drawing_area = cdos_popup_separator_menu_item_get_drawing_area (CDOS_POPUP_SEPARATOR_MENU_ITEM(separator));
	st_widget_remove_style_class_name (ST_WIDGET(separator->drawing_area), "popup-separator-menu-item");
	st_widget_set_style_class_name (ST_WIDGET(separator->drawing_area), "menu-separator-line");
	
	if (style_class)
	{
		st_widget_remove_style_class_name (ST_WIDGET(separator->drawing_area), "menu-separator-line");
		st_widget_set_style_class_name (ST_WIDGET(separator->drawing_area), style_class);
	}
	
	return separator;
}

StWidget *
applet_separator_get_actor (AppletSeparator *separator)
{
	StWidget *actor;
	
	actor = ST_WIDGET(cdos_popup_base_menu_item_get_actor (CDOS_POPUP_BASE_MENU_ITEM (separator)));
	
	return actor;
}
