#ifndef __APPLET_SEPARATOR_H__
#define __APPLET_SEPARATOR_H__

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <cairo.h>
#include "st.h"
#include "cdos-popup-separator-menu-item.h"

#define APPLET_TYPE_SEPARATOR                (applet_separator_get_type ())

#define APPLET_SEPARATOR(obj) \
	(G_TYPE_CHECK_INSTANCE_CAST((obj), APPLET_TYPE_SEPARATOR, AppletSeparator))
	
#define APPLET_IS_SEPARATOR(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_SEPARATOR))

#define APPLET_SEPARATOR_CLASS(klass) \
	(G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_SEPARATOR, AppletSeparatorClass))
	
#define APPLET_IS_SEPARATOR_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_SEPARATOR))

#define APPLET_SEPARATOR_GET_CLASS(obj) \
	(G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_SEPARATOR, AppletSeparatorClass))
	
/*用于访问私有结构*/
#define APPLET_SEPARATOR_GET_PRIVATE(obj) \
  (G_TYPE_INSTANCE_GET_PRIVATE ((obj), APPLET_TYPE_SEPARATOR, AppletSeparatorPrivate))

typedef struct _AppletSeparator AppletSeparator;
typedef struct _AppletSeparatorClass AppletSeparatorClass;

/*实例结构*/
struct _AppletSeparator
{
	CdosPopupSeparatorMenuItem parent_instance;
	
	StDrawingArea *drawing_area;
};

/*类结构*/
struct _AppletSeparatorClass
{
	CdosPopupSeparatorMenuItemClass parent_class;
};

GType applet_separator_get_type (void);

AppletSeparator *applet_separator_new (gchar *style_class);

StWidget *applet_separator_get_actor (AppletSeparator *separator);

#endif /* __APPLET_SEPARATOR_H__ */
