#ifndef __APPLET_SHORTCUT_ITEM_H__
#define __APPLET_SHORTCUT_ITEM_H__

#include <glib.h>
#include "cdos-popup-base-menu-item.h"
#include "st.h"
#include "applet-hover-icon.h"

#define APPLET_TYPE_SHORTCUT_ITEM                 (applet_shortcut_item_get_type ())
#define APPLET_SHORTCUT_ITEM(obj)                 (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_SHORTCUT_ITEM, AppletShortcutItem))
#define APPLET_SHORTCUT_ITEM_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_SHORTCUT_ITEM, AppletShortcutItemClass))
#define APPLET_IS_SHORTCUT_ITEM(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_SHORTCUT_ITEM))
#define APPLET_IS_SHORTCUT_ITEM_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_SHORTCUT_ITEM))
#define APPLET_SHORTCUT_ITEM_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_SHORTCUT_ITEM, AppletShortcutItemClass))

typedef struct _AppletShortcutItem AppletShortcutItem;
typedef struct _AppletShortcutItemClass AppletShortcutItemClass;
typedef struct _AppletShortcutItemPrivate AppletShortcutItemPrivate;

struct _AppletShortcutItem
{
  CdosPopupBaseMenuItem parent;

  AppletShortcutItemPrivate *priv;
};

struct _AppletShortcutItemClass
{
	CdosPopupBaseMenuItemClass parent_class;
};


GType applet_shortcut_item_get_type (void) G_GNUC_CONST;

AppletShortcutItem *
applet_shortcut_item_new(const gchar *label, 
                        const gchar *icon_name, 
                        gchar *command, 
                        GObject *parent,
                        AppletHoverIcon *hoverIcon);


AppletShortcutItem *
applet_shortcut_item_set_params(AppletShortcutItem *item,
                                const gchar *label, 
                                const gchar *icon_name, 
                                const gchar *command, 
                                GObject *parent,
                                AppletHoverIcon *hoverIcon);

void
applet_shortcut_item_set_active(AppletShortcutItem *item, gboolean active);


void
applet_shortcut_item_activate(AppletShortcutItem *item, gpointer event, gboolean keep, gpointer data);

#endif /* __APPLET_SHORTCUT_ITEM_H__ */
