#include "applet-shutdown-contextmenu-item.h"
#include "st.h"
#include <glibtop.h>
#include <glibtop/mem.h>

/*关机菜单项*/

G_DEFINE_TYPE(AppletShutdownContextmenuItem, applet_shutdown_contextmenu_item, CDOS_TYPE_POPUP_BASE_MENU_ITEM);

#define APPLET_SHUTDOWN_CONTEXTMENU_ITEM_GET_PRIVATE(obj)\
	    (G_TYPE_INSTANCE_GET_PRIVATE ((obj), APPLET_TYPE_SHUTDOWN_CONTEXTMENU_ITEM, AppletShutdownContextmenuItemPrivate))

struct _AppletShutdownContextmenuItemPrivate {
    ShutdownAction  action;
    StLabel         *label;
    CdosPopupMenu   *parent;
    AppletMenu      *applet;
};

enum {
    PROP_0,
};

enum
{
    LAST_SIGNAL
};

static void
applet_shutdown_contextmenu_item_finalize(GObject *object)
{
     AppletShutdownContextmenuItemPrivate *priv = APPLET_SHUTDOWN_CONTEXTMENU_ITEM(object)->priv;
     g_object_unref(priv->label);
     g_object_unref(priv->parent);

     G_OBJECT_CLASS(applet_shutdown_contextmenu_item_parent_class)->finalize(object);
}

static void
applet_shutdown_contextmenu_item_set_property(GObject * gobject,
                                    guint prop_id,
                                    const GValue * value, GParamSpec * pspec)
{
    AppletShutdownContextmenuItem *obj = APPLET_SHUTDOWN_CONTEXTMENU_ITEM(gobject);

    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_shutdown_contextmenu_item_get_property(GObject * gobject,
                                            guint prop_id, 
                                            GValue * value, 
                                            GParamSpec * pspec)
{
    AppletShutdownContextmenuItemPrivate *priv;

    priv = APPLET_SHUTDOWN_CONTEXTMENU_ITEM(gobject)->priv;
    switch (prop_id)
    {
        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID(gobject, prop_id, pspec);
            break;
    }
}

static void
applet_shutdown_contextmenu_item_class_init(AppletShutdownContextmenuItemClass * klass)
{
    GObjectClass *gobject_class = G_OBJECT_CLASS(klass);
    GParamSpec *pspec;
    gobject_class->set_property = applet_shutdown_contextmenu_item_set_property;
    gobject_class->get_property = applet_shutdown_contextmenu_item_get_property;

    g_type_class_add_private(klass, sizeof (AppletShutdownContextmenuItemPrivate));

}

static void
applet_shutdown_contextmenu_item_init(AppletShutdownContextmenuItem * self)
{
    AppletShutdownContextmenuItemPrivate *priv;
    priv = self->priv = APPLET_SHUTDOWN_CONTEXTMENU_ITEM_GET_PRIVATE(self);
}

static void
_applet_shutdown_contextmenu_item_activate(AppletShutdownContextmenuItem *self, 
                                        gpointer event, 
                                        gboolean keep, 
                                        gpointer data)
{
    AppletShutdownContextmenuItemPrivate *priv;
    CdosPopupMenu *contextmenu = (CdosPopupMenu *)data;
    priv = self->priv;

    glibtop_mem memory; 
    cdos_popup_menu_base_toggle(contextmenu);
    cdos_popup_menu_close(priv->applet->menu, TRUE);
    switch(priv->action)
        {
            case LOCK_SCREEN :
                cdos_util_spawn_command_line("cdos-screensaver-command --lock");
            break;
            case SWITCH_USER :
	    	cdos_util_spawn_command_line("numlockx off");
            cdos_util_spawn_command_line("dm-tool switch-to-greeter");
            break;
            case LOGOUT :
                cdos_util_spawn_command_line("dbus-send --session --print-reply --dest=\"org.gnome.SessionManager\" /org/gnome/SessionManager org.gnome.SessionManager.Logout uint32:0");
            break;
            case SHUTDOWN :
		 if(g_file_test("/var/lib/e4rat/startup.log",G_FILE_TEST_EXISTS))
                 {
			 if(g_file_test("/var/lib/e4rat/startup-backup.log",G_FILE_TEST_EXISTS))
			 {
				cdos_util_spawn_command_line("notify-send 系统正在进行初始化操作，请稍等");
				return 0;
			 }


		 }

                cdos_util_spawn_command_line("numlockx off");                
                cdos_util_spawn_command_line("dbus-send --session --print-reply --dest=\"org.gnome.SessionManager\" /org/gnome/SessionManager org.gnome.SessionManager.Shutdown");
            break;
            case REBOOT :
		 if(g_file_test("/var/lib/e4rat/startup.log",G_FILE_TEST_EXISTS))
                 {
                         if(g_file_test("/var/lib/e4rat/startup-backup.log",G_FILE_TEST_EXISTS))
                         {
                                cdos_util_spawn_command_line("notify-send 系统正在进行初始化操作，请稍等");
                                return 0;
                         }


                 }

                cdos_util_spawn_command_line("dbus-send --session --print-reply --dest=\"org.gnome.SessionManager\" /org/gnome/SessionManager org.gnome.SessionManager.Reboot");
            break;
            case SUSPEND :

		 if(!g_file_test("/var/tmp/copy_big_file",G_FILE_TEST_EXISTS))
		 {
			 
			 glibtop_get_mem(&memory);
		 	if((memory.free/(1024*1024)) <150)
		 	{
		     		cdos_util_spawn_command_line("notify-send 正在进行占用大量内存操作，不能进入睡眠，请稍后重试！");
		 	}
		 	else
			{
                   		cdos_util_spawn_command_line("dbus-send --system --print-reply --dest=\"org.freedesktop.login1\" /org/freedesktop/login1 org.freedesktop.login1.Manager.Suspend boolean:'true'");
		 	}
		  }
		 else
		 {
			 
		     		cdos_util_spawn_command_line("notify-send 正在进行占用大量内存操作，不能进入睡眠，请稍后重试！");
			
		 }

            break;
            case HIBERNATE :
		 if(g_file_test("/var/lib/e4rat/startup.log",G_FILE_TEST_EXISTS))
                 {
                         if(g_file_test("/var/lib/e4rat/startup-backup.log",G_FILE_TEST_EXISTS))
                         {
                                cdos_util_spawn_command_line("notify-send 系统正在进行初始化操作，请稍等");
                                return 0;
                         }


                 }
		 if(!g_file_test("/var/tmp/copy_big_file",G_FILE_TEST_EXISTS))
		 {
			 
			 glibtop_get_mem(&memory);
		 	if((memory.free/(1024*1024)) <150)
		 	{
		     		cdos_util_spawn_command_line("notify-send 正在进行占用大量内存操作，不能进入休眠，请稍后重试！");
		 	}
		 	else
			{
                   		cdos_util_spawn_command_line("dbus-send --system --print-reply --dest=\"org.freedesktop.login1\" /org/freedesktop/login1 org.freedesktop.login1.Manager.Hibernate boolean:'true'");
		 	}
		  }
		 else
		 {
			 
		     		cdos_util_spawn_command_line("notify-send 正在进行占用大量内存操作，不能进入休眠，请稍后重试！");
			
		 }
            break;
            default:
            break;
    	}
}

//zhangdj start
static gboolean
_applet_shutdown_contextmenu_item_button_press_event (CdosGenericContainer *actor,
                                                      ClutterEvent *event,
                                                      gpointer user_data)
{
    st_widget_add_style_pseudo_class (ST_WIDGET(actor), "click");
    
    return TRUE;
}

static gboolean
_applet_shutdown_contextmenu_item_button_release_event (CdosGenericContainer *actor,
                                                        ClutterEvent *event,
                                                        gpointer user_data)
{
    st_widget_remove_style_pseudo_class (ST_WIDGET(actor), "click");
    
    return TRUE;
}
//zhangdj end

AppletShutdownContextmenuItem *
applet_shutdown_contextmenu_item_new(AppletMenu *applet, 
                                CdosPopupMenu *parent,  
                                gchar         *label, 
                                ShutdownAction action)
{
    AppletShutdownContextmenuItem           *object;
    PopupBaseMenuItemInit                   params;
    ActorChild                              child_params;
    AppletShutdownContextmenuItemPrivate    *priv;
    CdosGenericContainer                    *actor;

    object = g_object_new(APPLET_TYPE_SHUTDOWN_CONTEXTMENU_ITEM, NULL);
    priv = object->priv;

    cdos_popup_base_menu_item_get_init_params(&params);
    params.focusOnHover = FALSE;
    cdos_popup_base_menu_item_get_actor_child(&child_params);

    cdos_popup_base_menu_item_set_params(object, &params);
    actor = cdos_popup_base_menu_item_get_actor(object);

    priv->parent = parent;
    priv->label = st_label_new(label);
    priv->action = action;
    priv->applet = applet;

    cdos_popup_base_menu_item_add_actor(object, priv->label, &child_params);
    st_widget_set_style_class_name(actor, "shutdown-context-menu-item");
    
    //zhangdj start
    g_signal_connect (actor,
                      "button-press-event",
                      G_CALLBACK(_applet_shutdown_contextmenu_item_button_press_event),
                      NULL);
                      
    g_signal_connect (actor,
                      "button-release-event",
                      G_CALLBACK(_applet_shutdown_contextmenu_item_button_release_event),
                      NULL);
    //zhangdj end

    g_signal_connect(object, "activate", 
                    G_CALLBACK(_applet_shutdown_contextmenu_item_activate), 
                    priv->parent);

    return object;
}
