#ifndef __APPLET_SHUTDOWN_CONTEXTMENU_ITEM_H__
#define __APPLET_SHUTDOWN_CONTEXTMENU_ITEM_H__

#include <glib.h>
#include <glib-object.h>
#include "st.h"
#include "cdos-popup-menu.h"
#include "cdos-popup-base-menu-item.h"
#include "cdos-util.h"
#include "applet-menu.h"

G_BEGIN_DECLS

#define APPLET_TYPE_SHUTDOWN_CONTEXTMENU_ITEM                   (applet_shutdown_contextmenu_item_get_type ())
#define APPLET_SHUTDOWN_CONTEXTMENU_ITEM(obj)                   (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_SHUTDOWN_CONTEXTMENU_ITEM, AppletShutdownContextmenuItem))
#define APPLET_IS_SHUTDOWN_CONTEXTMENU_ITEM(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_SHUTDOWN_CONTEXTMENU_ITEM))
#define APPLET_SHUTDOWN_CONTEXTMENU_ITEM_CLASS(klass)           (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_SHUTDOWN_CONTEXTMENU_ITEM, AppletShutdownContextmenuItemClass))
#define APPLET_IS_SHUTDOWN_CONTEXTMENU_ITEM_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_SHUTDOWN_CONTEXTMENU_ITEM))
#define APPLET_SHUTDOWN_CONTEXTMENU_ITEM_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_SHUTDOWN_CONTEXTMENU_ITEM, AppletShutdownContextmenuItemClass))

typedef struct _AppletShutdownContextmenuItem AppletShutdownContextmenuItem;
typedef struct _AppletShutdownContextmenuItemPrivate AppletShutdownContextmenuItemPrivate;
typedef struct _AppletShutdownContextmenuItemClass AppletShutdownContextmenuItemClass;

struct _AppletShutdownContextmenuItem 
{
    CdosPopupBaseMenuItem parent_instance;
    AppletShutdownContextmenuItemPrivate *priv;
};

struct _AppletShutdownContextmenuItemClass 
{
	CdosPopupBaseMenuItemClass parent_class;
};

typedef enum{
    LOCK_SCREEN,
    SWITCH_USER,
    LOGOUT,
    SHUTDOWN,
    REBOOT,
    SUSPEND,
    HIBERNATE
} ShutdownAction;

GType
applet_shutdown_contextmenu_item_get_type(void) G_GNUC_CONST;

AppletShutdownContextmenuItem *
applet_shutdown_contextmenu_item_new(AppletMenu *applet, 
                            CdosPopupMenu *parent,  
                            gchar *label, 
                            ShutdownAction action);

G_END_DECLS

#endif              /* __UI_BOX_POINTER_H__ */
