#include "applet-nm-wired-section-title-menu-item.h"

G_DEFINE_TYPE ( AppletNMWiredSectionTitleMenuItem, applet_nm_wired_section_title_menu_item, CDOS_TYPE_POPUP_SWITCH_MENU_ITEM);

static void
applet_nm_wired_section_title_menu_item_finalize (GObject *gobject)
{
  //AppletNMWiredSectionTitleMenuItem *self = APPLET_NM_WIRED_SECTION_TITLE_MENU_ITEM (gobject);

  G_OBJECT_CLASS (applet_nm_wired_section_title_menu_item_parent_class)->finalize (gobject);
}
static void
applet_nm_wired_section_title_menu_item_dispose (GObject *gobject)
{
    //AppletNMWiredSectionTitleMenuItem *self = APPLET_NM_WIRED_SECTION_TITLE_MENU_ITEM (gobject);
    /* 调用父类的 finalize() 方法 */
    G_OBJECT_CLASS (applet_nm_wired_section_title_menu_item_parent_class)->dispose (gobject);
}
static void
applet_nm_wired_section_title_menu_item_activate(CdosPopupBaseMenuItem *item,
                                                 ClutterEvent *event,
                                                 gboolean keepmenu)
{
    AppletNMWiredSectionTitleMenuItem *self = APPLET_NM_WIRED_SECTION_TITLE_MENU_ITEM (item);

    if( !self->device )
    {
        g_print("Section title activated when there is more than one device, should be non reactive");
        return;
    }

    gboolean newState = cdos_popup_switch_menu_item_get_status( CDOS_POPUP_SWITCH_MENU_ITEM(self) );
    //cdos_popup_switch_menu_item_set_toggle_status( CDOS_POPUP_SWITCH_MENU_ITEM(self), FALSE );
    if ( newState )
        applet_nm_device_activate(self->device);
    else
        applet_nm_device_deactivate(self->device);
}

static void 
applet_nm_wired_section_title_menu_item_class_init (AppletNMWiredSectionTitleMenuItemClass *klass) {

    GObjectClass *gobject_class = G_OBJECT_CLASS(klass);

    gobject_class->finalize = applet_nm_wired_section_title_menu_item_finalize;
    gobject_class->dispose = applet_nm_wired_section_title_menu_item_dispose;

    CdosPopupBaseMenuItemClass *parent_class = CDOS_POPUP_BASE_MENU_ITEM_CLASS (klass);
    parent_class->activate = applet_nm_wired_section_title_menu_item_activate;
}

static void
applet_nm_wired_section_title_menu_item_init ( AppletNMWiredSectionTitleMenuItem *self ) {
}

/*公有函数定义*/

AppletNMWiredSectionTitleMenuItem *
applet_nm_wired_section_title_menu_item_new(const char *label)
{
    AppletNMWiredSectionTitleMenuItem *self;

    self = g_object_new( APPLET_TYPE_NM_WIRED_SECTION_TITLE_MENU_ITEM, NULL );
    cdos_popup_switch_menu_item_set_text((CdosPopupSwitchMenuItem *)self, label);
    cdos_popup_switch_menu_item_set_active(CDOS_POPUP_SWITCH_MENU_ITEM(self), 1);
    return self;
}

void
applet_nm_wired_section_title_menu_item_update_for_device (CdosPopupSwitchMenuItem *self, AppletNMDevice *device)
{
    if (device)
    {
        AppletNMWiredSectionTitleMenuItem *item = (void *)self;
        item->device = device;
        cdos_popup_switch_menu_item_set_toggle_status(self,
                applet_nm_device_get_connected(device));
        gboolean avail = 1;
        NMDeviceState state = nm_device_get_state (device->device);
        if ((state == NM_DEVICE_STATE_UNAVAILABLE) ||
            (state == NM_DEVICE_STATE_UNMANAGED))
            avail = 0;
        if (!avail)
            cdos_popup_base_menu_item_set_sensitive ((CdosPopupBaseMenuItem *)self, 0);
            //clutter_actor_hide ((ClutterActor *)cdos_popup_base_menu_item_get_actor ((CdosPopupBaseMenuItem *)self));
        else
            cdos_popup_base_menu_item_set_sensitive ((CdosPopupBaseMenuItem *)self, 1);
            //clutter_actor_show ((ClutterActor *)cdos_popup_base_menu_item_get_actor ((CdosPopupBaseMenuItem *)self));
    }
}



