#ifndef __APPLET_NOTIFICATIONS_H__
#define __APPLET_NOTIFICATIONS_H__

#include <glib-object.h>
#include <gio/gio.h>
#include "ui/cdos-message-tray.h"
#include "ui/cdos-applet.h"
#include "ui/cdos-icon-applet.h"
#include "ui/cdos-popup-menu-manager.h"
#include "ui/cdos-text-applet.h"
#include "ui/cdos-text-icon-applet.h"
#include "ui/cdos-popup-menu-item.h"
#include "ui/cdos-popup-separator-menu-item.h"
#include "ui/cdos-applet-settings.h"
#include "st.h"
#include "cdos-global.h"

#define APPLET_TYPE_NOTIFICATIONS            (applet_notifications_get_type ())
#define APPLET_NOTIFICATIONS(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_NOTIFICATIONS, AppletNotifications))
#define APPLET_IS_NOTIFICATIONS(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_NOTIFICATIONS))
#define APPLET_NOTIFICATIONS_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_NOTIFICATIONS, AppletNotificationsClass))
#define APPLET_IS_NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_NOTIFICATIONS))
#define APPLET_NOTIFICATIONS_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_NOTIFICATIONS, AppletNotificationsClass))

typedef struct _AppletNotifications AppletNotifications;
typedef struct _AppletNotificationsClass AppletNotificationsClass;

/* instance structure */
struct _AppletNotifications
{
    /*父类*/
    CdosTextIconApplet parent_instance;
    /*AppletNotifications->CdosTextIconApplet->IconApplet->Applet*/

    /*成员*/
    CdosAppletSettings *settings; /*不确定*/
    StSide p_orientation;/*不确定*/
    CdosPopupMenuManager *menu_manager;
    guint notification_count;
    GList *notifications;/*不确定, data数据类型是CdosNotification*/
    gboolean p_blinking;
    gboolean p_blink_toggle;
    StWidget *p_main_container;
    StWidget *p_notification_bin;
    StBoxLayout *button_label_box;
    gchar *menu_text;
    CdosPopupMenuItem *menu_label;
    CdosPopupSeparatorMenuItem *clear_separator;
    CdosPopupMenuItem *clear_action;
    CdosPopupMenu *menu;/*cdos_applet_get_popupmenu in applet.h*/
    StWidget *scroll_view;
    ClutterActor *p_crit_icon;
    ClutterActor *p_alt_crit_icon;
    gboolean ignore_transient_notifications;
};

/* class structure */
struct _AppletNotificationsClass
{
    /*父类*/
    CdosTextIconAppletClass parent_class;

    /*私有变量*/

};

GType applet_notifications_get_type (void);

void applet_notifications_update_list (AppletNotifications *self);
void applet_notifications_on_applet_added_to_panel (AppletNotifications *self);
void applet_notifications_on_orientation_changed (AppletNotifications *self, StSide orientation);
void applet_notifications_on_applet_clicked_cb (ClutterActor* actor, ClutterEvent* event, gpointer user_data);
gboolean applet_notifications_critical_blink (AppletNotifications *self);

CdosApplet *applet_notifications_main (MetaData *metadata, StSide orientation, gfloat panel_height, gchar *instanceId);
#endif
