#ifndef __CDOS_PLACE_DEVICE_INFO_H__
#define __CDOS_PLACE_DEVICE_INFO_H__

#include <glib.h>
#include "applet-place-info.h"

#define CDOS_TYPE_PLACE_DEVICE_INFO                 (cdos_place_device_info_get_type ())
#define CDOS_PLACE_DEVICE_INFO(obj)                 (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_PLACE_DEVICE_INFO, CdosPlaceDeviceInfo))
#define CDOS_PLACE_DEVICE_INFO_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_PLACE_DEVICE_INFO, CdosPlaceDeviceInfoClass))
#define CDOS_IS_PLACE_DEVICE_INFO(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_PLACE_DEVICE_INFO))
#define CDOS_IS_PLACE_DEVICE_INFO_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_PLACE_DEVICE_INFO))
#define CDOS_PLACE_DEVICE_INFO_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_PLACE_DEVICE_INFO, CdosPlaceDeviceInfoClass))

typedef struct _CdosPlaceDeviceInfo        CdosPlaceDeviceInfo;  
typedef struct _CdosPlaceDeviceInfoClass   CdosPlaceDeviceInfoClass;
typedef struct _CdosPlaceDeviceInfoPrivate CdosPlaceDeviceInfoPrivate;

struct _CdosPlaceDeviceInfo
{
  CdosPlaceInfo parent;

  CdosPlaceDeviceInfoPrivate *priv;
};

struct _CdosPlaceDeviceInfoClass
{
  CdosPlaceInfoClass parent_class;
};

GType cdos_place_device_info_get_type (void) G_GNUC_CONST;

CdosPlaceDeviceInfo *
cdos_place_device_info_new_with_params(GMount *mount);

CdosPlaceDeviceInfo *
cdos_place_device_info_set_params(CdosPlaceDeviceInfo *info,
                                  GMount *mount);

ClutterActor *
cdos_place_device_info_icon_factory(CdosPlaceDeviceInfo *info,
                                    gint size);

void
cdos_place_device_info_launch(CdosPlaceDeviceInfo *info,
                              CdosPlaceInfoParams *params);

gboolean 
cdos_place_device_info_is_removable(CdosPlaceDeviceInfo *info);

void
cdos_place_device_info_remove(CdosPlaceDeviceInfo *info);

#endif /* __CDOS_PLACE_DEVICE_INFO_H__ */