#ifndef __CDOS_PLACE_INFO_H__
#define __CDOS_PLACE_INFO_H__

#include "st.h"
#include <gdk/gdk.h>
#include "cdos-doc-info.h"


#define CDOS_TYPE_PLACE_INFO                 (cdos_place_info_get_type ())
#define CDOS_PLACE_INFO(obj)                 (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_PLACE_INFO, CdosPlaceInfo))
#define CDOS_PLACE_INFO_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_PLACE_INFO, CdosPlaceInfoClass))
#define CDOS_IS_PLACE_INFO(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_PLACE_INFO))
#define CDOS_IS_PLACE_INFO_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_PLACE_INFO))
#define CDOS_PLACE_INFO_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_PLACE_INFO, CdosPlaceInfoClass))

typedef struct _CdosPlaceInfo CdosPlaceInfo;
typedef struct _CdosPlaceInfoClass CdosPlaceInfoClass;
typedef struct _CdosPlaceInfoPrivate CdosPlaceInfoPrivate;

struct _CdosPlaceInfo
{
  GObject parent;

  CdosPlaceInfoPrivate *priv;
};

struct _CdosPlaceInfoClass
{
  GObjectClass parent_class;
};

typedef struct 
{
        gint workspace;
        gint timestamp;
}CdosPlaceInfoParams;

GType cdos_place_info_get_type (void) G_GNUC_CONST;

GAppLaunchContext *
cdos_place_info_make_launch_conext(CdosPlaceInfoParams *params);

gboolean 
cdos_place_info_is_removeable(CdosPlaceInfo *info);

MATCHTYPE 
cdos_place_info_match_terms(CdosPlaceInfo *info, GArray *terms);

CdosPlaceInfo *
cdos_place_info_set_params(CdosPlaceInfo *info,
                           gchar         *id,
                           gchar         *name,
                           gpointer       iconFactory,
                           gpointer       launch);
CdosPlaceInfo *
cdos_place_info_new_with_params(gchar     *id, 
                                gchar     *name, 
                                gpointer   iconFactory,
                                gpointer   launch);

gchar *
cdos_place_info_get_id(CdosPlaceInfo *info);

gchar *
cdos_place_info_get_name(CdosPlaceInfo *info);

CdosPlaceInfo *
cdos_place_info_new(void);

#endif /* __CDOS_PLACE_INFO_H__ */
