#ifndef __CDOS_PLACES_MANAGER_H__
#define __CDOS_PLACES_MANAGER_H__

#include <glib.h>
#include "applet-place-info.h"

#define CDOS_TYPE_PLACES_MANAGER                 (cdos_places_manager_get_type ())
#define CDOS_PLACES_MANAGER(obj)                 (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_PLACES_MANAGER, CdosPlacesManager))
#define CDOS_PLACES_MANAGER_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_PLACES_MANAGER, CdosPlacesManagerClass))
#define CDOS_IS_PLACES_MANAGER(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_PLACES_MANAGER))
#define CDOS_IS_PLACES_MANAGER_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_PLACES_MANAGER))
#define CDOS_PLACES_MANAGER_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_PLACES_MANAGER, CdosPlacesManagerClass))

typedef struct _CdosPlacesManager CdosPlacesManager;
typedef struct _CdosPlacesManagerClass CdosPlacesManagerClass;
typedef struct _CdosPlacesManagerPrivate CdosPlacesManagerPrivate;

struct _CdosPlacesManager
{
	GObject parent;

  	CdosPlacesManagerPrivate *priv;
};

struct _CdosPlacesManagerClass
{
  	GObjectClass parent_class;
  	void (*mounts_updated)(CdosPlacesManager *manager);
  	void (*places_updated)(CdosPlacesManager *manager);
  	void (*bookmarks_updated)(CdosPlacesManager *manager);
};


GType cdos_places_manager_get_type (void) G_GNUC_CONST;

GPtrArray *
cdos_places_manager_get_all_places(CdosPlacesManager *manager);

GPtrArray *
cdos_places_manager_get_default_places(CdosPlacesManager *manager);

GPtrArray *
cdos_places_manager_get_bookmarks(CdosPlacesManager *manager);

GPtrArray *
cdos_places_manager_get_mounts(CdosPlacesManager *manager);

CdosPlaceInfo *
cdos_places_manager_lookup_place_by_id(CdosPlacesManager *manager, gchar *id);

CdosPlacesManager *
cdos_places_manager_get_default(void);

#endif /* __CDOS_PLACES_MANAGER_H__ */
