#ifndef __APPLET_TEXT_IMAGE_MENU_ITEM_H__
#define SLIDER_SCROLL_STEP  0.05 /* Slider scrolling step in % */
#define THEME_ICON_PATH "/usr/share/cdos-de/theme"
#define __APPLET_TEXT_IMAGE_MENU_ITEM_H__

#include <gio/gio.h>
#include "st.h"
#include "ui/cdos-popup-base-menu-item.h"

#define APPLET_TYPE_TEXT_IMAGE_MENU_ITEM            (applet_text_image_menu_item_get_type ())
#define APPLET_TEXT_IMAGE_MENU_ITEM(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLET_TYPE_TEXT_IMAGE_MENU_ITEM, AppletTextImageMenuItem))
#define APPLET_IS_TEXT_IMAGE_MENU_ITEM(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLET_TYPE_TEXT_IMAGE_MENU_ITEM))
#define APPLET_TEXT_IMAGE_MENU_ITEM_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), APPLET_TYPE_TEXT_IMAGE_MENU_ITEM, AppletTextImageMenuItemClass))
#define APPLET_IS_TEXT_IMAGE_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLET_TYPE_TEXT_IMAGE_MENU_ITEM))
#define APPLET_TEXT_IMAGE_MENU_ITEM_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLET_TYPE_TEXT_IMAGE_MENU_ITEM, AppletTextImageMenuItemClass))

typedef struct _AppletTextImageMenuItem AppletTextImageMenuItem;
typedef struct _AppletTextImageMenuItemClass AppletTextImageMenuItemClass;

/* instance structure */
struct _AppletTextImageMenuItem
{
    /*父类*/
    CdosPopupBaseMenuItem parent_instance;
    StIcon *st_icon;
    StWidget *st_text;
};

/* class structure */
struct _AppletTextImageMenuItemClass
{
    /*父类*/
    CdosPopupBaseMenuItemClass parent_class;
};

GType applet_text_image_menu_item_get_type (void);

AppletTextImageMenuItem *
applet_text_image_menu_item_new (const gchar *text, const gchar *icon, const gchar *image, const gchar *align, const gchar *style);

void applet_text_image_menu_item_set_text (AppletTextImageMenuItem *self, const gchar *text);

void applet_text_image_menu_item_set_icon (AppletTextImageMenuItem *self, const gchar *icon);

void applet_text_image_menu_item_set_image (AppletTextImageMenuItem *self, const gchar *image);

#endif
