//
// Created by zhangtao on 16-3-15.
// source:applets/window-list*/specialButtons.js

//添加依赖;
#include <math.h>
#include "applet-app-button.h"
#include "cdos-window-tracker.h"
#include "cdos-global.h"
#include "cdos-applet.h"
#include "applet-window-list.h"
#include "applet-app-group.h"

typedef struct _AppletAppButtonSignalIds AppletAppButtonSignalIds;

/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletAppButtonPrivate{
    /*public*/
    gint icon_size;
    gboolean is_favorite_app;
    CdosApp *app;
    ClutterActor *icon;
    MetaWorkspace *meta_workspace;
    AppletWindowList *applet;
    //AppletAppGroup *parent;
    AppletAppButtonSignalIds *signal_ids;
};
struct _AppletAppButtonSignalIds{

    gulong window_tracker_notify_focus_app_id;
    gulong global_display_window_demands_attention_id;

};
/*-------global variables-------------*/
static gint AppletAppButton_private_offset = 0;
static gint applet_app_button_signals[LAST_SIGNAL] = { 0 };
static gpointer applet_app_button_parent_class = NULL;

//static CdosGlobal *global = NULL;

/*-------class functions---------*/
static void applet_app_button_init(AppletAppButton *self);
static void applet_app_button_class_init(AppletAppButtonClass *klass);

static void applet_app_button_dispose(GObject *object);
static void applet_app_button_finalize(GObject *object);

/*-------------private functions of instance-------------------*/
static void applet_app_button_constructor(AppletAppButton *self,AppletAppGroup *parent);

static void applet_app_button_tracker_on_notify_focus_app(GObject *tracker,GParamSpec *pspec,AppletAppButton *self);

static void applet_app_button_global_display_on_window_demands_attention(MetaDisplay *display,MetaWindow *meta_window,AppletAppButton *self);


/*-------functions-------------*/
/**
 * 注册类；
 *
 *
 * */
GType
applet_app_button_get_type(void)
{
    static GType applet_app_button_type = 0;
    if(G_UNLIKELY(applet_app_button_type==0))
    {
        static const GTypeInfo applet_app_button_info = {
                sizeof(AppletAppButtonClass),
                NULL,NULL,
                (GClassInitFunc)applet_app_button_class_init,
                NULL,NULL,
                sizeof(AppletAppButton),
                0,
                (GInstanceInitFunc)applet_app_button_init
        };
        //类注册
        applet_app_button_type = g_type_register_static(APPLET_TYPE_ICON_LABEL_BUTTON,"AppletAppButton",&applet_app_button_info,0);
        //g_type_add_class_private(applet_app_button_type, sizeof(AppletAppButtonClassPrivate));
        AppletAppButton_private_offset =
                g_type_add_instance_private(applet_app_button_type, sizeof(AppletAppButtonPrivate));

    }
    return applet_app_button_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_app_button_get_instance_private(AppletAppButton *self){
    return (G_STRUCT_MEMBER_P (self, AppletAppButton_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_app_button_init(AppletAppButton *self)
{
    AppletAppButtonPrivate *priv;
    self->priv=applet_app_button_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/
    if(global == NULL){
        global = cdos_global_get();
    }
    priv->signal_ids = g_new0(AppletAppButtonSignalIds,1);

    CdosWindowTracker *tracker = cdos_window_tracker_get_default();

    priv->signal_ids->window_tracker_notify_focus_app_id = \
            g_signal_connect(G_OBJECT(tracker),"notify::focus-app",G_CALLBACK(applet_app_button_tracker_on_notify_focus_app),self);
    MetaDisplay *global_display = cdos_global_get_display(global);
    priv->signal_ids->global_display_window_demands_attention_id = \
            g_signal_connect(global_display,"window-demands-attention",G_CALLBACK(applet_app_button_global_display_on_window_demands_attention),self);
    applet_icon_label_button_set_style(APPLET_ICON_LABEL_BUTTON(self),"window-list-item-box-none");

}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_app_button_class_init(AppletAppButtonClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletAppButton_private_offset);
    applet_app_button_parent_class = g_type_class_peek_parent(klass);

    //gobject_class->constructed=applet_app_button_constructed;
    gobject_class->dispose=applet_app_button_dispose;
    gobject_class->finalize=applet_app_button_finalize;
}

/*------------类方法定义-----------*/
static void applet_app_button_dispose(GObject *object){
    AppletAppButton *self = APPLET_APP_BUTTON(object);
    AppletAppButtonPrivate *priv = self->priv;
    g_clear_object(&priv->icon);
    G_OBJECT_CLASS(applet_app_button_parent_class)->dispose(object);
}

static void applet_app_button_finalize(GObject *object){
    AppletAppButton *self = APPLET_APP_BUTTON(object);
    AppletAppButtonPrivate *priv = self->priv;

    g_free(priv->signal_ids);

    G_OBJECT_CLASS(applet_app_button_parent_class)->finalize(object);
}

/*-------------private functions--------------*/
static void applet_app_button_constructor(AppletAppButton *self,AppletAppGroup *parent){
    AppletAppButtonPrivate *priv = self->priv;
    priv->applet = applet_app_group_get_applet(parent);

    priv->icon_size = floor(applet_window_list_get_panel_height(priv->applet) - 16);
    priv->app = applet_app_group_get_app(parent);

    if(!priv->app){
        g_error("Error:app is NULL in %s!",__func__);
    }
    priv->icon = cdos_app_create_icon_texture(priv->app,priv->icon_size);
    priv->is_favorite_app = applet_app_group_get_is_favorite_app(parent);

    applet_icon_label_button_constructor(APPLET_ICON_LABEL_BUTTON(self),priv->applet,priv->icon);
    gfloat button_height = applet_window_list_get_panel_height(priv->applet);

    StWidget *actor = applet_icon_label_button_get_actor((AppletIconLabelButton *)self);
    clutter_actor_set_height(CLUTTER_ACTOR(actor),(float)button_height);

    AppletAppList *app_list  = applet_app_group_get_app_list(parent);
    guint meta_workspace_index = applet_app_list_get_workspace_index(app_list);
    //直接掉用接口获取工作区地址,存在问题--地址有变动;
    MetaScreen *global_screen = cdos_global_get_screen(global);
    MetaWorkspace *meta_workspace = meta_screen_get_workspace_by_index (global_screen,meta_workspace_index);
    priv->meta_workspace = meta_workspace;
    //zhangtao:just for track dug #0235908
    if(meta_workspace_index == 0){
        GMenuTreeEntry *entry = cdos_app_get_tree_entry (priv->app);
        g_print("\n%s:====>app_name = %s,desktop_file_path = %s;\n",__func__,cdos_app_get_name(priv->app),gmenu_tree_entry_get_desktop_file_path(entry));
    }
}

static void applet_app_button_tracker_on_notify_focus_app(GObject *tracker,GParamSpec *pspec,AppletAppButton *self){
    applet_app_button_update_actor_style(self);
}

static void applet_app_button_global_display_on_window_demands_attention(MetaDisplay *display,MetaWindow *meta_window,AppletAppButton *self){

}

/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletAppButton* applet_app_button_new(AppletAppGroup *parent)
{
    AppletAppButton *self;
    self = g_object_new(APPLET_TYPE_APP_BUTTON, NULL);

    applet_app_button_constructor(self,parent);
    return self;
}

void applet_app_button_destroy(AppletAppButton *self){

    AppletAppButtonPrivate *priv = self->priv;
    CdosWindowTracker *tracker = cdos_window_tracker_get_default();
    MetaDisplay *global_display = cdos_global_get_display(global);
    if(priv->signal_ids->window_tracker_notify_focus_app_id > 0){
        g_signal_handler_disconnect(tracker,priv->signal_ids->window_tracker_notify_focus_app_id);
        priv->signal_ids->window_tracker_notify_focus_app_id = 0;
    }
    if(priv->signal_ids->global_display_window_demands_attention_id >0){
        g_signal_handler_disconnect(global_display,priv->signal_ids->global_display_window_demands_attention_id);
        priv->signal_ids->global_display_window_demands_attention_id = 0;
    }
    applet_icon_label_button_destroy(APPLET_ICON_LABEL_BUTTON(self));
}
//暂无相关实现内容；
void applet_app_button_is_favorite(AppletAppButton *self,gboolean is_favorite){

}

gint applet_app_button_get_icon_size(AppletAppButton *self){
    g_return_val_if_fail(APPLET_IS_APP_BUTTON(self),0);
    AppletAppButtonPrivate *priv = self->priv;
    return priv->icon_size;
}

ClutterActor* applet_app_button_get_icon(AppletAppButton *self){
    g_return_val_if_fail(APPLET_IS_APP_BUTTON(self),NULL);
    AppletAppButtonPrivate *priv = self->priv;
    return priv->icon;
}
gboolean applet_app_button_get_is_favorite_app(AppletAppButton *self){
    g_return_val_if_fail(APPLET_IS_APP_BUTTON(self),NULL);
    AppletAppButtonPrivate *priv = self->priv;
    return priv->is_favorite_app;
}
void applet_app_button_update_actor_style(AppletAppButton *self){
    g_return_val_if_fail(APPLET_IS_APP_BUTTON(self),NULL);
    AppletAppButtonPrivate *priv = self->priv;

    StWidget *actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(self));
    GSList *windows = cdos_app_get_windows(priv->app);
    gint win_num = 0;
    gint focus = FALSE;
    while (windows){
        MetaWindow *meta_window = windows->data;
        MetaWorkspace *meta_workspace = meta_window_get_workspace(meta_window);
        MetaWindowType meta_window_type = meta_window_get_window_type(meta_window);
        if(meta_window_type == META_WINDOW_NORMAL && meta_workspace == priv->meta_workspace){
            if(meta_window_appears_focused(meta_window) || meta_window_has_focus(meta_window)){
                focus = TRUE;
            }
            win_num++;
            if(win_num >= 3){
                break;
            }
        }
        windows = windows->next;
    }
    st_widget_remove_style_class_name(actor,"window-list-item-box-one-active");
    st_widget_remove_style_class_name(actor,"window-list-item-box-two-active");
    st_widget_remove_style_class_name(actor,"window-list-item-box-more-active");
    if(focus){
        st_widget_add_style_pseudo_class(actor,"focus");
        //notice:暂时无用；
        //st_widget_remove_style_class_name(actor,"window-list-item-demands-attention");
        //st_widget_remove_style_class_name(actor,"window-list-item-demands-attention-top");
        if(win_num == 1){
            st_widget_add_style_class_name(actor,"window-list-item-box-one-active");
        }else if(win_num == 2){
            st_widget_add_style_class_name(actor,"window-list-item-box-two-active");
        }else if(win_num >= 3){
            st_widget_add_style_class_name(actor,"window-list-item-box-more-active");
        }
    }else{
        st_widget_remove_style_pseudo_class(actor,"focus");
    }

}
