//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialMenus.js
#include "cdos.h"
#include "applet-app-context-menu.h"
#include "cdos-popup-menu-item.h"
#include "cdos-provider.h"
#include "cdos-popup-separator-menu-item.h"
#include "cdos-global.h"
#include "cdos-utils-private.h"
#include "cdos-util.h"
#include "cdos-popup-switch-menu-item.h"
#include "applet-window-list.h"
#include "applet-app-list.h"
#include "applet-app-group.h"
#define MENU_ITEM_LABEL_MARGIN_LEFT 10
typedef struct _AppletAppContextMenuSignalIds AppletAppContextMenuSignalIds;
typedef struct _AppletAppContextMenuItems AppletAppContextMenuItems;
/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletAppContextMenuPrivate{
    StSide orientation;
    gboolean is_added;
    MetaWindow *meta_window;
    CdosApp *app;
    gboolean is_favorite_app;
    GList *windows;
    gchar *app_id;
    ClutterEvent *mouse_event;
    StWidget *parent_actor;
    AppletWindowList *applet;
    AppletAppContextMenuItems *items;
    AppletAppContextMenuSignalIds *signal_ids;
    gboolean open_state;
    AppletAppGroup *app_group;
    gboolean is_show_desktop;
};

struct _AppletAppContextMenuItems{
    CdosPopupMenuItem *close_window;
    CdosPopupMenuItem *close_all_windows;
    CdosPopupMenuItem *minimize_window;
    CdosPopupMenuItem *maximize_window;
    CdosPopupMenuItem *move_to_left_workspace;
    CdosPopupMenuItem *move_to_right_workspace;
    CdosPopupMenuItem *on_all_workspaces;
    CdosPopupMenuItem *launch;
    CdosPopupMenuItem *settings;

    CdosPopupSwitchMenuItem *re_arrange;
    CdosPopupSwitchMenuItem *show_pinned;
    CdosPopupSwitchMenuItem *group_apps;
    CdosPopupSwitchMenuItem *show_thumbs;
    CdosPopupSwitchMenuItem *vertical_thumbs;
    CdosPopupSwitchMenuItem *stack_thumbs;
    CdosPopupSwitchMenuItem *enable_peek;
    CdosPopupMenuItem *toggle_favorite;

    CdosPopupSeparatorMenuItem *separator;
    CdosPopupSeparatorMenuItem *separator1;
};
struct _AppletAppContextMenuSignalIds{
    gulong app_context_menu_open_state_changed_id;
    gulong parent_actor_button_release_id;
    gulong parent_actor_key_press_id;
    gulong close_window_activate_id;
    gulong close_all_windows_activate_id;
    gulong minimize_window_activate_id;
    gulong maximize_window_activate_id;
    gulong move_to_left_workspace_activate_id;
    gulong move_to_right_workspace_activate_id;
    gulong on_all_workspaces_activate_id;
    gulong launch_activate_id;
    gulong settings_activate_id;
    gulong re_arrange_toggled_id;
    gulong show_pinned_toggled_id;
    gulong group_apps_toggled_id;
    gulong show_thumbs_toggled_id;
    gulong vertical_thumbs_toggled_id;
    gulong stack_thumbs_toggled_id;
    gulong enable_peek_toggled_id;
    gulong toggle_favorite_toggle_id;

};

static const gchar *single_window_apps[] = {"libreoffice","wps","liteword","litecalc","System Monitor","系统监视器","system-monitor","Music Player","音乐播放器","rhythmbox","__MSG_AppName__","APK应用管理",NULL};


/*-------global variables-------------*/
static gint AppletAppContextMenu_private_offset = 0;

//static CdosGlobal *global = NULL;

/*-------class functions---------*/
static void applet_app_context_menu_init(AppletAppContextMenu *self);
static void applet_app_context_menu_class_init(AppletAppContextMenuClass *klass);

static void applet_app_context_menu_dispose(GObject *object);
static void applet_app_context_menu_finalize(GObject *object);

static void applet_app_context_menu_constructor(AppletAppContextMenu *self,AppletAppContextMenuParams *params);

/*-------------private functions of instance-------------------*/
static gboolean applet_app_context_menu_is_added_to_panel(AppletAppContextMenu *self,gchar *app_id);

static gboolean applet_app_context_menu_parent_actor_on_button_release(ClutterActor *actor,ClutterEvent *event,AppletAppContextMenu *self);

static gboolean applet_app_context_menu_actor_on_key_press(ClutterActor *actor,ClutterEvent *event,AppletAppContextMenu *self);

static void applet_app_context_menu_on_open_state_changed(CdosPopupMenuBase *popup_menu_base,gboolean state,AppletAppContextMenu *self);

static void applet_app_context_menu_refresh(AppletAppContextMenu *self);

static gboolean applet_app_context_menu_has_mata_window(AppletAppContextMenu *self);

static void applet_app_context_menu_items_remove_all_foreach(gpointer actor,AppletAppContextMenu *self);

static void applet_app_context_menu_items_destroy_all(AppletAppContextMenu *self);

static void applet_app_context_menu_items_disconnect_all(AppletAppContextMenu *self);

//右键菜单项触发的回调;
static void applet_app_context_menu_item_on_close_window(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_close_all_windows(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_minimize_window(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_maximize_window(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_move_to_left_workspace(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_move_to_right_workspace(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_on_all_workspaces(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_launch(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_settings(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self);

static void applet_app_context_menu_item_on_re_arrange(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_show_pinned(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_group_apps(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_show_thumbs(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_vertical_thumbs(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_stack_thumbs(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self);
static void applet_app_context_menu_item_on_enable_peek(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self);

static void applet_app_context_menu_item_on_toggle_favorite(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self);


G_DEFINE_TYPE (AppletAppContextMenu, applet_app_context_menu, CDOS_TYPE_POPUP_MENU);

#define APPLET_APP_CONTEXT_MENU_GET_PRIVATE( obj )(G_TYPE_INSTANCE_GET_PRIVATE( (obj), APPLET_TYPE_APP_CONTEXT_MENU, AppletAppContextMenuPrivate) )
/**
 * 实例初始化；
 *
 * */
static void
applet_app_context_menu_init(AppletAppContextMenu *self)
{
    AppletAppContextMenuPrivate *priv;
    self->priv=APPLET_APP_CONTEXT_MENU_GET_PRIVATE(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/
    if(global == NULL){
        global = cdos_global_get();
    }
    priv->signal_ids = g_new0(AppletAppContextMenuSignalIds,1);
    priv->items = g_new0 (AppletAppContextMenuItems, 1);

    priv->signal_ids->app_context_menu_open_state_changed_id = \
    g_signal_connect(CDOS_POPUP_MENU_BASE(self),"open-state-changed",G_CALLBACK(applet_app_context_menu_on_open_state_changed),self);
    priv->is_show_desktop = FALSE;

}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_app_context_menu_class_init(AppletAppContextMenuClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    //g_type_class_adjust_private_offset(klass,&AppletAppContextMenu_private_offset);
    applet_app_context_menu_parent_class = g_type_class_peek_parent(klass);

    g_type_class_add_private(klass, sizeof (AppletAppContextMenuPrivate));

    gobject_class->dispose=applet_app_context_menu_dispose;
    gobject_class->finalize=applet_app_context_menu_finalize;
}

/*------------类方法定义-----------*/
static void applet_app_context_menu_dispose(GObject *object){
    //cdos_debug("%p", object);
    AppletAppContextMenu *self = APPLET_APP_CONTEXT_MENU(object);
    AppletAppContextMenuPrivate *priv = self->priv;
    //notice:此处需要转换为接口函数；

    applet_app_context_menu_items_disconnect_all(self);
    applet_app_context_menu_items_destroy_all (self);

    if(CDOS_POPUP_MENU_BASE(self)->is_open)
        cdos_popup_menu_close ((CdosPopupMenuBase *)self, TRUE);

    G_OBJECT_CLASS(applet_app_context_menu_parent_class)->dispose(object);
}

static void applet_app_context_menu_finalize(GObject *object){
    //cdos_debug ("%p", object);
    AppletAppContextMenu *self = APPLET_APP_CONTEXT_MENU(object);
    AppletAppContextMenuPrivate *priv = self->priv;

    if(priv->windows != NULL){
        g_list_free(priv->windows);
    }
    g_free(priv->items);
    g_free(priv->signal_ids);
    G_OBJECT_CLASS(applet_app_context_menu_parent_class)->finalize(object);
}

static gboolean applet_app_context_menu_is_added_to_panel(AppletAppContextMenu *self,gchar *app_id){
    AppletAppContextMenuPrivate *priv = self->priv;
    GSettings *global_settings = cdos_global_get_settings(global);
    gchar **desktop_files = g_settings_get_strv(global_settings,"panel-launchers");
    int i;
    for (i = 0; desktop_files[i] != NULL; i++) {
        if(g_strcmp0(app_id,desktop_files[i]) == 0){
            return TRUE;
        }
    }
    g_strfreev(desktop_files);
    return FALSE;
}

void applet_app_context_menu_is_favorite(AppletAppContextMenu *self,gboolean is_added){
    AppletAppContextMenuPrivate *priv = self->priv;
    gboolean show_pinned = TRUE;

    /* debug
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    show_pinned = cdos_provider_get_boolean(CDOS_PROVIDER(applet_settings),"show-pinned","value");
    */

    AppletAppContextMenuItems *items = priv->items;
    CdosPopupMenuBase *menu = CDOS_POPUP_MENU_BASE(self);
    if(is_added){
        //cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->settings),-1);
        /*
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->re_arrange),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->show_pinned),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->group_apps),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->show_thumbs),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->stack_thumbs),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->enable_peek),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->vertical_thumbs),-1);
        */
        //cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->separator),-1);

        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->launch),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->toggle_favorite),-1);
    } else if(priv->orientation == ST_SIDE_BOTTOM){
        //cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->on_all_workspaces),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->move_to_left_workspace), 0);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->move_to_right_workspace), 1);

        //cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->separator),-1);

        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->launch),-1);
        if(show_pinned){
            cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->toggle_favorite),-1);
        }else{
            //cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->settings),-1);
        }

        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->separator1),-1);

        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->minimize_window),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->maximize_window),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->close_window),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->close_all_windows),-1);

    } else {

        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->close_all_windows),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->close_window),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->minimize_window),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->maximize_window),-1);

        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->separator),-1);

        if(show_pinned){
            cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->toggle_favorite),-1);
        }else{
            //cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->settings),-1);
        }
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->separator1),-1);

        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->move_to_left_workspace),-1);
        cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->move_to_right_workspace),-1);
        //cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(items->on_all_workspaces),-1);
    }

}

static gboolean applet_app_context_menu_parent_actor_on_button_release(ClutterActor *actor,ClutterEvent *event,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    ClutterModifierType state = clutter_event_get_state(event);
    guint32 button = clutter_event_get_button(event);
    GSettings *global_settings = cdos_global_get_settings(global);
    gboolean panel_edit_mode = g_settings_get_boolean(global_settings,"panel-edit-mode");
    panel_edit_mode = APPLET_WINDOW_LIST_DEBUG == TRUE ? FALSE : panel_edit_mode;
    if((state & CLUTTER_BUTTON1_MASK) || button == 1){
        //notice:此处要转换为接口函数；
        if(CDOS_POPUP_MENU_BASE(self)->is_open){
            cdos_popup_menu_base_toggle(CDOS_POPUP_MENU_BASE(self));
        }
    }else if((state & CLUTTER_BUTTON2_MASK) || button == 2) {
        cdos_popup_menu_close(CDOS_POPUP_MENU_BASE(self),FALSE);
    }else if((state & CLUTTER_BUTTON3_MASK || button == 3) && !panel_edit_mode){
        //priv->mouse_event = event;
        cdos_popup_menu_base_toggle(CDOS_POPUP_MENU_BASE(self));
    }
    return FALSE;
}

static gboolean applet_app_context_menu_actor_on_key_press(ClutterActor *actor,ClutterEvent *event,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    guint symbol = clutter_event_get_key_symbol(event);
    if(symbol == CLUTTER_KEY_space || symbol == CLUTTER_KEY_Return ){

        return TRUE;
    }else if(symbol == CLUTTER_KEY_Escape){

        return TRUE;
    }else if(symbol == CLUTTER_KEY_Down){
        return TRUE;
    }else{
        return FALSE;
    }
}

static void applet_app_context_menu_on_open_state_changed(CdosPopupMenuBase *popup_menu,gboolean state,AppletAppContextMenu *self){
    AppletAppContextMenu *menu = APPLET_APP_CONTEXT_MENU(popup_menu);
    AppletAppContextMenuPrivate *priv = menu->priv;
    AppletAppContextMenuItems *items = priv->items;

    gboolean has_window = applet_app_context_menu_has_mata_window(self);
    if(priv->meta_window == NULL || !has_window){
        cdos_popup_base_menu_item_set_sensitive((CdosPopupBaseMenuItem *)items->launch,TRUE);
        return ;
    }
    priv->open_state = state;
    CdosGenericContainer *actor_left = cdos_popup_base_menu_item_get_actor(CDOS_POPUP_BASE_MENU_ITEM(items->move_to_left_workspace));
    CdosGenericContainer *actor_right = cdos_popup_base_menu_item_get_actor(CDOS_POPUP_BASE_MENU_ITEM(items->move_to_right_workspace));

    MetaScreen *screen = cdos_global_get_screen (global);
    gboolean is_show_desktop = meta_screen_get_showing_desktop(screen);
    priv->is_show_desktop = is_show_desktop;

    if(meta_window_is_on_all_workspaces(priv->meta_window)){
        //cdos_popup_menu_item_set_label(items->on_all_workspaces,_("Only on this workspace"));
        clutter_actor_hide(CLUTTER_ACTOR(actor_left));
        clutter_actor_hide(CLUTTER_ACTOR(actor_right));
    }else if (priv->meta_window != NULL){
        //cdos_popup_menu_item_set_label(items->on_all_workspaces,_("Visible on all workspaces"));
        MetaWorkspace *meta_workspace = meta_window_get_workspace(priv->meta_window);
        MetaWorkspace *neighbor_left = meta_workspace_get_neighbor(meta_workspace,META_MOTION_LEFT);
        MetaWorkspace *neighbor_right = meta_workspace_get_neighbor(meta_workspace,META_MOTION_RIGHT);

        if(meta_workspace != neighbor_left){
            clutter_actor_show(CLUTTER_ACTOR(actor_left));
        }else{
            clutter_actor_hide(CLUTTER_ACTOR(actor_left));
        }
        if(meta_workspace != neighbor_right){
            clutter_actor_show(CLUTTER_ACTOR(actor_right));
        }else{
            clutter_actor_hide(CLUTTER_ACTOR(actor_right));
        }
    }

    if(meta_window_get_maximized(priv->meta_window)){
        cdos_popup_menu_item_set_label(items->maximize_window,_("Unmaximize"));
    }
    if(priv->meta_window != NULL){
        if(meta_window_get_maximized(priv->meta_window)){
            cdos_popup_menu_item_set_label(items->maximize_window,_("Unmaximize"));
        }else{
            cdos_popup_menu_item_set_label(items->maximize_window,_("Maximize"));
        }
        gboolean minimized,resizeable;
        g_object_get(priv->meta_window,"minimized",&minimized,NULL);
        g_object_get(priv->meta_window,"resizeable",&resizeable,NULL);

        if(minimized || priv->is_show_desktop){
            cdos_popup_menu_item_set_label(items->minimize_window,_("Restore"));
            cdos_popup_base_menu_item_set_sensitive((CdosPopupBaseMenuItem *)items->maximize_window,FALSE);
        }else{
            cdos_popup_menu_item_set_label(items->minimize_window,_("Minimize"));
            cdos_popup_base_menu_item_set_sensitive((CdosPopupBaseMenuItem *)items->maximize_window,TRUE);
        }
        if(resizeable == FALSE){
            cdos_popup_base_menu_item_set_sensitive((CdosPopupBaseMenuItem *)items->maximize_window,FALSE);
        }
    }

    //如果是单窗口模式，则冻结打开新窗口功能;
    if(priv->meta_window || has_window){
        const gchar *app_name = cdos_app_get_name(priv->app);
        const gchar **swa = single_window_apps;
        //g_print("\n%s:===========>app_name = %s\n",__func__,app_name);
        gint i;
        gboolean match = FALSE;
        for(i = 0; swa[i] != NULL;i++){
            const gchar *app = swa[i];
            gchar *pattern = g_strconcat("(",app,")+",NULL);
            gboolean m = g_regex_match_simple(pattern,app_name,G_REGEX_CASELESS,G_REGEX_MATCH_ANCHORED);
            g_free(pattern);
            if(m){
                match = m;
                break ;
            }
        }
        if(match){
            cdos_popup_base_menu_item_set_sensitive((CdosPopupBaseMenuItem *)items->launch,FALSE);
        }
    }

}

static void applet_app_context_menu_item_on_close_window(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    guint32 current_time = cdos_global_get_current_time(global);
    if(priv->meta_window){
        meta_window_delete(priv->meta_window,current_time);
    }else{
        AppletAppList* app_list = applet_app_group_get_app_list(priv->app_group);
        applet_app_list_refresh(app_list);
    }
}

static void applet_app_context_menu_item_on_close_all_windows(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    GList *windows = priv->windows;
    while (windows){
        guint32 current_time = cdos_global_get_current_time(global);
        meta_window_delete(windows->data,current_time);
        windows = windows->next;
    }

    g_list_free(priv->windows);
    priv->windows = NULL;

}

static void applet_app_context_menu_item_on_minimize_window(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    g_return_if_fail (priv->meta_window != NULL);
    guint32 current_time = cdos_global_get_current_time(global);
    gboolean minimized;
    if(priv->is_show_desktop){
        meta_window_minimize(priv->meta_window);
    }
    g_object_get(priv->meta_window,"minimized",&minimized,NULL);
    if(minimized){
        meta_window_unminimize(priv->meta_window);
        meta_window_activate(priv->meta_window,current_time);
    }else{
        meta_window_minimize(priv->meta_window);
    }
}

static void applet_app_context_menu_item_on_maximize_window(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    if(meta_window_get_maximized(priv->meta_window)){
        meta_window_unmaximize(priv->meta_window,META_MAXIMIZE_HORIZONTAL | META_MAXIMIZE_VERTICAL);
    }else{
        meta_window_maximize(priv->meta_window,META_MAXIMIZE_HORIZONTAL | META_MAXIMIZE_VERTICAL);
    }
}

static void applet_app_context_menu_item_on_move_to_left_workspace(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    g_return_if_fail (priv->meta_window != NULL);
    MetaWorkspace *meta_workspace = meta_window_get_workspace(priv->meta_window);
    MetaWorkspace *neighbor_left = meta_workspace_get_neighbor(meta_workspace,META_MOTION_LEFT);
    if(neighbor_left){
        meta_window_change_workspace(priv->meta_window,neighbor_left);
        //notice:此处需要main下的checkWorkspaces();

    }
}

static void applet_app_context_menu_item_on_move_to_right_workspace(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    g_return_if_fail (priv->meta_window != NULL);
    MetaWorkspace *meta_workspace = meta_window_get_workspace(priv->meta_window);
    MetaWorkspace *neighbor_right = meta_workspace_get_neighbor(meta_workspace,META_MOTION_RIGHT);
    if(neighbor_right){
        meta_window_change_workspace(priv->meta_window,neighbor_right);
        //notice:此处需要main下的checkWorkspaces();

    }
}

static void 
applet_app_context_menu_item_on_on_all_workspaces(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    g_return_if_fail (priv->meta_window != NULL);
    if(meta_window_is_on_all_workspaces(priv->meta_window)) {
        meta_window_unstick(priv->meta_window);
    }else{
        meta_window_stick(priv->meta_window);
    }
}

static void applet_app_context_menu_item_on_launch(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    gboolean res = cdos_app_open_new_window(priv->app,-1);
    if(res == FALSE){

        gboolean minimized;
        MetaWindow *last_focused_window = priv->meta_window;
        if(!G_IS_OBJECT(last_focused_window)){
            g_print("last_focused_window is not a gobject!\n");
            return ;
        }
        applet_app_group_windows_change_effect(priv->app_group);
        g_object_get(last_focused_window,"minimized",&minimized,NULL);
        guint32 current_time = cdos_global_get_current_time(global);

        meta_window_activate(last_focused_window,current_time);
        if(minimized){
            meta_window_unminimize(last_focused_window);
        }
        meta_window_raise(last_focused_window);
    }
}

static void applet_app_context_menu_item_on_settings(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self){
    cdos_util_spawn_command_line("cdos-settings applets window-list@cdos.org");
}

static void applet_app_context_menu_item_on_re_arrange(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //cdos_provider_set_boolean(CDOS_PROVIDER(applet_settings),"arrange-pinnedApps",NULL,state);
}

static void applet_app_context_menu_item_on_show_pinned(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //cdos_provider_set_boolean(CDOS_PROVIDER(applet_settings),"show-pinned",NULL,state);
}
static void applet_app_context_menu_item_on_group_apps(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //cdos_provider_set_boolean(CDOS_PROVIDER(applet_settings),"group-apps",NULL,state);

}
static void applet_app_context_menu_item_on_show_thumbs(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //cdos_provider_set_boolean(CDOS_PROVIDER(applet_settings),"show-thumbnails",NULL,state);
}
static void applet_app_context_menu_item_on_vertical_thumbs(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //cdos_provider_set_boolean(CDOS_PROVIDER(applet_settings),"vertical-thumbnails",NULL,state);
}
static void applet_app_context_menu_item_on_stack_thumbs(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //cdos_provider_set_boolean(CDOS_PROVIDER(applet_settings),"stack-thumbnails",NULL,state);
}
static void applet_app_context_menu_item_on_enable_peek(CdosPopupSwitchMenuItem *item,gboolean state,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //cdos_provider_set_boolean(CDOS_PROVIDER(applet_settings),"enable-hover-peek",NULL,state);
}

static void applet_app_context_menu_item_on_toggle_favorite(CdosPopupBaseMenuItem *item,ClutterEvent *event,gboolean keep_menu,AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;

    GSettings *settings = cdos_global_get_settings(global);
    gchar **desktop_files = g_settings_get_strv(settings,"panel-launchers");
    guint max_apps = g_settings_get_int(settings, "panel-launchers-max-number");
    if(priv->app_id == NULL){
        return ;
    }
    //AppletAppContextMenuItems *items = priv->items;
    cdos_popup_menu_close(CDOS_POPUP_MENU_BASE(self),FALSE);
    gchar **desktop_files_new = NULL;

    if(priv->is_added){
        desktop_files_new = cdos_strv_elem_del_by_str(desktop_files,priv->app_id);
        g_settings_set_strv(settings,"panel-launchers",(const gchar *const *)desktop_files_new);
        //cdos_popup_menu_item_set_label(items->toggle_favorite,_("Add App"));
    }else{
        if(g_strv_length(desktop_files) < max_apps){
            desktop_files_new = cdos_strv_elem_add(desktop_files,priv->app_id);
            g_settings_set_strv(settings,"panel-launchers",(const gchar *const *)desktop_files_new);
            //cdos_popup_menu_item_set_label(items->toggle_favorite,_("Remove App"));
        }else{
            g_print("too many favoritr application, please delete some first\n");
            gchar *msg = g_strconcat("notify-send ","'",_("Too many applications added"),"' '",_("The max number is 8"),"' ",NULL);
            cdos_util_spawn_command_line(msg);
            cdos_message_tray_want_send_to_applet(FALSE);
            g_free(msg);
        }
    }
    if(desktop_files_new != NULL){
        //notice: you cann't use  "g_strfreev"  to free "desktop_files_new",please see the return of the function "g_ptr_array_free";
        g_free(desktop_files_new);
        g_strfreev(desktop_files);
    }
}

static void applet_app_context_menu_refresh(AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;

    MetaWorkspace *workspace = NULL;
    if(priv->meta_window){
        workspace = meta_window_get_workspace(priv->meta_window);
    }
    GSList *windows = cdos_app_get_windows(priv->app);


    g_return_if_fail (priv->meta_window != NULL);
    if(priv->windows){
        g_list_free(priv->windows);
        priv->windows = NULL;
    }
    while(windows != NULL){
        MetaWindow *win = windows->data;
        if(meta_window_get_workspace(win) == workspace){
            priv->windows = g_list_append(priv->windows,win);
        }
        windows = windows->next;
    }

    if(priv->windows == NULL){
        priv->meta_window = NULL;
    }
    AppletAppContextMenuItems *items = priv->items;
    CdosPopupBaseMenuItem *item = CDOS_POPUP_BASE_MENU_ITEM(items->close_all_windows);
    CdosGenericContainer *actor = cdos_popup_base_menu_item_get_actor(item);
    if(g_list_length(priv->windows) > 1){
        cdos_popup_base_menu_item_show(CDOS_POPUP_BASE_MENU_ITEM(items->close_all_windows));
    } else {
        cdos_popup_base_menu_item_hide(CDOS_POPUP_BASE_MENU_ITEM(items->close_all_windows));
    }

}

static void applet_app_context_menu_constructor(AppletAppContextMenu *self,AppletAppContextMenuParams *params){

    g_return_if_fail(APPLET_APP_CONTEXT_MENU(self));
    AppletAppContextMenuPrivate *priv = self->priv;
    cdos_popup_menu_constructor ((CdosPopupMenu *)self, CLUTTER_ACTOR (params->parent_actor), 0, 2);

    StBin *actor = CDOS_POPUP_MENU(self)->actor;
    //cdos_layout_manager_add_chrome (cdos_monkey_plugin_get_layout_manager (monkey_plugin_get ()),CLUTTER_ACTOR(actor));

    StWidget *box = cdos_popup_menu_base_get_box(CDOS_POPUP_MENU_BASE(self));

    priv->signal_ids->parent_actor_button_release_id =
        g_signal_connect(CLUTTER_ACTOR(priv->parent_actor),"button-release-event",
            G_CALLBACK(applet_app_context_menu_parent_actor_on_button_release),self);
    priv->signal_ids->parent_actor_key_press_id =
        g_signal_connect(CLUTTER_ACTOR(priv->parent_actor),"key-press-event",
            G_CALLBACK(applet_app_context_menu_actor_on_key_press),self);

    AppletAppContextMenuItems *items = priv->items;
    items->separator = cdos_popup_separator_menu_item_new();
    items->separator1 = cdos_popup_separator_menu_item_new();

    //注册菜单项目
#define ADD_NEW_ITEM(item,label) \
    do{\
        PopupBaseMenuItemInit params;\
        cdos_popup_base_menu_item_get_init_params(&params);\
        items->item=cdos_popup_menu_item_new_with_params (_(label),&params);\
        StLabel *item_label = cdos_popup_menu_item_get_label(items->item);\
        clutter_actor_set_margin_left((ClutterActor *)item_label,MENU_ITEM_LABEL_MARGIN_LEFT);\
        priv->signal_ids->item##_activate_id=\
            g_signal_connect((CdosPopupBaseMenuItem *)items->item,"activate",G_CALLBACK(applet_app_context_menu_item_on_##item),self);\
    }while(0)

    ADD_NEW_ITEM(close_window, "Close");
    ADD_NEW_ITEM(close_all_windows, _("Close all"));
    ADD_NEW_ITEM(minimize_window, "Minimize");
    ADD_NEW_ITEM(maximize_window, "Maximize");
    ADD_NEW_ITEM(move_to_left_workspace, "Move to left workspace");
    ADD_NEW_ITEM(move_to_right_workspace, "Move to right workspace");
    ADD_NEW_ITEM(on_all_workspaces, "Visible on all workspace");
    ADD_NEW_ITEM(launch, "New Window");
    ADD_NEW_ITEM(settings, "Go to settings");
#undef ADD_NEW_ITEM
#define ADD_NEW_ITEM(item,setting,label) \
    do{\
        gboolean item =  TRUE;\
        items->item=cdos_popup_switch_menu_item_new ();\
        cdos_popup_switch_menu_item_set_text ((CdosPopupSwitchMenuItem *)items->item, _(label));\
        priv->signal_ids->item##_toggled_id=\
            g_signal_connect(items->item,"toggled",G_CALLBACK(applet_app_context_menu_item_on_##item), self);\
    }while(0)

    //CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    ADD_NEW_ITEM(re_arrange,"arrange-pinnedApps","ReArrange");
    ADD_NEW_ITEM(show_pinned, "show-pinned", "Show Pinned");
    ADD_NEW_ITEM(group_apps, "group-apps", "Group Apps");
    ADD_NEW_ITEM(show_thumbs, "show-thumbnails", "Show Thumbs");
    ADD_NEW_ITEM(vertical_thumbs, "vertical-thumbnails", "Vertical Thumbs");
    ADD_NEW_ITEM(stack_thumbs, "stack-thumbnails", "Stack Thumbs");
    ADD_NEW_ITEM(enable_peek, "hover-peek", "Hover Peek");
#undef ADD_NEW_ITEM

    priv->app_id = cdos_app_get_id(priv->app);
    if(priv->app_id){
        priv->is_added = applet_app_context_menu_is_added_to_panel(self,priv->app_id);
    }

    gboolean show_pinned = TRUE;
    //show_pinned = cdos_provider_get_boolean(CDOS_PROVIDER(applet_settings),"show-pinned",NULL);
    if(show_pinned){
        items->toggle_favorite = cdos_popup_menu_item_new ();
        if(priv->is_added)
            cdos_popup_menu_item_set_label(items->toggle_favorite, _("Remove App"));
        else
            cdos_popup_menu_item_set_label(items->toggle_favorite, _("Add App"));
        if(priv->app_id ){
            cdos_popup_base_menu_item_set_sensitive(CDOS_POPUP_BASE_MENU_ITEM(items->toggle_favorite),TRUE);
        }else{
            cdos_popup_base_menu_item_set_sensitive(CDOS_POPUP_BASE_MENU_ITEM(items->toggle_favorite),FALSE);
        }
        StLabel *item_toggle_favorite_label = cdos_popup_menu_item_get_label(items->toggle_favorite);
        clutter_actor_set_margin_left((ClutterActor *)item_toggle_favorite_label,MENU_ITEM_LABEL_MARGIN_LEFT);
        priv->signal_ids->toggle_favorite_toggle_id =
            g_signal_connect(CDOS_POPUP_BASE_MENU_ITEM(items->toggle_favorite),"activate",
                    G_CALLBACK(applet_app_context_menu_item_on_toggle_favorite),self);

    }
    if(priv->is_favorite_app){
        applet_app_context_menu_is_favorite(self,TRUE);
    }else{
        applet_app_context_menu_is_favorite(self,FALSE);
    }

}


static gboolean
applet_app_context_menu_has_mata_window(AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    MetaWorkspace *workspace = NULL;
    gboolean has_flag = FALSE;
    if(priv->meta_window == NULL){
        return FALSE;
    }
    workspace = meta_window_get_workspace(priv->meta_window);
    GSList *windows = cdos_app_get_windows(priv->app);
    while(windows != NULL){
        MetaWindow *win = windows->data;
        if(meta_window_get_workspace(win) == workspace){
            has_flag = TRUE;
            break;
        }
        windows = windows->next;
    }
    if(windows == NULL || !has_flag){
        priv->meta_window = NULL;
    }
    return has_flag;
}

static void applet_app_context_menu_items_remove_all_foreach(gpointer actor,AppletAppContextMenu *self){
    //AppletAppContextMenuPrivate *priv = self->priv;
    StBoxLayout *box = cdos_popup_menu_base_get_box(CDOS_POPUP_MENU_BASE(self));
    ClutterActor *child = CLUTTER_ACTOR(actor);
    g_object_ref(child);
    st_container_remove_actor(ST_CONTAINER(box),child);
}

static void applet_app_context_menu_items_destroy_all(AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    AppletAppContextMenuItems *items = priv->items;
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->close_window));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->close_all_windows));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->minimize_window));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->maximize_window));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->move_to_left_workspace));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->move_to_right_workspace));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->on_all_workspaces));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->launch));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->settings));

    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->re_arrange));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->show_pinned));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->group_apps));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->show_thumbs));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->vertical_thumbs));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->stack_thumbs));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->enable_peek));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->toggle_favorite));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->separator));
    cdos_popup_base_menu_item_destroy(CDOS_POPUP_BASE_MENU_ITEM(items->separator1));
}

static void applet_app_context_menu_items_disconnect_all(AppletAppContextMenu *self){
    AppletAppContextMenuPrivate *priv = self->priv;
    AppletAppContextMenuSignalIds *signal_ids = priv->signal_ids;
    AppletAppContextMenuItems *items = priv->items;

    g_signal_handler_disconnect(items->close_window,signal_ids->close_window_activate_id);
    signal_ids->close_window_activate_id = 0;
    g_signal_handler_disconnect(items->close_all_windows,signal_ids->close_all_windows_activate_id);
    signal_ids->close_all_windows_activate_id = 0;
    g_signal_handler_disconnect(items->minimize_window,signal_ids->minimize_window_activate_id);
    signal_ids->minimize_window_activate_id = 0;
    g_signal_handler_disconnect(items->maximize_window,signal_ids->maximize_window_activate_id);
    signal_ids->maximize_window_activate_id = 0;
    g_signal_handler_disconnect(items->move_to_left_workspace,signal_ids->move_to_left_workspace_activate_id);
    signal_ids->move_to_left_workspace_activate_id = 0;
    g_signal_handler_disconnect(items->move_to_right_workspace,signal_ids->move_to_right_workspace_activate_id);
    signal_ids->move_to_right_workspace_activate_id = 0;
    g_signal_handler_disconnect(items->on_all_workspaces,signal_ids->on_all_workspaces_activate_id);
    signal_ids->on_all_workspaces_activate_id = 0;
    g_signal_handler_disconnect(items->launch,signal_ids->launch_activate_id);
    signal_ids->launch_activate_id = 0;
    g_signal_handler_disconnect(items->settings,signal_ids->settings_activate_id);
    signal_ids->settings_activate_id = 0;
    g_signal_handler_disconnect(items->re_arrange,signal_ids->re_arrange_toggled_id);
    signal_ids->re_arrange_toggled_id = 0;
    g_signal_handler_disconnect(items->show_pinned,signal_ids->show_pinned_toggled_id);
    signal_ids->show_pinned_toggled_id = 0;
    g_signal_handler_disconnect(items->group_apps,signal_ids->group_apps_toggled_id);
    signal_ids->group_apps_toggled_id = 0;
    g_signal_handler_disconnect(items->show_thumbs,signal_ids->show_thumbs_toggled_id);
    signal_ids->show_thumbs_toggled_id = 0;
    g_signal_handler_disconnect(items->vertical_thumbs,signal_ids->vertical_thumbs_toggled_id);
    signal_ids->vertical_thumbs_toggled_id = 0;
    g_signal_handler_disconnect(items->stack_thumbs,signal_ids->stack_thumbs_toggled_id);
    signal_ids->stack_thumbs_toggled_id = 0;
    g_signal_handler_disconnect(items->enable_peek,signal_ids->enable_peek_toggled_id);
    signal_ids->enable_peek_toggled_id = 0;
    g_signal_handler_disconnect(items->toggle_favorite,signal_ids->toggle_favorite_toggle_id);
    signal_ids->toggle_favorite_toggle_id = 0;

}
/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletAppContextMenu* applet_app_context_menu_new(AppletAppContextMenuParams *params)
{
    AppletAppContextMenu *self;
    self = g_object_new(APPLET_TYPE_APP_CONTEXT_MENU, NULL);
    AppletAppContextMenuPrivate *priv = self->priv;
    priv->meta_window = params->meta_window != NULL ? params->meta_window : NULL;
    priv->parent_actor = params->actor;
    priv->orientation = params->orientation;
    priv->applet = params->applet;
    priv->app = params->app;
    priv->is_favorite_app = params->is_favorite_app;
    priv->app_group = params->app_group;

    applet_app_context_menu_constructor(self,params);
    clutter_container_add_actor ((ClutterContainer *)ui_group, 
                            (ClutterActor *)((CdosPopupMenu *)self)->actor);
    return self;
}

void applet_app_context_menu_remove_items(AppletAppContextMenu *self){
    g_return_if_fail(APPLET_APP_CONTEXT_MENU(self));
    //AppletAppContextMenuPrivate *priv = self->priv;
    //cdos_popup_menu_base_remove_all(CDOS_POPUP_MENU_BASE(self));
    StBoxLayout *box = cdos_popup_menu_base_get_box(CDOS_POPUP_MENU_BASE(self));
    GList *children = st_container_get_children_list ((StContainer *)box);
    //guint children_length = g_list_length(children);
    g_list_foreach(children,applet_app_context_menu_items_remove_all_foreach,self);
}

void applet_app_context_menu_destroy(AppletAppContextMenu *self){
    g_return_if_fail(APPLET_APP_CONTEXT_MENU(self));
    g_clear_object(&self);
}
void applet_app_context_menu_set_meta_window(AppletAppContextMenu *self,MetaWindow *meta_window){
    g_return_if_fail(APPLET_APP_CONTEXT_MENU(self));
    AppletAppContextMenuPrivate *priv = self->priv;

    priv->meta_window = meta_window;
    applet_app_context_menu_refresh(self);
}

MetaWindow* applet_app_context_menu_get_meta_window(AppletAppContextMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_CONTEXT_MENU(self),NULL);
    AppletAppContextMenuPrivate *priv = self->priv;
    return priv->meta_window;
}

CdosApp* applet_app_context_menu_get_app(AppletAppContextMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_CONTEXT_MENU(self),NULL);
    AppletAppContextMenuPrivate *priv = self->priv;
    return priv->app;
}
GList* applet_app_context_menu_get_windows(AppletAppContextMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_CONTEXT_MENU(self),NULL);
    AppletAppContextMenuPrivate *priv = self->priv;
    return priv->windows;
}
gchar * applet_app_context_menu_get_app_id(AppletAppContextMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_CONTEXT_MENU(self),NULL);
    AppletAppContextMenuPrivate *priv = self->priv;
    return priv->app_id;
}

gboolean applet_app_context_menu_get_open_state(AppletAppContextMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_CONTEXT_MENU(self),FALSE);
    AppletAppContextMenuPrivate *priv = self->priv;
    return priv->open_state;
}
