//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js
#include <meta/window.h>
#include <meta/screen.h>
#include "applet-app-group.h"
//添加依赖库;
#include "cdos-popup-menu-manager.h"
#include "applet-window-list-draggable.h"

#include "applet-window-list.h"
#include "cdos-provider.h"
#include "applet-window-list-box.h"
#include "applet-app-list.h"
#include "cdos-window-tracker.h"
#include "applet-window-button.h"
#include "cdos-global.h"
#include "cdos-debug.h"

typedef struct _AppletAppGroupSignalIds AppletAppGroupSignalIds;
typedef struct _AppletAppGroupMetaWindowsSignalIds AppletAppGroupMetaWindowsSignalIds;
typedef struct _AppletAppGroupOtherSignalIds AppletAppGroupOtherSignalIds;

/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletAppGroupPrivate{
    gboolean is_favorite_app;
    gboolean is_not_favorite_app;
    gboolean was_favorite_app;
    StSide orientation;
    AppletAppList *app_list;
    CdosApp *app;
    AppletOrderedHash *meta_windows;
    AppletOrderedHash *meta_workspaces;
    StWidget *actor;
    StWidget *my_actor;
    gboolean app_button_visible;
    gboolean window_buttons_visible;
    AppletAppContextMenu *right_click_menu;
    AppletAppThumbnailHoverMenu *hover_menu;
    gboolean is_draggable_app;
    //last_focus修改为：last_focus_window
    MetaWindow *last_focused_window;
    gboolean focus_state;
    //从私有转为公有；
    AppletButtonBox *window_button_box;
    AppletAppButton *app_button;

    AppletWindowList *applet;
    CdosPopupMenuManager *menu_manager;
    CdosPopupMenuManager *hover_menu_manager;
    AppletWindowListDraggable *draggable;
    AppletAppGroupOtherSignalIds *signal_ids;
};

struct _AppletAppGroupSignalIds{
    MetaWorkspace *meta_workspace;
    gulong window_added_signal_id;
    gulong window_removed_signal_id;
};

struct _AppletAppGroupMetaWindowsSignalIds{
    MetaWindow *meta_window;
    AppletWindowButton *button;
    gulong meta_window_notify_title_id;
    gulong meta_window_notify_appears_focused_id;
    gulong meta_window_changed_workspace_id;
};

struct _AppletAppGroupOtherSignalIds{
    gulong app_button_actor_button_release_id;
    gulong app_button_actor_button_press_id;
    gulong draggable_drag_cancelled_id;
    gulong draggable_drag_end_id;
    gulong global_settings_changed_panel_edit_mode_id;
    gulong applet_settings_arrange_pinnedApps_id;
    gulong applet_settings_changed_title_display_id;
};
/*-------global variables-------------*/
static gint AppletAppGroup_private_offset = 0;
static gpointer applet_app_group_parent_class = NULL;

//static CdosGlobal *global = NULL;

/*-------class functions---------*/
static void applet_app_group_init(AppletAppGroup *self);
static void applet_app_group_class_init(AppletAppGroupClass *klass);

static void applet_app_group_dispose(GObject *object);
static void applet_app_group_finalize(GObject *object);

/*-------------private functions of instance-------------------*/
static void applet_app_group_constructor(AppletAppGroup *self);
static gboolean applet_app_group_app_button_on_press(ClutterActor *actor,ClutterEvent *event,AppletAppGroup *self);
static gboolean applet_app_group_app_button_on_release(ClutterActor *actor,ClutterEvent *event,AppletAppGroup *self);

static void applet_app_group_draggable_on_drag_cancelled(CdosDraggable *draggable,guint64 event_time,AppletAppGroup *self);
static void applet_app_group_draggable_on_drag_end(CdosDraggable *draggable,guint64 event_time,gboolean *is_target,AppletAppGroup *self);

static void applet_app_group_on_changed_panel_edit_mode(GSettings *global_settings,gchar *key,AppletAppGroup *self);
static void applet_app_group_applet_settings_on_arrange_pinned_apps(CdosAppletSettings *settings,AppletAppGroup *self);

static MetaWindow* applet_app_group_get_last_focused_window_private(AppletAppGroup *self);

static void applet_app_group_window_added(AppletAppGroup *self,MetaWorkspace *meta_workspace,MetaWindow *meta_window);
static void applet_app_group_meta_workspace_on_window_added(MetaWorkspace *meta_workspace,MetaWindow *meta_window,AppletAppGroup *self);
static void applet_app_group_window_removed(AppletAppGroup *self,MetaWorkspace *meta_workspace,MetaWindow *meta_window);
static void applet_app_group_meta_workspace_on_window_removed(MetaWorkspace *meta_workspace,MetaWindow *meta_window,AppletAppGroup *self);

static void applet_app_group_window_title_changed(AppletAppGroup *self,MetaWindow *meta_window);

static void applet_app_group_focus_window_change(AppletAppGroup *self,MetaWindow *meta_window);

static void applet_app_group_update_focused_status(AppletAppGroup *self,gboolean force);

static void applet_app_group_focused_label(AppletAppGroup *self,gboolean focus_state);

static void applet_app_group_load_win_box_favs(AppletAppGroup *self);

static void applet_app_group_animate(AppletAppGroup *self);

static void applet_app_group_applet_settings_on_changed_number_display(CdosAppletSettings *applet_settings,GList *params);

static void applet_app_group_meta_workspaces_remove_signals(AppletAppGroupSignalIds *signals,AppletAppGroup *self);

static gint32 applet_app_group_meta_windows_sort(MetaWindow *win1,MetaWindow *win2);

static void applet_app_group_applet_settings_on_changed_title_display(CdosAppletSettings *applet_settings,AppletAppGroup *self);

static void applet_app_group_meta_window_on_notify_title(GObject *meta_window,GParamSpec *pspec,AppletAppGroup *self);

static void applet_app_group_meta_window_on_notify_appears_focused(GObject *meta_window,GParamSpec *pspec,AppletAppGroup *self);

static gint applet_app_group_meta_windows_signals_sort(MetaWindow *win1,MetaWindow *win2);

static DragMotionResult  applet_app_group_handle_drag_over (AppletAppGroup *self, void *source, ClutterActor *actor, float x, float y, guint32 time);

static ClutterActor* applet_app_group_get_drag_actor (AppletAppGroup *self);

static ClutterActor* applet_app_group_get_drag_actor_source (AppletAppGroup *self);

static gboolean applet_hover_menu_controller_on_capture_event(ClutterActor *actor, ClutterEvent *event,gpointer user_data);

static gboolean applet_app_group_is_focus_app(AppletAppGroup *self);

static void applet_app_group_meta_window_on_workspace_changed(MetaWindow *meta_window,gint index,AppletAppGroup *self);

static gboolean applet_app_group_windows_change_effect_after(AppletAppGroup *self);
/*-------functions-------------*/

/**
 * 注册类；
 *
 *
 * */
GType
applet_app_group_get_type(void)
{
    static GType applet_app_group_type = 0;
    if(G_UNLIKELY(applet_app_group_type==0))
    {
        static const GTypeInfo applet_app_group_info = {
                sizeof(AppletAppGroupClass),
                NULL,NULL,
                (GClassInitFunc)applet_app_group_class_init,
                NULL,NULL,
                sizeof(AppletAppGroup),
                0,
                (GInstanceInitFunc)applet_app_group_init
        };
        //类注册
        applet_app_group_type = g_type_register_static(G_TYPE_OBJECT,"AppletAppGroup",&applet_app_group_info,0);
        //g_type_add_class_private(applet_app_group_type, sizeof(AppletAppGroupClassPrivate));
        AppletAppGroup_private_offset =
                g_type_add_instance_private(applet_app_group_type, sizeof(AppletAppGroupPrivate));

    }
    return applet_app_group_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_app_group_get_instance_private(AppletAppGroup *self){
    return (G_STRUCT_MEMBER_P (self, AppletAppGroup_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_app_group_init(AppletAppGroup *self)
{
    AppletAppGroupPrivate *priv;
    self->priv=applet_app_group_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/
    if(global == NULL){
        global = cdos_global_get();
    }
    priv->applet = NULL;
    priv->app_list = NULL;
    priv->app = NULL;
    priv->signal_ids = g_new0(AppletAppGroupOtherSignalIds,1);

    //priv->signal_ids = g_new0(AppletAppGroupSignalIds,1);
    priv->meta_windows = applet_ordered_hash_new();
    priv->meta_workspaces = applet_ordered_hash_new();

    priv->actor = st_bin_new();
    clutter_actor_set_reactive(CLUTTER_ACTOR(priv->actor),TRUE);
    st_widget_set_can_focus(priv->actor,TRUE);
    st_bin_set_fill(ST_BIN(priv->actor),TRUE,FALSE);
    st_widget_set_track_hover(priv->actor,TRUE);

    st_widget_set_style_class_name(ST_WIDGET(priv->actor),"window-list-group");

    priv->my_actor = st_box_layout_new();
    clutter_actor_set_reactive(CLUTTER_ACTOR(priv->my_actor),TRUE);
    st_container_add_actor((ClutterContainer *)priv->actor,CLUTTER_ACTOR(priv->my_actor));
    st_widget_set_style_class_name(ST_WIDGET(priv->my_actor),"window-list-group-box");
    st_widget_set_can_focus(priv->my_actor,TRUE);
    st_widget_set_track_hover(priv->my_actor,TRUE);

    priv->window_button_box = applet_button_box_new();
}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_app_group_class_init(AppletAppGroupClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletAppGroup_private_offset);
    applet_app_group_parent_class = g_type_class_peek_parent(klass);

    /*-------------重写父类的虚方法---------------*/
    //gobject_class->constructed=applet_app_group_constructed;
    gobject_class->dispose=applet_app_group_dispose;
    gobject_class->finalize=applet_app_group_finalize;
}

/*------------类方法定义-----------*/
static void applet_app_group_dispose(GObject *object){
    AppletAppGroup *self = APPLET_APP_GROUP(object);
    AppletAppGroupPrivate *priv = self->priv;

    if(priv->app_button){
        StWidget *applet_icon_label_button_actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(priv->app_button));
        ClutterActor *app_button_actor = CLUTTER_CONTAINER(applet_icon_label_button_actor);
        clutter_container_remove_actor(CLUTTER_CONTAINER(priv->my_actor),app_button_actor);
    }
    if(priv->window_button_box){
        StWidget *window_button_box_actor = applet_button_box_get_actor(priv->window_button_box);
        clutter_container_remove_actor(CLUTTER_CONTAINER(priv->my_actor),CLUTTER_ACTOR(window_button_box_actor));
    }
    applet_ordered_hash_destroy(priv->meta_windows,TRUE);
    applet_ordered_hash_destroy(priv->meta_workspaces,TRUE);
    clutter_container_remove_actor(CLUTTER_CONTAINER(priv->actor),CLUTTER_ACTOR(priv->my_actor));

    g_clear_object(&priv->window_button_box);
    g_clear_object(&priv->app_button);
    g_clear_object(&priv->right_click_menu);
    g_clear_object(&priv->menu_manager);
    g_clear_object(&priv->hover_menu);
    g_clear_object(&priv->hover_menu_manager);
    g_clear_object(&priv->meta_workspaces);
    g_clear_object(&priv->meta_windows);
    g_clear_object(&priv->draggable);

    if(priv->actor){
        g_clear_object(&priv->actor);
    }

    G_OBJECT_CLASS(applet_app_group_parent_class)->dispose(object);
}

static void applet_app_group_finalize(GObject *object){
    AppletAppGroup *self = APPLET_APP_GROUP(object);
    AppletAppGroupPrivate *priv = self->priv;

    g_free(priv->signal_ids);
    G_OBJECT_CLASS(applet_app_group_parent_class)->finalize(object);
}

/*-------------private functions--------------*/
static void applet_app_group_constructor(AppletAppGroup *self){
    AppletAppGroupPrivate *priv = self->priv;

    priv->app_button = applet_app_button_new(self);
    StWidget *applet_icon_label_button_actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(priv->app_button));

    ClutterActor *app_button_actor = CLUTTER_ACTOR(applet_icon_label_button_actor);
    st_container_add_actor((ClutterContainer *)priv->my_actor,CLUTTER_ACTOR(applet_icon_label_button_actor));

    StWidget *window_button_box_actor = applet_button_box_get_actor(priv->window_button_box);

    st_container_add_actor((ClutterContainer *)priv->my_actor,CLUTTER_ACTOR(window_button_box_actor));
    priv->app_button_visible = TRUE;
    priv->window_buttons_visible = TRUE;

    priv->signal_ids->app_button_actor_button_press_id = \
    g_signal_connect(app_button_actor,"button-press-event",G_CALLBACK(applet_app_group_app_button_on_press),self);
    priv->signal_ids->app_button_actor_button_release_id = \
    g_signal_connect(app_button_actor,"button-release-event",G_CALLBACK(applet_app_group_app_button_on_release),self);

    AppletAppThumbnailHoverMenuParams *param_hover = g_malloc0 (sizeof (AppletAppThumbnailHoverMenuParams));
    param_hover->actor = applet_icon_label_button_actor;
    param_hover->orientation = priv->orientation;
    param_hover->app = priv->app;
    param_hover->is_favorite_app = priv->is_favorite_app;
    param_hover->applet = priv->applet;
    priv->hover_menu = applet_app_thumbnail_hover_menu_new (param_hover);
    g_free(param_hover);

    priv->hover_menu_manager = cdos_popup_menu_manager_new ((ClutterActor *)applet_icon_label_button_actor);
    //cdos_popup_menu_manager_set_event_capture(priv->hover_menu_manager,applet_hover_menu_controller_on_capture_event);

    cdos_popup_menu_manager_add_menu (CDOS_POPUP_MENU_MANAGER (priv->hover_menu_manager),
                                                           CDOS_POPUP_MENU_BASE(priv->hover_menu), -1);

    AppletAppContextMenuParams *right_click_menu_params;
    right_click_menu_params = g_new0(AppletAppContextMenuParams,1);
    right_click_menu_params->actor = applet_icon_label_button_actor;
    right_click_menu_params->parent_actor = priv->actor;
    right_click_menu_params->app = priv->app;
    right_click_menu_params->applet = priv->applet;
    right_click_menu_params->is_favorite_app = priv->is_favorite_app;
    right_click_menu_params->orientation = priv->orientation;
    right_click_menu_params->app_group = self;

    priv->right_click_menu = applet_app_context_menu_new(right_click_menu_params);
    g_free(right_click_menu_params);

    priv->menu_manager = cdos_popup_menu_manager_new((ClutterActor *)applet_icon_label_button_actor);

    cdos_popup_menu_manager_add_menu(priv->menu_manager,CDOS_POPUP_MENU_BASE(priv->right_click_menu), -1);
    // new:当右键菜单激活后，不触发窗口预览。
    applet_app_thumbnail_hover_menu_set_context_menu(priv->hover_menu,priv->right_click_menu);
    /* debug:暂时不可用
    priv->draggable = applet_window_list_draggable_make(CLUTTER_ACTOR(priv->actor));
    cdos_draggable_set_delegate (CLUTTER_ACTOR(priv->actor),self);
    cdos_draggable_set_func (CLUTTER_ACTOR(priv->actor), applet_app_group_get_drag_actor, DND_GET_DRAG_ACTOR);
    cdos_draggable_set_func (CLUTTER_ACTOR(priv->actor), applet_app_group_get_drag_actor_source, DND_GET_DRAG_ACTOR_SRC);
    cdos_draggable_set_func (CLUTTER_ACTOR(priv->actor), applet_app_group_handle_drag_over, DND_HANDLE_DRAG_OVER);

    priv->signal_ids->draggable_drag_cancelled_id = \
    g_signal_connect(CDOS_DRAGGABLE(priv->draggable),"drag-cancelled",G_CALLBACK(applet_app_group_draggable_on_drag_cancelled),self);
    priv->signal_ids->draggable_drag_end_id = \
    g_signal_connect(CDOS_DRAGGABLE(priv->draggable),"drag-end",G_CALLBACK(applet_app_group_draggable_on_drag_end),self);
    priv->is_draggable_app = TRUE;

    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    applet_app_group_applet_settings_on_arrange_pinned_apps(applet_settings,self);
    */
    GSettings *global_settings = cdos_global_get_settings(global);
    applet_app_group_on_changed_panel_edit_mode(global_settings,NULL,self);

    priv->signal_ids->global_settings_changed_panel_edit_mode_id = \
    g_signal_connect(global_settings,"changed::panel-edit-mode",G_CALLBACK(applet_app_group_on_changed_panel_edit_mode),self);
    /* debug
     priv->signal_ids->applet_settings_arrange_pinnedApps_id = \
    g_signal_connect(applet_settings,"arrange-pinnedApps",G_CALLBACK(applet_app_group_applet_settings_on_arrange_pinned_apps),self);
    */
};

static gboolean applet_app_group_app_button_on_press(ClutterActor *actor,ClutterEvent *event,AppletAppGroup *self){
    AppletAppGroupPrivate *priv = self->priv;
    guint32 button = clutter_event_get_button(event);

    if(button == 1 || button == 2){
        applet_icon_label_button_icon_sink(APPLET_ICON_LABEL_BUTTON(priv->app_button),2);
        if(button == 1) {
            StWidget *app_button_actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(priv->app_button));
            gboolean is_focus_app = applet_app_group_is_focus_app(self);
            if(is_focus_app){
                st_widget_add_style_pseudo_class(app_button_actor,"active");
            }else{
                st_widget_add_style_pseudo_class(app_button_actor,"click");
            }
        }
    }
    return FALSE;
}

static gboolean applet_app_group_app_button_on_release(ClutterActor *actor,ClutterEvent *event,AppletAppGroup *self){
    AppletAppGroupPrivate *priv = self->priv;
    ClutterModifierType state = clutter_event_get_state(event);
    guint32 button = clutter_event_get_button(event);
    if(button == 1 || button == 2){
        applet_icon_label_button_icon_recovery(APPLET_ICON_LABEL_BUTTON(priv->app_button));
    }
    if(button == 1) {
        StWidget *app_button_actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(priv->app_button));
        st_widget_remove_style_pseudo_class(app_button_actor,"click");
        st_widget_remove_style_pseudo_class(app_button_actor,"active");
    }
    if(((state & CLUTTER_BUTTON1_MASK || button == 1) && priv->is_favorite_app) || ((state & CLUTTER_SHIFT_MASK)  && (state & CLUTTER_BUTTON1_MASK || button == 1))){
        cdos_app_open_new_window (priv->app,-1);
        applet_app_group_animate(self);
        return FALSE;
    }
    MetaScreen *global_screen = cdos_global_get_screen(global);
    GSList *app_windows = cdos_app_get_windows(priv->app);
    gint n_workspaces = meta_screen_get_n_workspaces (global_screen);
    GSList *windows = NULL;
    while (app_windows){
	    guint i;
        MetaWindow *meta_window = app_windows->data;
        MetaWorkspace *window_workspace = meta_window_get_workspace(meta_window);
        for(i = 0; i<n_workspaces;i++){
            MetaWorkspace *workspace = meta_screen_get_workspace_by_index(global_screen,i);
            if(window_workspace == workspace){
                windows = g_slist_append(windows,meta_window);
            }
        }
        app_windows = app_windows->next;
    }

    gint window_num = g_slist_length(windows);
    g_slist_free(windows);
    if(priv->last_focused_window == NULL && !priv->is_favorite_app){
        return FALSE;
    }
    if((state & CLUTTER_BUTTON2_MASK || button == 2)){
        cdos_app_open_new_window (priv->app,-1);
    } else if(state & CLUTTER_BUTTON1_MASK || button == 1){
        gboolean on_click_thumbnails;
        /* debug
        CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
        on_click_thumbnails = cdos_provider_get_boolean(CDOS_PROVIDER(applet_settings),"onclick-thumbnails",NULL);
        */
        on_click_thumbnails = APPLET_WINDOW_LIST_DEBUG == TRUE ? TRUE : on_click_thumbnails;
        if(on_click_thumbnails && window_num >1){
            applet_app_thumbnail_hover_menu_set_should_open(priv->hover_menu,FALSE);
            applet_app_thumbnail_hover_menu_set_should_close(priv->hover_menu,FALSE);
            applet_app_thumbnail_hover_menu_hover_open(priv->hover_menu);
        }
        applet_app_group_window_handle(self,FALSE);
    } else if(state & CLUTTER_BUTTON3_MASK || button == 3){
        applet_app_thumbnail_hover_menu_set_should_open(priv->hover_menu,FALSE);
        applet_app_thumbnail_hover_menu_set_should_close(priv->hover_menu,TRUE);
        applet_app_thumbnail_hover_menu_hover_close(priv->hover_menu);
    }
    return FALSE;
}

static void applet_app_group_draggable_on_drag_cancelled(CdosDraggable *draggable,guint64 event_time,AppletAppGroup *self){
    AppletAppGroupPrivate *priv = self->priv;

    cdos_popup_menu_close(CDOS_POPUP_MENU_BASE(priv->right_click_menu),FALSE);
    cdos_popup_menu_close(CDOS_POPUP_MENU_BASE(priv->hover_menu),FALSE);

    AppletWindowListBox *my_actor_box = applet_app_list_get_my_actor_box(priv->app_list);
    applet_window_list_box_clear_drag_place_holder(my_actor_box);
}

static void applet_app_group_draggable_on_drag_end(CdosDraggable *draggable,guint64 event_time,gboolean *is_target,AppletAppGroup *self){
    AppletAppGroupPrivate *priv = self->priv;


    cdos_popup_menu_close(CDOS_POPUP_MENU_BASE(priv->right_click_menu),FALSE);
    cdos_popup_menu_close(CDOS_POPUP_MENU_BASE(priv->hover_menu),FALSE);

    AppletWindowListBox *my_actor_box = applet_app_list_get_my_actor_box(priv->app_list);
    applet_window_list_box_clear_drag_place_holder(my_actor_box);
}

static void applet_app_group_on_changed_panel_edit_mode(GSettings *global_settings,gchar *key,AppletAppGroup *self){
    g_return_if_fail(NULL != self && APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    ClutterActor *actor = CLUTTER_ACTOR(priv->actor);
    gboolean panel_edit_mode = g_settings_get_boolean(global_settings,"panel-edit-mode");
    clutter_actor_set_reactive(actor,panel_edit_mode ? FALSE : TRUE );
    //notice:需要转换为接口函数；
    //CDOS_DRAGGABLE(priv->draggable)->inhibit = panel_edit_mode;

}

static void applet_app_group_applet_settings_on_arrange_pinned_apps(CdosAppletSettings *settings,AppletAppGroup *self){
    //AppletAppGroupPrivate *priv = self->priv;
    //gboolean arrange_pinned_apps;
    //arrange_pinned_apps = cdos_provider_get_boolean(CDOS_PROVIDER(settings),"arrange-pinnedApps",NULL);
    //notice:需要转换为接口函数；
    //CDOS_DRAGGABLE(priv->draggable)->inhibit = arrange_pinned_apps ? FALSE : TRUE;

}

void applet_app_group_window_handle(AppletAppGroup *self,gboolean from_drag){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    if(priv->last_focused_window == NULL){
        return;
    }
    gboolean minimized;
    MetaWindow *last_focused_window = priv->last_focused_window;
    if(!G_IS_OBJECT(last_focused_window)){
        g_print("last_focused_window is not a gobject!\n");
        return ;
    }

    MetaScreen *screen = cdos_global_get_screen (global);
    gboolean is_show_desktop = meta_screen_get_showing_desktop(screen);

    if(is_show_desktop){
        meta_window_minimize(last_focused_window);
    }
    g_object_get(last_focused_window,"minimized",&minimized,NULL);
    guint32 current_time = cdos_global_get_current_time(global);

    if(meta_window_has_focus(last_focused_window) == FALSE ){
        if(from_drag){
            return;
        }
        if(minimized){
            meta_window_unminimize(last_focused_window);
        }
        meta_window_raise(last_focused_window);
        meta_window_activate(last_focused_window,current_time);
    }else{
        if(minimized){
            meta_window_unminimize(last_focused_window);
        }else{
            meta_window_minimize(last_focused_window);
        }
    }
}

static MetaWindow* applet_app_group_get_last_focused_window_private(AppletAppGroup *self){
    AppletAppGroupPrivate *priv = self->priv;
    GList *list = applet_ordered_hash_keys(priv->meta_windows);
    if(list){
        MetaWindow *mw = g_list_first(list)->data;
        g_list_free(list);
        return mw;
    }else{
        return NULL;
    }

}

static void applet_app_group_window_added(AppletAppGroup *self,MetaWorkspace *meta_workspace,MetaWindow *meta_window){
    AppletAppGroupPrivate *priv = self->priv;
    if(!meta_workspace || !meta_window ){
        g_warning("\nFile = %s >> Func = %s >> Line = %d:meta_workspace or meta_window is NULL!\n",__FILE__,__func__,__LINE__);
        return;
    }
    CdosWindowTracker *tracker = cdos_window_tracker_get_default();
    CdosApp *app = cdos_window_tracker_get_window_app(tracker,meta_window);
    if(app == NULL){
        return ;
    }

    MetaWindowType meta_window_type = meta_window_get_window_type(meta_window);

    if(app == priv->app && applet_ordered_hash_contains(priv->meta_windows,meta_window) == FALSE && cdos_window_tracker_is_window_interesting(meta_window) && meta_window_type == META_WINDOW_NORMAL){

        applet_app_group_windows_change_effect(self);

        AppletWindowButtonParams *params = g_new0(AppletWindowButtonParams,1);
        params->meta_window = meta_window;
        params->is_favorite_app = FALSE;
        params->app = priv->app;
        params->applet = priv->applet;
        params->app_list = priv->app_list;
        params->orientation = priv->orientation;
        //params->parent = self;
        AppletWindowButton *button = applet_window_button_new(params);
        g_free(params);

        StWidget *button_actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(button));
        applet_button_box_add(priv->window_button_box,CLUTTER_ACTOR(button_actor));

        {
            MetaRectangle rect;
            ClutterPoint icon_position;
            ClutterSize  icon_size;
            clutter_actor_get_transformed_position ((ClutterActor *)button_actor, &icon_position.x, &icon_position.y);
            clutter_actor_get_transformed_size ((ClutterActor *)button_actor, &icon_size.width, &icon_size.height);
            rect.x = (gint)icon_position.x;
            rect.y = (gint)icon_position.y;
            rect.width = icon_size.width;
            rect.height = icon_size.height;
            cdos_debug ("%d %d", rect.x, rect.y);
            meta_window_set_icon_geometry (meta_window, &rect);
        }

        if(meta_window){
            priv->last_focused_window = meta_window;
            applet_app_context_menu_set_meta_window(priv->right_click_menu,priv->last_focused_window);
            applet_app_thumbnail_hover_menu_set_meta_window(priv->hover_menu,priv->last_focused_window);
        }
        /*debug
        CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);

        priv->signal_ids->applet_settings_changed_title_display_id = \
        g_signal_connect(applet_settings,"changed::title-display",G_CALLBACK(applet_app_group_applet_settings_on_changed_title_display),self);
         */
        AppletAppGroupMetaWindowsSignalIds *signals = g_new0(AppletAppGroupMetaWindowsSignalIds,1);
        signals->button = button;
        signals->meta_window = meta_window;

        signals->meta_window_notify_title_id = g_signal_connect(G_OBJECT(meta_window),"notify::title",G_CALLBACK(applet_app_group_meta_window_on_notify_title),self);
        signals->meta_window_notify_appears_focused_id = g_signal_connect(G_OBJECT(meta_window),"notify::appears-focused",G_CALLBACK(applet_app_group_meta_window_on_notify_appears_focused),self);

        signals->meta_window_changed_workspace_id = g_signal_connect(meta_window,"workspace-changed",G_CALLBACK(applet_app_group_meta_window_on_workspace_changed),self);

        applet_ordered_hash_set(priv->meta_windows,meta_window,signals);
        /*  该函数存在问题，暂时关闭
        applet_ordered_hash_sort(priv->meta_windows,applet_app_group_meta_windows_signals_sort);
        */
        if(priv->is_favorite_app){
            applet_app_group_is_favorite(self,FALSE);
        }
        applet_app_group_calc_window_number(self,meta_workspace);
    }
	
	const gchar *wm_class = meta_window_get_wm_class (meta_window);
	const gchar *name     =	meta_window_get_title(meta_window);
	if (g_strcmp0 (wm_class, "Viewperf-gui") == 0){
        	cdos_util_spawn_command_line("/usr/bin/remove_maya.sh");
    	}
        if (g_strcmp0 (name, "SPECviewperf") == 0){
                cdos_util_spawn_command_line("/usr/bin/remove_maya.sh");
        }


}

static void applet_app_group_meta_workspace_on_window_added(MetaWorkspace *meta_workspace,MetaWindow *meta_window,AppletAppGroup *self){
    MetaWindowType meta_window_type = meta_window_get_window_type(meta_window);
    //g_print("\n%s:---------->meta_workspace = %x,meta_window = %x,self = %x;\n",__func__,meta_workspace,meta_window,self);
    if(meta_window_type == META_WINDOW_NORMAL){
        applet_app_group_window_added(self,meta_workspace,meta_window);
    }
}

static void applet_app_group_window_removed(AppletAppGroup *self,MetaWorkspace *meta_workspace,MetaWindow *meta_window){
    AppletAppGroupPrivate *priv = self->priv;
    MetaWindow *next_window = NULL;
    GList *windows = NULL;
    windows = applet_ordered_hash_keys(priv->meta_windows);
    if(windows){
        while (windows != NULL){
            MetaWindow *window = windows->data;
            windows = windows->next;
            if(window == meta_window){
                if(windows && windows->data){
                    next_window = windows->data;
                }
                break;
            }
        }
        g_list_free(windows);
    }
    AppletAppGroupMetaWindowsSignalIds *signals = applet_ordered_hash_remove(priv->meta_windows,meta_window);
    if(signals) {
        g_signal_handler_disconnect(signals->meta_window, signals->meta_window_notify_title_id);
        signals->meta_window_notify_title_id = 0;
        g_signal_handler_disconnect(signals->meta_window, signals->meta_window_notify_appears_focused_id);
        signals->meta_window_notify_appears_focused_id = 0;
        g_signal_handler_disconnect(signals->meta_window, signals->meta_window_changed_workspace_id);
        signals->meta_window_changed_workspace_id = 0;

        StWidget *button_actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(signals->button));
        applet_button_box_remove(priv->window_button_box, CLUTTER_ACTOR(button_actor));
        applet_window_button_destroy(signals->button);
        g_clear_object(&signals->button);
        g_free(signals);
    }
    windows = applet_ordered_hash_keys(priv->meta_windows);
    //applet_app_thumbnail_hover_menu_set_is_keep_menu(priv->hover_menu,FALSE);
    if(windows != NULL){
        if(next_window){
            applet_app_thumbnail_hover_menu_set_is_keep_menu(priv->hover_menu,TRUE);
        }else{
            next_window = g_list_last(windows)->data;
        }
        if(next_window){
            priv->last_focused_window = next_window;
            applet_app_group_window_title_changed(self,priv->last_focused_window);
            applet_app_thumbnail_hover_menu_set_meta_window(priv->hover_menu,priv->last_focused_window);
            applet_app_context_menu_set_meta_window(priv->right_click_menu,priv->last_focused_window);
        }
        g_list_free(windows);
    }else{
        priv->last_focused_window = NULL;
        applet_app_thumbnail_hover_menu_set_meta_window(priv->hover_menu,priv->last_focused_window);
		 applet_app_thumbnail_hover_menu_set_is_keep_menu(priv->hover_menu,FALSE);
    }

    applet_app_group_calc_window_number(self,meta_workspace);
    applet_app_thumbnail_hover_menu_refresh(priv->hover_menu);
}

static void applet_app_group_meta_workspace_on_window_removed(MetaWorkspace *meta_workspace,MetaWindow *meta_window,AppletAppGroup *self){
    MetaWindowType meta_window_type = meta_window_get_window_type(meta_window);
    //g_print("\n%s:---------->meta_workspace = %x,meta_window = %x,self = %x;\n",__func__,meta_workspace,meta_window,self);
    if(meta_window_type == META_WINDOW_NORMAL){
        applet_app_group_window_removed(self,meta_workspace,meta_window);
    }
}

static void applet_app_group_window_title_changed(AppletAppGroup *self,MetaWindow *meta_window){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    if(!priv->app_button){
        g_warning("Warning:priv->app_button is undefined!");
        return ;
    }

    if(meta_window != priv->last_focused_window || priv->is_favorite_app){
        return;
    }
    AppletTitleDisplay title_type;
    /* debugCdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);

    title_type = cdos_provider_get_int(CDOS_PROVIDER(applet_settings),"title-display",NULL);
    */
    title_type = APPLET_WINDOW_LIST_DEBUG == TRUE ? APPLET_TITLE_DISPLAY_NONE : title_type;
    gchar *title = meta_window_get_title(meta_window);
    gchar *app_name = cdos_app_get_name(priv->app);

    if(title_type == APPLET_TITLE_DISPLAY_TITLE){
        if(title) {
            applet_icon_label_button_set_text(APPLET_ICON_LABEL_BUTTON(priv->app_button),title);
        }
    }else if(title_type == APPLET_TITLE_DISPLAY_FOCUSED){
        if(title) {
            applet_icon_label_button_set_text(APPLET_ICON_LABEL_BUTTON(priv->app_button),title);
            applet_app_group_update_focused_status(self,TRUE);
        }
    }else if(title_type == APPLET_TITLE_DISPLAY_APP){
        if(app_name) {
            applet_icon_label_button_set_text(APPLET_ICON_LABEL_BUTTON(priv->app_button),app_name);
        }
    }else if(title_type == APPLET_TITLE_DISPLAY_NONE){
        applet_icon_label_button_set_text(APPLET_ICON_LABEL_BUTTON(priv->app_button),"\0");
    }
}

static void applet_app_group_focus_window_change(AppletAppGroup *self,MetaWindow *meta_window){
    g_return_if_fail(NULL != self && APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    if(meta_window_appears_focused(meta_window)){
        priv->last_focused_window = meta_window;
        applet_app_group_window_title_changed(self,priv->last_focused_window);
        applet_app_context_menu_set_meta_window(priv->right_click_menu,priv->last_focused_window);
    }
    AppletTitleDisplay title_type;
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //title_type = cdos_provider_get_int(CDOS_PROVIDER(applet_settings),"title-display",NULL);
    if(title_type == APPLET_TITLE_DISPLAY_FOCUSED){
        applet_app_group_update_focused_status(self,FALSE);
    }
}

static void applet_app_group_update_focused_status(AppletAppGroup *self,gboolean force){
    AppletAppGroupPrivate *priv = self->priv;
    GList *meta_windows = applet_ordered_hash_keys(priv->meta_windows);
    gboolean focus_stae;
    while(meta_windows){
        if(meta_window_appears_focused(meta_windows->data)){
            focus_stae = TRUE;
        }
        meta_windows = meta_windows->next;
    }
    if(priv->focus_state != focus_stae || force){
        applet_app_group_focused_label(self,focus_stae);
    }
    priv->focus_state = focus_stae;
    g_list_free(meta_windows);
}

static void applet_app_group_focused_label(AppletAppGroup *self,gboolean focus_state){
    //AppletAppGroupPrivate *priv = self->priv;
    if(focus_state){
        applet_app_group_show_app_button_label(self,TRUE,150);
    }else{
        applet_app_group_hide_app_button_label(self,TRUE);
    }
}

static void applet_app_group_load_win_box_favs(AppletAppGroup *self){
    AppletAppGroupPrivate *priv = self->priv;
    if(priv->is_favorite_app || priv->was_favorite_app){
        AppletWindowButtonParams *params = g_new0(AppletWindowButtonParams,1);
        params->meta_window = NULL;
        params->is_favorite_app = TRUE;
        params->app = priv->app;
        params->applet = priv->applet;
        params->app_list = priv->app_list;
        params->orientation = priv->orientation;

        AppletWindowButton *button = applet_window_button_new(params);
        g_free(params);

        StWidget *button_actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(button));
        applet_button_box_add(priv->window_button_box,CLUTTER_ACTOR(button_actor));

    }
}

static void applet_app_group_animate(AppletAppGroup *self){
    //AppletAppGroupPrivate *priv = self->priv;
    //clutter_actor_set_z_rotation_from_gravity(CLUTTER_ACTOR(priv->actor),0.0,CLUTTER_GRAVITY_CENTER);
    //notice:此处需要添加tweener;
    if(APPLET_WINDOW_LIST_DEBUG){

    }

}

static void applet_app_group_applet_settings_on_changed_number_display(CdosAppletSettings *applet_settings,GList *params){
    AppletAppGroup *self = g_list_first(params)->data;
    MetaWorkspace *meta_workspace = g_list_last(params)->data;
    applet_app_group_calc_window_number(self,meta_workspace);
}

static void applet_app_group_meta_workspaces_remove_signals(AppletAppGroupSignalIds *signals,AppletAppGroup *self){
    MetaWorkspace *meta_workspace = signals->meta_workspace;
    if(signals->window_added_signal_id > 0){
        g_signal_handler_disconnect(meta_workspace,signals->window_added_signal_id);
        signals->window_added_signal_id = 0;
    }
    if(signals->window_removed_signal_id > 0){
        g_signal_handler_disconnect(meta_workspace,signals->window_removed_signal_id);
        signals->window_removed_signal_id = 0;
    }
}

static gint32 applet_app_group_meta_windows_sort(MetaWindow *win1,MetaWindow *win2){

    guint32  win1_time = meta_window_get_user_time (win1);
    guint32  win2_time = meta_window_get_user_time (win2);
    return win1_time - win2_time;

}
static void applet_app_group_applet_settings_on_changed_title_display(CdosAppletSettings *applet_settings,AppletAppGroup *self){
    AppletAppGroupPrivate *priv = self->priv;
    applet_app_group_window_title_changed(self,priv->last_focused_window);
}
static void applet_app_group_meta_window_on_notify_title(GObject *meta_window,GParamSpec *pspec,AppletAppGroup *self){
    //applet_app_group_window_title_changed(self,(MetaWindow *)meta_window);
}

static void applet_app_group_meta_window_on_notify_appears_focused(GObject *meta_window,GParamSpec *pspec,AppletAppGroup *self){
    applet_app_group_focus_window_change(self,(MetaWindow *)meta_window);
}

static gint applet_app_group_meta_windows_signals_sort(MetaWindow *win1,MetaWindow *win2){
    guint s1 = 0,s2 = 0;
    if(META_IS_WINDOW(win1)){
         s1 = meta_window_get_stable_sequence (win1);
    }
    if(!META_IS_WINDOW(win2)){
         s2 = meta_window_get_stable_sequence (win2);
    }
    return s1-s2;
}

static DragMotionResult  applet_app_group_handle_drag_over (AppletAppGroup *self, void *source, ClutterActor *actor, float x, float y, guint32 time){

    if(APPLET_IS_APP_GROUP(source) || applet_app_group_get_is_draggabel_app(source)){
        return DRAG_MOTION_CONTINUE;
    }
    return DRAG_MOTION_CONTINUE;
}

static ClutterActor* applet_app_group_get_drag_actor (AppletAppGroup *self){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    gfloat panel_height = cdos_applet_get_panel_height(CDOS_APPLET(priv->applet));
    return cdos_app_create_icon_texture(priv->app,panel_height);
}

static ClutterActor* applet_app_group_get_drag_actor_source (AppletAppGroup *self){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    return priv->actor;
}

static gboolean applet_hover_menu_controller_on_capture_event(ClutterActor *actor, ClutterEvent *event,gpointer user_data){
    return FALSE;
}
static gboolean applet_app_group_is_focus_app(AppletAppGroup *self){
    AppletAppGroupPrivate *priv = self->priv;
    GSList *windows = cdos_app_get_windows(priv->app);
    gint focus = FALSE;
    while (windows){
        MetaWindow *meta_window = windows->data;
        if(meta_window_appears_focused(meta_window) || meta_window_has_focus(meta_window)){
            focus = TRUE;
            break ;
        }
        windows = windows->next;
    }
    return focus;
}
static void
applet_app_group_meta_window_on_workspace_changed(MetaWindow *meta_window,gint index,AppletAppGroup *self){
    AppletAppGroupPrivate *priv = self->priv;
    gboolean is_on_all_workspaces = meta_window_is_on_all_workspaces(meta_window);
    if(is_on_all_workspaces == FALSE){
        /* 暂时用不上了
        MetaWorkspace *mw = applet_app_list_get_workspace(priv->app_list);
        MetaWorkspace *new_workspace = meta_window_get_workspace(meta_window);
        gint new_index = meta_workspace_index(new_workspace);
        gint mw_index = meta_workspace_index(mw);
        g_print("\n%s:---->mw = %x,index = %d,new_index = %d,mw_index = %d;\n",__func__,mw,index,new_index,mw_index);
        if(mw){
            //applet_app_group_calc_window_number(self,mw);
        }*/
    }
}
void
applet_app_group_windows_change_effect(AppletAppGroup *self){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    StWidget *app_button_actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(priv->app_button));
    gboolean is_focus_app = applet_app_group_is_focus_app(self);
    st_widget_add_style_pseudo_class(app_button_actor,"click");
    gint time_out = 100;
    g_timeout_add(time_out,(GSourceFunc)applet_app_group_windows_change_effect_after ,self);
}
static gboolean
applet_app_group_windows_change_effect_after(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),false);
    AppletAppGroupPrivate *priv = self->priv;
    StWidget *app_button_actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(priv->app_button));
    st_widget_remove_style_pseudo_class(app_button_actor,"click");
    return FALSE;
}
/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletAppGroup* applet_app_group_new(AppletWindowList *applet,AppletAppList *app_list,CdosApp *app,gboolean is_favorite_app,StSide orientation)
{
    if(!CDOS_IS_APP(app)){
        g_warning(":File = %s >> Func = %s >> Line = %d:app is NULL!;\n",__FILE__,__func__,__LINE__);
    }
    AppletAppGroup *self;
    self = g_object_new(APPLET_TYPE_APP_GROUP, NULL);

    AppletAppGroupPrivate *priv;
    priv = self->priv;

    priv->applet = applet;
    priv->app_list = app_list;
    priv->app = app;
    priv->is_favorite_app = is_favorite_app;
    priv->is_not_favorite_app = is_favorite_app == TRUE ? FALSE : TRUE;
    priv->orientation = orientation;

    applet_app_group_constructor(self);

    return self;
}

void applet_app_group_watch_workspace(AppletAppGroup *self,MetaWorkspace *meta_workspace){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    if(meta_workspace == NULL){
        g_warning(":File = %s >> Func = %s >> Line = %d:meta_workspace is NULL!;\n",__FILE__,__func__,__LINE__);
        return;
    }
    AppletAppGroupPrivate *priv = self->priv;
    if(!applet_ordered_hash_contains(priv->meta_workspaces,meta_workspace)){
        gulong window_added_signal,window_removed_signal;
        window_added_signal = g_signal_connect_after(meta_workspace,"window-added",G_CALLBACK(applet_app_group_meta_workspace_on_window_added),self);
        window_removed_signal = g_signal_connect_after(meta_workspace,"window-removed",G_CALLBACK(applet_app_group_meta_workspace_on_window_removed),self);

        AppletAppGroupSignalIds *signalIds = g_new0(AppletAppGroupSignalIds,1);
        signalIds->meta_workspace = meta_workspace;
        signalIds->window_added_signal_id = window_added_signal;
        signalIds->window_removed_signal_id = window_removed_signal;
        applet_ordered_hash_set(priv->meta_workspaces,meta_workspace,signalIds);
    }
    applet_app_group_calc_window_number(self,meta_workspace);
    /* debug
    GList *params = NULL;
    params = g_list_append(params,self);
    params = g_list_append(params,meta_workspace);
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    g_signal_connect(applet_settings,"changed::number-display",G_CALLBACK(applet_app_group_applet_settings_on_changed_number_display),params);
    */
}

void applet_app_group_unwatch_workspace(AppletAppGroup *self,MetaWorkspace *meta_workspace){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    GList *items = applet_ordered_hash_items(priv->meta_workspaces);
    if(!meta_workspace){
        //GList *keys = applet_ordered_hash_keys(priv->meta_workspaces);
        g_list_foreach(items,applet_app_group_meta_workspaces_remove_signals,self);
        g_list_free(items);
        applet_ordered_hash_destroy(priv->meta_workspaces,TRUE);

    }else if(applet_ordered_hash_contains(priv->meta_workspaces,meta_workspace)){
        GList *it = NULL;
        for(it = items;it;it = it->next){
            AppletAppGroupSignalIds *signals = it->data;
            if(signals->meta_workspace == meta_workspace){
                applet_app_group_meta_workspaces_remove_signals(signals,self);
                applet_ordered_hash_remove(priv->meta_workspaces,meta_workspace);
                g_free(signals);
                break;
            }
        }
    }
}

void applet_app_group_hide_window_buttons(AppletAppGroup *self,gboolean animate){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    applet_button_box_hide(priv->window_button_box,animate);
    priv->window_buttons_visible = FALSE;
}

void applet_app_group_show_window_buttons(AppletAppGroup *self,gboolean animate){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    gfloat target_width = 0;
    if(animate){
        target_width = clutter_actor_get_width(CLUTTER_ACTOR(priv->actor));
    }
    applet_button_box_show(priv->window_button_box,animate,target_width);
    priv->window_buttons_visible = TRUE;

}

void applet_app_group_hide_app_button(AppletAppGroup *self,gboolean animate){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    applet_icon_label_button_hide(APPLET_ICON_LABEL_BUTTON(priv->app_button),animate);
    priv->app_button_visible = FALSE;

}

void applet_app_group_show_app_button(AppletAppGroup *self,gboolean animate){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    gfloat target_width = 0;
    if(animate){
        target_width = clutter_actor_get_width(CLUTTER_ACTOR(priv->actor));
    }
    applet_icon_label_button_show(APPLET_ICON_LABEL_BUTTON(priv->app_button),animate,target_width);
    priv->app_button_visible = TRUE;

}

void applet_app_group_hide_app_button_label(AppletAppGroup *self,gboolean animate){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    applet_icon_label_button_hide_label(APPLET_ICON_LABEL_BUTTON(priv->app_button),animate);
}

void applet_app_group_show_app_button_label(AppletAppGroup *self,gboolean animate,gint target_width){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    applet_icon_label_button_show_label(APPLET_ICON_LABEL_BUTTON(priv->app_button),animate,target_width);

}

void applet_app_group_destroy(AppletAppGroup *self){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;

    GList *meta_windows = applet_ordered_hash_items(priv->meta_windows);
    while(meta_windows){
        AppletAppGroupMetaWindowsSignalIds *signals = meta_windows->data;
        if(signals){
            g_signal_handler_disconnect(signals->meta_window,signals->meta_window_notify_title_id);
            g_signal_handler_disconnect(signals->meta_window,signals->meta_window_notify_appears_focused_id);
            signals->meta_window_notify_appears_focused_id = 0;
            signals->meta_window_notify_title_id = 0;
            g_clear_object(&signals->button);
            signals->button = NULL;
        }
        meta_windows = meta_windows->next;
    }
    g_list_free(meta_windows);

    applet_app_context_menu_destroy(priv->right_click_menu);
    applet_app_thumbnail_hover_menu_destroy(priv->hover_menu);
    applet_app_group_unwatch_workspace(self,NULL);
    applet_app_button_destroy(priv->app_button);

    applet_button_box_destroy(priv->window_button_box);
    clutter_actor_destroy(CLUTTER_ACTOR(priv->my_actor));
    priv->my_actor = NULL;
    clutter_actor_destroy(CLUTTER_ACTOR(priv->actor));
    priv->actor = NULL;
}

void applet_app_group_new_app_key_number(AppletAppGroup *self,gint number){
    //AppletAppGroupPrivate *priv = self->priv;
    if(number < 10){
        //notice:此处需要添加快捷键绑定；
    }
}
void applet_app_group_update_meta_windows(AppletAppGroup *self,MetaWorkspace *meta_workspace){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    if(meta_workspace == NULL){
        g_warning("\nFile = %s >> Func = %s >> Line = %d:meta_workspace is NULL!\n",__FILE__,__func__,__LINE__);
        return;
    }
    CdosWindowTracker *tracker = cdos_window_tracker_get_default();
    GList *window_list = meta_workspace_list_windows(meta_workspace);
    //GList *new_window_list;
    applet_button_box_clear(priv->window_button_box);
    //notice:该函数涉及内存泄露问题，暂时关闭使用。
    //applet_app_group_load_win_box_favs(self);
    if(window_list){
        while (window_list){
            MetaWindow *meta_window = window_list->data;
            CdosApp *app = cdos_window_tracker_get_window_app(tracker,meta_window);
            if(app == priv->app && cdos_window_tracker_is_window_interesting(meta_window)){
                applet_app_group_window_added(self,meta_workspace,meta_window);
            }
            window_list = window_list->next;
        }
    }
    if(!priv->last_focused_window){
        priv->last_focused_window = applet_app_group_get_last_focused_window_private(self);
    }

    if(priv->last_focused_window){
        applet_app_group_window_title_changed(self,priv->last_focused_window);
        applet_app_context_menu_set_meta_window(priv->right_click_menu,priv->last_focused_window);
    }
}

void applet_app_group_calc_window_number(AppletAppGroup *self,MetaWorkspace *meta_workspace){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;

    if(!priv->app_button){
        g_warning("Warning:priv->app_button is NULL!");
        return ;
    }
    GSList *app_windows = cdos_app_get_windows(priv->app);
    if(app_windows == NULL && !priv->is_favorite_app){
        return;
    }
    GSList *list = app_windows;
    GSList *new_app_windows = NULL;
    while (list){
        MetaWindow *meta_window = list->data;
        MetaWorkspace *mw = meta_window_get_workspace(meta_window);
        MetaWindowType meta_window_type = meta_window_get_window_type(meta_window);

        if(meta_window_type == META_WINDOW_NORMAL && meta_workspace == mw){
            new_app_windows = g_slist_append(new_app_windows,list->data);
        }
        list = list->next;
    }
    gint window_num = g_slist_length(new_app_windows);
    g_slist_free(new_app_windows);
    //gint display_num = 0;
    /* debug
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    display_num = cdos_provider_get_int(CDOS_PROVIDER(applet_settings),"number-display",NULL);
    */
    gchar *num_label_text;
    num_label_text = g_strdup_printf ("%d", window_num);
    applet_icon_label_button_set_num_label_text(APPLET_ICON_LABEL_BUTTON(priv->app_button),num_label_text);

    StWidget *app_button_num_label = applet_icon_label_button_get_label(APPLET_ICON_LABEL_BUTTON(priv->app_button));
    clutter_actor_hide(CLUTTER_ACTOR(app_button_num_label));

    StWidget *app_button_actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(priv->app_button));
    st_widget_set_style_class_name(app_button_actor,NULL);
    gfloat mod_value = 0;
    if(window_num == 0){
        st_widget_set_style_class_name(app_button_actor,"window-list-item-box-none");
        mod_value = 0;
    }else if(window_num == 1){
        st_widget_set_style_class_name(app_button_actor,"window-list-item-box-one");
        mod_value = 0;
    }else if(window_num == 2){
        st_widget_set_style_class_name(app_button_actor,"window-list-item-box-two");
        mod_value = -1;
    }else if(window_num >= 3){
        st_widget_set_style_class_name(app_button_actor,"window-list-item-box-more");
        mod_value = -1;
    }
    applet_icon_label_button_set_icon_modification_x(APPLET_ICON_LABEL_BUTTON(priv->app_button),mod_value);
    g_free(num_label_text);
    //st_widget_set_style(app_button_actor,"background-size:64px 50px;");
    applet_app_button_update_actor_style(priv->app_button);
}

void applet_app_group_is_favorite(AppletAppGroup *self,gboolean is_favorite){

    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;

    priv->is_favorite_app = is_favorite;
    priv->was_favorite_app = is_favorite == TRUE ? FALSE : TRUE;
    applet_app_button_is_favorite(priv->app_button,is_favorite);

    applet_app_context_menu_remove_items(priv->right_click_menu);
    applet_app_context_menu_is_favorite(priv->right_click_menu,is_favorite);

    AppletAppSwitcherItem *app_switcher_item = applet_app_thumbnail_hover_menu_get_app_switcher_item(priv->hover_menu);
    applet_app_switcher_item_is_favorite(app_switcher_item,is_favorite);

    applet_app_group_window_title_changed(self,priv->last_focused_window);
}

void applet_app_group_show(AppletAppGroup *self){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    clutter_actor_show(CLUTTER_ACTOR(priv->actor));
};

void applet_app_group_hide(AppletAppGroup *self){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    clutter_actor_hide(CLUTTER_ACTOR(priv->actor));
};

AppletWindowList* applet_app_group_get_applet(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),NULL);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->applet;
}
gboolean applet_app_group_get_is_favorite_app(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),FALSE);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->is_favorite_app;
}

AppletAppList* applet_app_group_get_app_list(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),NULL);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->app_list;
}

CdosApp* applet_app_group_get_app(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),NULL);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->app;
}

gboolean applet_app_group_get_was_favorite_app(AppletAppGroup *self){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    return priv->was_favorite_app;
}

StWidget* applet_app_group_get_actor(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),NULL);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->actor;
}

StWidget* applet_app_group_get_my_actor(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),NULL);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->my_actor;
}

gboolean applet_app_group_get_app_button_visible(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),FALSE);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->app_button_visible;
}

gboolean applet_app_group_get_window_buttons_visible(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),FALSE);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->window_buttons_visible;
}

void applet_app_group_set_window_buttons_visible(AppletAppGroup *self,gboolean visible){
    g_return_if_fail(APPLET_IS_APP_GROUP(self));
    AppletAppGroupPrivate *priv = self->priv;
    priv->window_buttons_visible = visible;
}

MetaWindow* applet_app_group_get_last_focused_window(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),NULL);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->last_focused_window;
}

AppletButtonBox* applet_app_group_get_window_button_box(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),NULL);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->window_button_box;
}

AppletAppButton* applet_app_group_get_app_button(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),NULL);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->app_button;
}
gboolean applet_app_group_get_is_draggabel_app(AppletAppGroup *self){
    g_return_val_if_fail(APPLET_IS_APP_GROUP(self),FALSE);
    AppletAppGroupPrivate *priv = self->priv;
    return priv->is_draggable_app;
};
