//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js

#ifndef __APPLET_APP_GROUP_H__
#define __APPLET_APP_GROUP_H__
#include <clutter/clutter.h>
#include <glib-object.h>
#include <meta/workspace.h>

#include "applet-window-list-private.h"
#include "cdos-app.h"
#include "applet-ordered-hash.h"
#include "st.h"
#include "applet-app-context-menu.h"
#include "applet-app-thumbnail-hover-menu.h"
#include "applet-app-button.h"
#include "applet-button-box.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_APP_GROUP (applet_app_group_get_type())
//强制类型转换;
#define APPLET_APP_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_APP_GROUP,AppletAppGroup))
//检测类型实例
#define APPLET_IS_APP_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_APP_GROUP))
//类型转换(可选)
#define APPLET_APP_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_APP_GROUP,AppletAppGroupClass))
//检测是否是类的成员(可选)
#define APPLET_IS_APP_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_APP_GROUP))
//获取实例对象的类结构(可选)
#define APPLET_APP_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_APP_GROUP,AppletAppGroupClass))

//定义对象实例
//typedef struct _AppletAppGroup AppletAppGroup;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletAppGroupClass AppletAppGroupClass;

typedef struct _AppletAppGroupPrivate AppletAppGroupPrivate;

struct _AppletAppGroup {
    GObject parent;
    /*private*/
    AppletAppGroupPrivate *priv;
};
struct _AppletAppGroupClass {
    GObjectClass parent_class;
};
//取得对象类型ID;
GType	applet_app_group_get_type(void);
//创建对象实例;
AppletAppGroup*  applet_app_group_new(AppletWindowList *applet,AppletAppList *app_list,CdosApp *app,gboolean is_favorite_app,StSide orientation);

//对象的属性成员方法列表;
void applet_app_group_watch_workspace(AppletAppGroup *self,MetaWorkspace *meta_workspace);

void applet_app_group_unwatch_workspace(AppletAppGroup *self,MetaWorkspace *meta_workspace);

void applet_app_group_hide_window_buttons(AppletAppGroup *self,gboolean animate);

void applet_app_group_show_window_buttons(AppletAppGroup *self,gboolean animate);

void applet_app_group_hide_app_button(AppletAppGroup *self,gboolean animate);

void applet_app_group_show_app_button(AppletAppGroup *self,gboolean animate);

void applet_app_group_hide_app_button_label(AppletAppGroup *self,gboolean animate);

void applet_app_group_show_app_button_label(AppletAppGroup *self,gboolean animate,gint target_width);

void applet_app_group_destroy(AppletAppGroup *self);

AppletWindowList* applet_app_group_get_applet(AppletAppGroup *self);

void applet_app_group_show(AppletAppGroup *self);

void applet_app_group_hide(AppletAppGroup *self);

//该函数由私有转为公有
void applet_app_group_new_app_key_number(AppletAppGroup *self,gint number);

void applet_app_group_update_meta_windows(AppletAppGroup *self,MetaWorkspace *meta_workspace);

void applet_app_group_calc_window_number(AppletAppGroup *self,MetaWorkspace *meta_workspace);

void applet_app_group_is_favorite(AppletAppGroup *self,gboolean is_favorite);

//getter and setter functions
gboolean applet_app_group_get_is_favorite_app(AppletAppGroup *self);

AppletAppList* applet_app_group_get_app_list(AppletAppGroup *self);

CdosApp* applet_app_group_get_app(AppletAppGroup *self);

gboolean applet_app_group_get_was_favorite_app(AppletAppGroup *self);

StWidget* applet_app_group_get_actor(AppletAppGroup *self);

StWidget* applet_app_group_get_my_actor(AppletAppGroup *self);

gboolean applet_app_group_get_app_button_visible(AppletAppGroup *self);

gboolean applet_app_group_get_window_buttons_visible(AppletAppGroup *self);

void applet_app_group_set_window_buttons_visible(AppletAppGroup *self,gboolean visible);

MetaWindow* applet_app_group_get_last_focused_window(AppletAppGroup *self);

AppletButtonBox* applet_app_group_get_window_button_box(AppletAppGroup *self);

AppletAppButton* applet_app_group_get_app_button(AppletAppGroup *self);

gboolean applet_app_group_get_is_draggabel_app(AppletAppGroup *self);

void applet_app_group_window_handle(AppletAppGroup *self,gboolean from_drag);

void applet_app_group_windows_change_effect(AppletAppGroup *self);

#endif //__APPLET_APP_GROUP_H__
