//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js

#include "applet-app-list.h"
//添加依赖库;
#include <meta/window.h>
#include <meta/workspace.h>
#include <math.h>
#include "applet-ordered-hash.h"
#include "applet-app-tracker.h"
#include "cdos-window-tracker.h"
#include "applet-window-list.h"

#include "cdos-global.h"
#include "cdos-provider.h"
#include "applet-app-group.h"
#include "cdos-app-system.h"
#include "applet-window-list-box.h"
#include "cdos-tooltip.h"

typedef struct _AppletAppListSignalIds AppletAppListSignalIds;

/*-----------------信号枚举-------------------*/
enum {
    APPLET_APP_LIST_APP_GROUP_COUNT_CHANGE,
    APPLET_APP_LIST_PAGE_SIZE_CHANGE,
    APPLET_APP_LIST_PAGE_COUNT_CHANGE,
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletAppListPrivate{
    StSide orientation;
    AppletWindowListBox *my_actor_box;
    StWidget *actor;
    GList *signals;
    MetaWorkspace *meta_workspace;

    StWidget *button_box;
    //总页数
    guint page_count;
    //每页显示数
    guint page_size;
    //当前页码
    guint page_number;
    StWidget *button_prev;
    StWidget *button_next;
    CdosTooltip *button_prev_tooltip;
    CdosTooltip *button_next_tooltip;

    AppletWindowList *applet;
    AppletOrderedHash *app_list;
    AppletAppTracker *tracker;
    AppletAppListSignalIds *signal_ids;
};

struct _AppletAppListSignalIds{
    gulong app_notify_state_id;
    gulong app_list_app_group_count_change_id;
    gulong app_list_page_size_change_id;
    gulong app_list_page_count_change_id;
    gulong button_prev_clicked_id;
    gulong button_next_clicked_id;
    gulong app_list_scroll_id;
};

/*-------prototypes---------*/
static void applet_app_list_init(AppletAppList *self);
static void applet_app_list_class_init(AppletAppListClass *klass);

static void applet_app_list_dispose(GObject *object);

static void applet_app_list_finalize(GObject *object);

/*-------variables-------------*/
static gint applet_app_list_signals[LAST_SIGNAL] = { 0 };
static gint AppletAppList_private_offset = 0;
static gpointer applet_app_list_parent_class = NULL;

//static CdosGlobal *global = NULL;
static gint app_group_number;

/*-------functions-------------*/
static void applet_app_list_on_changed_panel_edit_mode(GSettings *global_settings,gchar *key,AppletAppList *self);

static void applet_app_list_set_signals(AppletAppList *self);

static void applet_app_list_group_apps(AppletAppList *self);

static void applet_app_list_refresh_list(AppletAppList *self);

static gint applet_app_list_app_group_number(AppletAppList *self,CdosApp *parent_app);

static void applet_app_list_refresh_app_group_number(AppletAppList *self);

static void applet_app_list_window_added(AppletAppList *self,MetaWorkspace *meta_workspace,MetaWindow *meta_window,CdosApp *favapp,gboolean is_favapp);

static void applet_app_list_on_window_added(MetaWorkspace *meta_workspace,MetaWindow *meta_window,AppletAppList *self);

static void applet_app_list_remove_app(AppletAppList *self,CdosApp *app);

static void applet_app_list_load_favorites(AppletAppList *self);

static void applet_app_list_window_removed(AppletAppList *self,MetaWorkspace *meta_workspace,MetaWindow *meta_window);

static void applet_app_list_on_window_removed(MetaWorkspace *meta_workspace,MetaWindow *meta_window,AppletAppList *self);

static void applet_app_list_on_changed_pinned_apps(CdosAppletSettings *settings,AppletAppList *self);

static void applet_app_list_on_changed_group_apps(CdosAppletSettings *settings,AppletAppList *self);

static void applet_app_list_on_changed_show_pinned(GSettings *settings,AppletAppList *self);

static void applet_app_list_on_changed_panel_launchers(GSettings *settings,gchar *key,AppletAppList *self);

static void applet_app_list_foreach_func(CdosApp *app,AppletAppGroup *data,gint index,gboolean *group_apps);

static void applet_app_list_refresh_apps_foreach_callback(MetaWindow *meta_window,AppletAppList *self);

static void applet_app_list_refresh_list_foreach_func(CdosApp *app,AppletAppGroup *data,gint index,AppletAppList *self);

static void applet_app_list_app_group_number_foreach_func(CdosApp *app,AppletAppGroup *data,gint index,CdosApp *parent_app);

static void applet_app_list_refresh_app_group_number_foreach_func(CdosApp *app,AppletAppGroup *data,gint index);

static void applet_app_list_app_notify_state_callback(CdosApp *app,GParamSpec *pspec,AppletAppList *self);

static gboolean applet_app_list_remove_app_callback(AppletAppList *self);

static void applet_app_list_destroy_signals_foreach_func(gulong signal_id,AppletAppList *self);

static void applet_app_list_destroy_app_list_foreach_func(CdosApp *app,AppletAppGroup *data,gint index);

static void applet_app_list_group_apps_foreach(CdosApp *app,AppletAppGroup *app_group,gint index,gpointer group_apps);

static gboolean applet_app_list_remove_app_refresh(AppletAppList *self);

static void applet_app_list_set_pagination(AppletAppList *self);

static void applet_app_list_pagination_hide(AppletAppList *self);

static void applet_app_list_pagination_show(AppletAppList *self);

static void applet_app_list_on_app_group_count_change(AppletAppList *self);

static void applet_app_list_on_page_size_change(AppletAppList *self);

static void applet_app_list_page_count_change(AppletAppList *self,guint new_count);

static void applet_app_list_button_prev_on_page_up(StButton *button, gint clicked_button,AppletAppList *self);

static void applet_app_list_button_next_on_page_down(StButton *button, gint clicked_button,AppletAppList *self);

static void applet_app_list_page_up(AppletAppList *self);

static void applet_app_list_page_down(AppletAppList *self);

static void applet_app_list_button_prev_set_state(AppletAppList *self,gboolean state);

static void applet_app_list_button_next_set_state(AppletAppList *self,gboolean state);

static void applet_app_list_pagination_refresh(AppletAppList *self);

static void applet_app_list_set_page_number(AppletAppList *self,guint new_page_number);

static gboolean applet_app_list_on_scroll(ClutterActor *actor,ClutterEvent *event,AppletAppList *self);

static void applet_app_list_on_panel_resize(ClutterActor* actor, GParamSpec *pspec, AppletAppList* self);
static void applet_app_list_recalc_page_size(AppletAppList *self);

static void applet_app_list_system_on_installed_changed(CdosAppSystem *app_system,AppletAppList *self);

static void applet_app_list_on_tracked_window_changed(CdosWindowTracker *tracker,AppletAppList *self);

static void applet_list_screen_on_monitors_changed(MetaScreen *meta_screen,AppletAppList *self);
/**
 * 注册类；
 *
 *
 * */
GType
applet_app_list_get_type(void)
{
    static GType applet_app_list_type = 0;
    if(G_UNLIKELY(applet_app_list_type==0))
    {
        static const GTypeInfo applet_app_list_info = {
                sizeof(AppletAppListClass),
                NULL,NULL,
                (GClassInitFunc)applet_app_list_class_init,
                NULL,NULL,
                sizeof(AppletAppList),
                0,
                (GInstanceInitFunc)applet_app_list_init
        };
        //类注册
        applet_app_list_type = g_type_register_static(G_TYPE_OBJECT,"AppletAppList",&applet_app_list_info,0);
        //g_type_add_class_private(applet_app_list_type, sizeof(AppletAppListClassPrivate));
        AppletAppList_private_offset =
                g_type_add_instance_private(applet_app_list_type, sizeof(AppletAppListPrivate));

    }
    return applet_app_list_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_app_list_get_instance_private(AppletAppList *self){
    return (G_STRUCT_MEMBER_P (self, AppletAppList_private_offset));
}
static void
applet_list_screen_on_monitors_changed(MetaScreen *meta_screen,AppletAppList *self){

    applet_app_list_recalc_page_size(self);
}

/**
 * 实例初始化；
 *
 * */
static void
applet_app_list_init(AppletAppList *self)
{
    AppletAppListPrivate *priv;
    self->priv=applet_app_list_get_instance_private(self);
    priv=self->priv;

    /*--------------实例初始化（构造实例）-------------*/
    if(global == NULL){
        global = cdos_global_get();
    }
    priv->signal_ids = g_new0(AppletAppListSignalIds,1);
    priv->app_list = applet_ordered_hash_new();
    CdosWindowTracker *window_tracker = cdos_window_tracker_get_default();
    priv->tracker = applet_app_tracker_new(window_tracker);
    priv->signals = NULL;
    priv->button_prev = st_button_new();
    st_widget_set_style_class_name(priv->button_prev,"button-prev");
    clutter_actor_set_reactive(CLUTTER_ACTOR(priv->button_prev),TRUE);
    priv->button_prev_tooltip = cdos_tooltip_new(CLUTTER_ACTOR(priv->button_prev),_("First Page Now"));

    priv->button_next = st_button_new();
    st_widget_set_style_class_name(priv->button_next,"button-next");
    clutter_actor_set_reactive(CLUTTER_ACTOR(priv->button_next),TRUE);
    priv->button_next_tooltip = cdos_tooltip_new(CLUTTER_ACTOR(priv->button_next),_("Last Page Now"));

    priv->button_box = st_box_layout_new();
    st_widget_set_style_class_name(priv->button_box,"page-flip-button");
    st_box_layout_set_vertical(ST_BOX_LAYOUT(priv->button_box),TRUE);

    clutter_actor_hide(CLUTTER_ACTOR(priv->button_box));

    clutter_container_add_actor(CLUTTER_CONTAINER(priv->button_box),CLUTTER_ACTOR(priv->button_prev));
    clutter_container_add_actor(CLUTTER_CONTAINER(priv->button_box),CLUTTER_ACTOR(priv->button_next));

    CdosAppSystem *app_system = cdos_app_system_get_default();
    g_signal_connect(app_system,"installed-changed",G_CALLBACK(applet_app_list_system_on_installed_changed),self);
    g_signal_connect(window_tracker,"tracked-windows-changed",G_CALLBACK(applet_app_list_on_tracked_window_changed),self);

    MetaScreen *meta_screen = cdos_global_get_screen(global);
    g_signal_connect(meta_screen,"monitors-changed",G_CALLBACK(applet_list_screen_on_monitors_changed),self);

}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_app_list_class_init(AppletAppListClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletAppList_private_offset);
    applet_app_list_parent_class = g_type_class_peek_parent(klass);

    gobject_class->dispose=applet_app_list_dispose;
    gobject_class->finalize=applet_app_list_finalize;

    /*-------------信号注册---------------*/
    applet_app_list_signals[APPLET_APP_LIST_APP_GROUP_COUNT_CHANGE] =   \
            g_signal_new (
                    "app-group-count-change",
                    G_TYPE_FROM_CLASS (gobject_class),
                    G_SIGNAL_RUN_LAST,
                    0,
                    NULL,NULL,
                    g_cclosure_marshal_VOID__VOID,
                    G_TYPE_NONE,
                    0
            );
    applet_app_list_signals[APPLET_APP_LIST_PAGE_SIZE_CHANGE] =   \
            g_signal_new (
            "page-size-change",
            G_TYPE_FROM_CLASS (gobject_class),
            G_SIGNAL_RUN_LAST,
            0,
            NULL,NULL,
            g_cclosure_marshal_VOID__VOID,
            G_TYPE_NONE,
            0
    );

    applet_app_list_signals[APPLET_APP_LIST_PAGE_COUNT_CHANGE] =   \
            g_signal_new (
            "page-count-change",
            G_TYPE_FROM_CLASS (gobject_class),
            G_SIGNAL_RUN_LAST,
            0,
            NULL,NULL,
            g_cclosure_marshal_VOID__VOID,
            G_TYPE_NONE,
            0
    );
}

/*------------类方法定义-----------*/

static void applet_app_list_dispose(GObject *object){
    AppletAppList *self = APPLET_APP_LIST(object);
    AppletAppListPrivate *priv = self->priv;
    applet_app_list_remove_pagination(self);
    clutter_container_remove_actor(CLUTTER_CONTAINER(priv->button_box),CLUTTER_ACTOR(priv->button_prev));
    clutter_container_remove_actor(CLUTTER_CONTAINER(priv->button_box),CLUTTER_ACTOR(priv->button_next));
    applet_ordered_hash_destroy(priv->app_list,TRUE);

    g_clear_object(&priv->button_box);
    g_clear_object(&priv->my_actor_box);
    g_clear_object(&priv->tracker);
    g_clear_object(&priv->app_list);

    G_OBJECT_CLASS(applet_app_list_parent_class)->dispose(object);
}

static void applet_app_list_finalize(GObject *object){
    AppletAppList *self = APPLET_APP_LIST(object);
    AppletAppListPrivate *priv = self->priv;

    g_free(priv->signals);
    g_free(priv->signal_ids);

    G_OBJECT_CLASS(applet_app_list_parent_class)->finalize(object);
}

/*-------------private functions--------------*/
static void applet_app_list_on_changed_panel_edit_mode(GSettings *global_settings,gchar *key,AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    ClutterActor *actor = CLUTTER_ACTOR(priv->actor);
    gboolean panel_edit_mode = g_settings_get_boolean(global_settings,"panel-edit-mode");
    clutter_actor_set_reactive(actor,panel_edit_mode);
}

static void applet_app_list_set_signals(AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);

    if(!applet_settings){
        return;
    }

    gulong window_added_id,window_removed_id,changed_pinned_apps_id,changed_group_apps_id,changed_show_pinned_id,changed_panel_edit_mode_id,changed_panel_launchers_id;

    window_added_id = g_signal_connect_after(priv->meta_workspace,"window-added",G_CALLBACK(applet_app_list_on_window_added),self);

    window_removed_id = g_signal_connect_after(priv->meta_workspace,"window-removed",G_CALLBACK(applet_app_list_on_window_removed),self);

    changed_pinned_apps_id = g_signal_connect(applet_settings,"changed::pinned-apps",G_CALLBACK(applet_app_list_on_changed_pinned_apps),self);

    changed_group_apps_id = g_signal_connect(applet_settings,"changed::group-apps",G_CALLBACK(applet_app_list_on_changed_group_apps),self);

    changed_show_pinned_id = g_signal_connect(applet_settings,"changed::show-pinned",G_CALLBACK(applet_app_list_on_changed_show_pinned),self);

    GSettings *global_settings = cdos_global_get_settings(global);

    changed_panel_edit_mode_id = g_signal_connect(global_settings,"changed::panel-edit-mode",G_CALLBACK(applet_app_list_on_changed_panel_edit_mode),self);

    changed_panel_launchers_id = g_signal_connect(global_settings,"changed::panel-launchers",G_CALLBACK(applet_app_list_on_changed_panel_launchers),self);

    priv->signals = g_list_append(priv->signals,&window_added_id);
    priv->signals = g_list_append(priv->signals,&window_removed_id);
    /*
    priv->signals = g_list_append(priv->signals,changed_pinned_apps_id);
    priv->signals = g_list_append(priv->signals,changed_group_apps_id);
    priv->signals = g_list_append(priv->signals,changed_show_pinned_id);
    priv->signals = g_list_append(priv->signals,changed_panel_edit_mode_id);
    priv->signals = g_list_append(priv->signals,changed_panel_launchers_id);*/

}

static void applet_app_list_group_apps(AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    gboolean groups_app = TRUE;
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);

    //groups_app = cdos_provider_get_boolean(CDOS_PROVIDER(applet_settings),"group-apps",NULL);

    applet_ordered_hash_foreach(priv->app_list,applet_app_list_group_apps_foreach,&groups_app);

}

static void applet_app_list_refresh_list(AppletAppList *self){

    AppletAppListPrivate *priv = self->priv;
    applet_ordered_hash_foreach(priv->app_list,applet_app_list_refresh_list_foreach_func,NULL);
    applet_ordered_hash_destroy(priv->app_list,TRUE);

    applet_app_list_load_favorites(self);
    applet_app_list_refresh_apps(self);
}

static gint applet_app_list_app_group_number(AppletAppList *self,CdosApp *parent_app){
    AppletAppListPrivate *priv = self->priv;
    app_group_number = 0;
    applet_ordered_hash_foreach(priv->app_list,applet_app_list_app_group_number_foreach_func,parent_app);

    return app_group_number;
}

static void applet_app_list_refresh_app_group_number(AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    applet_ordered_hash_foreach(priv->app_list,applet_app_list_refresh_app_group_number_foreach_func,NULL);
}

static void applet_app_list_window_added(AppletAppList *self,MetaWorkspace *meta_workspace,MetaWindow *meta_window,CdosApp *favapp,gboolean is_favapp){

    AppletAppListPrivate *priv = self->priv;
    AppletAppTracker *tracker = priv->tracker;

    CdosApp *app;
    if(favapp){
        app = favapp;
    }else{
        app = applet_app_tracker_get_window_app(tracker,meta_window);
    }

    //g_print("\nDebug:File = %s >> Func = %s >> Line = %d: has_app = %d,app = %x;\n",__FILE__,__func__,__LINE__,applet_ordered_hash_contains(priv->app_list,app),app);
    if(meta_window){
        MetaWindowType meta_window_type = meta_window_get_window_type(meta_window);
        if(meta_window_type != META_WINDOW_NORMAL){
            return ;
        }
    }
	if(!applet_ordered_hash_contains(priv->app_list,app) && app ){
        AppletAppGroup *app_group = applet_app_group_new(priv->applet,self,app,is_favapp,priv->orientation);
        StWidget *app_group_actor = applet_app_group_get_actor(app_group);
        clutter_container_add_actor(CLUTTER_CONTAINER(priv->actor),CLUTTER_ACTOR(app_group_actor));

        applet_app_group_update_meta_windows(app_group,meta_workspace);
        applet_app_group_watch_workspace(app_group,meta_workspace);

        gboolean group_apps = TRUE;
        CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
        //group_apps = cdos_provider_get_boolean(CDOS_PROVIDER(applet_settings),"group-apps",NULL);
        group_apps = APPLET_WINDOW_LIST_DEBUG == TRUE ? TRUE : group_apps;
        if(group_apps){
            applet_app_group_hide_window_buttons(app_group,FALSE);
        }else{
            applet_app_group_hide_app_button(app_group,FALSE);
        }
        /*
        priv->signal_ids->app_notify_state_id = \
        g_signal_connect(app,"notify::state",G_CALLBACK(applet_app_list_app_notify_state_callback),self);
        */
        applet_ordered_hash_set(priv->app_list,app,app_group);

	if (meta_window != NULL) {
            g_signal_emit(self,applet_app_list_signals[APPLET_APP_LIST_APP_GROUP_COUNT_CHANGE],0);
	}
        gint app_group_num = applet_app_list_app_group_number(self,app);
        applet_app_group_new_app_key_number(app_group,app_group_num);

        gint title_display;
        title_display = APPLET_TITLE_DISPLAY_FOCUSED;
        // title_display = cdos_provider_get_int(CDOS_PROVIDER(applet_settings),"title-display",NULL);
        // title_display = APPLET_WINDOW_LIST_DEBUG == TRUE ? APPLET_TITLE_DISPLAY_FOCUSED : title_display;

        if(title_display == APPLET_TITLE_DISPLAY_FOCUSED){
            applet_app_group_hide_app_button_label(app_group,FALSE);
        }

    }
}

static void applet_app_list_on_window_added(MetaWorkspace *meta_workspace,MetaWindow *meta_window,AppletAppList *self){
    MetaWindowType meta_window_type = meta_window_get_window_type(meta_window);
    if(meta_window_type == META_WINDOW_NORMAL){
        applet_app_list_window_added(self,meta_workspace,meta_window,NULL,FALSE);
    }
}

static void applet_app_list_remove_app(AppletAppList *self,CdosApp *app){
    AppletAppListPrivate *priv = self->priv;
    AppletAppGroup *app_group = applet_ordered_hash_get(priv->app_list,app);

    if(app_group){
        gboolean was_favorite_app = applet_app_group_get_was_favorite_app(app_group);
        gboolean is_favorite_app = applet_app_group_get_is_favorite_app(app_group);

        if(was_favorite_app || is_favorite_app){
            applet_app_group_is_favorite(app_group,TRUE);
            g_timeout_add (0, (GSourceFunc)applet_app_list_remove_app_refresh, self);
            return ;
        }
        StWidget *app_group_actor = applet_app_group_get_actor(app_group);
        clutter_container_remove_actor(CLUTTER_CONTAINER(priv->actor),CLUTTER_ACTOR(app_group_actor));

        applet_ordered_hash_remove(priv->app_list,app);

        applet_app_group_destroy(app_group);
        //g_object_unref(app_group);

        g_signal_emit(self,applet_app_list_signals[APPLET_APP_LIST_APP_GROUP_COUNT_CHANGE],0);
        g_timeout_add (15, (GSourceFunc)applet_app_list_remove_app_callback, self);
    }
}
static gboolean applet_app_list_remove_app_refresh(AppletAppList *self){
    g_return_val_if_fail(APPLET_IS_APP_LIST(self),FALSE);
    applet_app_list_refresh_apps(self);
    return FALSE;
}

static void applet_app_list_load_favorites(AppletAppList *self){
    gboolean show_pinned = TRUE;
    AppletAppListPrivate *priv = self->priv;
    //CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //show_pinned = cdos_provider_get_boolean(CDOS_PROVIDER(applet_settings),"show-pinned",NULL);
    //show_pinned = APPLET_WINDOW_LIST_DEBUG == TRUE ? TRUE : FALSE;
    show_pinned = TRUE;
    if(!show_pinned){
        return ;
    }
    gchar **launchers;
    GSettings *global_settings = cdos_global_get_settings(global);
    launchers = g_settings_get_strv(global_settings,"panel-launchers");
    CdosAppSystem *app_system = cdos_app_system_get_default ();
    guint i;
    guint l = g_strv_length(launchers);
    for(i = 0;i < l;i++){
        gchar *launcher = launchers[i];
        CdosApp *app;
        app = cdos_app_system_lookup_app(app_system,launcher);
        if(!app){
            app = cdos_app_system_lookup_settings_app(app_system,launcher);
        }
        if(!app){
            continue ;
        }else {
            applet_app_list_window_added(self,priv->meta_workspace,NULL,app,TRUE);
        }
    }
    if(launchers != NULL){
        g_strfreev(launchers);
    }

}

static void applet_app_list_window_removed(AppletAppList *self,MetaWorkspace *meta_workspace,MetaWindow *meta_window){
    AppletAppListPrivate *priv = self->priv;
    AppletAppTracker *tracker = priv->tracker;
    CdosApp *app;
    app = applet_app_tracker_get_window_app(tracker,meta_window);
    if(!app){
        return ;
    }
    GSList *app_windows = cdos_app_get_windows(app);
    gboolean has_windows_on_workspace = FALSE;
    GSList *it = app_windows;
    while(it != NULL){
        MetaWindow *meta_window_tmp = it->data;
        if(meta_window != meta_window_tmp){
            MetaWindowType meta_window_type = meta_window_get_window_type(meta_window_tmp);
            MetaWorkspace *workspace = meta_window_get_workspace(meta_window_tmp);
            if(meta_window_type == META_WINDOW_NORMAL && workspace == meta_workspace){
                has_windows_on_workspace = TRUE;
                break;
            }
        }
        it = it->next;
    }

    if(meta_window){
        applet_app_tracker_remove_window(tracker,meta_window);
    }

    if(!has_windows_on_workspace && app){
        applet_app_list_remove_app(self,app);
    }
}

static void applet_app_list_on_window_removed(MetaWorkspace *meta_workspace,MetaWindow *meta_window,AppletAppList *self){
    MetaWindowType meta_window_type = meta_window_get_window_type(meta_window);
    //g_print("\n%s:---------->meta_workspace = %x,meta_window = %x,type = %x;\n",__func__,meta_workspace,meta_window,meta_window_type);
    if(meta_window_type == META_WINDOW_NORMAL){
        applet_app_list_window_removed(self,meta_workspace,meta_window);
    }
}

static void applet_app_list_on_changed_pinned_apps(CdosAppletSettings *settings,AppletAppList *self){
    applet_app_list_refresh_list(self);
}

static void applet_app_list_on_changed_group_apps(CdosAppletSettings *settings,AppletAppList *self){
    applet_app_list_group_apps(self);
}

static void applet_app_list_on_changed_show_pinned(GSettings *settings,AppletAppList *self){
    applet_app_list_refresh_list(self);
}

static void applet_app_list_on_changed_panel_launchers(GSettings *settings,gchar *key,AppletAppList *self){
    g_return_if_fail(NULL != self && APPLET_IS_APP_LIST(self));
    AppletAppListPrivate *priv = self->priv;
    guint last_page_number = priv->page_number;
    applet_app_list_refresh_list(self);
    applet_app_list_set_page_number(self,last_page_number);
}

static void applet_app_list_foreach_func(CdosApp *app,AppletAppGroup *data,gint index,gboolean *group_apps){

    AppletAppButton *app_button = applet_app_group_get_app_button(data);
    AppletButtonBox *window_button_box = applet_app_group_get_window_button_box(data);

    if(group_apps){
        applet_icon_label_button_show(APPLET_ICON_LABEL_BUTTON(app_button),TRUE,0);
        applet_button_box_hide(window_button_box,TRUE);
    }else{
        applet_icon_label_button_hide(APPLET_ICON_LABEL_BUTTON(app_button),TRUE);
        applet_button_box_hide(window_button_box,TRUE);
    }
}

static void applet_app_list_refresh_apps_foreach_callback(MetaWindow *meta_window,AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;

    applet_app_list_window_added(self,priv->meta_workspace,meta_window,NULL,FALSE);
}

static void applet_app_list_refresh_list_foreach_func(CdosApp *app,AppletAppGroup *data,gint index,AppletAppList *self){
    applet_app_group_destroy(data);
    //g_object_unref(data);
}

static void applet_app_list_app_group_number_foreach_func(CdosApp *app,AppletAppGroup *data,gint index,CdosApp *parent_app){
    if(app == parent_app){
        app_group_number = index;
    }
}
static void applet_app_list_refresh_app_group_number_foreach_func(CdosApp *app,AppletAppGroup *data,gint index){
    applet_app_group_new_app_key_number(data,index+1);
}

static void applet_app_list_app_notify_state_callback(CdosApp *app,GParamSpec *pspec,AppletAppList *self){

    CdosAppState state = cdos_app_get_state (app);
    AppletAppListPrivate *priv = self->priv;
    if(state == CDOS_APP_STATE_STOPPED && applet_ordered_hash_contains(priv->app_list,app) ){
        applet_app_list_remove_app(self,app);

        AppletAppGroup *app_group = applet_ordered_hash_get(priv->app_list,app);
        if(app_group){
            applet_app_group_calc_window_number(app_group,priv->meta_workspace);
        }
    }

}
static gboolean applet_app_list_remove_app_callback(AppletAppList *self){
    g_return_val_if_fail(APPLET_IS_APP_LIST(self),FALSE);
    applet_app_list_refresh_apps(self);
    applet_app_list_refresh_app_group_number(self);
    return FALSE;
}

static void applet_app_list_destroy_signals_foreach_func(gulong signal_id,AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    g_signal_handler_disconnect(priv->meta_workspace,signal_id);
}

static void applet_app_list_destroy_app_list_foreach_func(CdosApp *app,AppletAppGroup *data,gint index){
    applet_app_group_destroy(data);
    //g_object_unref(data);
}
static void applet_app_list_group_apps_foreach(CdosApp *app,AppletAppGroup *app_group,gint index,gpointer group_apps){

    AppletWindowButton *app_button = applet_app_group_get_app_button(app_group);
    AppletButtonBox *window_button_box = applet_app_group_get_window_button_box(app_group);
    if(group_apps){
        applet_icon_label_button_show(APPLET_ICON_LABEL_BUTTON(app_button),TRUE,-1);
        applet_button_box_hide(window_button_box,TRUE);
    }else{
        applet_icon_label_button_hide(APPLET_ICON_LABEL_BUTTON(app_button),TRUE);
        applet_button_box_show(window_button_box,TRUE,-1);
    }
}
static void applet_app_list_set_pagination(AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;

    priv->page_size = APPLET_APP_LIST_PAGE_SIZE;
    priv->page_number = 1;
    priv->page_count = 1;
    st_widget_add_style_class_name(priv->button_prev,"button-prev-disable");
    st_widget_add_style_class_name(priv->button_next,"button-next-disable");

    //StWidget *window_list_actor = applet_window_list_get_actor(priv->applet);
    clutter_actor_set_reactive(CLUTTER_ACTOR(priv->actor),TRUE);
    //clutter_container_add_actor(CLUTTER_CONTAINER(window_list_actor),CLUTTER_ACTOR(priv->button_box));
    gfloat panel_height = cdos_applet_get_panel_height(CDOS_APPLET(priv->applet));
    clutter_actor_set_height(CLUTTER_ACTOR(priv->button_prev),ceil(panel_height/2));
    clutter_actor_set_height(CLUTTER_ACTOR(priv->button_next),ceil(panel_height/2));

    priv->signal_ids->app_list_app_group_count_change_id = g_signal_connect(self,"app-group-count-change",G_CALLBACK(applet_app_list_on_app_group_count_change),NULL);
    priv->signal_ids->app_list_page_size_change_id = g_signal_connect(self,"page-size-change",G_CALLBACK(applet_app_list_on_page_size_change),NULL);
    priv->signal_ids->button_prev_clicked_id = g_signal_connect(ST_BUTTON(priv->button_prev),"clicked",G_CALLBACK(applet_app_list_button_prev_on_page_up),self);
    priv->signal_ids->button_next_clicked_id = g_signal_connect(ST_BUTTON(priv->button_next),"clicked",G_CALLBACK(applet_app_list_button_next_on_page_down),self);
    priv->signal_ids->app_list_scroll_id = g_signal_connect(CLUTTER_ACTOR(priv->actor),"scroll-event",G_CALLBACK(applet_app_list_on_scroll),self);

    CdosPanel* panel = cdos_monkey_plugin_get_panel(monkey_plugin_get());
    StBoxLayout* leftpanel = cdos_panel_get_leftbox(panel);
    StBoxLayout* rightpanel = cdos_panel_get_rightbox(panel);
    if ((NULL != leftpanel) && (NULL != rightpanel)) {
        g_signal_connect(leftpanel, "notify::width", G_CALLBACK(applet_app_list_on_panel_resize), self);
        g_signal_connect(rightpanel, "notify::width", G_CALLBACK(applet_app_list_on_panel_resize), self);
    }
};

static void applet_app_list_on_app_group_count_change(AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    GList *app_groups = applet_ordered_hash_keys(priv->app_list);
    guint app_group_count = g_list_length(app_groups);
    g_list_free(app_groups);
    guint new_count = (guint)ceil(((double)app_group_count) / ((double)(priv->page_size)));
    if (0 == new_count || 0 == app_group_count) {
        return;
    }
    applet_app_list_recalc_page_size(self);
    if(app_group_count > (priv->page_count) * (priv->page_size) || app_group_count <= (priv->page_count -1) * (priv->page_size)){
        applet_app_list_page_count_change(self,new_count);
    }
    applet_app_list_pagination_refresh(self);
}


static void applet_app_list_on_page_size_change(AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    GList *app_groups = applet_ordered_hash_keys(priv->app_list);
    guint app_group_count = g_list_length(app_groups);
    g_list_free(app_groups);
    guint new_count = (guint)ceil(((double)app_group_count) / ((double)(priv->page_size)));
    if (0 == new_count || 0 == app_group_count) {
        return;
    }
    applet_app_list_page_count_change(self,new_count);
    applet_app_list_pagination_refresh(self);
}

static void applet_app_list_page_count_change(AppletAppList *self,guint new_count){
    AppletAppListPrivate *priv = self->priv;
    guint old_count = priv->page_count;
    priv->page_count = new_count;

    if(new_count > old_count) { //increase;
        applet_app_list_pagination_show(self);
        if(priv->page_number + 1 == priv->page_count){
            applet_app_list_button_next_set_state(self,TRUE);
        }
    }else if(new_count < old_count) { //decrease;
        if(new_count == 1){
            applet_app_list_button_prev_set_state(self,FALSE);
            applet_app_list_button_next_set_state(self,FALSE);
            applet_app_list_pagination_hide(self);
        }
        if(new_count < priv->page_number){
            priv->page_number = new_count;
        }
    }
    if(priv->page_count > 1){
        clutter_actor_show(CLUTTER_ACTOR(priv->button_box));
    }else{
        clutter_actor_hide(CLUTTER_ACTOR(priv->button_box));
    }
}

static void applet_app_list_button_prev_on_page_up(StButton *button, gint clicked_button,AppletAppList *self){
    //AppletAppListPrivate *priv = self->priv;
    if(clicked_button == 1){
        applet_app_list_page_up(self);
    }
}

static void applet_app_list_button_next_on_page_down(StButton *button, gint clicked_button,AppletAppList *self){
    //AppletAppListPrivate *priv = self->priv;
    if(clicked_button == 1){
        applet_app_list_page_down(self);
    }
}

static void applet_app_list_pagination_hide(AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    clutter_actor_hide(CLUTTER_ACTOR(priv->button_box));
}

static void applet_app_list_pagination_show(AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    clutter_actor_show(CLUTTER_ACTOR(priv->button_box));
}

static void applet_app_list_page_up(AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    if(priv->page_number == 1){
        return ;
    }else{
        if(priv->page_number == priv->page_count){
            applet_app_list_button_next_set_state(self,TRUE);
        }
        priv->page_number -=1;
        if(priv->page_number == 1){
            applet_app_list_button_prev_set_state(self,FALSE);
        }
    }
    applet_app_list_pagination_refresh(self);
}

static void applet_app_list_page_down(AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    if(priv->page_number == priv->page_count){
        return ;
    }else{
        if(priv->page_number == 1){
            applet_app_list_button_prev_set_state(self,TRUE);
        }
        priv->page_number +=1;
        if(priv->page_number == priv->page_count){
            applet_app_list_button_next_set_state(self,FALSE);
        }
    }
    applet_app_list_pagination_refresh(self);
}

static void applet_app_list_button_prev_set_state(AppletAppList *self,gboolean state){
    AppletAppListPrivate *priv = self->priv;
    if(state == TRUE){  //激活
        st_widget_remove_style_class_name(priv->button_prev,"button-prev-disable");
        cdos_tooltip_set_text(priv->button_prev_tooltip,_("Previous Page"));
    }else{  //冻结
        st_widget_add_style_class_name(priv->button_prev,"button-prev-disable");
        cdos_tooltip_set_text(priv->button_prev_tooltip,_("First Page Now"));
    }
}

static void applet_app_list_button_next_set_state(AppletAppList *self,gboolean state){
    AppletAppListPrivate *priv = self->priv;
    if(state == TRUE){  //激活
        st_widget_remove_style_class_name(priv->button_next,"button-next-disable");
        cdos_tooltip_set_text(priv->button_next_tooltip,_("Next Page"));
    }else{  //冻结
        st_widget_add_style_class_name(priv->button_next,"button-next-disable");
        cdos_tooltip_set_text(priv->button_next_tooltip,_("Last Page Now"));
    }
}
static void applet_app_list_pagination_refresh(AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;
    GList *apps = applet_ordered_hash_items(priv->app_list);
    guint i = 0;
    guint start_index = (priv->page_number - 1) * priv->page_size;
    guint end_index = priv->page_number * priv->page_size;
    while (apps != NULL){
        AppletAppGroup *app_group = apps->data;
        if(i >= start_index && i< end_index){
            applet_app_group_show(app_group);
        }else{
            applet_app_group_hide(app_group);
        }
        i++;
        apps = apps->next;
    }
    g_list_free(apps);
}

static void applet_app_list_set_page_number(AppletAppList *self,guint new_page_number){
    AppletAppListPrivate *priv = self->priv;
    if(new_page_number>0 && new_page_number <= priv->page_count){
        priv->page_number = new_page_number;

        if(new_page_number == 1){
            applet_app_list_button_prev_set_state(self,FALSE);
        }else{
            applet_app_list_button_prev_set_state(self,TRUE);
        }
        if(new_page_number == priv->page_count){
            applet_app_list_button_next_set_state(self,FALSE);
        }else{
            applet_app_list_button_next_set_state(self,TRUE);
        }
        applet_app_list_pagination_refresh(self);
    }
}
static gboolean
applet_app_list_on_scroll(ClutterActor *actor,ClutterEvent *event,AppletAppList *self){
    //AppletAppListPrivate *priv = self->priv;
    ClutterScrollDirection direction = clutter_event_get_scroll_direction(event);
    if(direction == CLUTTER_SCROLL_UP){
        applet_app_list_page_up(self);
    }else if(direction == CLUTTER_SCROLL_DOWN){
        applet_app_list_page_down(self);
    }
    return FALSE;
}
static void applet_app_list_system_on_installed_changed(CdosAppSystem *app_system,AppletAppList *self){
    AppletAppListPrivate *priv = self->priv;

    GSettings *settings = cdos_global_get_settings(global);
    gchar **launchers = g_settings_get_strv(settings,"panel-launchers");
    gchar **launchers_new = NULL;
    guint i;
    guint l = g_strv_length(launchers);
    for(i = 0;i < l;i++){
        gchar *launcher = launchers[i];
        if(launcher){
            CdosApp *app;
            app = cdos_app_system_lookup_app(app_system,launcher);
            if(!app){
                app = cdos_app_system_lookup_settings_app(app_system,launcher);
            }
            if(!app){
                launchers_new = cdos_strv_elem_del_by_str(launchers,launcher);
            }else{
                launchers_new = cdos_strv_elem_add(launchers_new,launcher);
            }
        }
    }
    if(l != g_strv_length(launchers_new)){
        g_settings_set_strv(settings,"panel-launchers",(const gchar *const *)launchers_new);
    }
    if(launchers_new != NULL){
        g_free(launchers_new);
        g_strfreev(launchers);
    }
}

static void applet_app_list_on_tracked_window_changed(CdosWindowTracker *tracker,AppletAppList *self){
    //g_print("\n%s:=================================================\n",__func__);
    //applet_app_list_refresh_list(self);
}
/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletAppList* applet_app_list_new(AppletWindowList *applet,MetaWorkspace *meta_workspace,StSide orientation)
{
    AppletAppList *self;
    AppletAppListPrivate *priv;
    self = g_object_new(APPLET_TYPE_APP_LIST, NULL);
    priv = self->priv;
    priv->orientation = orientation;
    priv->meta_workspace = meta_workspace;
    priv->applet = applet;
    priv->my_actor_box = applet_window_list_box_new(applet);

    priv->actor = applet_window_list_box_get_actor(priv->my_actor_box);

    if(orientation == ST_SIDE_TOP){
        st_widget_add_style_class_name(priv->actor,"window-list-box-top");
        st_widget_set_style(priv->actor,"margin-top:0;padding-top:0;");
    }else{
        st_widget_add_style_class_name(priv->actor,"window-list-box-bottom");
        st_widget_set_style(priv->actor,"margin-bottom:0;padding-bottom:0;");
    }
    applet_app_list_set_pagination(self);

    applet_app_list_set_signals(self);
    applet_app_list_refresh_list(self);

    return self;
}

void applet_app_list_destroy(AppletAppList *self){
    g_return_if_fail(APPLET_IS_APP_LIST(self));
    AppletAppListPrivate *priv = self->priv;

    g_signal_handler_disconnect(self,priv->signal_ids->app_list_app_group_count_change_id);
    g_signal_handler_disconnect(self,priv->signal_ids->app_list_page_count_change_id);
    g_signal_handler_disconnect(priv->button_prev,priv->signal_ids->button_prev_clicked_id);
    g_signal_handler_disconnect(priv->button_next,priv->signal_ids->button_next_clicked_id);
    //g_signal_handler_disconnect(self,priv->signal_ids->app_list_page_size_change_id);

    StWidget *window_list_actor = applet_window_list_get_actor(priv->applet);
    clutter_container_remove_actor(CLUTTER_CONTAINER(window_list_actor),CLUTTER_ACTOR(priv->button_box));
    clutter_actor_destroy(CLUTTER_ACTOR(priv->button_box));
    priv->button_box = NULL;
    priv->button_prev = NULL;
    priv->button_next = NULL;

    g_list_foreach(priv->signals,applet_app_list_destroy_signals_foreach_func,self);
    applet_ordered_hash_foreach(priv->app_list,applet_app_list_destroy_app_list_foreach_func,NULL);
    applet_ordered_hash_destroy(priv->app_list,TRUE);
    //priv->app_list = NULL;
}

void applet_app_list_refresh_apps(AppletAppList *self){
    g_return_if_fail(APPLET_IS_APP_LIST(self));
    AppletAppListPrivate *priv = self->priv;
    GList *windows = NULL;
    windows = meta_workspace_list_windows(priv->meta_workspace);

    if(windows){
        g_list_foreach(windows,applet_app_list_refresh_apps_foreach_callback,self);
    }
}

AppletWindowListBox* applet_app_list_get_my_actor_box(AppletAppList *self){
    g_return_val_if_fail(APPLET_IS_APP_LIST(self),NULL);
    AppletAppListPrivate *priv = self->priv;
    return priv->my_actor_box;
}

StWidget* applet_app_list_get_actor(AppletAppList *self){
    g_return_val_if_fail(APPLET_IS_APP_LIST(self),NULL);
    AppletAppListPrivate *priv = self->priv;
    return priv->actor;
}

MetaWorkspace* applet_app_list_get_meta_workspace(AppletAppList *self){
    g_return_val_if_fail(APPLET_IS_APP_LIST(self),NULL);
    AppletAppListPrivate *priv = self->priv;
    return priv->meta_workspace;
}

guint applet_app_list_get_page_size(AppletAppList *self){
    g_return_val_if_fail(APPLET_IS_APP_LIST(self),0);
    AppletAppListPrivate *priv = self->priv;
    return priv->page_size;
}

gboolean applet_app_list_set_page_size(AppletAppList *self,guint page_size){
    g_return_val_if_fail(APPLET_IS_APP_LIST(self),FALSE);
    AppletAppListPrivate *priv = self->priv;
    if(page_size <= APPLET_APP_LIST_PAGE_SIZE_MAX && page_size >= APPLET_APP_LIST_PAGE_SIZE_MIN ){
        guint old_size = priv->page_size;
        priv->page_size = page_size;
        if(priv->page_size != old_size){
            g_signal_emit(self,applet_app_list_signals[APPLET_APP_LIST_PAGE_SIZE_CHANGE],0);
            return TRUE;
        }
    }else{
        g_warning("The page_size is out of the number range,please set it from %d to %d!",APPLET_APP_LIST_PAGE_SIZE_MIN,APPLET_APP_LIST_PAGE_SIZE_MAX);
    }
    return FALSE;
}

void applet_app_list_add_pagination(AppletAppList *self){
    g_return_if_fail(APPLET_IS_APP_LIST(self));
    AppletAppListPrivate *priv = self->priv;
    StWidget *window_list_actor = applet_window_list_get_actor(priv->applet);
    clutter_container_add_actor(CLUTTER_CONTAINER(window_list_actor),CLUTTER_ACTOR(priv->button_box));
    if(priv->page_count > 1){
        clutter_actor_show(CLUTTER_ACTOR(priv->button_box));
    }else{
        clutter_actor_hide(CLUTTER_ACTOR(priv->button_box));
    }
}

void applet_app_list_remove_pagination(AppletAppList *self){
    g_return_if_fail(APPLET_IS_APP_LIST(self));
    AppletAppListPrivate *priv = self->priv;
    StWidget *window_list_actor = applet_window_list_get_actor(priv->applet);
    g_object_ref(priv->button_box);
    clutter_container_remove_actor(CLUTTER_CONTAINER(window_list_actor),CLUTTER_ACTOR(priv->button_box));
}

static void applet_app_list_recalc_page_size(AppletAppList *self) {
    g_return_if_fail(APPLET_IS_APP_LIST(self));
    //AppletAppListPrivate *priv = self->priv;
    CdosPanel* panel = cdos_monkey_plugin_get_panel(monkey_plugin_get());
    StBoxLayout* leftpanel = cdos_panel_get_leftbox(panel);
    StBoxLayout* rightpanel = cdos_panel_get_rightbox(panel);

    gint screen_width,screen_height;
    CdosLayoutManager *layout_manager = cdos_layout_manager_get_default ();
    MetaRectangle *monitor = cdos_layout_manager_get_primary_monitor (layout_manager);
    screen_width = monitor->width;
    screen_height = monitor->height;

    if ((NULL != leftpanel) && (NULL != rightpanel)) {
        gfloat left_width = clutter_actor_get_width(CLUTTER_ACTOR(leftpanel));
        gfloat right_width = clutter_actor_get_width(CLUTTER_ACTOR(rightpanel));
        guint page_size = (int)((screen_width - left_width - right_width) * 0.9 / 67.0f);
        if(APPLET_WINDOW_LIST_DEBUG == TRUE){
            page_size = APPLET_APP_LIST_PAGE_SIZE;
        }
        applet_app_list_set_page_size(self, page_size);
    }
}

static void applet_app_list_on_panel_resize(ClutterActor* actor, GParamSpec *pspec, AppletAppList* self) {
    g_return_if_fail(APPLET_IS_APP_LIST(self));
    applet_app_list_recalc_page_size(self);
}
guint applet_app_list_get_workspace_index(AppletAppList *self){
    g_return_val_if_fail(APPLET_IS_APP_LIST(self),NULL);
    AppletAppListPrivate *priv = self->priv;
    guint workspace_index = meta_workspace_index(priv->meta_workspace);
    return workspace_index;
}
void applet_app_list_refresh(AppletAppList *self){
    g_return_if_fail(APPLET_IS_APP_LIST(self));
    applet_app_list_refresh_list(self);
}
