//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialMenus.js

#include "applet-app-thumbnail-hover-menu.h"
//添加依赖库;
#include "applet-window-list.h"
#include "cdos-provider.h"
#include "cdos-monkey-plugin.h"
#include "cdos-debug.h"
typedef struct _AppletAppThumbnailHoverMenuSignalIds AppletAppThumbnailHoverMenuSignalIds;
/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletAppThumbnailHoverMenuPrivate{
    gboolean is_favorite_app;
    gboolean should_open;
    gboolean should_close;
    gint hover_time;
    MetaWindow *meta_window;
    CdosApp *app;
    StWidget *parent_actor;
    AppletAppSwitcherItem *app_switcher_item;
    AppletWindowList *applet;
    AppletAppThumbnailHoverMenuSignalIds *signal_ids;
    AppletAppContextMenu *context_menu;
    gboolean is_keep_menu;
};

struct _AppletAppThumbnailHoverMenuSignalIds{
    gulong actor_enter_id;
    gulong actor_leave_id;
    gulong actor_button_release_id;
    gulong parent_actor_enter_id;
    gulong parent_actor_leave_id;
    gulong parent_actor_button_release_id;

    gulong applet_settings_thumbnail_timeout_id;
};

/*-------global variables-------------*/
static gint AppletAppThumbnailHoverMenu_private_offset = 0;
static gint applet_app_thumbnail_hover_menu_signals[LAST_SIGNAL] = { 0 };
static gpointer applet_app_thumbnail_hover_menu_parent_class = NULL;


/*-------class functions---------*/
static void applet_app_thumbnail_hover_menu_init(AppletAppThumbnailHoverMenu *self);
static void applet_app_thumbnail_hover_menu_class_init(AppletAppThumbnailHoverMenuClass *klass);

static void applet_app_thumbnail_hover_menu_dispose(GObject *object);
static void applet_app_thumbnail_hover_menu_finalize(GObject *object);

/*-------------private functions of instance-------------------*/
static void applet_app_thumbnail_hover_menu_constructor(AppletAppThumbnailHoverMenu *self,AppletAppThumbnailHoverMenuParams *params);

static gboolean applet_app_thumbnail_hover_menu_actor_on_enter(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self);

static gboolean applet_app_thumbnail_hover_menu_actor_on_leave(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self);

static gboolean applet_app_thumbnail_hover_menu_actor_on_button_release(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self);

static gboolean applet_app_thumbnail_hover_menu_parent_actor_on_enter(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self);

static gboolean applet_app_thumbnail_hover_menu_parent_actor_on_leave(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self);

static gboolean applet_app_thumbnail_hover_menu_parent_actor_on_button_release(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self);

static void applet_app_thumbnail_hover_menu_applet_settings_on_thumbnail_timeout(CdosProvider *settings,AppletAppThumbnailHoverMenu *self);

static gboolean applet_app_thumbnail_hover_menu_main_loop_hover_close(AppletAppThumbnailHoverMenu *self);

static gboolean applet_app_thumbnail_hover_menu_main_loop_hover_open(AppletAppThumbnailHoverMenu *self);

static void applet_app_thumbnail_hover_menu_disconnect_signals(AppletAppThumbnailHoverMenu *self);

/*-------functions-------------*/

/**
 * 注册类；
 *
 *
 * */
GType
applet_app_thumbnail_hover_menu_get_type(void)
{
    static GType applet_app_thumbnail_hover_menu_type = 0;
    if(G_UNLIKELY(applet_app_thumbnail_hover_menu_type==0))
    {
        static const GTypeInfo applet_app_thumbnail_hover_menu_info = {
                sizeof(AppletAppThumbnailHoverMenuClass),
                NULL,NULL,
                (GClassInitFunc)applet_app_thumbnail_hover_menu_class_init,
                NULL,NULL,
                sizeof(AppletAppThumbnailHoverMenu),
                0,
                (GInstanceInitFunc)applet_app_thumbnail_hover_menu_init
        };
        //类注册
        applet_app_thumbnail_hover_menu_type = g_type_register_static(CDOS_TYPE_POPUP_MENU,"AppletAppThumbnailHoverMenu",&applet_app_thumbnail_hover_menu_info,0);
        //g_type_add_class_private(applet_app_thumbnail_hover_menu_type, sizeof(AppletAppThumbnailHoverMenuClassPrivate));
        AppletAppThumbnailHoverMenu_private_offset =
                g_type_add_instance_private(applet_app_thumbnail_hover_menu_type, sizeof(AppletAppThumbnailHoverMenuPrivate));

    }
    return applet_app_thumbnail_hover_menu_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_app_thumbnail_hover_menu_get_instance_private(AppletAppThumbnailHoverMenu *self){
    return (G_STRUCT_MEMBER_P (self, AppletAppThumbnailHoverMenu_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_app_thumbnail_hover_menu_init(AppletAppThumbnailHoverMenu *self)
{
    AppletAppThumbnailHoverMenuPrivate *priv;
    self->priv=applet_app_thumbnail_hover_menu_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/
    priv->signal_ids = g_new0(AppletAppThumbnailHoverMenuSignalIds,1);
    priv->context_menu = NULL;
    priv->is_keep_menu = TRUE;
}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_app_thumbnail_hover_menu_class_init(AppletAppThumbnailHoverMenuClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletAppThumbnailHoverMenu_private_offset);
    applet_app_thumbnail_hover_menu_parent_class = g_type_class_peek_parent(klass);

    /*-------------重写父类的虚方法---------------*/
    //gobject_class->constructed=applet_app_thumbnail_hover_menu_constructed;
    gobject_class->dispose=applet_app_thumbnail_hover_menu_dispose;
    gobject_class->finalize=applet_app_thumbnail_hover_menu_finalize;
}

/*------------类方法定义-----------*/
static void applet_app_thumbnail_hover_menu_dispose(GObject *object){
    AppletAppThumbnailHoverMenu *self = APPLET_APP_THUMBNAIL_HOVER_MENU(object);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    applet_app_thumbnail_hover_menu_disconnect_signals(self);

    G_OBJECT_CLASS(applet_app_thumbnail_hover_menu_parent_class)->dispose(object);
}

static void applet_app_thumbnail_hover_menu_finalize(GObject *object){
    AppletAppThumbnailHoverMenu *self = APPLET_APP_THUMBNAIL_HOVER_MENU(object);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    g_free(priv->signal_ids);

    G_OBJECT_CLASS(applet_app_thumbnail_hover_menu_parent_class)->finalize(object);
}

/*-------------private functions--------------*/
static void applet_app_thumbnail_hover_menu_constructor(AppletAppThumbnailHoverMenu *self,AppletAppThumbnailHoverMenuParams *params){
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    cdos_popup_menu_constructor (CDOS_POPUP_MENU (self), CLUTTER_ACTOR(priv->parent_actor), 0.45, 2);

    StWidget *actor = ST_WIDGET(CDOS_POPUP_MENU(self)->actor);
    StWidget *box = cdos_popup_menu_base_get_box(CDOS_POPUP_MENU_BASE(self));
    st_widget_set_style(box,"background:none;border:none;");
    st_widget_set_style_class_name(actor,"hide-arrow");

    //notice:此处需要传入参数
    AppletAppSwitcherItemParams *switcher_item_params = g_new0(AppletAppSwitcherItemParams,1);
    switcher_item_params->applet = priv->applet;
    switcher_item_params->app = priv->app;
    switcher_item_params->is_favorite_app = priv->is_favorite_app;
    switcher_item_params->meta_window = priv->meta_window;
    switcher_item_params->hover = FALSE;
    priv->app_switcher_item = applet_app_switcher_item_new(switcher_item_params);
    g_free(switcher_item_params);

    CdosPopupMenuBase *menu = CDOS_POPUP_MENU_BASE(self);
    cdos_popup_menu_base_add_menu_item(menu,CDOS_POPUP_BASE_MENU_ITEM(priv->app_switcher_item), -1);
    clutter_actor_hide(CLUTTER_ACTOR(actor));
    clutter_actor_hide(CLUTTER_ACTOR(box));

    ClutterActor *ui_group = monkey_plugin_get_ui_group (monkey_plugin_get ());
    st_container_add_actor ((ClutterContainer *) ui_group,CLUTTER_ACTOR(actor));
    //cdos_layout_manager_add_chrome (cdos_monkey_plugin_get_layout_manager (monkey_plugin_get ()),CLUTTER_ACTOR(actor));

    priv->signal_ids->parent_actor_enter_id = \
    g_signal_connect(CLUTTER_ACTOR(priv->parent_actor),"enter-event",G_CALLBACK(applet_app_thumbnail_hover_menu_parent_actor_on_enter),self);
    priv->signal_ids->parent_actor_leave_id = \
    g_signal_connect(CLUTTER_ACTOR(priv->parent_actor),"leave-event",G_CALLBACK(applet_app_thumbnail_hover_menu_parent_actor_on_leave),self);
    priv->signal_ids->parent_actor_button_release_id = \
    g_signal_connect(CLUTTER_ACTOR(priv->parent_actor),"button-release-event",G_CALLBACK(applet_app_thumbnail_hover_menu_parent_actor_on_button_release),self);
    priv->signal_ids->actor_enter_id = \
    g_signal_connect(CLUTTER_ACTOR(actor),"enter-event",G_CALLBACK(applet_app_thumbnail_hover_menu_actor_on_enter),self);
    priv->signal_ids->actor_leave_id = \
    g_signal_connect(CLUTTER_ACTOR(actor),"leave-event",G_CALLBACK(applet_app_thumbnail_hover_menu_actor_on_leave),self);
    priv->signal_ids->actor_button_release_id = \
    g_signal_connect(CLUTTER_ACTOR(actor),"button-release-event",G_CALLBACK(applet_app_thumbnail_hover_menu_actor_on_button_release),self);

    gint hover_time = 250;
    /* debug
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    hover_time = cdos_provider_get_int(CDOS_PROVIDER(applet_settings),"thumbnail-timeout",NULL);
    */
    priv->hover_time = hover_time;

    //CdosPopupBaseMenuItem *xunli = cdos_popup_menu_item_new_with_params("Test", NULL);
}

static gboolean applet_app_thumbnail_hover_menu_actor_on_enter(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self){
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    priv->should_open = TRUE;
    priv->should_close = FALSE;
    g_timeout_add(priv->hover_time,(GSourceFunc)applet_app_thumbnail_hover_menu_main_loop_hover_open,self);
    return FALSE;
}

static gboolean applet_app_thumbnail_hover_menu_actor_on_leave(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self){
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    priv->should_open = FALSE;
    priv->should_close = TRUE;
    g_timeout_add(priv->hover_time,(GSourceFunc)applet_app_thumbnail_hover_menu_main_loop_hover_close,self);
    return FALSE;
}

static gboolean applet_app_thumbnail_hover_menu_actor_on_button_release(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self){

    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    gboolean on_click_thumbs = FALSE;
    /*
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    on_click_thumbs = cdos_provider_get_boolean(CDOS_PROVIDER(applet_settings),"onclick-thumbnails",NULL);
     */
    if(priv->parent_actor == actor && on_click_thumbs){
        return FALSE;
    }
    priv->should_open = FALSE;
    priv->should_close = TRUE;

    g_timeout_add(priv->hover_time,(GSourceFunc)applet_app_thumbnail_hover_menu_main_loop_hover_close,self);
    return FALSE;
}

static gboolean applet_app_thumbnail_hover_menu_parent_actor_on_enter(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self){
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;

    if(priv->context_menu != NULL && applet_app_context_menu_get_open_state(priv->context_menu) == TRUE){
        priv->should_open = FALSE;
    }else{
        priv->should_open = TRUE;
    }
    priv->should_close = FALSE;
    g_timeout_add(priv->hover_time, (GSourceFunc)applet_app_thumbnail_hover_menu_main_loop_hover_open,self);
    return FALSE;
}

static gboolean applet_app_thumbnail_hover_menu_parent_actor_on_leave(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self){
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;

    priv->should_open = FALSE;
    priv->should_close = TRUE;
    g_timeout_add(priv->hover_time,(GSourceFunc)applet_app_thumbnail_hover_menu_main_loop_hover_close,self);
    return FALSE;
}

static gboolean applet_app_thumbnail_hover_menu_parent_actor_on_button_release(ClutterActor *actor,ClutterEvent *event,AppletAppThumbnailHoverMenu *self){
    applet_app_thumbnail_hover_menu_actor_on_button_release(actor,event,self);
    return FALSE;
}

static void applet_app_thumbnail_hover_menu_applet_settings_on_thumbnail_timeout(CdosProvider *settings,AppletAppThumbnailHoverMenu *self){

    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    gint hover_time = 250;
    CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //hover_time = cdos_provider_get_int(applet_settings,"thumbnail-timeout",NULL);
    priv->hover_time = hover_time;

}

static gboolean applet_app_thumbnail_hover_menu_main_loop_hover_open(AppletAppThumbnailHoverMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self),FALSE);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    gboolean is_open = CDOS_POPUP_MENU_BASE(self)->is_open;
    if(priv->should_open && !is_open){
        applet_app_thumbnail_hover_menu_open(self,TRUE);
    }
    return FALSE;
}

static gboolean applet_app_thumbnail_hover_menu_main_loop_hover_close(AppletAppThumbnailHoverMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self),FALSE);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    if(priv->should_close){
        applet_app_thumbnail_hover_menu_close(self,TRUE);
    }
    return FALSE;
}

static void
applet_app_thumbnail_hover_menu_disconnect_signals(AppletAppThumbnailHoverMenu *self){
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    AppletAppThumbnailHoverMenuSignalIds *signal_ids = priv->signal_ids;
    if(signal_ids->parent_actor_button_release_id != 0){
        g_signal_handler_disconnect(CLUTTER_ACTOR(priv->parent_actor),signal_ids->parent_actor_button_release_id);
        signal_ids->parent_actor_button_release_id = 0;
    }
    if(signal_ids->parent_actor_enter_id > 0){
        g_signal_handler_disconnect(CLUTTER_ACTOR(priv->parent_actor),signal_ids->parent_actor_enter_id);
        signal_ids->parent_actor_enter_id = 0;
    }
    if(signal_ids->parent_actor_leave_id > 0){
        g_signal_handler_disconnect(CLUTTER_ACTOR(priv->parent_actor),signal_ids->parent_actor_leave_id);
        signal_ids->parent_actor_leave_id = 0;
    }
    StWidget *actor = ST_WIDGET(CDOS_POPUP_MENU(self)->actor);
    if(signal_ids->actor_button_release_id > 0){
        g_signal_handler_disconnect(CLUTTER_ACTOR(actor),signal_ids->actor_button_release_id);
        signal_ids->actor_button_release_id = 0;
    }
    if(signal_ids->actor_enter_id > 0){
        g_signal_handler_disconnect(CLUTTER_ACTOR(actor),signal_ids->actor_enter_id);
        signal_ids->actor_enter_id = 0;
    }
    if(signal_ids->actor_leave_id > 0){
        g_signal_handler_disconnect(CLUTTER_ACTOR(actor),signal_ids->actor_leave_id);
        signal_ids->actor_leave_id = 0;
    }
}
/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletAppThumbnailHoverMenu* applet_app_thumbnail_hover_menu_new(AppletAppThumbnailHoverMenuParams *params)
{
    AppletAppThumbnailHoverMenu *self;
    gint hover_time;

    self = g_object_new(APPLET_TYPE_APP_THUMBNAIL_HOVER_MENU, NULL);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    priv->applet = params->applet;
    priv->meta_window = NULL;
    priv->app = params->app;
    priv->is_favorite_app = params->is_favorite_app;
    priv->parent_actor = params->actor;

    applet_app_thumbnail_hover_menu_constructor(self,params);

    return self;
}

void applet_app_thumbnail_hover_menu_open(AppletAppThumbnailHoverMenu *self,gboolean animate){
    g_return_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self));
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;

    applet_app_switcher_item_refresh( APPLET_APP_SWITCHER_ITEM (priv->app_switcher_item));
    CdosGenericContainer *actor = cdos_popup_base_menu_item_get_actor(CDOS_POPUP_BASE_MENU_ITEM(priv->app_switcher_item));
    StWidget *box = cdos_popup_menu_base_get_box(CDOS_POPUP_MENU_BASE(self));
    clutter_actor_show(CLUTTER_ACTOR(actor));
    clutter_actor_show(CLUTTER_ACTOR(box));
    cdos_popup_menu_open(CDOS_POPUP_MENU_BASE(self),animate);
}

void applet_app_thumbnail_hover_menu_close(AppletAppThumbnailHoverMenu *self,gboolean animate){
    g_return_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self));
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    cdos_popup_menu_close(CDOS_POPUP_MENU_BASE(self),animate);
    //CdosGenericContainer *actor = cdos_popup_base_menu_item_get_actor(CDOS_POPUP_BASE_MENU_ITEM(priv->app_switcher_item));
    //clutter_actor_hide(CLUTTER_ACTOR(actor));
}

void applet_app_thumbnail_hover_menu_destroy(AppletAppThumbnailHoverMenu *self){
    g_return_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self));
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    applet_app_thumbnail_hover_menu_disconnect_signals(self);
    applet_app_thumbnail_hover_menu_close (self, TRUE);
    g_object_unref (self);
}
void applet_app_thumbnail_hover_menu_hover_close(AppletAppThumbnailHoverMenu *self){
    applet_app_thumbnail_hover_menu_main_loop_hover_close(self);

}

void applet_app_thumbnail_hover_menu_hover_open(AppletAppThumbnailHoverMenu *self){
    applet_app_thumbnail_hover_menu_main_loop_hover_open(self);
}

void applet_app_thumbnail_hover_menu_set_meta_window(AppletAppThumbnailHoverMenu *self,MetaWindow *meta_window){
    g_return_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self));
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    priv->meta_window = meta_window;
    applet_app_switcher_item_set_meta_window(priv->app_switcher_item,meta_window);
}

MetaWindow* applet_app_thumbnail_hover_menu_get_meta_window(AppletAppThumbnailHoverMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self),NULL);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    return priv->meta_window;
}
CdosApp* applet_app_thumbnail_hover_menu_get_app(AppletAppThumbnailHoverMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self),NULL);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    return priv->app;
}
gboolean applet_app_thumbnail_hover_menu_get_is_favorite_app(AppletAppThumbnailHoverMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self),NULL);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    return priv->is_favorite_app;
}
StWidget* applet_app_thumbnail_hover_menu_get_parent_actor(AppletAppThumbnailHoverMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self),NULL);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    return priv->parent_actor;
}
StWidget* applet_app_thumbnail_hover_menu_get_actor(AppletAppThumbnailHoverMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self),NULL);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    return ST_WIDGET(CDOS_POPUP_MENU(self)->actor);
}

AppletAppSwitcherItem* applet_app_thumbnail_hover_menu_get_app_switcher_item(AppletAppThumbnailHoverMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self),NULL);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    return priv->app_switcher_item;
}
gboolean applet_app_thumbnail_hover_menu_get_should_open(AppletAppThumbnailHoverMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self),NULL);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    return priv->should_open;
}

void applet_app_thumbnail_hover_menu_set_should_open(AppletAppThumbnailHoverMenu *self,gboolean should_open){
    g_return_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self));
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    priv->should_open = should_open;
}

gboolean applet_app_thumbnail_hover_menu_get_should_close(AppletAppThumbnailHoverMenu *self){
    g_return_val_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self),NULL);
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    return priv->should_close;
}

void applet_app_thumbnail_hover_menu_set_should_close(AppletAppThumbnailHoverMenu *self,gboolean should_close){
    g_return_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self));
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    priv->should_close = should_close;
}

void applet_app_thumbnail_hover_menu_refresh(AppletAppThumbnailHoverMenu *self){
    g_return_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self));
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    if(priv->is_keep_menu ==  FALSE){
        priv->should_open = FALSE;
        priv->should_close = TRUE;
    } else {
        priv->should_open = TRUE;
        priv->should_close = FALSE;
    }
    applet_app_thumbnail_hover_menu_main_loop_hover_close(self);
    applet_app_switcher_item_refresh( APPLET_APP_SWITCHER_ITEM (priv->app_switcher_item));
}

void applet_app_thumbnail_hover_menu_set_context_menu(AppletAppThumbnailHoverMenu *self,AppletAppContextMenu *context_menu){
    g_return_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self));
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    priv->context_menu = context_menu;
}
void applet_app_thumbnail_hover_menu_set_is_keep_menu(AppletAppThumbnailHoverMenu *self,gboolean is_keep_menu){
    g_return_if_fail(APPLET_IS_APP_THUMBNAIL_HOVER_MENU(self));
    AppletAppThumbnailHoverMenuPrivate *priv = self->priv;
    priv->is_keep_menu = is_keep_menu;
}

