//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js

#include "applet-app-tracker.h"
//添加依赖库;


/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletAppTrackerPrivate{
    CdosWindowTracker *tracker;
    AppletOrderedHash *hash;
};

/*-------global variables-------------*/
static gint AppletAppTracker_private_offset = 0;
static gint applet_app_tracker_signals[LAST_SIGNAL] = { 0 };
static gpointer applet_app_tracker_parent_class = NULL;

/*-------class functions---------*/
static void applet_app_tracker_init(AppletAppTracker *self);
static void applet_app_tracker_class_init(AppletAppTrackerClass *klass);

static void applet_app_tracker_dispose(GObject *object);
static void applet_app_tracker_finalize(GObject *object);

/*-------------private functions of instance-------------------*/


/*-------functions-------------*/

/**
 * 注册类；
 *
 *
 * */
GType
applet_app_tracker_get_type(void)
{
    static GType applet_app_tracker_type = 0;
    if(G_UNLIKELY(applet_app_tracker_type == 0))
    {
        static const GTypeInfo applet_app_tracker_info = {
                sizeof(AppletAppTrackerClass),
                NULL,NULL,
                (GClassInitFunc)applet_app_tracker_class_init,
                NULL,NULL,
                sizeof(AppletAppTracker),
                0,
                (GInstanceInitFunc)applet_app_tracker_init
        };
        //类注册
        applet_app_tracker_type = g_type_register_static(G_TYPE_OBJECT,"AppletAppTracker",&applet_app_tracker_info,0);
        //g_type_add_class_private(applet_app_tracker_type, sizeof(AppletAppTrackerClassPrivate));
        AppletAppTracker_private_offset =
                g_type_add_instance_private(applet_app_tracker_type, sizeof(AppletAppTrackerPrivate));

    }
    return applet_app_tracker_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_app_tracker_get_instance_private(AppletAppTracker *self){
    return (G_STRUCT_MEMBER_P (self, AppletAppTracker_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_app_tracker_init(AppletAppTracker *self)
{
    AppletAppTrackerPrivate *priv;
    self->priv=applet_app_tracker_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/
    priv->hash = applet_ordered_hash_new();

}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_app_tracker_class_init(AppletAppTrackerClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletAppTracker_private_offset);
    applet_app_tracker_parent_class = g_type_class_peek_parent(klass);

    /*-------------重写父类的虚方法---------------*/
    //gobject_class->constructed=applet_app_tracker_constructed;
    gobject_class->dispose=applet_app_tracker_dispose;
    gobject_class->finalize=applet_app_tracker_finalize;
}

/*------------类方法定义-----------*/
static void applet_app_tracker_dispose(GObject *object){
    AppletAppTracker *self = APPLET_APP_TRACKER(object);
    AppletAppTrackerPrivate *priv = self->priv;

    applet_ordered_hash_destroy(priv->hash,FALSE);

    g_object_unref(priv->tracker);
    g_clear_object(&priv->hash);
    G_OBJECT_CLASS(applet_app_tracker_parent_class)->dispose(object);
}

static void applet_app_tracker_finalize(GObject *object){
    AppletAppTracker *self = APPLET_APP_TRACKER(object);

    G_OBJECT_CLASS(applet_app_tracker_parent_class)->finalize(object);
}

/*-------------private functions--------------*/




/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletAppTracker* applet_app_tracker_new(CdosWindowTracker *tracker)
{
    AppletAppTracker *self;
    self = g_object_new(APPLET_TYPE_APP_TRACKER, NULL);
    AppletAppTrackerPrivate *priv = self->priv;
    if(tracker == NULL){
        priv->tracker = cdos_window_tracker_get_default();
    }else{
        priv->tracker = tracker;
    }
    g_object_ref(priv->tracker);
    return self;
}


CdosApp* applet_app_tracker_get_window_app(AppletAppTracker *self,MetaWindow *meta_window){
    g_return_val_if_fail(APPLET_IS_APP_TRACKER(self),NULL);
    g_return_val_if_fail(META_IS_WINDOW(meta_window),NULL);

    AppletAppTrackerPrivate *priv = self->priv;
    CdosApp *app = cdos_window_tracker_get_window_app(priv->tracker,meta_window);
    MetaWindowType meta_window_type = meta_window_get_window_type(meta_window);
    if(meta_window_type == META_WINDOW_NORMAL){
        if(app == NULL){
            app = applet_ordered_hash_get(priv->hash,meta_window);
        }else{
            applet_ordered_hash_set(priv->hash,meta_window,app);
        }
    }

    if(!app){
        g_warning("get_window_app returned NULL and there was no record of meta_window in internal database");
    }
    return app;
}

CdosWindowTracker* applet_app_tracker_get_cdos_window_tracker(AppletAppTracker *self){
    g_return_val_if_fail(APPLET_IS_APP_TRACKER(self),NULL);
    AppletAppTrackerPrivate *priv = self->priv;
    return priv->tracker;
}

void applet_app_tracker_set_cdos_window_tracker(AppletAppTracker *self,CdosWindowTracker *tracker){
    g_return_if_fail(APPLET_IS_APP_TRACKER(self));
    AppletAppTrackerPrivate *priv = self->priv;
    if(priv->tracker != NULL){
        g_object_unref(priv->tracker);
    }
    priv->tracker = g_object_ref(tracker);

}

void applet_app_tracker_remove_window(AppletAppTracker *self,MetaWindow *meta_window){
    g_return_if_fail(APPLET_IS_APP_TRACKER(self));
    g_return_if_fail(META_IS_WINDOW(meta_window));

    AppletAppTrackerPrivate *priv = self->priv;
    if(applet_ordered_hash_contains(priv->hash,meta_window)){
        applet_ordered_hash_remove(priv->hash,meta_window);
    }
}