//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialButtons.js

#include "applet-button-box.h"
//添加依赖库;


/*-----------------实例私有结构体-------------------*/
struct _AppletButtonBoxPrivate{
    gfloat old_width;
    StWidget *actor;
};

/*-------global variables-------------*/
static gint AppletButtonBox_private_offset = 0;
static gpointer applet_button_box_parent_class = NULL;

/*-------class functions---------*/
static void applet_button_box_init(AppletButtonBox *self);
static void applet_button_box_class_init(AppletButtonBoxClass *klass);

static void applet_button_box_dispose(GObject *object);
static void applet_button_box_finalize(GObject *object);

/**
 * 注册类；
 *
 *
 * */
GType
applet_button_box_get_type(void)
{
    static GType applet_button_box_type = 0;
    if(G_UNLIKELY(applet_button_box_type==0))
    {
        static const GTypeInfo applet_button_box_info = {
                sizeof(AppletButtonBoxClass),
                NULL,NULL,
                (GClassInitFunc)applet_button_box_class_init,
                NULL,NULL,
                sizeof(AppletButtonBox),
                0,
                (GInstanceInitFunc)applet_button_box_init
        };
        //类注册
        applet_button_box_type = g_type_register_static(G_TYPE_OBJECT,"AppletButtonBox",&applet_button_box_info,0);
        //g_type_add_class_private(applet_button_box_type, sizeof(AppletButtonBoxClassPrivate));
        AppletButtonBox_private_offset =
                g_type_add_instance_private(applet_button_box_type, sizeof(AppletButtonBoxPrivate));

    }
    return applet_button_box_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_button_box_get_instance_private(AppletButtonBox *self){
    return (G_STRUCT_MEMBER_P (self, AppletButtonBox_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_button_box_init(AppletButtonBox *self)
{
    AppletButtonBoxPrivate *priv;
    self->priv=applet_button_box_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/
    priv->actor = st_box_layout_new();
    st_widget_set_style(priv->actor, "spacing:2px;");
}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_button_box_class_init(AppletButtonBoxClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletButtonBox_private_offset);
    applet_button_box_parent_class = g_type_class_peek_parent(klass);

    /*-------------重写父类的虚方法---------------*/
    //gobject_class->constructed=applet_button_box_constructed;
    gobject_class->dispose=applet_button_box_dispose;
    gobject_class->finalize=applet_button_box_finalize;
}

/*------------类方法定义-----------*/
static void applet_button_box_dispose(GObject *object){
    AppletButtonBox *self = APPLET_BUTTON_BOX(object);
    AppletButtonBoxPrivate *priv = self->priv;
    if(priv->actor){
        clutter_actor_destroy((ClutterActor *)priv->actor);
    }
    G_OBJECT_CLASS(applet_button_box_parent_class)->dispose(object);
};

static void applet_button_box_finalize(GObject *object){
    AppletButtonBox *self = APPLET_BUTTON_BOX(object);
    AppletButtonBoxPrivate *priv = self->priv;
    
    G_OBJECT_CLASS(applet_button_box_parent_class)->finalize(object);
};
/*-------------private functions--------------*/




/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletButtonBox* applet_button_box_new(void)
{
    AppletButtonBox *self;
    self = g_object_new(APPLET_TYPE_BUTTON_BOX, NULL);
    return self;
}

void applet_button_box_show(AppletButtonBox *self,gboolean animate,gfloat target_width){
    g_return_if_fail(APPLET_IS_BUTTON_BOX(self));
    AppletButtonBoxPrivate *priv = self->priv;

    if(!animate){
        clutter_actor_show(CLUTTER_ACTOR(priv->actor));
        return ;
    }
    //gfloat width = priv->old_width || target_width;
    gfloat width = -1;
    if(target_width >= 0){
        width = target_width;
    }else{
        width = priv->old_width;
    }
    if(width == -1){
        gfloat min_width,natural_width;
        clutter_actor_get_preferred_width((ClutterActor *)priv->actor,-1,&min_width,&natural_width);
        width = natural_width;
    }
    clutter_actor_set_width(CLUTTER_ACTOR(priv->actor),3.0);
    clutter_actor_show(CLUTTER_ACTOR(priv->actor));
    //notice:此处需要添加tweener动画效果;

}

void applet_button_box_hide(AppletButtonBox *self,gboolean animate){
    g_return_if_fail(APPLET_IS_BUTTON_BOX(self));
    AppletButtonBoxPrivate *priv = self->priv;

    if(!animate){
        clutter_actor_hide(CLUTTER_ACTOR(priv->actor));
        return ;
    }
    priv->old_width = clutter_actor_get_width(CLUTTER_ACTOR(priv->actor));
    //notice:此处需要添加tweener动画效果;

}

void applet_button_box_add(AppletButtonBox *self,ClutterActor *actor){

    g_return_if_fail(APPLET_IS_BUTTON_BOX(self));
    AppletButtonBoxPrivate *priv = self->priv;
    clutter_container_add_actor(CLUTTER_CONTAINER(priv->actor),actor);
    applet_button_box_hide_fav(self);

}

void applet_button_box_remove(AppletButtonBox *self,ClutterActor *actor){
    g_return_if_fail(APPLET_IS_BUTTON_BOX(self));
    AppletButtonBoxPrivate *priv = self->priv;
    g_object_ref(actor);
    clutter_container_remove_actor ((ClutterContainer *)priv->actor,actor);
    applet_button_box_hide_fav(self);
}

void applet_button_box_clear(AppletButtonBox *self){
    g_return_if_fail(APPLET_IS_BUTTON_BOX(self));
    AppletButtonBoxPrivate *priv = self->priv;
    st_container_destroy_children(ST_CONTAINER(priv->actor));
}

void applet_button_box_hide_fav(AppletButtonBox *self){
    g_return_if_fail(APPLET_IS_BUTTON_BOX(self));
    AppletButtonBoxPrivate *priv = self->priv;
    GList *children = clutter_container_get_children ((ClutterContainer *)priv->actor);
    GList *fisrt_child = g_list_first(children);
    if(fisrt_child == NULL){
        return ;
    }
    ClutterActor *first_actor = fisrt_child->data;
    if(g_list_length(children) == 1){
        clutter_actor_show(CLUTTER_ACTOR(first_actor));
    }else{
        clutter_actor_hide(CLUTTER_ACTOR(first_actor));
    }
    g_list_free(children);
}

void applet_button_box_destroy(AppletButtonBox *self){
    g_return_if_fail(APPLET_IS_BUTTON_BOX(self));
    AppletButtonBoxPrivate *priv = self->priv;
    GList *children = clutter_container_get_children((ClutterContainer *)priv->actor);
    while (children != NULL){
        clutter_actor_destroy(children->data);
        children = children->next;
    }
    clutter_actor_destroy(CLUTTER_ACTOR(priv->actor));
    g_list_free(children);
    priv->actor = NULL;
}

StWidget* applet_button_box_get_actor(AppletButtonBox *self){
    g_return_val_if_fail(APPLET_IS_BUTTON_BOX(self),NULL);
    AppletButtonBoxPrivate *priv = self->priv;
    return priv->actor;

}
