//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialButtons.js

#include "applet-icon-label-button.h"
//添加依赖库;
#include <math.h>
#include <clutter/clutter.h>
#include "applet-app-group.h"
#include "applet-window-list.h"
#include "cdos-applet.h"
#include "cdos-debug.h"

typedef struct _AppletIconLabelButtonSignalIds AppletIconLabelButtonSignalIds;

/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletIconLabelButtonPrivate{
    ClutterAllocationFlags flags;
    gfloat old_width;
    StWidget *actor;

    AppletWindowList *applet;
    ClutterActor *icon;
    gfloat icon_x1;
    gfloat icon_x2;
    gfloat icon_y1;
    gfloat icon_y2;
    CdosGenericContainer *container;
    StWidget *label;
    StWidget *num_label;
    ClutterActorBox *child_box;
    AppletIconLabelButtonSignalIds *signal_ids;
    gboolean show_num_label;
    gdouble min_size;
    gdouble natural_size;
    gfloat icon_modification_x;
};
struct _AppletIconLabelButtonSignalIds{
    gulong container_get_preferred_width_id;
    gulong container_get_preferred_height_id;
    gulong container_allocate_id;
};

/*-------global variables-------------*/
static gint AppletIconLabelButton_private_offset = 0;
static gint applet_icon_label_button_signals[LAST_SIGNAL] = { 0 };
static gpointer applet_icon_label_button_parent_class = NULL;

/*-------class functions---------*/
static void applet_icon_label_button_init(AppletIconLabelButton *self);
static void applet_icon_label_button_class_init(AppletIconLabelButtonClass *klass);

static void applet_icon_label_button_dispose(GObject *object);
static void applet_icon_label_button_finalize(GObject *object);

/*-------------private functions of instance-------------------*/
static void applet_icon_label_button_container_on_get_preferred_width(CdosGenericContainer *container,gfloat for_height,CdosGenericContainerAllocation *alloc,AppletIconLabelButton *self);
static void applet_icon_label_button_container_on_get_preferred_height(CdosGenericContainer *container,gfloat for_width,CdosGenericContainerAllocation *alloc,AppletIconLabelButton *self);
static void applet_icon_label_button_container_on_allocate(GObject *container,ClutterActorBox *box,ClutterAllocationFlags flags,AppletIconLabelButton *self);

static void applet_icon_label_center(gfloat length,gfloat natural_length,gfloat *x1,gfloat *x2);

static void applet_icon_label_remove_all_actors(AppletIconLabelButton *self);

static void applet_icon_label_disconnect_signals(AppletIconLabelButton *self);

/*-------functions-------------*/

/**
 * 注册类；
 *
 *
 * */
GType
applet_icon_label_button_get_type(void)
{
    static GType applet_icon_label_button_type = 0;
    if(G_UNLIKELY(applet_icon_label_button_type==0))
    {
        static const GTypeInfo applet_icon_label_button_info = {
                sizeof(AppletIconLabelButtonClass),
                NULL,NULL,
                (GClassInitFunc)applet_icon_label_button_class_init,
                NULL,NULL,
                sizeof(AppletIconLabelButton),
                0,
                (GInstanceInitFunc)applet_icon_label_button_init
        };
        //类注册
        applet_icon_label_button_type = g_type_register_static(G_TYPE_OBJECT,"AppletIconLabelButton",&applet_icon_label_button_info,0);
        //g_type_add_class_private(applet_icon_label_button_type, sizeof(AppletIconLabelButtonClassPrivate));
        AppletIconLabelButton_private_offset =
                g_type_add_instance_private(applet_icon_label_button_type, sizeof(AppletIconLabelButtonPrivate));

    }
    return applet_icon_label_button_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_icon_label_button_get_instance_private(AppletIconLabelButton *self){
    return (G_STRUCT_MEMBER_P (self, AppletIconLabelButton_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_icon_label_button_init(AppletIconLabelButton *self)
{
    AppletIconLabelButtonPrivate *priv;
    self->priv=applet_icon_label_button_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/

    priv->signal_ids = g_new0(AppletIconLabelButtonSignalIds,1);
    priv->icon_x1 = 0;
    priv->icon_x2 = 0;
    priv->icon_y1 = 0;
    priv->icon_y2 = 0;
    priv->flags = CLUTTER_ALLOCATION_NONE;

    priv->actor = st_bin_new();
    st_widget_set_style_class_name(priv->actor,"window-list-item-box-none");
    st_widget_set_can_focus(priv->actor,TRUE);
    st_widget_set_track_hover(priv->actor,TRUE);
    st_bin_set_fill(ST_BIN(priv->actor),TRUE,FALSE);
    clutter_actor_set_reactive(CLUTTER_ACTOR(priv->actor),TRUE);

    priv->container = g_object_new(CDOS_TYPE_GENERIC_CONTAINER, NULL);
    clutter_actor_set_name(CLUTTER_ACTOR(priv->container),"iconLabelButton");
    st_bin_set_child(ST_BIN(priv->actor),CLUTTER_ACTOR(priv->container));

    priv->signal_ids->container_get_preferred_width_id = \
    g_signal_connect(priv->container,"get-preferred-width",G_CALLBACK(applet_icon_label_button_container_on_get_preferred_width),self);
    priv->signal_ids->container_get_preferred_height_id = \
    g_signal_connect(priv->container,"get-preferred-height",G_CALLBACK(applet_icon_label_button_container_on_get_preferred_height),self);

    priv->signal_ids->container_allocate_id = \
    g_signal_connect(priv->container,"allocate",G_CALLBACK(applet_icon_label_button_container_on_allocate),self);

    priv->label = st_label_new("");
    priv->num_label = st_label_new("");
    st_widget_set_style_class_name(priv->num_label,"window-list-item-label");
    st_widget_set_style(priv->num_label,"text-shadow:black 1px 0 2px");

    priv->show_num_label = FALSE;
    if(priv->show_num_label == FALSE){
        clutter_actor_hide(CLUTTER_ACTOR(priv->num_label));
    }
    clutter_actor_set_margin_left(CLUTTER_ACTOR(priv->actor),0);
    clutter_actor_set_margin_right(CLUTTER_ACTOR(priv->actor),0);
    priv->icon_modification_x = 0;
}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_icon_label_button_class_init(AppletIconLabelButtonClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);

    g_type_class_adjust_private_offset(klass,&AppletIconLabelButton_private_offset);
    applet_icon_label_button_parent_class = g_type_class_peek_parent(klass);

    //gobject_class->constructed=applet_icon_label_button_constructed;
    gobject_class->dispose=applet_icon_label_button_dispose;
    gobject_class->finalize=applet_icon_label_button_finalize;


}

/*------------类方法定义-----------*/
static void applet_icon_label_button_dispose(GObject *object){
    AppletIconLabelButton *self = APPLET_ICON_LABEL_BUTTON(object);
    AppletIconLabelButtonPrivate *priv = self->priv;
    applet_icon_label_disconnect_signals(self);
    if(priv->container){
        applet_icon_label_remove_all_actors(self);
        clutter_actor_destroy(CLUTTER_ACTOR(priv->container));
    }
    if(priv->actor){
        clutter_actor_destroy(CLUTTER_ACTOR(priv->actor));
    }

    G_OBJECT_CLASS(applet_icon_label_button_parent_class)->dispose(object);
}

static void applet_icon_label_button_finalize(GObject *object){
    AppletIconLabelButton *self = APPLET_ICON_LABEL_BUTTON(object);
    AppletIconLabelButtonPrivate *priv = self->priv;

    g_free(priv->signal_ids);

    G_OBJECT_CLASS(applet_icon_label_button_parent_class)->finalize(object);
}

/*-------------private functions--------------*/
static void applet_icon_label_button_container_on_get_preferred_width(CdosGenericContainer *container,gfloat for_height,CdosGenericContainerAllocation *alloc,AppletIconLabelButton *self){
    AppletIconLabelButtonPrivate *priv = self->priv;
    alloc->min_size = 48;
    alloc->natural_size = 48;
}

static void applet_icon_label_button_container_on_get_preferred_height(CdosGenericContainer *container,gfloat for_width,CdosGenericContainerAllocation *alloc,AppletIconLabelButton *self){

    AppletIconLabelButtonPrivate *priv = self->priv;
    gfloat icon_min_size,icon_natural_size,label_min_size,label_natural_size;
    clutter_actor_get_preferred_height(CLUTTER_ACTOR(priv->icon),for_width,&icon_min_size,&icon_natural_size);
    clutter_actor_get_preferred_height(CLUTTER_ACTOR(priv->label),for_width,&label_min_size,&label_natural_size);

    alloc->min_size = MIN(icon_min_size,label_min_size);
    alloc->natural_size = MAX(icon_natural_size,label_natural_size);

}

static void applet_icon_label_button_container_on_allocate(GObject *container,ClutterActorBox *box,ClutterAllocationFlags flags,AppletIconLabelButton *self){
    AppletIconLabelButtonPrivate *priv = self->priv;

    gfloat alloc_width = box->x2 - box->x1;
    gfloat alloc_height = box->y2 - box->y1;
    ClutterActorBox *child_box = clutter_actor_box_new(priv->icon_x1,priv->icon_y1,priv->icon_x2,priv->icon_y2);

    ClutterTextDirection direction = clutter_actor_get_text_direction(CLUTTER_ACTOR(priv->actor));

    gfloat icon_min_width,icon_min_height,icon_natural_width,icon_natural_height;
    clutter_actor_get_preferred_size(CLUTTER_ACTOR(priv->icon),&icon_min_width,&icon_min_height,&icon_natural_width,&icon_natural_height);

    static gfloat x1,y1,x2,y2;

    applet_icon_label_center(alloc_width,icon_natural_width,&x1,&x2);
    applet_icon_label_center(alloc_height,icon_natural_height,&y1,&y2);
    x1 = x1 + priv->icon_modification_x;
    x2 = x2 + priv->icon_modification_x;
    child_box->x1 = x1;
    child_box->x2 = x2;
    child_box->y1 = y1;
    child_box->y2 = y2;

    priv->icon_x1 = x1;
    priv->icon_x2 = x2;
    priv->icon_y1 = y1;
    priv->icon_y2 = y2;

    priv->flags = flags;
    clutter_actor_allocate(CLUTTER_ACTOR(priv->icon),child_box,priv->flags);

    gfloat icon_width = child_box->x1 - child_box->x2;
    gfloat label_min_width,label_min_height,label_natural_width,label_natural_height;
    clutter_actor_get_preferred_size(CLUTTER_ACTOR(priv->label),&label_min_width,&label_min_height,&label_natural_width,&label_natural_height);

    if(direction == CLUTTER_TEXT_DIRECTION_LTR){
        child_box->x1 = icon_width;
        child_box->x2 = MIN(alloc_width,APPLET_MAX_BUTTON_WIDTH);
    }else{
        child_box->x2 = MIN(alloc_width - icon_width,APPLET_MAX_BUTTON_WIDTH);
        child_box->x1 = MAX(0,child_box->x2 - label_natural_width);
    }
    clutter_actor_allocate(CLUTTER_ACTOR(priv->label),child_box,priv->flags);

    if(direction == CLUTTER_TEXT_DIRECTION_LTR){
        child_box->x1 = -3;
        child_box->x2 = child_box->x1 + clutter_actor_get_width(CLUTTER_ACTOR(priv->num_label));
        child_box->y1 = box->y1 -2;
        child_box->y2 = box->y2 -1;
    }else{
        gfloat num_label_width = clutter_actor_get_width(CLUTTER_ACTOR(priv->num_label));
        child_box->x1 = -num_label_width;
        child_box->x2 = child_box->x1 + num_label_width;
        child_box->y1 = box->y1;
        child_box->y2 = box->y2 -1;
    }
    clutter_actor_allocate(CLUTTER_ACTOR(priv->num_label),child_box,priv->flags);
    clutter_actor_box_free(child_box);
}

static void applet_icon_label_center(gfloat length,gfloat natural_length,gfloat *x1,gfloat *x2){

    gfloat max_length = MIN(length,natural_length);
    *x1 = MAX(0,floor((length-max_length)/2));
    *x2 = MIN(length,*x1 + max_length);
}

static void applet_icon_label_remove_all_actors(AppletIconLabelButton *self){
    AppletIconLabelButtonPrivate *priv = self->priv;
    if(priv->container != NULL){
        if(priv->icon){
            clutter_container_remove_actor(CLUTTER_CONTAINER(priv->container),CLUTTER_ACTOR(priv->icon));
        }
        if(priv->label){
            clutter_container_remove_actor(CLUTTER_CONTAINER(priv->container),CLUTTER_ACTOR(priv->label));
            priv->label = NULL;
        }
        if(priv->num_label){
            clutter_container_remove_actor(CLUTTER_CONTAINER(priv->container),CLUTTER_ACTOR(priv->num_label));
            priv->num_label = NULL;
        }
    }
}

static void applet_icon_label_disconnect_signals(AppletIconLabelButton *self){
    AppletIconLabelButtonPrivate *priv = self->priv;
    AppletIconLabelButtonSignalIds *signal_ids = priv->signal_ids;
    if(signal_ids->container_get_preferred_height_id > 0){
        g_signal_handler_disconnect(priv->container,signal_ids->container_get_preferred_height_id);
        signal_ids->container_get_preferred_height_id = 0;
    }
    if(signal_ids->container_get_preferred_width_id > 0){
        g_signal_handler_disconnect(priv->container,signal_ids->container_get_preferred_width_id);
        signal_ids->container_get_preferred_width_id = 0;
    }
    if(signal_ids->container_allocate_id > 0){
        g_signal_handler_disconnect(priv->container,signal_ids->container_allocate_id);
        signal_ids->container_allocate_id = 0;
    }
}

/*-------------public functions--------------*/
void applet_icon_label_button_constructor(AppletIconLabelButton *self,AppletWindowList *applet,ClutterActor *icon){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;
    priv->applet = applet;
    priv->icon = icon;

    StSide orientation = applet_window_list_get_orientation(priv->applet);
    clutter_container_add_actor(CLUTTER_CONTAINER(priv->container),priv->icon);
    clutter_container_add_actor(CLUTTER_CONTAINER(priv->container),CLUTTER_ACTOR(priv->label));
    clutter_container_add_actor(CLUTTER_CONTAINER(priv->container),CLUTTER_ACTOR(priv->num_label));

    if(orientation == ST_SIDE_TOP){
        st_widget_add_style_class_name(priv->actor,"window-list-item-box-top");
    }else{
        st_widget_add_style_class_name(priv->actor,"window-list-item-box-bottom");
    }
}

void applet_icon_label_button_set_icon_padding(AppletIconLabelButton *self){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;

}

void applet_icon_label_button_set_text(AppletIconLabelButton *self,gchar *text){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;
    if(text != NULL){
        st_label_set_text(ST_LABEL(priv->label),text);
    }
}

void applet_icon_label_button_set_style(AppletIconLabelButton *self,gchar *name){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;
    if(name != NULL){
        st_widget_set_style_class_name(priv->label,name);
    }
}

void applet_icon_label_button_icon_sink(AppletIconLabelButton *self,gint size){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;
    ClutterActorBox *child_box = clutter_actor_box_new(priv->icon_x1,priv->icon_y1,priv->icon_x2,priv->icon_y2);
    clutter_actor_box_init(child_box,
                           priv->icon_x1 + size,
                           priv->icon_y1 + size,
                           priv->icon_x2 + size,
                           priv->icon_y2 + size);
    clutter_actor_allocate(CLUTTER_ACTOR(priv->icon),child_box,priv->flags);
    clutter_actor_box_free(child_box);
}

void applet_icon_label_button_icon_recovery(AppletIconLabelButton *self){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;
    ClutterActorBox *child_box = clutter_actor_box_new(priv->icon_x1,priv->icon_y1,priv->icon_x2,priv->icon_y2);
    clutter_actor_box_init(child_box,
                           priv->icon_x1,
                           priv->icon_y1,
                           priv->icon_x2,
                           priv->icon_y2);
    clutter_actor_allocate(CLUTTER_ACTOR(priv->icon),child_box,priv->flags);
    clutter_actor_box_free(child_box);
}

void applet_icon_label_button_show(AppletIconLabelButton *self,gboolean animate,gfloat target_width){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;

    if(!animate){
        clutter_actor_show(CLUTTER_ACTOR(priv->actor));
        return;
    }
    gfloat width = -1;
    if(target_width >= 0){
        width = target_width;
    } else {
        width = priv->old_width;
    }

    if(width == -1){
        gfloat min_width,natural_width;
        clutter_actor_get_preferred_width (CLUTTER_ACTOR(priv->actor),-1,&min_width,&natural_width);
        width = natural_width;
    }
    clutter_actor_show(CLUTTER_ACTOR(priv->actor));

    //notice:此处需要添加tweener动画；
}

void applet_icon_label_button_hide(AppletIconLabelButton *self,gboolean animate){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;

    if(!animate){
        clutter_actor_hide(CLUTTER_ACTOR(priv->actor));
        return;
    }
    priv->old_width = clutter_actor_get_width (CLUTTER_ACTOR(priv->actor));
    //notice:此处需要添加tweener动画；

}

void applet_icon_label_button_show_label(AppletIconLabelButton *self,gboolean animate,gfloat target_width){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;

    gfloat min_width,natural_width;
    clutter_actor_get_preferred_width (CLUTTER_ACTOR(priv->label),-1,&min_width,&natural_width);

    //gfloat width = target_width || natural_width;
    gfloat width;
    if(target_width >= 0){
        width = target_width;
    } else {
        width = natural_width;
    }
    if(!animate){
        clutter_actor_set_width(CLUTTER_ACTOR(priv->label),width);
        clutter_actor_show(CLUTTER_ACTOR(priv->label));
        return;
    }
    clutter_actor_show(CLUTTER_ACTOR(priv->label));
    //notice:此处需要添加tweener动画；
}

void applet_icon_label_button_hide_label(AppletIconLabelButton *self,gboolean animate){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;
    if(!animate){
        clutter_actor_set_width(CLUTTER_ACTOR(priv->label),1);
        clutter_actor_hide(CLUTTER_ACTOR(priv->label));
        return;
    }
    //notice:此处需要添加tweener动画；

}

void applet_icon_label_button_destroy(AppletIconLabelButton *self){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;
    applet_icon_label_disconnect_signals(self);
    //st_container_destroy_children(ST_CONTAINER(priv->container));
    applet_icon_label_remove_all_actors(self);
    clutter_actor_destroy(CLUTTER_ACTOR(priv->container));
    clutter_actor_destroy(CLUTTER_ACTOR(priv->actor));
    priv->container = NULL;
    priv->actor = NULL;
}

CdosGenericContainer* applet_icon_label_button_get_container(AppletIconLabelButton *self){
    g_return_val_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self),NULL);
    AppletIconLabelButtonPrivate *priv = self->priv;
    return priv->container;
}

StWidget* applet_icon_label_button_get_actor(AppletIconLabelButton *self){
    g_return_val_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self),NULL);
    AppletIconLabelButtonPrivate *priv = self->priv;
    return priv->actor;
}

StWidget* applet_icon_label_button_get_num_label(AppletIconLabelButton *self){
    g_return_val_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self),NULL);
    AppletIconLabelButtonPrivate *priv = self->priv;
    return priv->num_label;
}

void applet_icon_label_button_set_num_label_text(AppletIconLabelButton *self,gchar *text){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;
    st_label_set_text(ST_LABEL(priv->num_label),text);
}

StWidget* applet_icon_label_button_get_label(AppletIconLabelButton *self){
    g_return_val_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self),NULL);
    AppletIconLabelButtonPrivate *priv = self->priv;
    return priv->label;
}

void applet_icon_label_button_set_label_text(AppletIconLabelButton *self,gchar *text){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;
    st_label_set_text(ST_LABEL(priv->label),text);
}
gfloat applet_icon_label_button_get_icon_modification_x(AppletIconLabelButton *self){
    g_return_val_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self),0);
    AppletIconLabelButtonPrivate *priv = self->priv;
    return priv->icon_modification_x;
}

void applet_icon_label_button_set_icon_modification_x(AppletIconLabelButton *self,gfloat value){
    g_return_if_fail(APPLET_IS_ICON_LABEL_BUTTON(self));
    AppletIconLabelButtonPrivate *priv = self->priv;
    if(value == priv->icon_modification_x){
        return ;
    }
    priv->icon_modification_x = value;
    clutter_actor_queue_relayout(CLUTTER_ACTOR(priv->container));
}
