//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js

#include "applet-ordered-hash.h"
#include "cdos-debug.h"
//添加依赖库;


/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletOrderedHashPrivate{
    GList *items;
};

struct _AppletOrderHashItem {
    gpointer key;
    gpointer item;
};
/*-------global variables-------------*/
static gint AppletOrderedHash_private_offset = 0;
static gint applet_ordered_hash_signals[LAST_SIGNAL] = { 0 };
static gpointer applet_ordered_hash_parent_class = NULL;



/*-------class functions---------*/
static void applet_ordered_hash_init(AppletOrderedHash *self);
static void applet_ordered_hash_class_init(AppletOrderedHashClass *klass);

static void applet_ordered_hash_dispose(GObject *object);
static void applet_ordered_hash_finalize(GObject *object);

/*-------------private functions of instance-------------------*/




/*-------functions-------------*/

/**
 * 注册类；
 *
 *
 * */
GType
applet_ordered_hash_get_type(void)
{
    static GType applet_ordered_hash_type = 0;
    if(G_UNLIKELY(applet_ordered_hash_type==0))
    {
        static const GTypeInfo applet_ordered_hash_info = {
                sizeof(AppletOrderedHashClass),
                NULL,NULL,
                (GClassInitFunc)applet_ordered_hash_class_init,
                NULL,NULL,
                sizeof(AppletOrderedHash),
                0,
                (GInstanceInitFunc)applet_ordered_hash_init
        };
        //类注册
        applet_ordered_hash_type = g_type_register_static(G_TYPE_OBJECT,"AppletOrderedHash",&applet_ordered_hash_info,0);
        //g_type_add_class_private(applet_ordered_hash_type, sizeof(AppletOrderedHashClassPrivate));
        AppletOrderedHash_private_offset =
                g_type_add_instance_private(applet_ordered_hash_type, sizeof(AppletOrderedHashPrivate));

    }
    return applet_ordered_hash_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_ordered_hash_get_instance_private(AppletOrderedHash *self){
    return (G_STRUCT_MEMBER_P (self, AppletOrderedHash_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_ordered_hash_init(AppletOrderedHash *self)
{
    AppletOrderedHashPrivate *priv;
    self->priv=applet_ordered_hash_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/
    priv->items = NULL;

}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_ordered_hash_class_init(AppletOrderedHashClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletOrderedHash_private_offset);
    applet_ordered_hash_parent_class = g_type_class_peek_parent(klass);

    /*-------------重写父类的虚方法---------------*/
    //gobject_class->constructed=applet_ordered_hash_constructed;
    gobject_class->dispose=applet_ordered_hash_dispose;
    gobject_class->finalize=applet_ordered_hash_finalize;
}

/*------------类方法定义-----------*/
static void applet_ordered_hash_dispose(GObject *object){
    AppletOrderedHash *self = APPLET_ORDERED_HASH(object);
    AppletOrderedHashPrivate *priv = self->priv;
    applet_ordered_hash_destroy(self,FALSE);

    G_OBJECT_CLASS(applet_ordered_hash_parent_class)->dispose(object);
};

static void applet_ordered_hash_finalize(GObject *object){
    AppletOrderedHash *self = APPLET_ORDERED_HASH(object);
    AppletOrderedHashPrivate *priv = self->priv;

    G_OBJECT_CLASS(applet_ordered_hash_parent_class)->finalize(object);
};
/*-------------private functions--------------*/




/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletOrderedHash* applet_ordered_hash_new(void)
{
    AppletOrderedHash *self;
    self = g_object_new(APPLET_TYPE_ORDERED_HASH, NULL);
    return self;
}

void applet_ordered_hash_set(AppletOrderedHash *self,gpointer key,gpointer value){
    g_return_val_if_fail(APPLET_IS_ORDERED_HASH(self),NULL);
    AppletOrderedHashPrivate *priv = self->priv;
    GList *items = priv->items;
    if(key == NULL){
        g_error("key is null in function %s",__func__);
        return ;
    }
    while (items){
        AppletOrderHashItem *it = items->data;
        if(key == it->key){
            it->item = value;
            return ;
        }
        items = items->next;
    }
    AppletOrderHashItem *temp = g_new0(AppletOrderHashItem,1);
    temp->item = value;
    temp->key = key;
    priv->items = g_list_append(priv->items,temp);
}

gpointer applet_ordered_hash_get(AppletOrderedHash *self,gpointer key){
    g_return_val_if_fail(APPLET_IS_ORDERED_HASH(self),NULL);
    AppletOrderedHashPrivate *priv = self->priv;
    GList *items = priv->items;
    if(items != NULL && key != NULL){
        while (items){
            AppletOrderHashItem *it = items->data;
            if(key == it->key){
                return it->item;
            }
            items = items->next;
        }
    }

    return NULL;
}


gboolean applet_ordered_hash_contains(AppletOrderedHash *self,gpointer key){
    g_return_val_if_fail(APPLET_IS_ORDERED_HASH(self),FALSE);
    AppletOrderedHashPrivate *priv = self->priv;
    GList *items = priv->items;
    if(items != NULL && key != NULL){
        while (items){
            AppletOrderHashItem *it = items->data;
            if(key == it->key){
                return TRUE;
            }
            items = items->next;
        }
    }
    return FALSE;
}

gpointer applet_ordered_hash_remove(AppletOrderedHash *self,gpointer key){
    g_return_val_if_fail(APPLET_IS_ORDERED_HASH(self),NULL);
    AppletOrderedHashPrivate *priv = self->priv;
    if(key == NULL){
        g_warning("key is null in function %s",__func__);
        return ;
    }
    GList *items = priv->items;
    gpointer ret = NULL;
    if(items != NULL){
        while (items != NULL){
            AppletOrderHashItem *it = items->data;
            if(key == it->key){
                priv->items = g_list_remove(priv->items,it);
                ret = it->item;
                g_free(it);
                break ;
            }
            items = items->next;
        }
    }
    return ret;
}

GList* applet_ordered_hash_items(AppletOrderedHash *self){

    g_return_val_if_fail(APPLET_IS_ORDERED_HASH(self),NULL);
    AppletOrderedHashPrivate *priv = self->priv;

    GList *items = priv->items;
    GList *new_items = NULL;
    if(items != NULL){
        while (items){
            AppletOrderHashItem *it = items->data;
            new_items = g_list_append(new_items,it->item);
            items = items->next;
        }
    }
    return new_items;
}

void applet_ordered_hash_foreach(AppletOrderedHash *self,AppletOrderedHashForEachFunc for_func,gpointer user_data){
    g_return_if_fail(APPLET_IS_ORDERED_HASH(self));
    AppletOrderedHashPrivate *priv = self->priv;
    GList *items = priv->items;
    gint i=-1;
    if(items != NULL){
        while (items){
            AppletOrderHashItem *it = items->data;
            i++;
            (*for_func)(it->key,it->item,i,user_data);
            items = items->next;
        }
    }

}

GList* applet_ordered_hash_sort(AppletOrderedHash *self,GCompareFunc sort_func){
    g_return_val_if_fail(APPLET_IS_ORDERED_HASH(self),NULL);
    AppletOrderedHashPrivate *priv = self->priv;
    GList *items = priv->items;
    priv->items = g_list_sort(items,sort_func);
    return priv->items;
}

void applet_ordered_hash_destroy(AppletOrderedHash *self,gboolean force){
    g_return_if_fail(APPLET_IS_ORDERED_HASH(self));
    AppletOrderedHashPrivate *priv = self->priv;
    GList *items = priv->items;
    if(items != NULL){
        while (items){
            AppletOrderHashItem *it = items->data;
            if(force == TRUE){
                if(G_IS_OBJECT(it->item)){
                    g_object_unref(it->item);
                }else{
                    g_free(it->item);
                }
            }
            it->key = NULL;
            it->item = NULL;
            g_free(it);
            items->data = NULL;
            items = items->next;
        }
        g_list_free(priv->items);
        priv->items = NULL;
    }
}

GList* applet_ordered_hash_keys(AppletOrderedHash *self){
    g_return_val_if_fail(APPLET_IS_ORDERED_HASH(self),NULL);
    AppletOrderedHashPrivate *priv = self->priv;
    GList *items = priv->items;
    GList *keys = NULL;
    if(items != NULL){
        while (items){
            AppletOrderHashItem *it = items->data;
            gpointer *key = it->key;
            keys = g_list_append(keys,key);
            items = items->next;
        }
    }
    return keys;
}

gboolean applet_ordered_hash_is_empty(AppletOrderedHash *self){
    g_return_val_if_fail(APPLET_IS_ORDERED_HASH(self),TRUE);
    AppletOrderedHashPrivate *priv = self->priv;
    GList *items = priv->items;
    if(items != NULL){
        return FALSE;
    }
    return TRUE;
}
