//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js

#ifndef __APPLET_ORDERED_HASH_H__
#define __APPLET_ORDERED_HASH_H__
#include <glib-object.h>
#include "applet-window-list-private.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_ORDERED_HASH (applet_ordered_hash_get_type())
//强制类型转换;
#define APPLET_ORDERED_HASH(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_ORDERED_HASH,AppletOrderedHash))
//检测类型实例
#define APPLET_IS_ORDERED_HASH(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_ORDERED_HASH))
//类型转换(可选)
#define APPLET_ORDERED_HASH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_ORDERED_HASH,AppletOrderedHashClass))
//检测是否是类的成员(可选)
#define APPLET_IS_ORDERED_HASH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_ORDERED_HASH))
//获取实例对象的类结构(可选)
#define APPLET_ORDERED_HASH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_ORDERED_HASH,AppletOrderedHashClass))

//定义对象实例
//typedef struct _AppletOrderedHash AppletOrderedHash;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletOrderedHashClass AppletOrderedHashClass;

typedef struct _AppletOrderedHashPrivate AppletOrderedHashPrivate;

typedef struct _AppletOrderHashItem AppletOrderHashItem;

struct _AppletOrderedHash {
    GObject parent;
    AppletOrderedHashPrivate *priv;
};
struct _AppletOrderedHashClass {
    GObjectClass parent_class;
};
typedef void (*AppletOrderedHashForEachFunc) (gpointer ws,gpointer data,gint index,gpointer user_data);
//typedef void (*AppletOrderedHashSortFunc) (gpointer d1,gpointer d2);

//取得对象类型ID;
GType	applet_ordered_hash_get_type(void);
//创建对象实例;
AppletOrderedHash*  applet_ordered_hash_new(void);

//对象的属性成员方法列表;
void applet_ordered_hash_set(AppletOrderedHash *self,gpointer key,gpointer value);

gpointer applet_ordered_hash_get(AppletOrderedHash *self,gpointer key);

GList* applet_ordered_hash_sort(AppletOrderedHash *self,GCompareFunc sort_func);

//void applet_ordered_hash_get_pair(AppletOrderedHash *self,gint index,gchar *output_key,GList *output_item);

gboolean applet_ordered_hash_contains(AppletOrderedHash *self,gpointer key);

gpointer applet_ordered_hash_remove(AppletOrderedHash *self,gpointer key);

GList* applet_ordered_hash_keys(AppletOrderedHash *self);

GList* applet_ordered_hash_items(AppletOrderedHash *self);

void applet_ordered_hash_foreach(AppletOrderedHash *self,AppletOrderedHashForEachFunc for_func,gpointer user_data);

void applet_ordered_hash_destroy(AppletOrderedHash *self,gboolean force);

gboolean applet_ordered_hash_is_empty(AppletOrderedHash *self);



#endif //__APPLET_ORDERED_HASH_H__
