//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/applet.js

#include "applet-pinned-favs.h"
//添加依赖库;

#include "cdos-global.h"
#include "cdos-app-system.h"
#include "cdos-app.h"
#include "applet-window-list.h"
#include "cdos-provider.h"

typedef  struct _AppletAppFavorite AppletAppFavorite;
typedef struct _AppletPinnedFavsSignalIds AppletPinnedFavsSignalIds;

/*-----------------信号枚举-------------------*/
enum {
    CHANGED,
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletPinnedFavsPrivate{
    AppletWindowList *applet;
    GList *favorites;
    AppletPinnedFavsSignalIds *signal_ids;
};

struct _AppletAppFavorite{
    gchar *app_id;
    CdosApp *app;
};
struct _AppletPinnedFavsSignalIds{
    gulong global_settings_changed_panel_launchers_id;


};
/*-------global variables-------------*/
static gint AppletPinnedFavs_private_offset = 0;
static gint applet_pinned_favs_signals[LAST_SIGNAL] = { 0 };
static gpointer applet_pinned_favs_parent_class = NULL;

//static CdosGlobal *global = NULL;

/*-------class functions---------*/
static void applet_pinned_favs_init(AppletPinnedFavs *self);
static void applet_pinned_favs_class_init(AppletPinnedFavsClass *klass);

static void applet_pinned_favs_dispose(GObject *object);
static void applet_pinned_favs_finalize(GObject *object);

/*-------------private functions of instance-------------------*/

static void applet_pinned_favs_global_settings_on_changed_panel_launchers(GSettings *settings,gchar *key,AppletPinnedFavs *self);

static void applet_pinned_favs_reload(AppletPinnedFavs *self);

static void applet_pinned_favs_get_ids(AppletPinnedFavs *self);

static void applet_pinned_favs_add_favorite_private(AppletPinnedFavs *self,gchar *app_id,gint pos);

static void applet_pinned_favs_remove_favorite_private(AppletPinnedFavs *self,gchar *app_id);

static void applet_pinned_favs_favorites_destroy(AppletPinnedFavs *self);

/*-------functions-------------*/

/**
 * 注册类；
 *
 *
 * */
GType
applet_pinned_favs_get_type(void)
{
    static GType applet_pinned_favs_type = 0;
    if(G_UNLIKELY(applet_pinned_favs_type==0))
    {
        static const GTypeInfo applet_pinned_favs_info = {
                sizeof(AppletPinnedFavsClass),
                NULL,NULL,
                (GClassInitFunc)applet_pinned_favs_class_init,
                NULL,NULL,
                sizeof(AppletPinnedFavs),
                0,
                (GInstanceInitFunc)applet_pinned_favs_init
        };
        //类注册
        applet_pinned_favs_type = g_type_register_static(G_TYPE_OBJECT,"AppletPinnedFavs",&applet_pinned_favs_info,0);
        //g_type_add_class_private(applet_pinned_favs_type, sizeof(AppletPinnedFavsClassPrivate));
        AppletPinnedFavs_private_offset =
                g_type_add_instance_private(applet_pinned_favs_type, sizeof(AppletPinnedFavsPrivate));

    }
    return applet_pinned_favs_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_pinned_favs_get_instance_private(AppletPinnedFavs *self){
    return (G_STRUCT_MEMBER_P (self, AppletPinnedFavs_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_pinned_favs_init(AppletPinnedFavs *self)
{
    AppletPinnedFavsPrivate *priv;
    self->priv=applet_pinned_favs_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/
    if(global == NULL){
        global = cdos_global_get();
    }

    priv->signal_ids = g_new0(AppletPinnedFavsSignalIds,1);
    GSettings *global_settings = cdos_global_get_settings(global);

    priv->signal_ids->global_settings_changed_panel_launchers_id = \
    g_signal_connect(global_settings,"changed::panel-launchers",G_CALLBACK(applet_pinned_favs_global_settings_on_changed_panel_launchers),self);
    applet_pinned_favs_reload(self);
}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_pinned_favs_class_init(AppletPinnedFavsClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletPinnedFavs_private_offset);
    applet_pinned_favs_parent_class = g_type_class_peek_parent(klass);

    /*-------------重写父类的虚方法---------------*/
    //gobject_class->constructed=applet_pinned_favs_constructed;
    gobject_class->dispose=applet_pinned_favs_dispose;
    gobject_class->finalize=applet_pinned_favs_finalize;
}

/*------------类方法定义-----------*/
static void applet_pinned_favs_dispose(GObject *object){
    AppletPinnedFavs *self = APPLET_PINNED_FAVS(object);
    AppletPinnedFavsPrivate *priv = self->priv;

    if(priv->favorites != NULL){
        applet_pinned_favs_favorites_destroy(self);
    }

    G_OBJECT_CLASS(applet_pinned_favs_parent_class)->dispose(object);
}

static void applet_pinned_favs_finalize(GObject *object){
    AppletPinnedFavs *self = APPLET_PINNED_FAVS(object);
    AppletPinnedFavsPrivate *priv = self->priv;
    g_free(priv->signal_ids);

    G_OBJECT_CLASS(applet_pinned_favs_parent_class)->finalize(object);
}

/*-------------private functions--------------*/

static void applet_pinned_favs_global_settings_on_changed_panel_launchers(GSettings *settings,gchar *key,AppletPinnedFavs *self){
    applet_pinned_favs_reload(self);
}

static void applet_pinned_favs_reload(AppletPinnedFavs *self){
    AppletPinnedFavsPrivate *priv = self->priv;
    GSettings *global_settings = cdos_global_get_settings(global);
    guint i;
    gchar **ids = g_settings_get_strv(global_settings,"panel-launchers");
    CdosAppSystem *app_system = cdos_app_system_get_default();
    guint ids_length = g_strv_length(ids);
    applet_pinned_favs_favorites_destroy(self);
    if(ids_length > 0){
        for(i = 0; i < ids_length;i++){
            gchar *id = ids[i];
            CdosApp *app = cdos_app_system_lookup_app(app_system,id);
            if(app != NULL){
                AppletAppFavorite *app_favorite = g_new0(AppletAppFavorite,1);
                app_favorite->app_id = cdos_app_get_id(app);
                app_favorite->app = app;
                priv->favorites = g_list_append(priv->favorites,app_favorite);
            }
        }
        g_strfreev(ids);
    }

}

static void applet_pinned_favs_get_ids(AppletPinnedFavs *self){



};

static void applet_pinned_favs_add_favorite_private(AppletPinnedFavs *self,gchar *app_id,gint pos){
    AppletPinnedFavsPrivate *priv = self->priv;
    if(applet_pinned_favs_is_favorite(self,app_id)){
        return FALSE;
    }
    CdosAppSystem *app_system = cdos_app_system_get_default ();
    CdosApp *app = cdos_app_system_lookup_app(app_system,app_id);
    if(app == NULL){
        app = cdos_app_system_lookup_settings_app(app_system,app_id);
    }
    if(app == NULL){
        return FALSE;
    }
    AppletAppFavorite *favorite = g_new0(AppletAppFavorite,1);
    favorite->app_id = app_id;
    favorite->app = app;
    if(pos == -1){
        priv->favorites = g_list_append(priv->favorites,favorite);
    }else{
        priv->favorites = g_list_insert(priv->favorites,favorite,pos);
    }
    return TRUE;
}

static void applet_pinned_favs_remove_favorite_private(AppletPinnedFavs *self,gchar *app_id){
    //g_return_if_fail(applet_pinned_favs_is_favorite(self,app_id));
    AppletPinnedFavsPrivate *priv = self->priv;
    GList *apps = priv->favorites;
    GList *old_item = NULL;
    GList *new_favorites = NULL;
    while (apps){
        AppletAppFavorite *f = apps->data;
        if(app_id == f->app_id){
            GList *old_item = f;
        }else{
            new_favorites = g_list_append(new_favorites,f->app_id);
        }
        apps = apps->next;
    }
    if(old_item != NULL){
        priv->favorites = g_list_remove(priv->favorites,old_item);
        //CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
        //cdos_provider_set_array(CDOS_PROVIDER(applet_settings),"pinned-apps",NULL,new_favorites);
        g_list_free(old_item);
    }
    g_list_free(new_favorites);
}

static void applet_pinned_favs_favorites_destroy(AppletPinnedFavs *self){
    AppletPinnedFavsPrivate *priv = self->priv;

    if(priv->favorites != NULL){
        GList *apps = priv->favorites;
        while (apps){
            g_free(apps->data);
            apps->data = NULL;
            apps = apps->next;
        }
        g_list_free(priv->favorites);
        priv->favorites = NULL;
    }

}

/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletPinnedFavs* applet_pinned_favs_new(AppletWindowList *applet)
{
    AppletPinnedFavs *self;
    self = g_object_new(APPLET_TYPE_PINNED_FAVS, NULL);
    AppletPinnedFavsPrivate *priv = self->priv;
    priv->applet = applet;

    return self;
}

GList* applet_pinned_favs_get_favorite_map(AppletPinnedFavs *self){
    AppletPinnedFavsPrivate *priv = self->priv;
    return priv->favorites;
}
/**
 *
 * @params favorites [out];
 *
 * */
void applet_pinned_favs_get_favorites(AppletPinnedFavs *self,GList *favorites){
    AppletPinnedFavsPrivate *priv = self->priv;

    if(g_list_length(priv->favorites) > 0){
        GList *apps = priv->favorites;
        while (apps){
            AppletAppFavorite *f = apps->data;
            favorites = g_list_append(favorites,f->app);
            apps = apps->next;
        }
    }
}

gboolean applet_pinned_favs_is_favorite(AppletPinnedFavs *self,gchar *app_id){
    AppletPinnedFavsPrivate *priv = self->priv;

    if(g_list_length(priv->favorites) > 0){
        GList *apps = priv->favorites;
        while (apps){
            AppletAppFavorite *f = apps->data;
            if(app_id == f->app_id){
                return TRUE;
            }
            apps = apps->next;
        }
    }
    return FALSE;
}

void applet_pinned_favs_add_favorite_at_pos(AppletPinnedFavs *self,gchar *app_id,gint pos){
    applet_pinned_favs_add_favorite_private(self,app_id,pos);
}

void applet_pinned_favs_add_favorite(AppletPinnedFavs *self,gchar *app_id){
    applet_pinned_favs_add_favorite_private(self,app_id,-1);
}

void applet_pinned_favs_remove_favorite(AppletPinnedFavs *self,gchar *app_id){
    //AppletPinnedFavsPrivate *priv = self->priv;
    g_return_if_fail(applet_pinned_favs_is_favorite(self,app_id));
    applet_pinned_favs_remove_favorite_private(self,app_id);

}

void applet_pinned_favs_move_favorite_to_pos(AppletPinnedFavs *self,gchar *app_id,gint pos){
    AppletPinnedFavsPrivate *priv = self->priv;
    if(g_list_length(priv->favorites) > 0){
        GList *apps = priv->favorites;
        gint old_index = -1;
        GList *old_item = NULL;
        while (apps){
            AppletAppFavorite *f = apps->data;
            if(app_id == f->app_id){
                old_index = g_list_index(priv->favorites,f);
                old_item = f;
                break;
            }
            apps = apps->next;
        }
        if(old_index != -1){
            if(pos > old_index){
                pos = pos - 1;
            }
            priv->favorites = g_list_remove(priv->favorites,old_item);
            priv->favorites = g_list_insert(priv->favorites,old_item,pos);
        }
    }
}
