//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialButtons.js
/**
 *
 *
 **/
#include "applet-window-button.h"
//添加依赖库;
#include <math.h>
#include "cdos-popup-menu-manager.h"
#include "applet-app-group.h"
#include "cdos-window-tracker.h"
#include "applet-window-list.h"
#include "applet-app-context-menu.h"
#include "cdos-provider.h"
#include "cdos-global.h"

typedef struct _AppletWindowButtonSignalIds AppletWindowButtonSignalIds;
/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletWindowButtonPrivate{
    gboolean is_favorite_app;
    StSide orientation;
    gint icon_size;
    AppletAppList *app_list;
    MetaWindow *meta_window;
    CdosApp *app;
    ClutterActor *icon;
    AppletAppContextMenu *right_click_menu;

    AppletWindowList *applet;
    CdosPopupMenuManager *menu_manager;
    AppletWindowButtonSignalIds *signal_ids;
};

struct _AppletWindowButtonSignalIds{
    gulong actor_button_release_event_id;
    gulong meta_window_notify_appears_focused_id;
    gulong meta_window_notify_title_id;
    gulong global_display_window_demands_attention_id;
    gulong applet_settings_changed_title_display_id;

};
/*-------global variables-------------*/
static gint AppletWindowButton_private_offset = 0;
static gint applet_window_button_signals[LAST_SIGNAL] = { 0 };
static gpointer applet_window_button_parent_class = NULL;

//static CdosGlobal *global = NULL;

/*-------class functions---------*/
static void applet_window_button_init(AppletWindowButton *self);
static void applet_window_button_class_init(AppletWindowButtonClass *klass);

static void applet_window_button_dispose(GObject *object);
static void applet_window_button_finalize(GObject *object);

/*-------------private functions of instance-------------------*/
static void applet_window_button_actor_on_button_release_event(ClutterActor *actor,ClutterEvent *event,AppletWindowButton *self);

static void applet_window_button_meta_window_on_notify_appears_focused(MetaWindow *meta_window,AppletWindowButton *self);

static void applet_window_button_meta_window_on_notify_title(MetaWindow *meta_window,AppletWindowButton *self);

static void applet_window_button_global_display_on_window_demands_attention(MetaDisplay *meta_display,AppletWindowButton *self);

static void applet_window_button_applet_settings_on_changed_title_display(CdosAppletSettings *applet_settings,AppletWindowButton *self);

static void applet_window_button_window_handle(AppletWindowButton *self,gboolean from_drag);

static void applet_window_button_animate(AppletWindowButton *self);

/*-------functions-------------*/

/**
 * 注册类；
 *
 *
 * */
GType
applet_window_button_get_type(void)
{
    static GType applet_window_button_type = 0;
    if(G_UNLIKELY(applet_window_button_type==0))
    {
        static const GTypeInfo applet_window_button_info = {
                sizeof(AppletWindowButtonClass),
                NULL,NULL,
                (GClassInitFunc)applet_window_button_class_init,
                NULL,NULL,
                sizeof(AppletWindowButton),
                0,
                (GInstanceInitFunc)applet_window_button_init
        };
        //类注册
        applet_window_button_type = g_type_register_static(APPLET_TYPE_ICON_LABEL_BUTTON,"AppletWindowButton",&applet_window_button_info,0);
        //g_type_add_class_private(applet_window_button_type, sizeof(AppletWindowButtonClassPrivate));
        AppletWindowButton_private_offset =
                g_type_add_instance_private(applet_window_button_type, sizeof(AppletWindowButtonPrivate));

    }
    return applet_window_button_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_window_button_get_instance_private(AppletWindowButton *self){
    return (G_STRUCT_MEMBER_P (self, AppletWindowButton_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_window_button_init(AppletWindowButton *self)
{
    AppletWindowButtonPrivate *priv;
    self->priv=applet_window_button_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/

    if(global == NULL){
        global = cdos_global_get();
    }
    priv->signal_ids = g_new0(AppletWindowButtonSignalIds,1);
    /* debug
    StWidget *actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(self));

    priv->signal_ids->actor_button_release_event_id = \
            g_signal_connect(CLUTTER_ACTOR(actor),"button-release-event",G_CALLBACK(applet_window_button_actor_on_button_release_event),self);

    */
}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_window_button_class_init(AppletWindowButtonClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletWindowButton_private_offset);
    applet_window_button_parent_class = g_type_class_peek_parent(klass);

    /*-------------重写父类的虚方法---------------*/
    //gobject_class->constructed=applet_window_button_constructed;
    gobject_class->dispose=applet_window_button_dispose;
    gobject_class->finalize=applet_window_button_finalize;

    /*-------------类方法注册---------------*/
    //示例：klass->monitors_changed=applet_window_button_monitors_changed;


    /*-------------信号注册---------------*/

}

/*------------类方法定义-----------*/
static void applet_window_button_dispose(GObject *object){
    AppletWindowButton *self = APPLET_WINDOW_BUTTON(object);
    AppletWindowButtonPrivate *priv = self->priv;

    g_clear_object(&priv->right_click_menu);
    g_clear_object(&priv->icon);
    g_clear_object(&priv->menu_manager);

    G_OBJECT_CLASS(applet_window_button_parent_class)->dispose(object);
}

static void applet_window_button_finalize(GObject *object){
    AppletWindowButton *self = APPLET_WINDOW_BUTTON(object);
    AppletWindowButtonPrivate *priv = self->priv;

    g_free(priv->signal_ids);
    G_OBJECT_CLASS(applet_window_button_parent_class)->finalize(object);
}

/*-------------private functions--------------*/
static void applet_window_button_actor_on_button_release_event(ClutterActor *actor,ClutterEvent *event,AppletWindowButton *self){
    AppletWindowButtonPrivate *priv = self->priv;
    ClutterModifierType state = clutter_event_get_state(event);
    if((state & CLUTTER_BUTTON1_MASK && priv->is_favorite_app) || (state & CLUTTER_SHIFT_MASK && state & CLUTTER_BUTTON1_MASK)){
        cdos_app_open_new_window(priv->app,-1);
        applet_window_button_animate(self);
        return;
    }

    if(state & CLUTTER_BUTTON1_MASK){
        applet_window_button_window_handle(self,FALSE);
    }

    if(state & CLUTTER_BUTTON2_MASK && !priv->is_favorite_app){
        //notice:此处需要转换为接口函数；
        gboolean is_open = CDOS_POPUP_MENU_BASE(priv->right_click_menu)->is_open;
        if(is_open){
            cdos_popup_menu_base_toggle(CDOS_POPUP_MENU_BASE(priv->right_click_menu));
        }
        cdos_app_open_new_window(priv->app,-1);
    }
}

static void applet_window_button_meta_window_on_notify_appears_focused(MetaWindow *meta_window,AppletWindowButton *self){
    AppletWindowButtonPrivate *priv = self->priv;
    gboolean focused;
    g_object_get(priv->meta_window,"appears-focused",&focused,NULL);
    StWidget *actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(self));
    if(focused){
        st_widget_add_style_pseudo_class(actor,"focus");
        st_widget_remove_style_class_name(actor,"window-list-item-demands-attention");
        st_widget_remove_style_class_name(actor,"window-list-item-demands-attention-top");
    }else{
        st_widget_remove_style_pseudo_class(actor,"focus");
    }
}

static void applet_window_button_meta_window_on_notify_title(MetaWindow *meta_window,AppletWindowButton *self){
    AppletWindowButtonPrivate *priv = self->priv;
    gchar *title, *app_name;
    if(priv->is_favorite_app){
        title = "";
        app_name = "";
    }else{
        title = meta_window_get_title(priv->meta_window);
        app_name = cdos_app_get_name(priv->app);
    }
    gint title_type;
    //CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //title_type = cdos_provider_get_int(CDOS_PROVIDER(applet_settings),"title-display",NULL);

    if(title_type == APPLET_TITLE_DISPLAY_TITLE){
        if(title){
            applet_icon_label_button_set_text(APPLET_ICON_LABEL_BUTTON(self),title);
        }else{
            applet_icon_label_button_set_text(APPLET_ICON_LABEL_BUTTON(self),app_name);
        }
        return;
    }else if(title_type == APPLET_TITLE_DISPLAY_APP){
        if(app_name){
            applet_icon_label_button_set_text(APPLET_ICON_LABEL_BUTTON(self),app_name);
            return;
        }

    }else{
        applet_icon_label_button_set_text(APPLET_ICON_LABEL_BUTTON(self),"");
    }
}

static void applet_window_button_global_display_on_window_demands_attention(MetaDisplay *meta_display,AppletWindowButton *self){
    AppletWindowButtonPrivate *priv = self->priv;
    if(!priv->is_favorite_app){
        StWidget *actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(self));
        st_widget_add_style_class_name(actor,"window-list-item-demands-attention");
    }
}

static void applet_window_button_applet_settings_on_changed_title_display(CdosAppletSettings *applet_settings,AppletWindowButton *self){
    applet_window_button_meta_window_on_notify_title(NULL,self);
}

static void applet_window_button_window_handle(AppletWindowButton *self,gboolean from_drag){
    AppletWindowButtonPrivate *priv = self->priv;
    guint32 current_time = cdos_global_get_current_time(global);
    if(meta_window_has_focus(priv->meta_window)){
        if(from_drag){
            return;
        }
        meta_window_minimize(priv->meta_window);
    }else{
        gboolean minimized;
        g_object_get(priv->meta_window,"minimized",&minimized,NULL);
        if(minimized){
            meta_window_unminimize(priv->meta_window);
        }
        meta_window_activate(priv->meta_window,current_time);
    }
}

static void applet_window_button_animate(AppletWindowButton *self){
    //notice:此处需要添加tweener动画效果；


}

/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletWindowButton* applet_window_button_new(AppletWindowButtonParams *params)
{
    AppletWindowButton *self;
    self = g_object_new(APPLET_TYPE_WINDOW_BUTTON, NULL);
    //applet_window_button_constructor(self,params);
    return self;
}

void applet_window_button_constructor(AppletWindowButton *self,AppletWindowButtonParams *params){
    g_return_if_fail(APPLET_IS_WINDOW_BUTTON(self));
    AppletWindowButtonPrivate *priv = self->priv;
    //AppletAppGroup *parent = params->parent;
    priv->applet = params->applet;
    priv->app_list = params->app_list;
    priv->meta_window = params->meta_window;
    priv->app = params->app;
    priv->is_favorite_app = params->is_favorite_app == TRUE ? TRUE : FALSE;
    priv->orientation = params->orientation;
    if(priv->app == NULL){
        CdosWindowTracker *tracker = cdos_window_tracker_get_default();
        priv->app = cdos_window_tracker_get_window_app(tracker,priv->meta_window);
    }

    priv->icon_size = floor(applet_window_list_get_panel_height(priv->applet) - 10);
    priv->icon = cdos_app_create_icon_texture(priv->app,priv->icon_size);

    applet_icon_label_button_constructor(APPLET_ICON_LABEL_BUTTON(self),priv->applet,priv->icon);

    StWidget *num_label = applet_icon_label_button_get_num_label(APPLET_ICON_LABEL_BUTTON(self));
    clutter_actor_hide(CLUTTER_ACTOR(num_label));

    if(priv->is_favorite_app){
        applet_icon_label_button_set_style(APPLET_ICON_LABEL_BUTTON(self),"panel-launcher");
    }
    /*
    if(priv->meta_window){
        CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
        priv->signal_ids->meta_window_notify_appears_focused_id = \
                g_signal_connect(priv->meta_window,"notify::appears-focused",G_CALLBACK(applet_window_button_meta_window_on_notify_appears_focused),self);
//        priv->signal_ids->meta_window_notify_title_id = \
                g_signal_connect(priv->meta_window,"notify::title",G_CALLBACK(applet_window_button_meta_window_on_notify_title),self);

        MetaDisplay *global_display = cdos_global_get_display(global);
        priv->signal_ids->global_display_window_demands_attention_id = \
                g_signal_connect(global_display,"window-demands-attention",G_CALLBACK(applet_window_button_global_display_on_window_demands_attention),self);

        priv->signal_ids->applet_settings_changed_title_display_id = \
                g_signal_connect(applet_settings,"changed::title-display",G_CALLBACK(applet_window_button_applet_settings_on_changed_title_display),self);


        //applet_window_button_focus_change(self);
        applet_window_button_meta_window_on_notify_appears_focused(NULL,self);
    }
    //applet_window_button_title_change(self);
    applet_window_button_meta_window_on_notify_title(NULL,self);

     */
    /* debug
    AppletAppContextMenuParams *right_click_menu_params;
    right_click_menu_params = g_new0(AppletAppContextMenuParams,1);

    right_click_menu_params->actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(self));
    right_click_menu_params->parent_actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(self));
    right_click_menu_params->app = priv->app;
    right_click_menu_params->applet = priv->applet;
    right_click_menu_params->is_favorite_app = priv->is_favorite_app;
    right_click_menu_params->meta_window = priv->meta_window;

    priv->right_click_menu = applet_app_context_menu_new(right_click_menu_params);
    g_free(right_click_menu_params);

    priv->menu_manager = cdos_popup_menu_manager_new(self);

    cdos_popup_menu_manager_add_menu(priv->menu_manager,CDOS_POPUP_MENU(priv->right_click_menu),NULL);
    */
}

void applet_window_button_destroy(AppletWindowButton *self){
    g_return_if_fail(APPLET_IS_WINDOW_BUTTON(self));
    AppletWindowButtonPrivate *priv = self->priv;
    if(priv->meta_window){
        /* debug
        g_signal_handler_disconnect(priv->meta_window,priv->signal_ids->meta_window_notify_appears_focused_id);
        g_signal_handler_disconnect(priv->meta_window,priv->signal_ids->meta_window_notify_title_id);
         */
    }
    MetaDisplay *meta_display = cdos_global_get_display(global);
    /* debug
    g_signal_handler_disconnect(meta_display,priv->signal_ids->global_display_window_demands_attention_id);
    applet_app_context_menu_destroy(priv->right_click_menu);
    */

    CdosGenericContainer *container = applet_icon_label_button_get_container(APPLET_ICON_LABEL_BUTTON(self));
    st_container_destroy_children((StContainer*)container);
    clutter_actor_destroy((ClutterActor*) container);
    StWidget *actor = applet_icon_label_button_get_actor(APPLET_ICON_LABEL_BUTTON(self));
    clutter_actor_destroy(CLUTTER_ACTOR(actor));

}

gboolean applet_window_button_handle_drag_over(AppletWindowButton *self,AppletWindowButton *source,ClutterActor *actor,gint x,gint y,gint time){
    return FALSE;
}

gboolean applet_window_button_accept_drop(AppletWindowButton *self,AppletWindowButton *source,ClutterActor *actor,gint x,gint y,gint time){
    return FALSE;
}

AppletAppList* applet_window_button_get_app_list(AppletWindowButton *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_BUTTON(self),NULL);
    AppletWindowButtonPrivate *priv = self->priv;
    return priv->app_list;
}

MetaWindow* applet_window_button_get_meta_window(AppletWindowButton *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_BUTTON(self),NULL);
    AppletWindowButtonPrivate *priv = self->priv;
    return priv->meta_window;
}

void applet_window_button_set_meta_window(AppletWindowButton *self,MetaWindow* meta_window){
    g_return_if_fail(APPLET_IS_WINDOW_BUTTON(self));
    AppletWindowButtonPrivate *priv = self->priv;
    priv->meta_window = meta_window;
}

CdosApp* applet_window_button_get_app(AppletWindowButton *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_BUTTON(self),NULL);
    AppletWindowButtonPrivate *priv = self->priv;
    return priv->app;
}

gboolean applet_window_button_get_is_favorite_app(AppletWindowButton *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_BUTTON(self),NULL);
    AppletWindowButtonPrivate *priv = self->priv;
    return priv->is_favorite_app;
}

void applet_window_button_set_is_favorite_app(AppletWindowButton *self,gboolean is_favorite_app){
    g_return_if_fail(APPLET_IS_WINDOW_BUTTON(self));
    AppletWindowButtonPrivate *priv = self->priv;
    priv->is_favorite_app = is_favorite_app;
}

ClutterActor* applet_window_button_get_icon(AppletWindowButton *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_BUTTON(self),NULL);
    AppletWindowButtonPrivate *priv = self->priv;
    return priv->icon;
}

gint applet_window_button_get_icon_size(AppletWindowButton *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_BUTTON(self),NULL);
    AppletWindowButtonPrivate *priv = self->priv;
    return priv->icon_size;
}

void applet_window_button_set_icon_size(AppletWindowButton *self,gint icon_size){
    g_return_if_fail(APPLET_IS_WINDOW_BUTTON(self));
    AppletWindowButtonPrivate *priv = self->priv;
    priv->icon_size = icon_size;
}
