//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialButtons.js

#include "applet-window-list-box.h"
//添加依赖库;


/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletWindowListBoxPrivate{

    StWidget *actor;
    AppletWindowList *applet;
};

/*-------global variables-------------*/
static gint AppletWindowListBox_private_offset = 0;
static gint applet_window_list_box_signals[LAST_SIGNAL] = { 0 };
static gpointer applet_window_list_box_parent_class = NULL;

/*-------class functions---------*/
static void applet_window_list_box_init(AppletWindowListBox *self);
static void applet_window_list_box_class_init(AppletWindowListBoxClass *klass);

static void applet_window_list_box_dispose(GObject *object);
static void applet_window_list_box_finalize(GObject *object);

/*-------------private functions of instance-------------------*/




/*-------functions-------------*/

/**
 * 注册类；
 *
 *
 * */
GType
applet_window_list_box_get_type(void)
{
    static GType applet_window_list_box_type = 0;
    if(G_UNLIKELY(applet_window_list_box_type==0))
    {
        static const GTypeInfo applet_window_list_box_info = {
                sizeof(AppletWindowListBoxClass),
                NULL,NULL,
                (GClassInitFunc)applet_window_list_box_class_init,
                NULL,NULL,
                sizeof(AppletWindowListBox),
                0,
                (GInstanceInitFunc)applet_window_list_box_init
        };
        //类注册
        applet_window_list_box_type = g_type_register_static(G_TYPE_OBJECT,"AppletWindowListBox",&applet_window_list_box_info,0);
        //g_type_add_class_private(applet_window_list_box_type, sizeof(AppletWindowListBoxClassPrivate));
        AppletWindowListBox_private_offset =
                g_type_add_instance_private(applet_window_list_box_type, sizeof(AppletWindowListBoxPrivate));

    }
    return applet_window_list_box_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_window_list_box_get_instance_private(AppletWindowListBox *self){
    return (G_STRUCT_MEMBER_P (self, AppletWindowListBox_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_window_list_box_init(AppletWindowListBox *self)
{
    AppletWindowListBoxPrivate *priv;
    self->priv=applet_window_list_box_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/
    priv->actor = st_box_layout_new();
    st_widget_add_style_class_name(priv->actor,"window-list-box");
}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_window_list_box_class_init(AppletWindowListBoxClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletWindowListBox_private_offset);
    applet_window_list_box_parent_class = g_type_class_peek_parent(klass);

    /*-------------重写父类的虚方法---------------*/
    //gobject_class->constructed=applet_window_list_box_constructed;
    gobject_class->dispose=applet_window_list_box_dispose;
    gobject_class->finalize=applet_window_list_box_finalize;
}

/*------------类方法定义-----------*/
static void applet_window_list_box_dispose(GObject *object){
    AppletWindowListBox *self = APPLET_WINDOW_LIST_BOX(object);
    AppletWindowListBoxPrivate *priv = self->priv;

    if(priv->actor != NULL){
        clutter_actor_destroy(CLUTTER_ACTOR(priv->actor));
    }
    G_OBJECT_CLASS(applet_window_list_box_parent_class)->dispose(object);
}

static void applet_window_list_box_finalize(GObject *object){
    AppletWindowListBox *self = APPLET_WINDOW_LIST_BOX(object);
    AppletWindowListBoxPrivate *priv = self->priv;



    G_OBJECT_CLASS(applet_window_list_box_parent_class)->finalize(object);
}

/*-------------private functions--------------*/




/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletWindowListBox* applet_window_list_box_new(AppletWindowList *applet)
{
    AppletWindowListBox *self;
    self = g_object_new(APPLET_TYPE_WINDOW_LIST_BOX, NULL);
    return self;
}
StWidget* applet_window_list_box_get_actor(AppletWindowListBox *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_LIST_BOX(self),NULL);
    AppletWindowListBoxPrivate *priv = self->priv;
    return priv->actor;
}
void applet_window_list_box_clear_drag_place_holder(AppletWindowListBox *self){

}
