//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialMenus.js

#include <math.h>
#include <meta/meta-window-actor.h>
#include "applet-window-thumbnail.h"
//添加依赖库;
#include "applet-window-list.h"
#include "cdos-provider.h"
#include "cdos-global.h"

typedef struct _AppletWindowThumbnailSignalIds AppletWindowThumbnailSignalIds;
/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _AppletWindowThumbnailPrivate{

    MetaWindow *meta_window;
    CdosApp *app;
    gboolean is_favorite_app;
    gboolean was_minimized;
    StWidget *actor;
    StWidget *thumbnail_actor;
    StWidget *container1;
    ClutterActor *icon;
    StWidget *label;
    StWidget *container2;
    StWidget *button;
    gint thumbnail_width;
    gint thumbnail_height;
    gboolean stop_click;
    ClutterActor *thumbnail;
    StWidget *parent_container;
    AppletWindowList *applet;
    AppletWindowThumbnailSignalIds *signal_ids;
    StWidget *error_icon_title;
    StWidget *error_icon_thumbnail;
    gfloat scale;
    gboolean no_thumbnail;
};
struct _AppletWindowThumbnailSignalIds{
    gulong meta_window_notify_title_id;
    gulong actor_enter_id;
    gulong actor_leave_id;
    gulong actor_button_release_id;
    gulong button_button_release_id;
};

/*-------global variables-------------*/
static gint AppletWindowThumbnail_private_offset = 0;
static gint applet_window_thumbnail_signals[LAST_SIGNAL] = { 0 };
static gpointer applet_window_thumbnail_parent_class = NULL;

//static CdosGlobal *global = NULL;

/*-------class functions---------*/
static void applet_window_thumbnail_init(AppletWindowThumbnail *self);
static void applet_window_thumbnail_class_init(AppletWindowThumbnailClass *klass);

static void applet_window_thumbnail_dispose(GObject *object);
static void applet_window_thumbnail_finalize(GObject *object);

static void applet_window_thumbnail_constructor(AppletWindowThumbnail *self,AppletWindowThumbnailParams *params);
/*-------------private functions of instance-------------------*/
static void applet_window_thumbnail_meta_window_on_notify_title(MetaWindow *meta_window,GParamSpec *pspec,AppletWindowThumbnail *self);

static gboolean applet_window_thumbnail_actor_on_enter(ClutterActor *actor,ClutterEvent *event,AppletWindowThumbnail *self);

static gboolean applet_window_thumbnail_actor_on_leave(ClutterActor *actor,ClutterEvent *event,AppletWindowThumbnail *self);

static gboolean applet_window_thumbnail_actor_on_release(ClutterActor *actor,ClutterEvent *event,AppletWindowThumbnail *self);

static gboolean applet_window_thumbnail_button_on_release(ClutterActor *actor,ClutterEvent *event,AppletWindowThumbnail *self);

static void applet_window_thumbnail_hover_peek(AppletWindowThumbnail *self,gint opacity,MetaWindow *meta_window);

static ClutterActor* applet_window_thumbnail_get_thumbnail_private(AppletWindowThumbnail *self);

static void applet_window_thumbnail_refresh(AppletWindowThumbnail *self);

static void applet_window_thumbnail_set_opacity(ClutterActor *actor,gfloat target_opacity);

static void applet_window_thumbnail_disconnect_signals(AppletWindowThumbnail *self);

static void applet_window_thumbnail_remove_all_actors(AppletWindowThumbnail *self);

static void applet_window_thumbnail_window_missing(AppletWindowThumbnail *self);

/*-------functions-------------*/

/**
 * 注册类；
 *
 *
 * */
GType
applet_window_thumbnail_get_type(void)
{
    static GType applet_window_thumbnail_type = 0;
    if(G_UNLIKELY(applet_window_thumbnail_type==0))
    {
        static const GTypeInfo applet_window_thumbnail_info = {
                sizeof(AppletWindowThumbnailClass),
                NULL,NULL,
                (GClassInitFunc)applet_window_thumbnail_class_init,
                NULL,NULL,
                sizeof(AppletWindowThumbnail),
                0,
                (GInstanceInitFunc)applet_window_thumbnail_init
        };
        //类注册
        applet_window_thumbnail_type = g_type_register_static(G_TYPE_OBJECT,"AppletWindowThumbnail",&applet_window_thumbnail_info,0);
        //g_type_add_class_private(applet_window_thumbnail_type, sizeof(AppletWindowThumbnailClassPrivate));
        AppletWindowThumbnail_private_offset =
                g_type_add_instance_private(applet_window_thumbnail_type, sizeof(AppletWindowThumbnailPrivate));

    }
    return applet_window_thumbnail_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
applet_window_thumbnail_get_instance_private(AppletWindowThumbnail *self){
    return (G_STRUCT_MEMBER_P (self, AppletWindowThumbnail_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
applet_window_thumbnail_init(AppletWindowThumbnail *self)
{
    AppletWindowThumbnailPrivate *priv;
    self->priv=applet_window_thumbnail_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/
    if(global == NULL){
        global = cdos_global_get();
    }
    priv->signal_ids = g_new0(AppletWindowThumbnailSignalIds,1);
    priv->was_minimized = FALSE;
    priv->actor = st_box_layout_new();
    priv->no_thumbnail = FALSE;

    st_widget_set_style_class_name(priv->actor,"item-box");
    clutter_actor_set_reactive(CLUTTER_ACTOR(priv->actor),TRUE);
    st_widget_set_track_hover(priv->actor,TRUE);
    st_box_layout_set_vertical(ST_BOX_LAYOUT(priv->actor),TRUE);

    priv->thumbnail_actor = st_bin_new();
    clutter_actor_hide(CLUTTER_ACTOR(priv->thumbnail_actor));
    st_widget_set_style_class_name(priv->thumbnail_actor,"thumbnail");

    priv->container1 = st_box_layout_new();
    priv->label = st_label_new(NULL);
    st_widget_set_style_class_name(priv->label,"thumbnail-title-label");
    st_widget_set_style_class_name(priv->container1,"thumbnail-title-box");

    priv->container2 = st_box_layout_new();

    priv->button = st_box_layout_new();
    st_widget_set_style_class_name(priv->button,"window-close-cs");
    clutter_actor_set_reactive(CLUTTER_ACTOR(priv->button),TRUE);
    st_widget_set_track_hover(priv->button,TRUE);
    clutter_actor_hide(CLUTTER_ACTOR(priv->button));

    clutter_container_add_actor(CLUTTER_CONTAINER(priv->container2),CLUTTER_ACTOR(priv->container1));
    clutter_container_add_actor(CLUTTER_CONTAINER(priv->container2),CLUTTER_ACTOR(priv->button));

    clutter_container_add_actor(CLUTTER_CONTAINER(priv->actor),CLUTTER_ACTOR(priv->container2));
    clutter_container_add_actor(CLUTTER_CONTAINER(priv->actor),CLUTTER_ACTOR(priv->thumbnail_actor));



}

/**
 *
 * 类结构初始化；
 *
 * */
static void
applet_window_thumbnail_class_init(AppletWindowThumbnailClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&AppletWindowThumbnail_private_offset);
    applet_window_thumbnail_parent_class = g_type_class_peek_parent(klass);

    /*-------------重写父类的虚方法---------------*/
    //gobject_class->constructed=applet_window_thumbnail_constructed;
    gobject_class->dispose=applet_window_thumbnail_dispose;
    gobject_class->finalize=applet_window_thumbnail_finalize;
}

/*------------类方法定义-----------*/
static void applet_window_thumbnail_dispose(GObject *object){
    AppletWindowThumbnail *self = APPLET_WINDOW_THUMBNAIL(object);
    AppletWindowThumbnailPrivate *priv = self->priv;

    if(priv->actor != NULL){
        applet_window_thumbnail_disconnect_signals(self);
        applet_window_thumbnail_remove_all_actors(self);
    }

    g_clear_object(&priv->actor);
    g_clear_object(&priv->thumbnail);


    G_OBJECT_CLASS(applet_window_thumbnail_parent_class)->dispose(object);
}

static void applet_window_thumbnail_finalize(GObject *object){

    AppletWindowThumbnail *self = APPLET_WINDOW_THUMBNAIL(object);
    AppletWindowThumbnailPrivate *priv = self->priv;

    g_free(priv->signal_ids);

    G_OBJECT_CLASS(applet_window_thumbnail_parent_class)->finalize(object);
}

/*-------------private functions--------------*/
static void applet_window_thumbnail_constructor(AppletWindowThumbnail *self,AppletWindowThumbnailParams *params){
    AppletWindowThumbnailPrivate *priv = self->priv;
    priv->applet = params->applet;

    priv->meta_window = params->meta_window != NULL ? params->meta_window : NULL;
    priv->app = params->app;
    priv->is_favorite_app = params->is_favorite_app == TRUE ? TRUE : FALSE;
    priv->parent_container = params->parent_container;
    priv->no_thumbnail = params->no_thumbnail;

    priv->icon = cdos_app_create_icon_texture(priv->app,APPLET_THUMBNAIL_ICON_SIZE);
    clutter_container_add_actor(CLUTTER_CONTAINER(priv->container1),CLUTTER_ACTOR(priv->icon));
    clutter_container_add_actor(CLUTTER_CONTAINER(priv->container1),CLUTTER_ACTOR(priv->label));

    applet_window_thumbnail_is_favorite(self,priv->is_favorite_app);
    if(priv->meta_window != NULL){
        priv->signal_ids->meta_window_notify_title_id = \
        g_signal_connect(priv->meta_window,"notify::title",G_CALLBACK(applet_window_thumbnail_meta_window_on_notify_title),self);
    }

    priv->signal_ids-> actor_enter_id= \
    g_signal_connect(CLUTTER_ACTOR(priv->actor),"enter-event",G_CALLBACK(applet_window_thumbnail_actor_on_enter),self);
    priv->signal_ids-> actor_leave_id= \
    g_signal_connect(CLUTTER_ACTOR(priv->actor),"leave-event",G_CALLBACK(applet_window_thumbnail_actor_on_leave),self);

    priv->signal_ids-> actor_button_release_id= \
    g_signal_connect(CLUTTER_ACTOR(priv->actor),"button-release-event",G_CALLBACK(applet_window_thumbnail_actor_on_release),self);
    priv->signal_ids-> button_button_release_id= \
    g_signal_connect(CLUTTER_ACTOR(priv->button),"button-release-event",G_CALLBACK(applet_window_thumbnail_button_on_release),self);
}

static void applet_window_thumbnail_meta_window_on_notify_title(MetaWindow *meta_window,GParamSpec *pspec,AppletWindowThumbnail *self){
    //g_print ("title is %s\n", meta_window_get_title (meta_window));

    if (meta_window != self->priv->meta_window){
	return;
    }
    g_return_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self));
    AppletWindowThumbnailPrivate *priv = self->priv;
    const gchar *title = meta_window_get_title(meta_window);
    if(priv->label){
        st_label_set_text(ST_LABEL(priv->label),title);
    }
}

static gboolean applet_window_thumbnail_actor_on_enter(ClutterActor *actor,ClutterEvent *event,AppletWindowThumbnail *self){
    AppletWindowThumbnailPrivate *priv = self->priv;
    if(!priv->is_favorite_app){
        gint peek_opacity = 10;
        CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
        //peek_opacity = cdos_provider_get_int(CDOS_PROVIDER(applet_settings),"hover-peek-opacity",NULL);
        applet_window_thumbnail_hover_peek(self,peek_opacity,priv->meta_window);
        st_widget_add_style_pseudo_class(priv->actor,"outlined");
        st_widget_add_style_pseudo_class(priv->actor,"selected");
        gboolean show_thumbs = TRUE;
        //show_thumbs = cdos_provider_get_boolean(CDOS_PROVIDER(applet_settings),"show-thumbnails",NULL);

        if(show_thumbs){
            clutter_actor_show(CLUTTER_ACTOR(priv->button));
            gboolean minimized,enable_peek = TRUE;
            g_object_get(priv->meta_window,"minimized",&minimized,NULL);
            //enable_peek = cdos_provider_get_boolean(CDOS_PROVIDER(applet_settings),"enable-hover-peek",NULL);
            if(minimized && enable_peek){
                meta_window_unminimize(priv->meta_window);
                priv->was_minimized = TRUE;
            } else {
                priv->was_minimized = FALSE;
            }
        }
    }
    return FALSE;
}

static gboolean applet_window_thumbnail_actor_on_leave(ClutterActor *actor,ClutterEvent *event,AppletWindowThumbnail *self){

    AppletWindowThumbnailPrivate *priv = self->priv;
    if(!priv->is_favorite_app){
        applet_window_thumbnail_hover_peek(self,APPLET_OPACITY_OPAQUE,priv->meta_window);
        st_widget_remove_style_pseudo_class(priv->actor,"outlined");
        st_widget_remove_style_pseudo_class(priv->actor,"selected");
        clutter_actor_hide(CLUTTER_ACTOR(priv->button));

        if(priv->was_minimized){
            meta_window_minimize(priv->meta_window);
        }
    }
    return FALSE;
}

static gboolean applet_window_thumbnail_actor_on_release(ClutterActor *actor,ClutterEvent *event,AppletWindowThumbnail *self){
    AppletWindowThumbnailPrivate *priv = self->priv;
    priv->was_minimized = FALSE;
    ClutterModifierType state = clutter_event_get_state(event);
    guint32 current_time = cdos_global_get_current_time(global);
    guint32 button = clutter_event_get_button(event);
    if((state & CLUTTER_BUTTON1_MASK || button == 1) && !priv->stop_click && !priv->is_favorite_app){
        meta_window_activate(priv->meta_window,current_time);
    } else if((state & CLUTTER_BUTTON2_MASK || button == 2) && !priv->stop_click) {
        meta_window_delete(priv->meta_window,current_time);
    }
    priv->stop_click = FALSE;
    return FALSE;
}

static gboolean applet_window_thumbnail_button_on_release(ClutterActor *actor,ClutterEvent *event,AppletWindowThumbnail *self){
    AppletWindowThumbnailPrivate *priv = self->priv;
    ClutterModifierType state = clutter_event_get_state(event);
    guint32 button = clutter_event_get_button(event);
    if((state & CLUTTER_BUTTON1_MASK || button == 1) && actor == CLUTTER_ACTOR(priv->button)){
        applet_window_thumbnail_hover_peek(self,APPLET_OPACITY_OPAQUE,priv->meta_window);
        guint32 current_time = cdos_global_get_current_time(global);
        meta_window_delete(priv->meta_window,current_time);
        priv->stop_click = TRUE;
        return TRUE;
    }
    return FALSE;

}

static void applet_window_thumbnail_hover_peek(AppletWindowThumbnail *self,gint opacity,MetaWindow *meta_window){
    AppletWindowThumbnailPrivate *priv = self->priv;
    AppletWindowList *applet = priv->applet;

    gboolean enable_peek= TRUE;
    //CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
    //enable_peek = cdos_provider_get_boolean(CDOS_PROVIDER(applet_settings),"enable-hover-peek",NULL);
    if(enable_peek == FALSE){
        return ;
    }
    GList *actors = cdos_global_get_window_actors(global);
    while (actors){
        MetaWindowActor *meta_window_actor = actors->data;
        MetaWindow *window = meta_window_actor_get_meta_window(meta_window_actor);
        if(meta_window = window ){
            return ;
        }
        MetaWindowType window_type = meta_window_get_window_type(window);
        if(window_type != META_WINDOW_DESKTOP){
            applet_window_thumbnail_set_opacity(CLUTTER_ACTOR(meta_window_actor),opacity);
        }
        actors = actors->next;
    }
}

static ClutterActor* applet_window_thumbnail_get_thumbnail_private(AppletWindowThumbnail *self){
    AppletWindowThumbnailPrivate *priv = self->priv;
    ClutterActor *thumbnail = NULL;
    GObject *muffin_window = NULL;
    muffin_window = meta_window_get_compositor_private(priv->meta_window);
    if(muffin_window != NULL){
        ClutterActor *window_texture = meta_window_actor_get_texture(META_WINDOW_ACTOR(muffin_window));
        gfloat width,height,scale;
        clutter_actor_get_size(window_texture,&width,&height);
        priv->thumbnail_width = width;
        priv->thumbnail_height = height;
        thumbnail = clutter_clone_new(window_texture);
        clutter_actor_set_reactive(thumbnail,TRUE);
    }
    return thumbnail;
}

static void applet_window_thumbnail_refresh(AppletWindowThumbnail *self){
    AppletWindowThumbnailPrivate *priv = self->priv;

    priv->is_favorite_app = FALSE;

    const gchar *title = meta_window_get_title(priv->meta_window);
    st_label_set_text(ST_LABEL(priv->label),title);
    gboolean show_thumbs = priv->no_thumbnail == TRUE ? FALSE : TRUE;
  //  CdosAppletSettings *applet_settings = applet_window_list_get_settings(priv->applet);
  //  show_thumbs = cdos_provider_get_boolean(CDOS_PROVIDER(applet_settings),"show-thumbnails",NULL);
    if(META_IS_WINDOW(priv->meta_window)){
        if(show_thumbs && priv->meta_window){
            priv->thumbnail = applet_window_thumbnail_get_thumbnail_private(self);
            st_bin_set_child(ST_BIN(priv->thumbnail_actor),priv->thumbnail);
            clutter_actor_show(CLUTTER_ACTOR(priv->thumbnail_actor));
        }
        if(show_thumbs == FALSE && priv->thumbnail){
            clutter_actor_destroy(CLUTTER_ACTOR(priv->thumbnail));
            st_bin_set_child(ST_BIN(priv->thumbnail_actor),NULL);
            clutter_actor_hide(CLUTTER_ACTOR(priv->thumbnail_actor));
            priv->thumbnail = NULL;

        }
    }else{
        applet_window_thumbnail_window_missing(self);
    }
}

static void
applet_window_thumbnail_disconnect_signals(AppletWindowThumbnail *self){
    AppletWindowThumbnailPrivate *priv = self->priv;
    AppletWindowThumbnailSignalIds *signal_ids = priv->signal_ids;

    if(signal_ids->actor_enter_id > 0){
        g_signal_handler_disconnect(CLUTTER_ACTOR(priv->actor),signal_ids->actor_enter_id);
        signal_ids->actor_enter_id = 0;
    }
    if(signal_ids->actor_leave_id > 0){
        g_signal_handler_disconnect(CLUTTER_ACTOR(priv->actor),signal_ids->actor_leave_id);
        signal_ids->actor_leave_id = 0;
    }
    if(signal_ids->actor_button_release_id > 0){
        g_signal_handler_disconnect(CLUTTER_ACTOR(priv->actor),signal_ids->actor_button_release_id);
        signal_ids->actor_button_release_id = 0;
    }
    if(signal_ids->button_button_release_id > 0){
        g_signal_handler_disconnect(CLUTTER_ACTOR(priv->actor),signal_ids->button_button_release_id);
        signal_ids->button_button_release_id = 0;
    }
}

static void applet_window_thumbnail_remove_all_actors(AppletWindowThumbnail *self){
    AppletWindowThumbnailPrivate *priv = self->priv;
    clutter_container_remove_actor(CLUTTER_CONTAINER(priv->container1),CLUTTER_ACTOR(priv->icon));
    clutter_container_remove_actor(CLUTTER_CONTAINER(priv->container1),CLUTTER_ACTOR(priv->label));

    clutter_container_remove_actor(CLUTTER_CONTAINER(priv->container2),CLUTTER_ACTOR(priv->container1));
    clutter_container_remove_actor(CLUTTER_CONTAINER(priv->container2),CLUTTER_ACTOR(priv->button));

    clutter_container_remove_actor(CLUTTER_CONTAINER(priv->actor),CLUTTER_ACTOR(priv->container2));
    
    clutter_container_remove_actor(CLUTTER_CONTAINER(priv->actor),CLUTTER_ACTOR(priv->thumbnail_actor));
    priv->icon = NULL;
    priv->label = NULL;
    priv->container1 = NULL;
    priv->container2 = NULL;
    priv->button =NULL;
    priv->thumbnail_actor = NULL;
}

static void applet_window_thumbnail_window_missing(AppletWindowThumbnail *self){
    AppletWindowThumbnailPrivate *priv = self->priv;


    st_label_set_text(priv->label,_("The window is missing, maybe these was something wrong with the program!"));
    if(priv->thumbnail){
        clutter_actor_destroy(priv->thumbnail);
    }
    priv->error_icon_thumbnail = st_icon_new();
    //priv->error_icon_title = st_icon_new();
    st_icon_set_icon_name(ST_ICON(priv->error_icon_thumbnail),"error");
    //st_icon_set_name(ST_ICON(priv->error_icon_title),"error");
    //st_icon_set_icon_size(ST_ICON(priv->error_icon_title),16);

    st_bin_set_child(ST_BIN(priv->thumbnail_actor),priv->error_icon_thumbnail);
    clutter_actor_show(CLUTTER_ACTOR(priv->thumbnail_actor));
    clutter_actor_hide(CLUTTER_ACTOR(priv->button));

}

/*-------------public functions--------------*/

/**
 * 创建一个新的实例对象；
 *
 * */
AppletWindowThumbnail* applet_window_thumbnail_new(AppletWindowThumbnailParams *params)
{
    AppletWindowThumbnail *self;
    self = g_object_new(APPLET_TYPE_WINDOW_THUMBNAIL, NULL);
    applet_window_thumbnail_constructor(self,params);
    //applet_window_thumbnail_set_scale(self,-1.0);
    return self;
}

void applet_window_thumbnail_destroy(AppletWindowThumbnail *self){
    g_return_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self));
    AppletWindowThumbnailPrivate *priv = self->priv;
    //g_print("\nDebug:File = %s >> Func = %s >> Line = %d;\n",__FILE__,__func__,__LINE__);
    applet_window_thumbnail_disconnect_signals(self);
    applet_window_thumbnail_remove_all_actors(self);
    clutter_actor_destroy(CLUTTER_ACTOR(priv->actor));
    priv->actor = NULL;
    g_object_unref(self);
}

gboolean applet_window_thumbnail_need_reflush(AppletWindowThumbnail *self){
    g_return_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self));
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->thumbnail == NULL ? FALSE : TRUE;
}

void applet_window_thumbnail_is_favorite(AppletWindowThumbnail *self,gboolean is_added){
    g_return_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self));
    AppletWindowThumbnailPrivate *priv = self->priv;
    if(is_added){
        st_bin_set_child(ST_BIN(priv->thumbnail_actor),NULL);
        const gchar *app_text = cdos_app_get_name(priv->app);
        priv->thumbnail_width = APPLET_THUMBNAIL_ICON_SIZE + (int)ceil(sizeof(app_text) * 12);
        st_label_set_text(ST_LABEL(priv->label),app_text);
        priv->is_favorite_app = TRUE;
        clutter_actor_set_width(CLUTTER_ACTOR(priv->container1),priv->thumbnail_width);
    } else {
        applet_window_thumbnail_refresh(self);
    }

}
static void applet_window_thumbnail_set_opacity(ClutterActor *actor,gfloat target_opacity){
    //notice:此处需要添加tweener;
    clutter_actor_hide(actor);

}

MetaWindow* applet_window_thumbnail_get_meta_window(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->meta_window;
}
void applet_window_thumbnail_set_meta_window(AppletWindowThumbnail *self,MetaWindow *meta_window){
    g_return_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self));
    AppletWindowThumbnailPrivate *priv = self->priv;
    priv->meta_window = meta_window;
}
CdosApp* applet_window_thumbnail_get_app(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->app;
}
gboolean applet_window_thumbnail_get_is_favorite_app(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),FALSE);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->is_favorite_app;
}
void applet_window_thumbnail_set_is_favorite_app(AppletWindowThumbnail *self,gboolean is_favorite_app){
    g_return_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self));
    AppletWindowThumbnailPrivate *priv = self->priv;
    priv->is_favorite_app = is_favorite_app;
}
gboolean applet_window_thumbnail_get_was_minimized(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),FALSE);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->was_minimized;
}
gboolean applet_window_thumbnail_get_stop_click(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),FALSE);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->stop_click;
}
StWidget* applet_window_thumbnail_get_actor(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->actor;
}
StWidget* applet_window_thumbnail_get_thumbnail_actor(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->thumbnail_actor;
}
StWidget* applet_window_thumbnail_get_container1(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->container1;
}
StWidget* applet_window_thumbnail_get_container2(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->container2;
}
StWidget* applet_window_thumbnail_get_label(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->label;
}
StWidget* applet_window_thumbnail_get_button(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->button;
}
ClutterActor* applet_window_thumbnail_get_icon(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->icon;
}
ClutterActor* applet_window_thumbnail_get_thumbnail(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->thumbnail;
}
gint applet_window_thumbnail_get_thumbnail_width(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->thumbnail_width;
}
gint applet_window_thumbnail_get_thumbnail_height(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),NULL);
    AppletWindowThumbnailPrivate *priv = self->priv;
    return priv->thumbnail_height;
}
void applet_window_thumbnail_set_scale(AppletWindowThumbnail *self,gfloat scale){
    g_return_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self));
    AppletWindowThumbnailPrivate *priv = self->priv;
    if(priv->thumbnail == NULL){
        return;
    }
    if(scale <= 0){
        gfloat w,h;
        clutter_actor_get_size(CLUTTER_ACTOR(priv->thumbnail_actor),&w,&h);
        scale = MIN(1.0,MIN(w/priv->thumbnail_width,h/priv->thumbnail_height));
    }
    priv->scale = scale;
    clutter_actor_set_width(priv->thumbnail,priv->thumbnail_width * (priv->scale));
    clutter_actor_set_height(priv->thumbnail,priv->thumbnail_height * (priv->scale));
}
gfloat applet_window_thumbnail_get_scale(AppletWindowThumbnail *self){
    g_return_val_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self),0);
    AppletWindowThumbnailPrivate *priv = self->priv;
    if(priv->thumbnail == NULL){
        return 0;
    }
    return priv->scale;
}

void applet_window_thumbnail_set_no_thumbnail(AppletWindowThumbnail *self,gboolean no_thumbnail){
    g_return_if_fail(APPLET_IS_WINDOW_THUMBNAIL(self));
    AppletWindowThumbnailPrivate *priv = self->priv;
    priv->no_thumbnail = no_thumbnail;
    applet_window_thumbnail_refresh(self);
}
