//
// Created by zhangtao on 16-4-16.
// source:applets/window-list*/specialMenus.js

#ifndef __APPLET_WINDOW_THUMBNAIL_H__
#define __APPLET_WINDOW_THUMBNAIL_H__
#include <glib-object.h>
#include <meta/window.h>
#include <clutter/clutter.h>
#include "cdos-app.h"
#include "applet-window-list-private.h"
#include "st.h"

//直接取得并替代对象ID标示符;
#define APPLET_TYPE_WINDOW_THUMBNAIL (applet_window_thumbnail_get_type())
//强制类型转换;
#define APPLET_WINDOW_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),APPLET_TYPE_WINDOW_THUMBNAIL,AppletWindowThumbnail))
//检测类型实例
#define APPLET_IS_WINDOW_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),APPLET_TYPE_WINDOW_THUMBNAIL))
//类型转换(可选)
#define APPLET_WINDOW_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),APPLET_TYPE_WINDOW_THUMBNAIL,AppletWindowThumbnailClass))
//检测是否是类的成员(可选)
#define APPLET_IS_WINDOW_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),APPLET_TYPE_WINDOW_THUMBNAIL))
//获取实例对象的类结构(可选)
#define APPLET_WINDOW_THUMBNAIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),APPLET_TYPE_WINDOW_THUMBNAIL,AppletWindowThumbnailClass))

//定义对象实例
//typedef struct _AppletWindowThumbnail AppletWindowThumbnail;
//定义对象的类结构，全部对象实例所共有；
typedef struct _AppletWindowThumbnailClass AppletWindowThumbnailClass;

typedef struct _AppletWindowThumbnailClassPrivate AppletWindowThumbnailClassPrivate;
typedef struct _AppletWindowThumbnailPrivate AppletWindowThumbnailPrivate;
typedef struct _AppletWindowThumbnailParams AppletWindowThumbnailParams;

struct _AppletWindowThumbnail {
    GObject parent;

    AppletWindowThumbnailPrivate *priv;
};
struct _AppletWindowThumbnailClass {
    GObjectClass parent_class;
    AppletWindowThumbnailClassPrivate *priv;
};

struct _AppletWindowThumbnailParams{
    AppletWindowList *applet;
    CdosApp *app;
    gboolean is_favorite_app;
    MetaWindow *meta_window;
    StWidget *parent_container;
    gboolean no_thumbnail;
};


//取得对象类型ID;
GType	applet_window_thumbnail_get_type(void);
//创建对象实例;
AppletWindowThumbnail*  applet_window_thumbnail_new(AppletWindowThumbnailParams *params);

//对象的属性成员方法列表;

void applet_window_thumbnail_destroy(AppletWindowThumbnail *self);

gboolean applet_window_thumbnail_need_reflush(AppletWindowThumbnail *self);

void applet_window_thumbnail_is_favorite(AppletWindowThumbnail *self,gboolean is_added);


//geter and setter functions;
MetaWindow* applet_window_thumbnail_get_meta_window(AppletWindowThumbnail *self);
void applet_window_thumbnail_set_meta_window(AppletWindowThumbnail *self,MetaWindow *meta_window);
CdosApp* applet_window_thumbnail_get_app(AppletWindowThumbnail *self);
gboolean applet_window_thumbnail_get_is_favorite_app(AppletWindowThumbnail *self);
void applet_window_thumbnail_set_is_favorite_app(AppletWindowThumbnail *self,gboolean is_favorite_app);
gboolean applet_window_thumbnail_get_was_minimized(AppletWindowThumbnail *self);
gboolean applet_window_thumbnail_get_stop_click(AppletWindowThumbnail *self);
StWidget* applet_window_thumbnail_get_actor(AppletWindowThumbnail *self);
StWidget* applet_window_thumbnail_get_thumbnail_actor(AppletWindowThumbnail *self);
StWidget* applet_window_thumbnail_get_container1(AppletWindowThumbnail *self);
StWidget* applet_window_thumbnail_get_container2(AppletWindowThumbnail *self);
StWidget* applet_window_thumbnail_get_label(AppletWindowThumbnail *self);
StWidget* applet_window_thumbnail_get_button(AppletWindowThumbnail *self);
ClutterActor* applet_window_thumbnail_get_icon(AppletWindowThumbnail *self);
ClutterActor* applet_window_thumbnail_get_thumbnail(AppletWindowThumbnail *self);
gint applet_window_thumbnail_get_thumbnail_width(AppletWindowThumbnail *self);
gint applet_window_thumbnail_get_thumbnail_height(AppletWindowThumbnail *self);
void applet_window_thumbnail_set_scale(AppletWindowThumbnail *self,gfloat scale);
gfloat applet_window_thumbnail_get_scale(AppletWindowThumbnail *self);

void applet_window_thumbnail_set_no_thumbnail(AppletWindowThumbnail *self,gboolean no_thumbnail);

#endif //__APPLET_WINDOW_THUMBNAIL_H__
