/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_APP_H__
#define __CDOS_APP_H__

#include <clutter/clutter.h>
#include <gio/gio.h>
#include <meta/window.h>
#define GMENU_I_KNOW_THIS_IS_UNSTABLE
#include <gmenu-tree.h>

G_BEGIN_DECLS

typedef struct _CdosApp CdosApp;
typedef struct _CdosAppClass CdosAppClass;
typedef struct _CdosAppPrivate CdosAppPrivate;

#define CDOS_TYPE_APP              (cdos_app_get_type ())
#define CDOS_APP(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), CDOS_TYPE_APP, CdosApp))
#define CDOS_APP_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_APP, CdosAppClass))
#define CDOS_IS_APP(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), CDOS_TYPE_APP))
#define CDOS_IS_APP_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_APP))
#define CDOS_APP_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_APP, CdosAppClass))

struct _CdosAppClass
{
  GObjectClass parent_class;

};

typedef enum {
  CDOS_APP_STATE_STOPPED,
  CDOS_APP_STATE_STARTING,
  CDOS_APP_STATE_RUNNING
} CdosAppState;

GType cdos_app_get_type (void) G_GNUC_CONST;

const char *cdos_app_get_id (CdosApp *app);
GMenuTreeEntry *cdos_app_get_tree_entry (CdosApp *app);
GDesktopAppInfo *cdos_app_get_app_info (CdosApp *app);

ClutterActor *cdos_app_create_icon_texture (CdosApp *app, int size);
ClutterActor *cdos_app_get_faded_icon (CdosApp *app, int size);
const char *cdos_app_get_name (CdosApp *app);
const char *cdos_app_get_description (CdosApp *app);
gboolean cdos_app_is_window_backed (CdosApp *app);

void cdos_app_activate_window (CdosApp *app, MetaWindow *window, guint32 timestamp);

void cdos_app_activate (CdosApp      *app);

void cdos_app_activate_full (CdosApp      *app,
                              int            workspace,
                              guint32        timestamp);

gboolean cdos_app_open_new_window (CdosApp *app,
                                int       workspace);

CdosAppState cdos_app_get_state (CdosApp *app);

gboolean cdos_app_request_quit (CdosApp *app);

guint cdos_app_get_n_windows (CdosApp *app);

GSList *cdos_app_get_windows (CdosApp *app);

GSList *cdos_app_get_pids (CdosApp *app);

gboolean cdos_app_is_on_workspace (CdosApp *app, MetaWorkspace *workspace);

gboolean cdos_app_launch (CdosApp     *app,
                           guint         timestamp,
                           GList        *uris,
                           int           workspace,
                           char        **startup_id,
                           GError      **error);

int cdos_app_compare_by_name (CdosApp *app, CdosApp *other);

int cdos_app_compare (CdosApp *app, CdosApp *other);

G_END_DECLS

#endif /* __CDOS_APP_H__ */
