/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_GENERIC_CONTAINER_H__
#define __CDOS_GENERIC_CONTAINER_H__

#include "st.h"

#define CDOS_TYPE_GENERIC_CONTAINER                 (cdos_generic_container_get_type ())
#define CDOS_GENERIC_CONTAINER(obj)                 (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_GENERIC_CONTAINER, CdosGenericContainer))
#define CDOS_GENERIC_CONTAINER_CLASS(klass)         (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_GENERIC_CONTAINER, CdosGenericContainerClass))
#define CDOS_IS_GENERIC_CONTAINER(obj)              (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_GENERIC_CONTAINER))
#define CDOS_IS_GENERIC_CONTAINER_CLASS(klass)      (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_GENERIC_CONTAINER))
#define CDOS_GENERIC_CONTAINER_GET_CLASS(obj)       (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_GENERIC_CONTAINER, CdosGenericContainerClass))

typedef struct {
  float min_size;
  float natural_size;

  /* <private> */
  guint _refcount;
} CdosGenericContainerAllocation;

#define CDOS_TYPE_GENERIC_CONTAINER_ALLOCATION (cdos_generic_container_allocation_get_type ())
GType cdos_generic_container_allocation_get_type (void);

typedef struct _CdosGenericContainer        CdosGenericContainer;
typedef struct _CdosGenericContainerClass   CdosGenericContainerClass;

typedef struct _CdosGenericContainerPrivate CdosGenericContainerPrivate;

struct _CdosGenericContainer
{
    StContainer parent;

    CdosGenericContainerPrivate *priv;
};

struct _CdosGenericContainerClass
{
    StContainerClass parent_class;
};

GType    cdos_generic_container_get_type(void);// G_GNUC_CONST;

guint    cdos_generic_container_get_n_skip_paint (CdosGenericContainer *self);

gboolean cdos_generic_container_get_skip_paint   (CdosGenericContainer *self,
                                                   ClutterActor          *child);
void     cdos_generic_container_set_skip_paint   (CdosGenericContainer *self,
                                                   ClutterActor          *child,
                                                   gboolean               skip);

ClutterActor *cdos_generic_container_new (void);
#endif /* __CDOS_GENERIC_CONTAINER_H__ */
