/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_RECORDER_SRC_H__
#define __CDOS_RECORDER_SRC_H__

#include <gst/gst.h>

G_BEGIN_DECLS

/**
 * CdosRecorderSrc:
 *
 * cdosrecordersrc a custom source element is pretty much like a very
 * simple version of the stander GStreamer 'appsrc' element, without
 * any of the provisions for seeking, generating data on demand,
 * etc. In both cases, the application supplies the buffers and the
 * element pushes them into the pipeline. The main reason for not using
 * appsrc is that it wasn't a supported element until gstreamer 0.10.22,
 * and as of 2009-03, many systems still have 0.10.21.
 */
typedef struct _CdosRecorderSrc      CdosRecorderSrc;
typedef struct _CdosRecorderSrcClass CdosRecorderSrcClass;

#define CDOS_TYPE_RECORDER_SRC              (cdos_recorder_src_get_type ())
#define CDOS_RECORDER_SRC(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), CDOS_TYPE_RECORDER_SRC, CdosRecorderSrc))
#define CDOS_RECORDER_SRC_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_RECORDER_SRC, CdosRecorderSrcClass))
#define CDOS_IS_RECORDER_SRC(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), CDOS_TYPE_RECORDER_SRC))
#define CDOS_IS_RECORDER_SRC_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_RECORDER_SRC))
#define CDOS_RECORDER_SRC_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_RECORDER_SRC, CdosRecorderSrcClass))

GType              cdos_recorder_src_get_type     (void) G_GNUC_CONST;

void cdos_recorder_src_register (void);

void cdos_recorder_src_add_buffer (CdosRecorderSrc *src,
				    GstBuffer        *buffer);
void cdos_recorder_src_close      (CdosRecorderSrc *src);

G_END_DECLS

#endif /* __CDOS_RECORDER_SRC_H__ */
