/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
#ifndef __CDOS_XFIXES_CURSOR_H__
#define __CDOS_XFIXES_CURSOR_H__

#include <clutter/clutter.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

G_BEGIN_DECLS

typedef struct _CdosXFixesCursor        CdosXFixesCursor;
typedef struct _CdosXFixesCursorClass   CdosXFixesCursorClass;

#define CDOS_TYPE_XFIXES_CURSOR             (cdos_xfixes_cursor_get_type ())
#define CDOS_XFIXES_CURSOR(object)          (G_TYPE_CHECK_INSTANCE_CAST ((object), CDOS_TYPE_XFIXES_CURSOR, CdosXFixesCursor))
#define CDOS_XFIXES_CURSOR_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_XFIXES_CURSOR, CdosXFixesCursorClass))
#define CDOS_IS_XFIXES_CURSOR(object)       (G_TYPE_CHECK_INSTANCE_TYPE ((object), CDOS_TYPE_XFIXES_CURSOR))
#define CDOS_IS_XFIXES_CURSOR_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_XFIXES_CURSOR))
#define CDOS_XFIXES_CURSOR_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_XFIXES_CURSOR, CdosXFixesCursorClass))

GType               cdos_xfixes_cursor_get_type     (void) G_GNUC_CONST;

CdosXFixesCursor   *cdos_xfixes_cursor_get_for_stage (ClutterStage *stage);

void                cdos_xfixes_cursor_show (CdosXFixesCursor *xfixes_cursor);
void                cdos_xfixes_cursor_hide (CdosXFixesCursor *xfixes_cursor);
int                 cdos_xfixes_cursor_get_hot_x (CdosXFixesCursor *xfixes_cursor);
int                 cdos_xfixes_cursor_get_hot_y (CdosXFixesCursor *xfixes_cursor);
void                cdos_xfixes_cursor_update_texture_image (CdosXFixesCursor *xfixes_cursor,
                                                              ClutterTexture *texture);

G_END_DECLS

#endif /* __CDOS_XFIXES_CURSOR_H__ */
