#ifndef  __CDOS_BACKGROUND_H__
#define  __CDOS_BACKGROUND_H__

#include <clutter/clutter.h>
#include <meta/meta-background.h>
#include <meta/meta-background-image.h>
#include <meta/meta-background-actor.h>

typedef struct _CdosBackground		CdosBackground;

struct _CdosBackground
{
    MetaScreen *screen;
    gulong changed_id;
    ClutterActor *container;
    GSettings *settings;
    gboolean vignette;
    guint monitor_index;
    gboolean control_position;
    MetaBackground *meta_background;
    MetaBackgroundImage *image;
    GFile *file;
    ClutterActor *actor;
    gulong monitor_changed_id;
    gulong settings_changed_id;
};

CdosBackground *cdos_background_new	(ClutterActor *container,
                                     guint monitor_index,
                                     gboolean vignette,
                                     gboolean control_position);

void cdos_background_destroy (CdosBackground *self);


typedef struct _CdosBackgroundManager		CdosBackgroundManager;

CdosBackgroundManager *
cdos_background_manager_new (ClutterActor *container,
                             gboolean vignette,
                             gboolean control_position);

void cdos_background_manager_destroy (CdosBackgroundManager *self);

#endif
