/**
 * SECTION: cdos-edge-flipper
 * @short_description: source:edgeFlip.js
 * @include: cdos-edge-flipper.h
 * 
 * 没有用到,暂时不写.
 */
//添加依赖库;
#include <glib.h>
#include <clutter/clutter.h>


//添加本地依赖
#include "st.h"
#include "cdos-edge-flipper.h"
#include "cdos-monkey-plugin.h"
#include "cdos-window-manager.h"

/*-----------------信号枚举-------------------*/
enum {
    LAST_SIGNAL
};
/*-----------------实例私有结构体-------------------*/
struct _CdosEdgeFlipperPrivate{
    gint side;
    gboolean enabled;
    guint delay;
    gboolean entered;
    gboolean activated;
    gint x_mouse;
    gint y_mouse;
};

/*-------prototypes---------*/
static void cdos_edge_flipper_init(CdosEdgeFlipper *self);
static void cdos_edge_flipper_class_init(CdosEdgeFlipperClass *klass);

static void cdos_edge_flipper_dispose(GObject *object);
static void cdos_edge_flipper_finalize(GObject *object);

/*-------------private functions of class-------------------*/
static  void cdos_edge_flipper_check (CdosEdgeFlipper *self);
static  void cdos_edge_flipper_check_over (CdosEdgeFlipper *self);
static  void cdos_edge_flipper_on_mouse_enter (CdosEdgeFlipper *self);
static  void cdos_edge_flipper_on_mouse_leave (CdosEdgeFlipper *self);

/*-------variables-------------*/
static gint CdosEdgeFlipper_private_offset = 0;
static gint cdos_edge_flipper_signals[LAST_SIGNAL] = { 0 };
static gpointer cdos_edge_flipper_parent_class = NULL;

static MonkeyPlugin  *main;
//static CdosGlobal *global;
static MetaScreen *globalScreen;
/*-------functions-------------*/

/**
 * 注册类；
 *
 *
 * */
GType
cdos_edge_flipper_get_type(void)
{
    static GType cdos_edge_flipper_type = 0;
    if(G_UNLIKELY(cdos_edge_flipper_type==0))
    {
        static const GTypeInfo cdos_edge_flipper_info = {
                sizeof(CdosEdgeFlipper),
                NULL,NULL,
                (GClassInitFunc)cdos_edge_flipper_class_init,
                NULL,NULL,
                sizeof(CdosEdgeFlipper),
                0,
                (GInstanceInitFunc)cdos_edge_flipper_init
        };
        //类注册
        cdos_edge_flipper_type = g_type_register_static(G_TYPE_OBJECT,"CdosEdgeFlipper",&cdos_edge_flipper_info,0);
        //g_type_add_class_private(cdos_edge_flipper_type, sizeof(CdosEdgeFlipperClassPrivate));
        CdosEdgeFlipper_private_offset =
                g_type_add_instance_private(cdos_edge_flipper_type, sizeof(CdosEdgeFlipperPrivate));

    }
    return cdos_edge_flipper_type;
}
/**
 *  获取实例的私有属性结构
 * */
static inline gpointer
cdos_edge_flipper_get_instance_private(CdosEdgeFlipper *self){
    return (G_STRUCT_MEMBER_P (self, CdosEdgeFlipper_private_offset));
}


/**
 * 实例初始化；
 *
 * */
static void
cdos_edge_flipper_init(CdosEdgeFlipper *self)
{
    CdosEdgeFlipperPrivate *priv;
    self->priv=cdos_edge_flipper_get_instance_private(self);
    priv=self->priv;
    /*--------------实例初始化（构造实例）-------------*/
    priv->enabled = TRUE;
    priv->delay = 1000;
    priv->entered = FALSE;
    priv->activated = FALSE;

    main = monkey_plugin_get();
    global = cdos_global_get ();
    globalScreen = cdos_global_get_screen(global);

    cdos_edge_flipper_check_over(self);

}

/**
 *
 * 类结构初始化；
 *
 * */
static void
cdos_edge_flipper_class_init(CdosEdgeFlipperClass *klass)
{
    //转换为gobject；
    GObjectClass *gobject_class=G_OBJECT_CLASS(klass);
    g_type_class_adjust_private_offset(klass,&CdosEdgeFlipper_private_offset);
    cdos_edge_flipper_parent_class = g_type_class_peek_parent(klass);
    /*-------------重写父类的虚方法---------------*/
    //gobject_class->constructed=cdos_edge_flipper_constructed;
    gobject_class->dispose=cdos_edge_flipper_dispose;
    gobject_class->finalize=cdos_edge_flipper_finalize;


    /*-------------类方法注册---------------*/

    /*-------------信号注册---------------*/

}

/*------------类方法定义-----------*/

static void cdos_edge_flipper_dispose(GObject *object){
    CdosEdgeFlipper *self = CDOS_EDGE_FLIPPER(object);
    CdosEdgeFlipperPrivate *priv = self->priv;



    G_OBJECT_CLASS(cdos_edge_flipper_parent_class)->dispose(object);
};

static void cdos_edge_flipper_finalize(GObject *object){
    CdosEdgeFlipper *self = CDOS_EDGE_FLIPPER(object);
    CdosEdgeFlipperPrivate *priv = self->priv;


    G_OBJECT_CLASS(cdos_edge_flipper_parent_class)->finalize(object);
};

/*------私有方法-----*/
static  void
cdos_edge_flipper_check (CdosEdgeFlipper *self){
    CdosEdgeFlipperPrivate *priv = self->priv;
    if(priv->entered && priv->enabled && !(priv->activated) ){
        CdosEdgeFlipperPrivate *priv = self->priv;

        //(*priv->func)(priv->func_data);
        if(priv->side == ST_SIDE_LEFT){
            //cdos_window_manager_action_flip_workspace_left(main->cdos_base_wm);
        }else if(priv->side == ST_SIDE_RIGHT){
            //cdos_window_manager_action_flip_workspace_right(main->cdos_base_wm);
        }
        priv->activated = TRUE;
    }
};
static  void
cdos_edge_flipper_check_over (CdosEdgeFlipper *self){
    CdosEdgeFlipperPrivate *priv = self->priv;
    gint mask;
    gint side = priv->side;
    gint x_mouse = priv->x_mouse;
    gint y_mouse = priv->y_mouse;

    cdos_global_get_pointer(global,&x_mouse,&y_mouse,&mask);

    if(!(mask & CLUTTER_BUTTON1_MASK)){

        gint screen_width,screen_height;

        meta_screen_get_size(globalScreen,&screen_width,&screen_height);

        if(side == ST_SIDE_RIGHT){
            if(x_mouse + 2 > screen_width ){
                cdos_edge_flipper_on_mouse_enter(self);
            }else{
                cdos_edge_flipper_on_mouse_leave(self);
            }
        }else if(side == ST_SIDE_LEFT){
            if(x_mouse < 2 ){
                cdos_edge_flipper_on_mouse_enter(self);
            }else{
                cdos_edge_flipper_on_mouse_leave(self);
            }

        }else if(side == ST_SIDE_BOTTOM){
            if(y_mouse + 2 > screen_height ){
                cdos_edge_flipper_on_mouse_enter(self);
            }else{
                cdos_edge_flipper_on_mouse_leave(self);
            }

        }else if(side == ST_SIDE_TOP){
            if(y_mouse < 2 ){
                cdos_edge_flipper_on_mouse_enter(self);
            }else{
                cdos_edge_flipper_on_mouse_leave(self);
            }
        }
    }

    guint t = (priv->delay)/2 >200 ? (priv->delay)/2 : 200;
    g_timeout_add(t,cdos_edge_flipper_check_over,self);

};
static  void
cdos_edge_flipper_on_mouse_enter (CdosEdgeFlipper *self){
    CdosEdgeFlipperPrivate *priv = self->priv;
    priv->entered = TRUE;
    g_timeout_add(priv->delay,cdos_edge_flipper_check,self);
};
static  void
cdos_edge_flipper_on_mouse_leave (CdosEdgeFlipper *self){
    CdosEdgeFlipperPrivate *priv = self->priv;
    priv->entered = FALSE;
    priv->activated = FALSE;
};

/**
 * 创建一个新的实例对象；
 *  @func   执行函数，
 *  @data   传入@func的参数；
 *
 * */
CdosEdgeFlipper* cdos_edge_flipper_new(StSide side)
{
    CdosEdgeFlipper *self;
    self = g_object_new(CDOS_TYPE_EDGE_FLIPPER, NULL);
    CdosEdgeFlipperPrivate *priv = self->priv;
    priv->side = side;
    //priv->func = func;
    //priv->func_data = data;

    //g_signal_emit();
    return self;
}
StSide cdos_edge_flipper_get_side(CdosEdgeFlipper *self){
    g_return_val_if_fail(CDOS_IS_EDIG_FLIPPER(self),0);
    CdosEdgeFlipperPrivate *priv = self->priv;
    return priv->side;
};

void cdos_edge_flipper_set_side(CdosEdgeFlipper *self,StSide side){
    g_return_if_fail(CDOS_IS_EDIG_FLIPPER(self));
    CdosEdgeFlipperPrivate *priv = self->priv;
    priv->side = side;
};

gboolean cdos_edge_flipper_get_enabled(CdosEdgeFlipper *self){
    g_return_val_if_fail(CDOS_IS_EDIG_FLIPPER(self),FALSE);
    CdosEdgeFlipperPrivate *priv = self->priv;
    return priv->enabled;
};

void cdos_edge_flipper_set_enabled(CdosEdgeFlipper *self,gboolean enabled){
    g_return_if_fail(CDOS_IS_EDIG_FLIPPER(self));
    CdosEdgeFlipperPrivate *priv = self->priv;
    priv->enabled = enabled;
};

guint cdos_edge_flipper_get_delay(CdosEdgeFlipper *self){
    g_return_val_if_fail(CDOS_IS_EDIG_FLIPPER(self),0);
    CdosEdgeFlipperPrivate *priv = self->priv;
    return priv->delay;
};

void cdos_edge_flipper_set_delay(CdosEdgeFlipper *self,guint delay){
    g_return_if_fail(CDOS_IS_EDIG_FLIPPER(self));
    CdosEdgeFlipperPrivate *priv = self->priv;
    priv->delay = delay;
};

gboolean cdos_edge_flipper_get_entered(CdosEdgeFlipper *self){
    g_return_val_if_fail(CDOS_IS_EDIG_FLIPPER(self),FALSE);
    CdosEdgeFlipperPrivate *priv = self->priv;
    return priv->entered;
};

void cdos_edge_flipper_set_entered(CdosEdgeFlipper *self,gboolean entered){
    g_return_if_fail(CDOS_IS_EDIG_FLIPPER(self));
    CdosEdgeFlipperPrivate *priv = self->priv;
    priv->entered = entered;
};

gboolean cdos_edge_flipper_get_activated(CdosEdgeFlipper *self){
    g_return_val_if_fail(CDOS_IS_EDIG_FLIPPER(self),FALSE);
    CdosEdgeFlipperPrivate *priv = self->priv;
    return priv->activated;
};

void cdos_edge_flipper_set_activated(CdosEdgeFlipper *self,gboolean activated){
    g_return_if_fail(CDOS_IS_EDIG_FLIPPER(self));
    CdosEdgeFlipperPrivate *priv = self->priv;
    priv->activated = activated;
};

gint cdos_edge_flipper_get_x_mouse(CdosEdgeFlipper *self){
    g_return_val_if_fail(CDOS_IS_EDIG_FLIPPER(self),0);
    CdosEdgeFlipperPrivate *priv = self->priv;
    return priv->x_mouse;
};

gint cdos_edge_flipper_get_y_mouse(CdosEdgeFlipper *self){
    g_return_val_if_fail(CDOS_IS_EDIG_FLIPPER(self),0);
    CdosEdgeFlipperPrivate *priv = self->priv;
    return priv->y_mouse;
};







