
#ifndef __CDOS_EXPO_THUMBNAILS_BOX_H__
#define __CDOS_EXPO_THUMBNAILS_BOX_H__

#include <glib-object.h>
#include "cdos-generic-container.h"
#include "st.h"
//#include "cdos-tooltip.h"
//#include "cdos-expo-thumbnail-private.h"
#include "cdos-expo-workspace-thumbnail.h"




GType	cdos_expo_thumbnails_box_get_type (void);

#define CDOS_TYPE_EXPO_THUMBNAILS_BOX  (cdos_expo_thumbnails_box_get_type ())
#define CDOS_EXPO_THUMBNAILS_BOX(obj)  (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_EXPO_THUMBNAILS_BOX,CdosExpoThumbnailsBox))
#define CDOS_IS_EXPO_THUMBNAILS_BOX(obj)  (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_EXPO_THUMBNAILS_BOX))
#define CDOS_EXPO_THUMBNAILS_BOX_CLASS(klass)  (G_TYPE_CHECK_CLASS_CAST ((klass),CDOS_TYPE_EXPO_THUMBNAILS_BOX,CdosExpoThumbnailsBoxClass))
#define CDOS_IS_EXPO_THUMBNAILS_BOX_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((obj),CDOS_TYPE_EXPO_THUMBNAILS_BOX))
#define CDOS_EXPO_THUMBNAILS_BOX_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),CDOS_TYPE_EXPO_THUMBNAILS_BOX,CdosExpoThumbnailsBoxClass))

typedef struct _CdosExpoThumbnailsBox CdosExpoThumbnailsBox;
typedef struct _CdosExpoThumbnailsBoxClass CdosExpoThumbnailsBoxClass;

typedef struct _ExpoThumbnailPorthole ExpoThumbnailPorthole;


struct _CdosExpoThumbnailsBox {

    CdosGenericContainer parent;

    GList *thumbnails;		//类型為CdosExpoWorkspaceThumbnail
	ClutterActorBox *box;
	ExpoThumbnailPorthole *porthole;
	StBin *background;
    StButton *button;
	ClutterActor *background_delegate;  //DND delegate
	CdosExpoWorkspaceThumbnail *lastActiveWorkspace;

	gfloat targetScale;
	gboolean pendingScaleUpdate;
	gdouble scale;	//内部私有变量
	CdosExpoWorkspaceThumbnail *lastHovered;
	gboolean stateUpdateQueued;
	
	guint stateCounts[8];
	gint kbThumbnailIndex;
    guint allocId;

	guint switchWorkspaceNotifyId;
	guint workspaceAddedId;
	guint workspaceRemovedId;
};


struct _CdosExpoThumbnailsBoxClass {
    CdosGenericContainerClass parent_class;
};


struct _ExpoThumbnailPorthole {
    	gint x;
    	gint y;
    	gint width;
    	gint height;
};



// 公有函数

CdosExpoThumbnailsBox*  cdos_expo_thumbnails_box_new (void);

void cdos_expo_thumbnails_box_set_scale (CdosExpoThumbnailsBox *self, gfloat scale);

gdouble cdos_expo_thumbnails_box_get_scale (CdosExpoThumbnailsBox *self);

void cdos_expo_thumbnails_box_remove_selected_workspace (CdosExpoThumbnailsBox *self);

CdosExpoWorkspaceThumbnail* cdos_expo_thumbnails_box_get_last_active_workspace (CdosExpoThumbnailsBox *self);

gboolean cdos_expo_thumbnails_box_handle_key_press_event (CdosExpoThumbnailsBox *self, ClutterActor *actor, ClutterEvent *event);

void cdos_expo_thumbnails_box_show (CdosExpoThumbnailsBox *self);

void cdos_expo_thumbnails_box_hide (CdosExpoThumbnailsBox *self);
guint cdos_expo_thumbnails_box_get_force_overview_mode (void);

#endif //__CDOS_EXPO_THUMBNAILS_BOX_H__
