
#ifndef __CDOS_EXPO_WINDOW_CLONE_H__
#define __CDOS_EXPO_WINDOW_CLONE_H__

#include <glib-object.h>
#include <clutter/clutter.h>
#include <meta/window.h>
#include <meta/meta-window-actor.h>

#include "st.h"

#include "cdos-expo-thumbnail-private.h"
#include "cdos-app.h"
#include "cdos-dnd.h"
#include "cdos-window-overlay.h"

GType	cdos_expo_window_clone_get_type (void);

#define CDOS_TYPE_EXPO_WINDOW_CLONE (cdos_expo_window_clone_get_type())
#define CDOS_EXPO_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_EXPO_WINDOW_CLONE,CdosExpoWindowClone))
#define CDOS_IS_EXPO_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_EXPO_WINDOW_CLONE))
#define CDOS_EXPO_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_EXPO_WINDOW_CLONE,CdosExpoWindowCloneClass))
#define CDOS_IS_EXPO_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_EXPO_WINDOW_CLONE))
#define CDOS_EXPO_WINDOW_CLONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_EXPO_WINDOW_CLONE,CdosExpoWindowCloneClass))


typedef struct _CdosExpoWindowClone CdosExpoWindowClone;
typedef struct _CdosExpoWindowCloneClass CdosExpoWindowCloneClass;

struct _CdosExpoWindowClone {
    ClutterActor parent;
    MetaWindowActor *realWindow;
    MetaWindow *metaWindow;
    CdosApp *app;
    ClutterActor *icon; 	//StGroup *icon;
    ClutterActor *clone;
    ClutterActor *stackAbove;
    ClutterActor *lastButtonPressActor;
    CdosPointerTracker *pointerTracker;

    CdosDraggable *draggable;
    gboolean inDrag;
    gboolean dragCancelled;

    gint urgencyTimeout;
    gboolean demanding_attention;

    guint positionChangedId;
    guint sizeChangedId;
    guint realWindowDestroyedId;
    guint workspaceChangedId;

    gboolean orphaned;
    guint32 lastButtonPressTime;
    guint attentionId;
    guint urgentId;

    gfloat origX;
    gfloat origY;

    //参数传递用
    gboolean force;	
    guint temp_param_reps;

    void (*disconnectWindowSignals)(GObject *, gpointer);
    void (*disconnectAttentionSignals)(GObject *, gpointer);
};


struct _CdosExpoWindowCloneClass {
    ClutterActorClass parent_class;
};


//公有函数


CdosExpoWindowClone* cdos_expo_window_clone_new (MetaWindowActor *windowActor);

void cdos_expo_window_clone_refresh_clone (CdosExpoWindowClone *self, gboolean with_transients);

void cdos_expo_window_clone_kill_urgency_timeout (CdosExpoWindowClone *self);

void cdos_expo_window_clone_show_urgency_state (CdosExpoWindowClone *self, gboolean param_showUrgent, guint param_reps);

void cdos_expo_window_clone_set_stack_above (CdosExpoWindowClone *self, ClutterActor *actor);

void cdos_expo_window_clone_destroy (CdosExpoWindowClone *self);

gboolean cdos_expo_window_clone_on_button_release (CdosExpoWindowClone *self, ClutterEvent *event);



#endif //__CDOS_EXPO_WINDOW_CLONE_H__
