#ifndef __CDOS_EXTENSION_TYPE_H__
#define __CDOS_EXTENSION_TYPE_H__

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>

G_BEGIN_DECLS

GType cdos_extension_type_get_type (void);

#define CDOS_TYPE_EXTENSION_TYPE (cdos_extension_type_get_type ())
#define CDOS_EXTENSION_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_EXTENSION_TYPE, CdosExtensionType))
#define CDOS_IS_EXTENSION_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_EXTENSION_TYPE))

typedef struct _CdosExtensionType CdosExtensionType;
typedef struct _CdosExtensionTypeClass CdosExtensionTypeClass;

struct _CdosExtensionType {
  GObject parent_instance;

  gchar *name;
  gchar *folder;
  gchar **required_functions;
  gchar **required_properties;
  gchar **nice_to_have_properties;
  /* Maps role --> CdosExtension object */
  GSList *roles;
  gint callback; /* TODO： maybe should be change */

  GFile *user_dir;
};

struct _CdosExtensionTypeClass {
  GObjectClass parent_class;
};

typedef enum {
  TYPE_EXTENSION,
  TYPE_APPLET,
  TYPE_DESKLET,
  TYPE_NUM
}ExtensionType;

CdosExtensionType *cdos_extension_type_new (gint type);

gboolean
cdos_extension_type_callbacks_finish_extension_load (CdosExtensionType *type,
                                                gpointer data);
gboolean
cdos_extension_type_callbacks_prepare_extension_unload (CdosExtensionType *type,
                                                gpointer data);

G_END_DECLS

#endif /* __CDOS_EXTENSION_TYPE_H__ */
