/**
 * 显示 #CdosMessageTray 的时候进行焦点的处理
 * Inherits: #GObject
 */
#ifndef __CDOS_FOCUS_GRABBER_H__
#define __CDOS_FOCUS_GRABBER_H__

#include <glib-object.h>
#include <glib.h>
#include <meta/display.h>
#include <clutter/clutter.h>

#define CDOS_TYPE_FOCUS_GRABBER		(cdos_focus_grabber_get_type ())
#define CDOS_FOCUS_GRABBER(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_FOCUS_GRABBER, CdosFocusGrabber))
#define CDOS_IS_FOCUS_GRABBER(obj)           	(G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_FOCUS_GRABBER))
#define CDOS_FOCUS_GRABBER_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_FOCUS_GRABBER, CdosFocusGrabberClass))
#define CDOS_IS_FOCUS_GRABBER_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_FOCUS_GRABBER))
#define CDOS_FOCUS_GRABBER_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_FOCUS_GRABBER, CdosFocusGrabberClass))

typedef struct _CdosFocusGrabber	CdosFocusGrabber;
typedef struct _CdosFocusGrabberClass	CdosFocusGrabberClass;


struct _CdosFocusGrabber
{
    GObject parent;
    ClutterActor *actor;
    /*private*/
    gboolean hasFocus;
    MetaWindow *prevFocusedWindow;
    ClutterActor *prevKeyFocusActor;
    gulong focusActorChangedId;
    gulong stageInputModeChangedId;
    gulong capturedEventId;
    gboolean togglingFocusGrabMode;
};

struct _CdosFocusGrabberClass
{
    GObjectClass parent_class;
};

GType cdos_focus_grabber_get_type (void);



/* FocusGrabber 公有函数 */

void cdos_focus_grabber_grab_focus ( CdosFocusGrabber *self, ClutterActor *actor );

void cdos_focus_grabber_ungrab_focus ( CdosFocusGrabber *self );

CdosFocusGrabber* cdos_focus_grabber_new (void);

#endif
