#include <glib.h>
#include "cdos-key-value.h"

/**
 * 这里的接口大多是临时添加
 * 将在后面对接口进行整合, 以去除不必要的接口
 * 并解决代码冗余的问题，提高代码复用率
 */

gboolean
cdos_kv_ss_remove_by_key (GSList *list, gchar *key)
{
  //guint i;
  CdosSString *stru;
  GSList *new_list = NULL;

  if (list && key) {
    GSList *it = list;
    while(it != NULL){
      stru = it->data;
      if (g_strcmp0 (stru->key, key) == 0) {
        new_list = g_slist_remove (list, stru);
        return TRUE;
      }
      it = it->next;
    }
  }
  return FALSE;
}

gchar *
cdos_kv_ss_find_by_key (GSList *list, gchar *key)
{
  //guint i;
  CdosSString *ss;

  if (list && key) {
    GSList *it = list;
    while(it != NULL){
      ss = it->data;
      if (g_strcmp0 (ss->key, key) == 0) {
        return ss->value;
      }
      it = it->next;
    }
  }
  return NULL;
}

CdosApplet *
cdos_kv_sa_find_by_key (GSList *list, gchar *key)
{
  //guint i;
  CdosSApplet *sa;

  if (list && key) {
    GSList *it = list;
    while(it != NULL){
      sa = it->data;
      if (sa && g_strcmp0 (sa->key, key) == 0) {
        return sa->value;
      }
      it = it->next;
    }
  }

  return NULL;
}

gboolean
cdos_kv_sa_remove_by_key (GSList *list, gchar *key)
{
  //guint i;
  CdosSApplet *sa;
  GSList *new_list = NULL;
  if (list && key) {
    GSList *it = list;
    while(it != NULL){
      sa = it->data;
      if (g_strcmp0 (sa->key, key) == 0) {
        new_list = g_slist_remove (list, sa);
        return TRUE;
      }
	  it = it->next;
    }
  }

  return FALSE;
}

gboolean
cdos_kv_sad_remove_by_key (GSList *list, gchar *key)
{
  if (list && key) {
    //guint i;
    SAppletDefinition *sad;
    GSList *it = list;
    GSList *new_list = NULL;
    while(it != NULL){
      sad = it->data;
      if (sad->key && g_strcmp0 (sad->key, key) == 0) {
        new_list = g_slist_remove (list, sad);
        return TRUE;
      }
	  it = it->next;
    }
  }
  return FALSE;
}

/**
 * Return -1： 表示参数错误，无法进行下一步
 *        0 ： 表示正常返回，删除成功
 *        1 ： 表示key不存在此list
 */
gint
cdos_kv_se_remove_by_key (GSList *list, gchar *key)
{
  //guint i;
  CdosSExtension *se;
  GSList *new_list = NULL;
  if (list && key) {
    GSList *it = list;
    while(it != NULL){
      se = it->data;
      if (g_strcmp0 (se->key, key) == 0) {
        new_list = g_slist_remove (list, se);
        return 0;
      }
	  it = it->next;
    }
    return 1;
  }

  return -1;
}

CdosExtension *
cdos_kv_se_find_by_key (GSList *list, gchar *key)
{
  //guint i;
  CdosSExtension *se;

  if (list && key) {
    GSList *it = list;
    while(it != NULL){
      se = it->data;
      if (g_strcmp0 (se->key, key) == 0) {
        return se->value;
      }
	  it = it->next;
    }
  }
  return NULL;
}
