#ifndef __CDOS_KEY_VALUE_H__
#define __CDOS_KEY_VALUE_H__

#include <glib.h>

#include "cdos-applet.h"
#include "cdos-extension.h"
#include "cdos-applet-manager.h"

typedef struct _SS CdosSString;
typedef struct _SApplet CdosSApplet;
typedef struct _SExtension CdosSExtension;
typedef struct _SAppletDefinition SAppletDefinition;

/* gchar * and gchar* */
struct _SS {
  gchar *key;
  gchar *value;
};

struct _SApplet {
  gchar *key;
  CdosApplet *value;
};

struct _SExtension {
  gchar *key;
  CdosExtension *value;
};

struct _SAppletDefinition {
  gchar *key;
  AppletDefinition *value;
};

/**
 * find a value (gchar *)
 * CdosSString *ss = list->data;
 */
gchar *
cdos_kv_ss_find_by_key (GSList *list, gchar *key);
gboolean
cdos_kv_ss_remove_by_key (GSList *list, gchar *key);

/* CdosSApplet */
CdosApplet *
cdos_kv_sa_find_by_key (GSList *list, gchar *key);
gboolean 
cdos_kv_sa_remove_by_key (GSList *list, gchar *key);

/* SAppletDefinition */
gboolean
cdos_kv_sad_remove_by_key (GSList *list, gchar *key);

gint
cdos_kv_se_remove_by_key (GSList *list, gchar *key);
CdosExtension *
cdos_kv_se_find_by_key (GSList *list, gchar *key);

#endif /* __CDOS_KEY_VALUE_H__ */
