#ifndef __CDOS_KEYBINDING_MANAGER_H__
#define __CDOS_KEYBINDING_MANAGER_H__ 

#include <gio/gio.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <glib-object.h>
#include <meta/display.h>
#include <meta/screen.h>
#include <json-glib/json-glib.h>
//#include <stdlib.h>

#define CDOS_TYPE_KEYBINDING_MANAGER                (cdos_keybinding_manager_get_type ())
#define CDOS_KEYBINDING_MANAGER(obj) \
	(G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_KEYBINDING_MANAGER, CdosKeybindingManager))
#define CDOS_IS_KEYBINDING_MANAGER(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_KEYBINDING_MANAGER))
#define CDOS_KEYBINDING_MANAGER_CLASS(klass) \
	(G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_KEYBINDING_MANAGER, CdosKeybindingManagerClass))
#define CDOS_IS_KEYBINDING_MANAGER_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_KEYBINDING_MANAGER))
#define CDOS_KEYBINDING_MANAGER_GET_CLASS(obj) \
	(G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_KEYBINDING_MANAGER, CdosKeybindingManagerClass))
/*用于访问私有结构*/
#define CDOS_KEYBINDING_MANAGER_GET_PRIVATE(obj) \
  (G_TYPE_INSTANCE_GET_PRIVATE ((obj), CDOS_TYPE_KEYBINDING_MANAGER, CdosKeybindingManagerPrivate))

typedef struct _CdosKeybindingManager CdosKeybindingManager;
typedef struct _CdosKeybindingManagerClass CdosKeybindingManagerClass;
typedef struct _CdosKeybindingManagerPrivate CdosKeybindingManagerPrivate;

/*实例结构*/
struct _CdosKeybindingManager
{
	GObject parent_instance;   //?
	
	MetaDisplay *meta_display;
	
	JsonObject *bindings;
	GSettings *kb_schema;
	GSettings *csd_kb_settings;

	CdosKeybindingManagerPrivate *priv;
};

/*类结构*/
//要填什么？
struct _CdosKeybindingManagerClass
{
	GObjectClass parent_class;  //?
};

GType cdos_keybinding_manager_get_type (void);

gboolean cdos_keybinding_manager_add_hot_key (CdosKeybindingManager *keybinding_manager,
                                                  gchar *name, 
                                                  gchar *binding, 
                                                  MetaKeyHandlerFunc callback,
                                                  gpointer user_data,
                                                  GDestroyNotify free_data);
                                                  
void cdos_keybinding_manager_remove_hot_key (CdosKeybindingManager *keybinding_manager, gchar *name);

void cdos_keybinding_manager_setup_custom_keybindings (CdosKeybindingManager *keybinding_manager);

void cdos_keybinding_manager_remove_custom_keybindings (CdosKeybindingManager *keybinding_manager);

void cdos_keybinding_manager_setup_media_keys (CdosKeybindingManager *keybinding_manager);

CdosKeybindingManager *cdos_keybinding_manager_new (void);
#endif /* __CDOS_KEYBINDING_MANAGER_H__ */
