//
// Created by zhangtao on 16-7-5.
// source:keyboard.js:Keyboard

#ifndef __CDOS_KEYBOARD_H__
#define __CDOS_KEYBOARD_H__
#include "cdos-keyboard-private.h"
//直接取得并替代对象ID标示符;
#define CDOS_TYPE_KEYBOARD (cdos_keyboard_get_type())
//强制类型转换;
#define CDOS_KEYBOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_KEYBOARD,CdosKeyboard))
//检测类型实例
#define CDOS_IS_KEYBOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_KEYBOARD))
//类型转换(可选)
#define CDOS_KEYBOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_KEYBOARD,CdosKeyboardClass))
//检测是否是类的成员(可选)
#define CDOS_IS_KEYBOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_KEYBOARD))
//获取实例对象的类结构(可选)
#define CDOS_KEYBOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_KEYBOARD,CdosKeyboardClass))

//定义对象实例
typedef struct _CdosKeyboardPrivate CdosKeyboardPrivate;
//定义对象的类结构，全部对象实例所共有；
typedef struct _CdosKeyboardClass CdosKeyboardClass;

struct _CdosKeyboard {
    GObject parent;
    CdosKeyboardPrivate *priv;
};
struct _CdosKeyboardClass {
    GObjectClass parent_class;
};

//取得对象类型ID;
GType	cdos_keyboard_get_type(void);
//创建对象实例;
CdosKeyboard*  cdos_keyboard_new(void);

void cdos_keyboard_show(CdosKeyboard *self);

void cdos_keyboard_start(CdosKeyboard *self);

void cdos_keyboard_hide(CdosKeyboard *self);

void cdos_keyboard_set_cursor_location(CdosKeyboard *self,gfloat x,gfloat y,gfloat w,gfloat h);

void cdos_keyboard_set_entry_location(CdosKeyboard *self,gfloat x,gfloat y,gfloat w,gfloat h);

//D-Bus method;
void cdos_keyboard_Show(CdosKeyboard *self,guint32 timestamp);
//D-Bus method;
void cdos_keyboard_Hide(CdosKeyboard *self,guint32 timestamp);


#endif //__CDOS_KEYBOARD_H__
