#ifndef __CDOS_LAYOUT_MANAGER_H__
#define __CDOS_LAYOUT_MANAGER_H__

#include "cdos-global.h"
#include "st.h"
//#include <girepository.h>
#include <meta/display.h>
#include <meta/util.h>
#include <meta/boxes.h>

/* 关于 GType 的这个宏，查看:
 * http://library.gnome.org/devel/gobject/2.46/gobject-Type-Information.html#G-DEFINE-TYPE:CAPS
 */

#define CDOS_TYPE_LAYOUT_MANAGER                (cdos_layout_manager_get_type ())
#define CDOS_LAYOUT_MANAGER(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_LAYOUT_MANAGER, CdosLayoutManager))
#define CDOS_IS_LAYOUT_MANAGER(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_LAYOUT_MANAGER))
#define CDOS_LAYOUT_MANAGER_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_LAYOUT_MANAGER, CdosLayoutManagerClass))
#define CDOS_IS_LAYOUT_MANAGER_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_LAYOUT_MANAGER))
#define CDOS_LAYOUT_MANAGER_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_LAYOUT_MANAGER, CdosLayoutManagerClass))

typedef struct _CdosLayoutManager              CdosLayoutManager;
typedef struct _CdosLayoutManagerPrivate       CdosLayoutManagerPrivate;
typedef struct _CdosLayoutManagerClass         CdosLayoutManagerClass;

struct _CdosLayoutManager
{
  /*< private >*/
  GObject parent_instance;
  //CdosGenericContainer *actor;

  CdosLayoutManagerPrivate *priv;
};

struct _CdosLayoutManagerClass
{
  GObjectClass parent_class;

  /* signals */

};

#define TRACK_FULLSCREEN 1
#define AFFECT_STRUTS 2
#define AFFECT_INPUT_REGION 4

GType cdos_layout_manager_get_type (void);

gint  cdos_layout_manager_get_index ();
MetaRectangle *
cdos_layout_manager_focus_monitor (CdosLayoutManager *self);

const MetaRectangle *
cdos_layout_manager_get_primary_monitor (CdosLayoutManager *self);

const MetaRectangle *
cdos_layout_manager_find_monitor_for_rect (CdosLayoutManager *self,
                                           int x, int y, int width, int height);

const MetaRectangle *
cdos_layout_manager_find_monitor_for_actor (CdosLayoutManager *self, ClutterActor *actor);

StBoxLayout *
cdos_layout_manager_get_panelbox (CdosLayoutManager *self);

StBoxLayout *
cdos_layout_manager_get_keyboardbox (CdosLayoutManager *self);

void
cdos_layout_manager_on_window_restacked (MetaScreen *screen, gpointer data);

gboolean
cdos_layout_manager_update_regions(CdosLayoutManager *self);

void 
cdos_layout_manager_update_boxes (CdosLayoutManager *self);

void
cdos_layout_manager_add_chrome(CdosLayoutManager *self,ClutterActor *actor, gint flags);

void
cdos_layout_manager_remove_chrome(CdosLayoutManager *self,ClutterActor *actor);

GPtrArray *
cdos_layout_manager_get_monitors (CdosLayoutManager *self);

CdosLayoutManager *
cdos_layout_manager_new(void);

CdosLayoutManager *
cdos_layout_manager_get_default (void);

#endif
