/**
 * Class that handle messageTray
 * Inherits: #CdosMessageTray
 */
#ifndef __CDOS_MESSAGE_TRAY_H__
#define __CDOS_MESSAGE_TRAY_H__

#include "cdos-source.h"
#include <glib-object.h>
#include <glib.h>
#include "cdos-session.h"

#define CDOS_TYPE_MESSAGE_TRAY		(cdos_message_tray_get_type ())
#define CDOS_MESSAGE_TRAY(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_MESSAGE_TRAY, CdosMessageTray))
#define CDOS_IS_MESSAGE_TRAY(obj)           	(G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_MESSAGE_TRAY))
#define CDOS_MESSAGE_TRAY_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_MESSAGE_TRAY, CdosMessageTrayClass))
#define CDOS_IS_MESSAGE_TRAY_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_MESSAGE_TRAY))
#define CDOS_MESSAGE_TRAY_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_MESSAGE_TRAY, CdosMessageTrayClass))

typedef struct _CdosMessageTray		CdosMessageTray;
typedef struct _CdosMessageTrayClass	CdosMessageTrayClass;

struct _CdosMessageTray
{
	GObject parent_instance;

	CdosSessionPresence *presence;
	guint userStatus;
	gboolean busy;
	gboolean backFromAway;

	StBin *notificationBin;
	GList *notificationQueue; //包含CdosNotification的list
	CdosNotification *notification;
	gulong notificationClickedId;

	gint pointerBarrier;

	guint trayState;
	gboolean locked;
	gboolean traySummoned;
	gboolean useLongerTrayLeftTimeout;
	gulong trayLeftTimeoutId;
	gboolean pointerInTray;
	gboolean pointerInKeyboard;
	guint notificationState;

	guint notificationTimeoutId;
	gulong notificationExpandedId;
	gboolean notificationRemoved;
	gpointer reNotifyAfterHideNotification;  //类型不确定

	GList *sources;  //包含CdosSource的list

	gboolean notificationsEnabled;

	gint showNotificationMouseX;
	gint showNotificationMouseY;
	gint lastSeenMouseY;

};

struct _CdosMessageTrayClass
{
	GObjectClass parent_class;
};

GType cdos_message_tray_get_type (void);


/* MessageTray 公有函数 */
gboolean cdos_message_tray_contains (CdosMessageTray *self, CdosSource *source);

void cdos_message_tray_add (CdosMessageTray *self, CdosSource *source);

void cdos_message_tray_toggle (CdosMessageTray *self);

void cdos_message_tray_hide (CdosMessageTray *self);

CdosMessageTray *cdos_message_tray_new (void);

void cdos_message_tray_want_send_to_applet (gboolean willSend);

#endif
