/**
 * created by lyl
 * Date: 2016-03-10
 */
#include "cdos-monkey-plugin.h"

typedef struct _MonkeyPluginClass MonkeyPluginClass;

struct _MonkeyPlugin 
{
  GObject parent;

  ClutterActor    *stage;
  ClutterActor    *ui_group;

  CdosPanel *panel;
  CdosPanel *panel2;

  ClutterActor    *background;
  ClutterActor    *window_group;
  ClutterActor    *bottom_window_group;
  ClutterActor    *overlay_group;
  ClutterActor    *top_window_group;

  gfloat          screen_height;
  gfloat          screen_width;

  CdosBaseWM      *cdos_base_wm;
  GSettings       *settings;

  StFocusManager  *focus_manager;

  CdosLayoutManager *layout_manager;

  gchar *desktop_layout;
  gint applet_side;

  CdosIconDispatcher *status_icon_dispatcher;

  CdosMessageTray *message_tray;
  CdosNotificationDaemon* notification_daemon;
  CdosSystrayManager *systray_manager;
  CdosThemeManager *theme_manager;
  CdosSoundManager *sound_manager;

  CdosOverview *overview;
  CdosKeyboard  *keyboard;
};

struct _MonkeyPluginClass 
{
  GObjectClass parent_class;
};

static MonkeyPlugin *monkey_plugin = NULL;

GType monkey_plugin_get_type (void);
G_DEFINE_TYPE (MonkeyPlugin, monkey_plugin, G_TYPE_OBJECT);

static void
monkey_plugin_init (MonkeyPlugin *plugin)
{
  //monkey_plugin = plugin;
}

static void
monkey_plugin_finalize (GObject *object)
{
  monkey_plugin = NULL;
}

static void
monkey_plugin_class_init (MonkeyPluginClass *klass)
{
  GObjectClass *gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize = monkey_plugin_finalize;
}

MonkeyPlugin *monkey_plugin_get (void)
{
  if (monkey_plugin == NULL) {
    monkey_plugin = g_object_new (MONKEY_TYPE_PLUGIN, NULL);
  }
  return monkey_plugin;
}

CdosLayoutManager 
*cdos_monkey_plugin_get_layout_manager (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), NULL);
  return plugin->layout_manager;
}

void cdos_monkey_plugin_set_layout_manager (MonkeyPlugin *plugin, 
				CdosLayoutManager *layout_manager)
{
  g_return_if_fail (IS_MONKEY_PLUGIN (plugin));
  plugin->layout_manager = layout_manager;
}


ClutterActor *
monkey_plugin_get_stage (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), NULL);
  return plugin->stage;
}

void monkey_plugin_set_stage (MonkeyPlugin *plugin, ClutterActor *stage)
{
  plugin->stage = stage;
}

ClutterActor *monkey_plugin_get_ui_group (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), NULL);
  return plugin->ui_group;
}

void monkey_plugin_set_ui_group (MonkeyPlugin *plugin, ClutterActor *ui_group)
{
  plugin->ui_group = ui_group;
}

CdosPanel *
cdos_monkey_plugin_get_panel (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), NULL);
  return plugin->panel;
}

CdosPanel *
cdos_monkey_plugin_get_panel2 (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), NULL);
  return plugin->panel2;
}

void cdos_monkey_plugin_set_panel (MonkeyPlugin *plugin, CdosPanel *panel)
{
  plugin->panel = panel;
}

void cdos_monkey_plugin_set_panel2 (MonkeyPlugin *plugin, CdosPanel *panel)
{
  plugin->panel2 = panel;
}

void monkey_plugin_set_background (MonkeyPlugin *plugin, ClutterActor *background)
{
  plugin->background = background;
}

void monkey_plugin_set_window_group (MonkeyPlugin *plugin, ClutterActor *window_group)
{
  plugin->window_group = window_group;
}

void monkey_plugin_set_bottom_window_group (MonkeyPlugin *plugin, 
				ClutterActor *bottom_window_group)
{
  plugin->bottom_window_group = bottom_window_group;
}

void monkey_plugin_set_top_window_group (MonkeyPlugin *plugin, 
				ClutterActor *top_window_group)
{
  plugin->top_window_group = top_window_group;
}

void monkey_plugin_set_overlay_group (MonkeyPlugin *plugin, 
				ClutterActor *overlay_group)
{
  plugin->overlay_group = overlay_group;
}

gfloat monkey_plugin_get_screen_width (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), 0);
  return plugin->screen_width;
}

void monkey_plugin_set_screen_width (MonkeyPlugin *plugin, gint screen_width)
{
  plugin->screen_width = screen_width;
}

gfloat monkey_plugin_get_screen_height (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), 0);
  return plugin->screen_height;
}

void monkey_plugin_set_screen_height (MonkeyPlugin *plugin, gint screen_height)
{
  plugin->screen_height = screen_height;
}

CdosBaseWM *monkey_plugin_get_cdos_base_wm (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), NULL);
  return plugin->cdos_base_wm;
}

void monkey_plugin_set_cdos_base_wm (MonkeyPlugin *plugin, CdosBaseWM *cdos_base_wm) 
{
  plugin->cdos_base_wm = cdos_base_wm;
}

void monkey_plugin_set_gsettings (MonkeyPlugin *plugin, GSettings *settings)
{
  plugin->settings = settings;
}

void monkey_plugin_set_focus_manager (MonkeyPlugin *plugin, 
				StFocusManager *focus_manager)
{
  plugin->focus_manager = focus_manager;
}

void monkey_plugin_set_desktop_layout (MonkeyPlugin *plugin, gchar *desktop_layout)
{
  plugin->desktop_layout = desktop_layout;
}

void monkey_plugin_set_applet_side (MonkeyPlugin *plugin, gint applet_side)
{
  plugin->applet_side = applet_side;
}

CdosIconDispatcher *
cdos_monkey_plugin_get_status_icon_dispatcher (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), NULL);
  return plugin->status_icon_dispatcher;
}

void 
cdos_monkey_plugin_set_status_icon_dispatcher (MonkeyPlugin *plugin, 
					CdosIconDispatcher *icon_dispatcher)
{
  plugin->status_icon_dispatcher = icon_dispatcher;
}

CdosMessageTray *
cdos_monkey_plugin_get_message_tray (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), NULL);
  return plugin->message_tray;
}

void
cdos_monkey_plugin_set_message_tray (MonkeyPlugin *plugin, CdosMessageTray *message_tray)
{
  g_return_if_fail (IS_MONKEY_PLUGIN (plugin) && CDOS_IS_MESSAGE_TRAY(message_tray));
  plugin->message_tray = message_tray;
}

CdosNotificationDaemon* cdos_monkey_plugin_get_notification_daemon(MonkeyPlugin *plugin) {
    g_return_val_if_fail(IS_MONKEY_PLUGIN(plugin), NULL);
    return plugin->notification_daemon;
}

void cdos_monkey_plugin_set_notification_daemon(MonkeyPlugin *plugin, CdosNotificationDaemon *notification_daemon) {
    g_return_if_fail (IS_MONKEY_PLUGIN (plugin) && CDOS_IS_NOTIFICATION_DAEMON(notification_daemon));
    plugin->notification_daemon = notification_daemon;
}

CdosSystrayManager *
cdos_monkey_plugin_get_systray_manager (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), NULL);
  return plugin->systray_manager;  
}

void
cdos_monkey_plugin_set_systray_manager (MonkeyPlugin *plugin, CdosSystrayManager *systray_manager)
{
  g_return_if_fail (IS_MONKEY_PLUGIN (plugin));
  plugin->systray_manager = systray_manager;
}

CdosThemeManager *
monkey_plugin_get_theme_manager (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), NULL);
  return plugin->theme_manager;
}

void
monkey_plugin_set_theme_manager (MonkeyPlugin *plugin, CdosThemeManager *theme_manager)
{
  g_return_if_fail (CDOS_IS_THEME_MANAGER (theme_manager));
  plugin->theme_manager = theme_manager;
}

CdosSoundManager *
monkey_plugin_get_sound_manager (MonkeyPlugin *plugin)
{
  g_return_val_if_fail (IS_MONKEY_PLUGIN (plugin), NULL);
  return plugin->sound_manager;
}

void
monkey_plugin_set_sound_manager (MonkeyPlugin *plugin, CdosSoundManager *sound_manager)
{
  plugin->sound_manager = sound_manager;
}

CdosKeyboard*
cdos_monkey_plugin_get_keyboard(void){
  MonkeyPlugin *plugin = monkey_plugin_get();
  return plugin->keyboard;
}
gboolean
cdos_monkey_plugin_set_keyboard(CdosKeyboard *keyboard){
  g_return_val_if_fail (CDOS_IS_KEYBOARD (keyboard),FALSE);
  MonkeyPlugin *plugin = monkey_plugin_get();
  if(plugin->keyboard){
    g_warning("The keyboard has existed,you should not change it!\n");
    return FALSE;
  }
  plugin->keyboard = keyboard;
  return TRUE;
}
