/**
 * created by lyl
 * Date: 2016-03-10
 */
#ifndef __UI_MONKEY_PLUGIN_H__
#define __UI_MONKEY_PLUGIN_H__

#include "cdos-overview.h"
#include "cdos-global.h"
#include "cdos-generic-container.h"
#include "cdos-wm.h"
#include "cdos-panel.h"
#include "cdos-icon-dispatcher.h"
#include "cdos-message-tray.h"
#include "cdos-notification-daemon.h"
#include "cdos-systray.h"
#include "cdos-theme-manager.h"
#include "cdos-keyboard.h"
#include "cdos-sound-manager.h"
#include "cdos.h"

G_BEGIN_DECLS


//typedef struct _CdosOverview CdosOverview;


#define MONKEY_TYPE_PLUGIN (monkey_plugin_get_type ())
#define MONKEY_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MONKEY_TYPE_PLUGIN, MonkeyPlugin))
#define IS_MONKEY_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MONKEY_TYPE_PLUGIN))

//extern CdosGlobal *global;
typedef struct _MonkeyPlugin MonkeyPlugin;

MonkeyPlugin *monkey_plugin_get (void);

CdosLayoutManager *cdos_monkey_plugin_get_layout_manager (MonkeyPlugin *plugin);
void cdos_monkey_plugin_set_layout_manager (MonkeyPlugin *plugin, CdosLayoutManager *layout_manager);

ClutterActor *
monkey_plugin_get_stage (MonkeyPlugin *plugin);
void monkey_plugin_set_stage (MonkeyPlugin *plugin, 
				ClutterActor *stage);

ClutterActor *monkey_plugin_get_ui_group (MonkeyPlugin *plugin);
void monkey_plugin_set_ui_group (MonkeyPlugin *plugin, ClutterActor *ui_group);

CdosPanel *
cdos_monkey_plugin_get_panel (MonkeyPlugin *plugin);
CdosPanel *
cdos_monkey_plugin_get_panel2 (MonkeyPlugin *plugin);
void cdos_monkey_plugin_set_panel (MonkeyPlugin *plugin, CdosPanel *panel);
void cdos_monkey_plugin_set_panel2 (MonkeyPlugin *plugin, CdosPanel *panel);

void monkey_plugin_set_background (MonkeyPlugin *plugin, ClutterActor *background);

void monkey_plugin_set_window_group (MonkeyPlugin *plugin, ClutterActor *window_group);

void monkey_plugin_set_bottom_window_group (MonkeyPlugin *plugin,
                                ClutterActor *bottom_window_group);

void monkey_plugin_set_top_window_group (MonkeyPlugin *plugin,
                                ClutterActor *top_window_group);

void monkey_plugin_set_overlay_group (MonkeyPlugin *plugin,
                                ClutterActor *overlay_group);

gfloat monkey_plugin_get_screen_width (MonkeyPlugin *plugin);
void monkey_plugin_set_screen_width (MonkeyPlugin *plugin, gint screen_width);
gfloat monkey_plugin_get_screen_height (MonkeyPlugin *plugin);
void monkey_plugin_set_screen_height (MonkeyPlugin *plugin, gint screen_height);

CdosBaseWM *monkey_plugin_get_cdos_base_wm (MonkeyPlugin *plugin);
void monkey_plugin_set_cdos_base_wm (MonkeyPlugin *plugin, CdosBaseWM *cdos_base_wm);

void monkey_plugin_set_gsettings (MonkeyPlugin *plugin, GSettings *settings);

void monkey_plugin_set_focus_manager (MonkeyPlugin *plugin,
                                StFocusManager *focus_manager);

void monkey_plugin_set_desktop_layout (MonkeyPlugin *plugin, gchar *desktop_layout);

void monkey_plugin_set_applet_side (MonkeyPlugin *plugin, gint applet_side);

CdosIconDispatcher *
cdos_monkey_plugin_get_status_icon_dispatcher (MonkeyPlugin *plugin);
void cdos_monkey_plugin_set_status_icon_dispatcher (MonkeyPlugin *plugin, 
					CdosIconDispatcher *icon_dispatcher);

CdosMessageTray *
cdos_monkey_plugin_get_message_tray (MonkeyPlugin *plugin);
void
cdos_monkey_plugin_set_message_tray (MonkeyPlugin *plugin, CdosMessageTray *message_tray);

CdosNotificationDaemon *
cdos_monkey_plugin_get_notification_daemon (MonkeyPlugin *plugin);
void
cdos_monkey_plugin_set_notification_daemon (MonkeyPlugin *plugin, CdosNotificationDaemon *notification_daemon);

CdosSystrayManager *
cdos_monkey_plugin_get_systray_manager (MonkeyPlugin *plugin);
void
cdos_monkey_plugin_set_systray_manager (MonkeyPlugin *plugin, CdosSystrayManager *systray_manager);

CdosThemeManager *
monkey_plugin_get_theme_manager (MonkeyPlugin *plugin);
void
monkey_plugin_set_theme_manager (MonkeyPlugin *plugin, CdosThemeManager *theme_manager);

CdosSoundManager *
monkey_plugin_get_sound_manager (MonkeyPlugin *plugin);
void
monkey_plugin_set_sound_manager (MonkeyPlugin *plugin, CdosSoundManager *sound_manager);

CdosKeyboard* cdos_monkey_plugin_get_keyboard(void);
gboolean cdos_monkey_plugin_set_keyboard(CdosKeyboard *keyboard);

G_END_DECLS

#endif /* __UI_MONKEY_PLUGIN_H__ */
