#ifndef __CDOS_NOTIFICATION_DAEMON_SOURCE_H__
#define __CDOS_NOTIFICATION_DAEMON_SOURCE_H__

#include <glib.h>
#include <glib-object.h>
#include "cdos-source.h"
#include <clutter/clutter.h>
//#include "cdos-message-tray.h"
//#include "cdos-notification-daemon.h"
#include "cdos-global.h"
#include "../cdos-app.h"
#include "../cdos-tray-icon.h"
#include "../cdos-window-tracker.h"
#include "string.h"
#include "st.h"


#define CDOS_TYPE_NOTIFICATION_DAEMON_SOURCE            (cdos_notification_daemon_source_get_type ())

#define CDOS_NOTIFICATION_DAEMON_SOURCE(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_NOTIFICATION_DAEMON_SOURCE, CdosNotificationDaemonSource))

#define CDOS_IS_NOTIFICATION_DAEMON_SOURCE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_NOTIFICATION_DAEMON_SOURCE))

#define CDOS_NOTIFICATION_DAEMON_SOURCE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_NOTIFICATION_DAEMON_SOURCE, CdosNotificationDaemonSourceClass))

#define CDOS_IS_NOTIFICATION_DAEMON_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_NOTIFICATION_DAEMON_SOURCE))

#define CDOS_NOTIFICATION_DAEMON_SOURCE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_NOTIFICATION_DAEMON_SOURCE, CdosNotificationDaemonSourceClass))

typedef struct _CdosNotificationDaemonSource CdosNotificationDaemonSource;
typedef struct _CdosNotificationDaemonSourceClass CdosNotificationDaemonSourceClass;
typedef struct _CdosNotificationDaemonSourcePrivate CdosNotificationDaemonSourcePrivate;


struct _CdosNotificationDaemonSource
{

    CdosSource parent_instance;

    CdosApp *app;
    gboolean useNotificationIcon;
    gchar *initialTitle;

    /*<private>*/
    CdosNotificationDaemonSourcePrivate *priv;

};

struct _CdosNotificationDaemonSourceClass
{
    CdosSourceClass parent_class;

    /*<private>*/
};

GType cdos_notification_daemon_source_get_type (void);

/*接口*/
gboolean cdos_notification_daemon_source_handle_summary_click(CdosNotificationDaemonSource *self);
void cdos_notification_daemon_source_process_notification(CdosNotificationDaemonSource *self, CdosNotification *notification, CdosTrayIcon *icon);
void cdos_notification_daemon_source_open_app(CdosNotificationDaemonSource *self);
void cdos_notification_daemon_source_open(CdosNotificationDaemonSource *self,  CdosNotification *notification);
void cdos_notification_daemon_source_destory(CdosNotificationDaemonSource *self);

/* property */
void cdos_notification_daemon_source_set_pid (CdosNotificationDaemonSource *self, guint pid);
void cdos_notification_daemon_source_set_title (CdosNotificationDaemonSource *self, gchar *title);
void cdos_notification_daemon_source_set_sender (CdosNotificationDaemonSource *self, gchar *sender);
void cdos_notification_daemon_source_set_trayicon (CdosNotificationDaemonSource *self, CdosTrayIcon *trayIcon);

gchar * cdos_notification_daemon_source_get_title (CdosNotificationDaemonSource *self);
gchar * cdos_notification_daemon_source_get_sender (CdosNotificationDaemonSource *self);
guint cdos_notification_daemon_source_get_pid (CdosNotificationDaemonSource *self);
CdosTrayIcon * cdos_notification_daemon_source_get_trayicon (CdosNotificationDaemonSource *self);

/* new */
CdosNotificationDaemonSource * cdos_notification_daemon_source_new(gchar *title, guint pid, gchar *sender, CdosTrayIcon *trayIcon);

#endif
