/*
 * Created by cdos on 16-3-30.
 */
#ifndef __CDOS_NOTIFICATION_DAEMON_H__
#define __CDOS_NOTIFICATION_DAEMON_H__

#include "cdos-generate-from-notification-daemon-iface-xml.h"
#include "cdos-notification.h"
#include <gio/gio.h> /*BUS define*/

#include "st.h"


#define CDOS_TYPE_NOTIFICATION_DAEMON    (cdos_notification_daemon_get_type ())
#define CDOS_NOTIFICATION_DAEMON(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_NOTIFICATION_DAEMON, CdosNotificationDaemon))
#define CDOS_IS_NOTIFICATION_DAEMON(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_NOTIFICATION_DAEMON))
#define CDOS_NOTIFICATION_DAEMON_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_NOTIFICATION_DAEMON, CdosNotificationDaemonClass))
#define CDOS_IS_NOTIFICATION_DAEMON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_NOTIFICATION_DAEMON))
#define CDOS_NOTIFICATION_DAEMON_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_NOTIFICATION_DAEMON, CdosNotificationDaemonClass))

typedef struct _CdosNotificationDaemon CdosNotificationDaemon;
typedef struct _CdosNotificationDaemonClass CdosNotificationDaemonClass;


/* instance structure */
struct _CdosNotificationDaemon
{
    /*父类*/
    GObject parent_instance;

    /*成员变量*/
    GDBusProxy *bus_proxy;
    GDBusNodeInfo* notification_node_info;
    GList *sources;/*this._sources, 估计data的类型是*/
    GHashTable *senderToPid;
    GList *notifications;/*data为ndataStruct类型的GList*/

    /*私有变量*/
};

/* class structure */
struct _CdosNotificationDaemonClass
{
    /*父类*/
    GObjectClass parent_class;

    /*信号*/

};

GType cdos_notification_daemon_get_type (void);

/*接口*/
gboolean
cdos_notification_daemon_notify(CdosNotificationDaemon *self, gchar *appName, guint replaceId, gchar *icon,
                                gchar *summary, gchar *body, GList *actions, GHashTable *hints,
                                guint timeout, guint* out_id, const gchar *sender);

gboolean cdos_notification_daemon_get_capabilities(CdosNotificationDaemon *self, GVariantBuilder *vBuilder);

gboolean cdos_notification_daemon_get_server_information(CdosNotificationDaemon* self, gchar** out_name, gchar** out_vendor, gchar** out_version, gchar** out_spec_ver);

gboolean cdos_notification_daemon_close_notification(CdosNotificationDaemon *self, guint id);

#endif //__CDOS_NOTIFICATION_DAEMON_H__
