
#ifndef __CDOS_OVERVIEW_WORKSPACE_THUMBNAIL_H__
#define __CDOS_OVERVIEW_WORKSPACE_THUMBNAIL_H__

#include <meta/workspace.h>
#include <meta/window.h>
#include <meta/meta-window-actor.h>
#include <meta/boxes.h>
#include <meta/screen.h>

#include "st.h"
#include "cdos-window-overlay.h"
#include "cdos-background.h"

GType    cdos_overview_workspace_thumbnail_get_type(void);

extern gfloat thumbnail_box_scale;

#define CDOS_TYPE_OVERVIEW_WORKSPACE_THUMBNAIL (cdos_overview_workspace_thumbnail_get_type())
#define CDOS_OVERVIEW_WORKSPACE_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_OVERVIEW_WORKSPACE_THUMBNAIL,CdosOverviewWorkspaceThumbnail))
#define CDOS_IS_OVERVIEW_WORKSPACE_THUMBNAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_OVERVIEW_WORKSPACE_THUMBNAIL))
#define CDOS_OVERVIEW_WORKSPACE_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_OVERVIEW_WORKSPACE_THUMBNAIL,CdosOverviewWorkspaceThumbnailClass))
#define CDOS_IS_OVERVIEW_WORKSPACE_THUMBNAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_OVERVIEW_WORKSPACE_THUMBNAIL))
#define CDOS_OVERVIEW_WORKSPACE_THUMBNAIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_OVERVIEW_WORKSPACE_THUMBNAIL,CdosOverviewWorkspaceThumbnailClass))

typedef struct _CdosOverviewWorkspaceThumbnail     CdosOverviewWorkspaceThumbnail;
typedef struct _CdosOverviewWorkspaceThumbnailClass        CdosOverviewWorkspaceThumbnailClass;

struct _CdosOverviewWorkspaceThumbnail
{
    ClutterActor parent;

    MetaWorkspace *metaWorkspace;
    guint monitor_index;

    guint lastButtonPressTimeStamp;
    ClutterActor *lastButtonPressActor;

    gboolean isSelected;

    CdosBackground *background;    
    ClutterActor *contents;
    StWidget *shader; /* StBin */

    gint count;
    GList *windows;

    GPtrArray *add_window_ids;
    gulong windowAddedId;
    gulong windowRemovedId;
    gulong windowEnteredMonitorId;
    gulong windowLeftMonitorId;
    gulong restackedNotifyId;
    gulong overview_hiding_id;

    gboolean isActive;
    gboolean hovering;

    gint slidePosition;    //unknow

    ClutterActor *lastHoveredClone;
    //在overview-thumbnails-box中使用
    CdosPointerTracker *pointerTracker;
};

struct _CdosOverviewWorkspaceThumbnailClass {
    ClutterActorClass parent_class;
};

CdosOverviewWorkspaceThumbnail*  cdos_overview_workspace_thumbnail_new (MetaWorkspace *metaWorkspace);

void cdos_overview_workspace_thumbnail_activate_workspace (CdosOverviewWorkspaceThumbnail *self);

void cdos_overview_workspace_thumbnail_highlight (CdosOverviewWorkspaceThumbnail *self);

void cdos_overview_workspace_thumbnail_shade (CdosOverviewWorkspaceThumbnail *self, gboolean force);

#endif //__CDOS_OVERVIEW_WORKSPACE_THUMBNAIL_H__

