#ifndef __CDOS_PANEL_H__
#define __CDOS_PANEL_H__

#include "cdos-generic-container.h"

#define DEFAULT_PANEL_HEIGHT 40.0

#define CDOS_TYPE_PANEL                (cdos_panel_get_type ())
#define CDOS_PANEL(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_PANEL, CdosPanel))
#define CDOS_IS_PANEL(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_PANEL))
#define CDOS_PANEL_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_PANEL, CdosPanelClass))
#define CDOS_IS_PANEL_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_PANEL))
#define CDOS_PANEL_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_PANEL, CdosPanelClass))

typedef struct _CdosPanel              CdosPanel;
typedef struct _CdosPanelPrivate       CdosPanelPrivate;
typedef struct _CdosPanelClass         CdosPanelClass;

struct _CdosPanel
{
  CdosGenericContainer parent_instance;

  CdosPanelPrivate *priv;
};

struct _CdosPanelClass
{
  CdosGenericContainerClass parent_class;

  /* signals */
  void (*insert_before)   (CdosPanel *panel);
};

GType cdos_panel_get_type (void);

CdosPanel * cdos_panel_new (gboolean bottom_position, gboolean is_primary);
StBoxLayout * cdos_panel_get_leftbox(CdosPanel *panel);
StBoxLayout * cdos_panel_get_centerbox(CdosPanel *panel);
StBoxLayout * cdos_panel_get_rightbox(CdosPanel *panel);

void cdos_panel_enable(CdosPanel  *self);
void cdos_panel_disable(CdosPanel *self);


gboolean cdos_panel_get_bottom_position (CdosPanel *self);

void cdos_panel_set_bottom_position (CdosPanel    *self,
                    gboolean bottom);
void cdos_panel_set_hideable (CdosPanel    *self,
                    gboolean hideable);
gboolean cdos_panel_on_button_press (ClutterActor *actor,
		 ClutterEvent *event,
		 gpointer data);

void cdos_panel_set_height(CdosPanel *cdos_panel,gfloat height);

gfloat cdos_panel_get_height(CdosPanel *cdos_panel);

#endif /* __CDOS_PANEL_H__ */
