#ifndef __CDOS_POPUP_ALTERNATING_MENU_ITEM_H__
#define __CDOS_POPUP_ALTERNATING_MENU_ITEM_H__

#include "cdos-popup-base-menu-item.h"


#define CDOS_TYPE_POPUP_ALTERNATING_MENU_ITEM    \
    (cdos_popup_alternating_menu_item_get_type())

#define CDOS_POPUP_ALTERNATING_MENU_ITEM(obj)    \
    (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_POPUP_ALTERNATING_MENU_ITEM, CdosPopupAlternatingMenuItem))

#define CDOS_IS_POPUP_ALTERNATING_MENU_ITEM(obj)    \
    (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_POPUP_ALTERNATING_MENU_ITEM))

#define CDOS_POPUP_ALTERNATING_MENU_ITEM_CLASS(klass)    \
    (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_POPUP_ALTERNATING_MENU_ITEM, CdosPopupAlternatingMenuItemClass))

#define CDOS_IS_POPUP_ALTERNATING_MENU_ITEM_CLASS(klass)    \
    (G_TYPE_CHECK_CLASS_TYPE((klass),CDOS_TYPE_POPUP_ALTERNATING_MENU_ITEM ))

#define CDOS_POPUP_ALTERNATING_MENU_ITEM_GET_CLASS(obj)    \
    (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_POPUP_ALTERNATING_MENU_ITEM, CdosPopupAlternatingMenuItemClass))

typedef struct _CdosPopupAlternatingMenuItem        CdosPopupAlternatingMenuItem;
typedef struct _CdosPopupAlternatingMenuItemPrivate CdosPopupAlternatingMenuItemPrivate;
typedef struct  _CdosPopupAlternatingMenuItemClass  CdosPopupAlternatingMenuItemClass;


struct _CdosPopupAlternatingMenuItem
{
	CdosPopupBaseMenuItem  parent_instance;
	CdosPopupAlternatingMenuItemPrivate   *priv;
};

struct  _CdosPopupAlternatingMenuItemClass
{
	CdosPopupBaseMenuItemClass 	parent_class;
};

GType cdos_popup_alternating_menu_item_get_type(void)  G_GNUC_CONST;

void 
cdos_popup_alternating_menu_item_set_text(CdosPopupAlternatingMenuItem  *item,
       	                               	  const gchar *text, 
                                          const gchar *alternateText);

CdosPopupAlternatingMenuItem *
cdos_popup_alternating_menu_item_new(const gchar *text, 
                                     const gchar *alternateText,
                                     PopupBaseMenuItemInit *params);

void 
cdos_popup_alternating_menu_item_update_text(CdosPopupAlternatingMenuItem *item,
                                             gchar *text, 
                                             gchar *alternateText);
     

#endif /*__CDOS_POPUP_ALTERNATING_MENU_ITEM_H__*/
