#ifndef __CDOS_POPUP_SLIDER_MENU_ITEM_H__
#define __CDOS_POPUP_SLIDER_MENU_ITEM_H__

#include <glib-object.h>
#include "cdos-popup-base-menu-item.h"
#include "st.h"

G_BEGIN_DECLS

#define CDOS_TYPE_POPUP_SLIDER_MENU_ITEM    \
        (cdos_popup_slider_menu_item_get_type())

#define CDOS_POPUP_SLIDER_MENU_ITEM(obj)    \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_POPUP_SLIDER_MENU_ITEM, CdosPopupSliderMenuItem))

#define CDOS_IS_POPUP_SLIDER_MENU_ITEM(obj)    \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_POPUP_SLIDER_MENU_ITEM))

#define CDOS_POPUP_SLIDER_MENU_ITEM_CLASS(klass)    \
        (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_POPUP_SLIDER_MENU_ITEM, CdosPopupSliderMenuItemCLASS))

#define CDOS_IS_POPUP_SLIDER_MENU_ITEM_CLASS(klass)    \
        (G_TYPE_CHECK_CLASS_TYPE(klass), CDOS_TYPE_POPUP_SLIDER_MENU_ITEM )

#define CDOS_POPUP_SLIDER_MENU_ITEM_GET_CLASS(obj)    \
        (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_POPUP_SLIDER_MENU_ITEM, CdosPopupSliderMenuItemCLASS))

typedef struct _CdosPopupSliderMenuItem        CdosPopupSliderMenuItem;
typedef struct _CdosPopupSliderMenuItemPrivate CdosPopupSliderMenuItemPrivate;
typedef struct _CdosPopupSliderMenuItemClass   CdosPopupSliderMenuItemClass;


struct _CdosPopupSliderMenuItem
{
    CdosPopupBaseMenuItem parent_instance;
	
    CdosPopupSliderMenuItemPrivate *priv;
};

struct _CdosPopupSliderMenuItemClass
{
    CdosPopupBaseMenuItemClass parent_class;
};
typedef enum {
    CDOS_POPUP_SLIDER_MENU_ITEM_VERTICALITY,
    CDOS_POPUP_SLIDER_MENU_ITEM_HORIZONTAL
} CdosPopupSliderMenuItemOrientation;

GType cdos_popup_slider_menu_item_get_type(void) G_GNUC_CONST;

CdosPopupSliderMenuItem *
cdos_popup_slider_menu_item_new (void);

CdosPopupSliderMenuItem *
cdos_popup_slider_menu_item_new_with_value (gfloat value,gfloat max_value,gfloat min_value,gfloat step);

void 
cdos_popup_slider_menu_item_set_value(CdosPopupSliderMenuItem *item, gfloat value);

gfloat
cdos_popup_slider_menu_item_get_value(CdosPopupSliderMenuItem *item);

void
cdos_popup_slider_menu_item_set_max_value(CdosPopupSliderMenuItem *item, gfloat value);

gfloat
cdos_popup_slider_menu_item_get_max_value(CdosPopupSliderMenuItem *item);

void
cdos_popup_slider_menu_item_set_min_value(CdosPopupSliderMenuItem *item, gfloat value);

gfloat
cdos_popup_slider_menu_item_get_min_value(CdosPopupSliderMenuItem *item);

void
cdos_popup_slider_menu_item_set_step(CdosPopupSliderMenuItem *item, gfloat step);

gfloat
cdos_popup_slider_menu_item_get_step(CdosPopupSliderMenuItem *item);

void
cdos_popup_slider_menu_item_set_orientation(CdosPopupSliderMenuItem *item,CdosPopupSliderMenuItemOrientation orientation);

CdosPopupSliderMenuItemOrientation
cdos_popup_slider_menu_item_get_orientation(CdosPopupSliderMenuItem *item);

G_END_DECLS

#endif /*__CDOS_POPUP_SLIDER_MENU_ITEM_H__*/