
#include "cdos-screen-saver.h"


G_DEFINE_TYPE ( CdosScreenSaver, cdos_screen_saver, G_TYPE_OBJECT );


//ScreenSaverIface
/*
const ScreenSaverIface = {
    name: 'org.cdos.ScreenSaver',
    methods: [{ name: 'GetActive',
                inSignature: '',
                outSignature: 'b' },
              { name: 'Lock',
                inSignature: '' },
              { name: 'SetActive',
                inSignature: 'b' }],
    signals: [{ name: 'ActiveChanged',
                inSignature: 'b' }]
};
*/

static void onActiveChanged ( GObject *gobject, gboolean isActive, gpointer user_data ) {

	CdosScreenSaver *self = CDOS_SCREEN_SAVER (user_data);
	
	self->screenSaverActive = isActive;
}


static void get_active_cb ( GObject *source_object, GAsyncResult *res, gpointer user_data ) {

	CdosScreenSaver *self = CDOS_SCREEN_SAVER (user_data);
	GError *error = NULL;
	GVariant *result = NULL;
	guint isActive;

        result = g_dbus_connection_call_finish ( G_DBUS_CONNECTION (source_object), res, &error );

    if (result == NULL) {
            g_warning ("screensave getActive failed: %s", error->message);
            g_error_free (error);
    }
	else
	{
  		g_variant_get (result, "(b)", &isActive);
		self->screenSaverActive = isActive;
  	}
  	g_variant_unref (result);
}


static void onSSAppeared_cb ( GDBusConnection *connection, const gchar *name, const gchar *name_owner, gpointer user_data ) {

    //CdosScreenSaver *self = CDOS_SCREEN_SAVER (user_data);

//调用dbus的getActive 方法
    g_dbus_connection_call ( connection,
                            "org.cdos.ScreenSaver",
                            "/org/cdos/ScreenSaver",
                            "org.cdos.ScreenSaver",
                            "getActive",
                            NULL, NULL,
                            G_DBUS_CALL_FLAGS_NONE, -1,
                            NULL, get_active_cb, NULL);
}


static void onSSVanished_cb ( GDBusConnection *connection, const gchar *name, gpointer user_data) {

        CdosScreenSaver *self = CDOS_SCREEN_SAVER (user_data);

        self->screenSaverActive = FALSE;

}


static void cdos_screen_saver_finalize ( GObject *gobject ) {



	/* 调用父类的 finalize() 方法 */
    G_OBJECT_CLASS (cdos_screen_saver_parent_class)->finalize(gobject);

}

static void cdos_screen_saver_dispose ( GObject *gobject ) {

    CdosScreenSaver *self = CDOS_SCREEN_SAVER (gobject);

    g_clear_object(&self->proxy);

    G_OBJECT_CLASS (cdos_screen_saver_parent_class)->dispose(gobject);
}

static void 
cdos_screen_saver_class_init ( CdosScreenSaverClass *klass ) {

    GObjectClass *gobject_class = G_OBJECT_CLASS(klass);

	gobject_class->finalize = cdos_screen_saver_finalize;
	gobject_class->dispose = cdos_screen_saver_dispose;

}


static void
cdos_screen_saver_init ( CdosScreenSaver *self ) {

    GError *error = NULL;
    self->screenSaverActive = FALSE;
    self->proxy = NULL;
    self->watchID = 0;

    self->proxy = g_dbus_proxy_new_for_bus_sync ( G_BUS_TYPE_SESSION,
                                                    0,
                                                    NULL,
                                                    "org.cdos.ScreenSaver",
                                                    "/org/cdos/ScreenSaver",
                                                    "org.cdos.ScreenSaver",
                                                    NULL, &error);

    if (self->proxy == NULL) {
            g_warning ("Couldn't org.cdos.ScreenSaver proxy: %s", error->message);
            g_error_free (error);
            return;
    }

    self->watchID = g_bus_watch_name ( G_BUS_TYPE_SYSTEM,
                                            "org.cdos.ScreenSaver",
                                            G_BUS_NAME_WATCHER_FLAGS_NONE,
                                            onSSAppeared_cb,
                                            onSSVanished_cb,
                                            self,
                                            NULL);

	g_signal_connect ( self, "ActiveChanged", G_CALLBACK ( onActiveChanged ), self );
}

/*公有函数定义*/
CdosScreenSaver *cdos_screen_saver_proxy_new (void) {
    CdosScreenSaver *instance = g_object_new ( CDOS_TYPE_SCREEN_SAVER, NULL );
    return instance;
}






