#ifndef __CDOS_SESSION_INHIBITOR_H__
#define __CDOS_SESSION_INHIBITOR_H__

#include <glib-object.h>
//#include "st.h"
#include <gio/gio.h>


/* Presence */

GType cdos_session_presence_get_type (void);

#define CDOS_TYPE_SESSION_PRESENCE		(cdos_session_presence_get_type ())
#define CDOS_SESSION_PRESENCE(obj)              (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_SESSION_PRESENCE, CdosSessionPresence))
#define CDOS_IS_SESSION_PRESENCE(obj)           (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_SESSION_PRESENCE))
#define CDOS_SESSION_PRESENCE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_SESSION_PRESENCE, CdosSessionPresenceClass))
#define CDOS_IS_SESSION_PRESENCE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_SESSION_PRESENCE))
#define CDOS_SESSION_PRESENCE_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_SESSION_PRESENCE, CdosSessionPresenceClass))

typedef struct _CdosSessionPresence		CdosSessionPresence;
typedef struct _CdosSessionPresenceClass      	CdosSessionPresenceClass;

struct _CdosSessionPresenceClass
{
	GObjectClass parent_class;

	
};


enum {

	AVAILABLE,
    	INVISIBLE,
    	BUSY,
    	IDLE

} PresenceStatus;



/* Inhibitor */

GType cdos_session_inhibitor_get_type (void);

#define CDOS_TYPE_SESSION_INHIBITOR             (cdos_session_inhibitor_get_type ())
#define CDOS_SESSION_INHIBITOR(obj)              (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_SESSION_INHIBITOR, CdosSessionInhibitor))
#define CDOS_IS_SESSION_INHIBITOR(obj)           (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_SESSION_INHIBITOR))
#define CDOS_SESSION_INHIBITOR_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_SESSION_INHIBITOR, CdosSessionInhibitorClass))
#define CDOS_IS_SESSION_INHIBITOR_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_SESSION_INHIBITOR))
#define CDOS_SESSION_INHIBITOR_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_SESSION_INHIBITOR, CdosSessionInhibitorClass))

typedef struct _CdosSessionInhibitor            CdosSessionInhibitor;
typedef struct _CdosSessionInhibitorClass       CdosSessionInhibitorClass;

struct _CdosSessionInhibitorClass
{
        GObjectClass parent_class;


};



/* 公有函数 */
//presence


CdosSessionPresence *cdos_session_presence_new (void);

guint cdos_session_presence_get_status ( CdosSessionPresence *presence, GFunc callback );

gboolean cdos_session_presence_set_status ( CdosSessionPresence *presence, guint status );


//inhibitor

CdosSessionInhibitor *cdos_session_inhibitor_new (gchar *objectPath);
//session

GDBusProxy *cdos_session_manager_new (void);

void cdos_session_logout (GDBusProxy *proxy, guint mode);

void cdos_session_shutdown (GDBusProxy *proxy);

gboolean cdos_session_can_shutdown (GDBusProxy *proxy);



#endif
