#ifndef __CDOS_SETTING_OBJ_H__
#define __CDOS_SETTING_OBJ_H__

#include "st.h"
#include "cdos-provider.h"
#include <glib.h>

G_BEGIN_DECLS

#define CDOS_TYPE_SETTING_OBJ  (cdos_setting_obj_get_type())

#define CDOS_SETTING_OBJ(obj)  \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_SETTING_OBJ, CdosSettingObj))

#define CDOS_IS_SETTING_OBJ(obj) \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_SETTING_OBJ))

#define CDOS_SETTING_OBJ_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_SETTING_OBJ, CdosSettingObjClass))

#define CDOS_IS_SETTING_OBJ_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_TYPE((klass), CDOS_TYPE_SETTING_OBJ ))

#define CDOS_SETTING_OBJ_GET_CLASS(obj) \
        (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_SETTING_OBJ, CdosSettingObjClass ))

typedef struct _CdosSettingObj CdosSettingObj;
typedef struct _CdosSettingObjPrivate CdosSettingObjPrivate;
typedef struct _CdosSettingObjClass CdosSettingObjClass;


struct _CdosSettingObj
{
    GObject parent_instance;
        
    CdosSettingObjPrivate *priv;
};

struct _CdosSettingObjClass
{
    GObjectClass parent_class;
};

GType cdos_setting_obj_get_type(void) G_GNUC_CONST;

CdosSettingObj *
cdos_setting_obj_new(CdosProvider *provider,
                                GFile  *file,
                                const gchar *uuid,
                                const gchar *instanceId);

void
cdos_setting_obj_save(CdosSettingObj *obj);

gchar *
cdos_setting_obj_get_data(CdosSettingObj *obj, 
                                                const gchar *group, 
                                                const gchar *key);

gchar *
cdos_setting_obj_get_key_exists_and_type(CdosSettingObj *obj, const gchar *group);

void 
cdos_setting_obj_set_value(CdosSettingObj *obj,
                                                const gchar *group, 
                                                const gchar *value);

void
cdos_setting_obj_set_node_from_dbus(CdosSettingObj *obj, 
                                                                const gchar *group_key,
                                                                const gchar *group_node);



GKeyFile *
cdos_setting_obj_get_key(CdosSettingObj *obj);

G_END_DECLS

#endif /*__CDOS_SETTING_OBJ_H__*/
