#ifndef __CDOS_SETTING_H__
#define __CDOS_SETTING_H__

#include "st.h"
#include "cdos-setting-obj.h"
#include  "cdos-provider.h"


G_BEGIN_DECLS

#define CDOS_TYPE_SETTING  (cdos_setting_get_type())

#define CDOS_SETTING(obj)  \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_SETTING, CdosSetting))

#define CDOS_IS_SETTING(obj) \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_SETTING))

#define CDOS_SETTING_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_SETTING, CdosSettingClass))

#define CDOS_IS_SETTING_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_TYPE((klass), CDOS_TYPE_SETTING ))

#define CDOS_SETTING_GET_CLASS(obj) \
        (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_SETTING, CdosSettingClass ))

typedef struct _CdosSetting CdosSetting;
typedef struct _CdosSettingPrivate CdosSettingPrivate;
typedef struct _CdosSettingClass CdosSettingClass;


struct _CdosSetting
{
    GObject parent_instance;
        
    CdosSettingPrivate *priv;
};

struct _CdosSettingClass
{
    GObjectClass parent_class;
};


GType cdos_setting_get_type(void) G_GNUC_CONST;

CdosSetting *
cdos_setting_new_with_params(BINDINGDIRECTION sync_type,
                                GHashTable  *obj,
                                const gchar *key_name,
                                CdosSettingObj *setting_obj,
                                gchar *applet_var,
                                func     applet_callback,
                                gpointer  user_data);

CdosSetting *
cdos_setting_set_params( CdosSetting *setting,    
                            BINDINGDIRECTION sync_type,
                            GHashTable  *obj,
                            const gchar *key_name,
                            CdosSettingObj *setting_obj,
                            gchar *applet_var,
                            func     applet_callback,
                            gpointer  user_data);
gchar *
cdos_setting_get_data(CdosSetting *setting,
                                        const gchar *value);
gchar *
cdos_setting_get_value(CdosSetting *setting);

void
cdos_setting_set_val(CdosSetting *setting, const gchar *value);

void
cdos_setting_set_applet_var_and_cb(CdosSetting *setting, gchar *new_val);

gchar *
cdos_setting_get_applet_var(CdosSetting *setting);


G_END_DECLS

#endif /*__CDOS_SETTING_H__*/
