#ifndef __CDOS_SETTINGS_MANAGER_H__
#define __CDOS_SETTINGS_MANAGER_H__

#include "st.h"

G_BEGIN_DECLS

#define CDOS_TYPE_SETTINGS_MANAGER  (cdos_settings_manager_get_type())

#define CDOS_SETTINGS_MANAGER(obj)  \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), CDOS_TYPE_SETTINGS_MANAGER, CdosSettingsManager))

#define CDOS_IS_SETTINGS_MANAGER(obj) \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), CDOS_TYPE_SETTINGS_MANAGER))

#define CDOS_SETTINGS_MANAGER_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_CAST((klass), CDOS_TYPE_SETTINGS_MANAGER, CdosSettingsManagerClass))

#define CDOS_IS_SETTINGS_MANAGER_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_TYPE((klass), CDOS_TYPE_SETTINGS_MANAGER ))

#define CDOS_SETTINGS_MANAGER_GET_CLASS(obj) \
        (G_TYPE_INSTANCE_GET_CLASS((obj), CDOS_TYPE_SETTINGS_MANAGER, CdosSettingsManagerClass ))

typedef struct _CdosSettingsManager CdosSettingsManager;
typedef struct _CdosSettingsManagerPrivate CdosSettingsManagerPrivate;
typedef struct _CdosSettingsManagerClass CdosSettingsManagerClass;


struct _CdosSettingsManager
{
    GObject parent_instance;
        
    CdosSettingsManagerPrivate *priv;
};

struct _CdosSettingsManagerClass
{
    GObjectClass parent_class;
};

typedef struct
{
    gchar *uuid;
    gchar *instance_id;
    GObject *obj;
} Uuids;

GType cdos_settings_manager_get_type(void) G_GNUC_CONST;

// create a new instance of settingsManager

CdosSettingsManager *cdos_settings_manager_get_default(void);

void cdos_settings_manager_set_default(CdosSettingsManager *manager);

CdosSettingsManager *cdos_settings_manager_new (gboolean is_default);

void cdos_settings_manager_register(CdosSettingsManager *manager, const gchar *uuid, const gchar *instance_id, GObject *obj);

void cdos_settings_manager_unregister(CdosSettingsManager *manager, const gchar *uuid, const gchar *instance_id);

G_END_DECLS

#endif /*__CDOS_SETTINGS_MANAGER_H__*/
