#ifndef __CDOS_SUMMARY_ITEM_H__
#define __CDOS_SUMMARY_ITEM_H__

#include <glib-object.h>
#include "cdos-source.h"


GType cdos_summary_item_get_type (void);

#define CDOS_TYPE_SUMMARY_ITEM		( cdos_summary_item_get_type () )
#define CDOS_SUMMARY_ITEM(obj)              (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_SUMMARY_ITEM, CdosSummaryItem))
#define CDOS_IS_SUMMARY_ITEM(obj)           (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_SUMMARY_ITEM))
#define CDOS_SUMMARY_ITEM_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_SUMMARY_ITEM, CdosSummaryItemClass))
#define CDOS_IS_SUMMARY_ITEM_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_SUMMARY_ITEM))
#define CDOS_SUMMARY_ITEM_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_SUMMARY_ITEM, CdosSummaryItemClass))

typedef struct _CdosSummaryItem		CdosSummaryItem;
typedef struct _CdosSummaryItemClass    CdosSummaryItemClass;

struct _CdosSummaryItem
{
	GObject parent_instance;

	CdosSource *source;
	StButton *actor;
	StBoxLayout *sourceBox;
	StBin *sourceIcon;
	StBin *sourceTitleBin;
	StLabel *sourceTitle;
	StScrollView *notificationStackView;
	StBoxLayout *notificationStack;
	GList *stackedNotifications;
	gdouble oldMaxScrollAdjustment;

	StBoxLayout *rightClickMenu;

};


struct _CdosSummaryItemClass
{
	GObjectClass parent_class;


};


/* 定义外部引用空函数*/




/* 公有函数 */


void cdos_summary_item_scroll_to ( CdosSummaryItem *self, guint side );

CdosSummaryItem *cdos_summary_item_new ( CdosSource *source );


#endif
