#ifndef __UI_BUTTON_H__
#define __UI_BUTTON_H__

#include <clutter/clutter.h>

GType ui_button_get_type (void);

#define UI_TYPE_BUTTON            (ui_button_get_type ())

#define UI_BUTTON(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), UI_TYPE_BUTTON, UiButton))

#define UI_IS_BUTTON(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UI_TYPE_BUTTON))

#define UI_BUTTON_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), UI_TYPE_BUTTON, UiButtonClass))

#define UI_IS_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UI_TYPE_BUTTON))

#define UI_BUTTON_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), UI_TYPE_BUTTON, UiButtonClass))

typedef struct _UiButtonPrivate UiButtonPrivate;
typedef struct _UiButton        UiButton;
typedef struct _UiButtonClass   UiButtonClass;

struct _UiButton
{
  ClutterActor parent_instance;

  UiButtonPrivate *priv;
};

struct _UiButtonClass
{
  void (* clicked)(UiButton *button);
  void (* drag)(UiButton *button);

  ClutterActorClass parent_class;
};

ClutterActor *ui_button_new (void);

const gchar *ui_button_get_text (UiButton *self);

void ui_button_set_text (UiButton    *self,
                         const gchar *text);

void ui_button_set_background_color (UiButton           *self,
                                     const ClutterColor *color);

void ui_button_set_text_color (UiButton           *self,
                               const ClutterColor *color);

#endif /* __UI_BUTTON_H__ */
