#ifndef __CDOS_URL_HIGHLIGHTER_H__
#define __CDOS_URL_HIGHLIGHTER_H__

/**
 * 用于对通知的URL进行高亮显示
 * Inherits: #GObject
 */


#include <stdio.h>
#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include "st.h"
#include "cdos-util.h"

#define CDOS_TYPE_URL_HIGHLIGHTER (cdos_url_highlighter_get_type())
#define CDOS_URL_HIGHLIGHTER(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_URL_HIGHLIGHTER,CdosUrlHighlighter))
#define CDOS_IS_URL_HIGHLIGHTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_URL_HIGHLIGHTER))
#define CDOS_URL_HIGHLIGHTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_URL_HIGHLIGHTER,CdosUrlHighlighterClass))
#define CDOS_IS_URL_HIGHLIGHTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_URL_HIGHLIGHTER))
#define CDOS_URL_HIGHLIGHTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_URL_HIGHLIGHTER,CdosUrlHighlighterClass))

typedef struct _CdosUrlHighlighter CdosUrlHighlighter;
typedef struct _CdosUrlHighlighterClass CdosUrlHighlighterClass;

struct _CdosUrlHighlighter
{

    GObject parent_instance;

    StLabel *actor;
    gchar *text;
    gchar *linkColor;
    gchar *url;	//不确定
    GList *urls;
    gboolean cursorChanged;

};

struct _CdosUrlHighlighterClass
{
    GObjectClass parent_class;

};

GType cdos_url_highlighter_get_type (void);

void cdos_url_highlighter_set_markup (CdosUrlHighlighter *self, gchar *text, gboolean allowMarkup);
gchar *cdos_url_highlighter_fix_markup (gchar *text, gboolean allowMarkup);
CdosUrlHighlighter *cdos_url_highlighter_new (const gchar *text, gboolean lineWrap, gboolean allowMarkup);
#endif
