#include <glib.h>
/**
 * cdos_utils_to_lower_case:
 * @str: 字符串
 *
 * 将当前字符串全部转换为小写。
 */
void cdos_utils_to_lower_case (gchar *str)
{
  while (*str) {
    if (*str >= 'A' && *str <= 'Z') {
      *str = 'a' + (*str - 'A');
    }
    ++str;
  }
}

/**
 * cdos_strv_elem_del_by_nth:
 * @strv:字符串数组
 * @n:索引值
 *
 * 从字符串数组中，移除指定索引值的成员。
 *
 * Returns:返回一个新的字符串数组
 */
gchar **
cdos_strv_elem_del_by_nth (gchar **strv, gint n)
{
  int i;
  GPtrArray *p_a = g_ptr_array_new ();

  // for (i = 0; i < g_strv_length (strv); i ++) {
  for (i = 0; strv[i] != NULL; i ++) {
    if (i == n) 
      continue;
    g_ptr_array_add (p_a, strv[i]);
  }
  g_ptr_array_add (p_a, NULL);


  return (gchar **) g_ptr_array_free (p_a, FALSE);
}

/**
 * cdos_strv_elem_del_by_str:
 * @strv:字符串数组
 * @str:待匹配的字符串
 *
 * 从字符串数组中，移除与指定字符串匹配的成员。
 *
 * Returns:返回一个新的字符串数组
 */
gchar **
cdos_strv_elem_del_by_str (gchar **strv, gchar *str)
{
  gint i;
  GPtrArray *p_a = g_ptr_array_new ();
  gint len = g_strv_length(strv);
  for (i = 0; i < len; i ++) {
    if (g_strcmp0 (strv[i], str) == 0) {
      continue;
    }
    g_ptr_array_add (p_a, strv[i]);
  }
  g_ptr_array_add (p_a, NULL);


  return (gchar **) g_ptr_array_free (p_a, FALSE);
}

/**
 * cdos_strv_elem_add:
 * @strv:字符串数组
 * @str:待添加的字符串
 *
 * 从字符串数组中，添加新的字符串成员。
 *
 * Returns:返回一个新的字符串数组
 */
gchar **
cdos_strv_elem_add (gchar **strv, gchar *str)
{
  g_print ("%s\n", __func__);
  gint i;
  GPtrArray *p_a = g_ptr_array_new ();
  gint len = g_strv_length(strv);
  for (i = 0; i < len; i ++) {
    g_ptr_array_add (p_a, strv[i]);
  }
  g_ptr_array_add (p_a, str);
  g_ptr_array_add (p_a, NULL);


  return (gchar **) g_ptr_array_free (p_a, FALSE);
}
