//
// Created by zhangtao on 16-3-15.
// source:workspace.js;

#ifndef __CDOS_WINDOW_CLONE_H__
#define __CDOS_WINDOW_CLONE_H__

#include <clutter/clutter.h>
#include <meta/window.h>
#include <meta/meta-window-actor.h>
#include "st.h"

#include "cdos-window-overlay.h"
#include "cdos-workspace.h"

GType	cdos_window_clone_get_type (void);

#define CDOS_TYPE_WINDOW_CLONE (cdos_window_clone_get_type())
#define CDOS_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_WINDOW_CLONE,CdosWindowClone))
#define CDOS_IS_WINDOW_CLONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_WINDOW_CLONE))
#define CDOS_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_WINDOW_CLONE,CdosWindowCloneClass))
#define CDOS_IS_WINDOW_CLONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_WINDOW_CLONE))
#define CDOS_WINDOW_CLONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_WINDOW_CLONE,CdosWindowCloneClass))

typedef struct _CdosWindowCloneClass CdosWindowCloneClass;
typedef struct _CdosWindowClone CdosWindowClone;

typedef struct _CdosScaledPoint CdosScaledPoint;

struct _CdosWindowCloneClass {
	ClutterActorClass parent_class;
};

struct _CdosWindowClone {    
    /*public*/
    ClutterActor parent;
    CdosWorkspaceMonitor *myContainer;
    MetaWindowActor *realWindow;
    MetaWindow *metaWindow;
    CdosWindowOverlay *overlay;
    gfloat origX;
    gfloat origY;

	ClutterActor *clone;
	ClutterActor *stackAbove;
	ClutterActor *origParent;

	guint disconnectWindowSignals;

    gboolean selected;

	gpointer metaWindow_delegate;

	guint sizeChangedId;
    guint workspaceChangedId;
    guint realWindowDestroyId;

};

CdosWindowClone *cdos_window_clone_new ( MetaWindowActor *real_window, CdosWorkspaceMonitor *my_container );

void cdos_window_clone_set_stack_above ( CdosWindowClone *self, ClutterActor *actor );

#endif //__CDOS_WINDOW_CLONE_H__
