
#ifndef __CDOS_WINDOW_CONTEXT_MENU_H__
#define __CDOS_WINDOW_CONTEXT_MENU_H__

#include <glib-object.h>
#include <clutter/clutter.h>
#include <meta/window.h>

#include "st.h"

#include "cdos-popup-menu-item.h"
#include "cdos-popup-combo-menu.h"


GType	cdos_window_context_menu_get_type (void);


#define CDOS_TYPE_WINDOW_CONTEXT_MENU (cdos_window_context_menu_get_type())
#define CDOS_WINDOW_CONTEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj),CDOS_TYPE_WINDOW_CONTEXT_MENU,CdosWindowContextMenu))
#define CDOS_IS_WINDOW_CONTEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj),CDOS_TYPE_WINDOW_CONTEXT_MENU))
#define CDOS_WINDOW_CONTEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass),CDOS_TYPE_WINDOW_CONTEXT_MENU,CdosWindowContextMenuClass))
#define CDOS_IS_WINDOW_CONTEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((obj),CDOS_TYPE_WINDOW_CONTEXT_MENU))
#define CDOS_WINDOW_CONTEXT_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj),CDOS_TYPE_WINDOW_CONTEXT_MENU,CdosWindowContextMenuClass))


typedef struct _CdosWindowContextMenuClass CdosWindowContextMenuClass;
typedef struct _CdosWindowContextMenu CdosWindowContextMenu;


struct _CdosWindowContextMenuClass {

	//继承自CdosPopupComboMenu
	CdosPopupComboMenuClass parent_class;


};

struct _CdosWindowContextMenu {

	CdosPopupComboMenu parent_instance;

	gchar *name;
	ClutterActor *actor;
	void (*onClose)();
	MetaWindow *metaWindow;
	CdosPopupMenuItem *itemCloseWindow;
	CdosPopupMenuItem *itemMinimizeWindow;
	CdosPopupMenuItem *itemMaximizeWindow;
	CdosPopupMenuItem *itemMoveToLeftWorkspace;
	CdosPopupMenuItem *itemMoveToRightWorkspace;
	CdosPopupMenuItem *itemOnAllWorkspaces;

	GList *monitorItems;
	gint index;
};



/*  公有函数 */

CdosWindowContextMenu *cdos_window_context_menu_new ( ClutterActor *actor, MetaWindow *metaWindow, void (*onClose) );




#endif //__CDOS_WINDOW_CONTEXT_MENU_H__
