#ifndef __CDOS_WORKSPACE_H__
#define __CDOS_WORKSPACE_H__

#include "cdos-global.h"
#include "st.h"
#include "cdos.h"
#include "cdos-workspaces-view.h"

#define CDOS_TYPE_WORKSPACE                (cdos_workspace_get_type ())
#define CDOS_WORKSPACE(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), CDOS_TYPE_WORKSPACE, CdosWorkspace))
#define CDOS_IS_WORKSPACE(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CDOS_TYPE_WORKSPACE))
#define CDOS_WORKSPACE_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST ((klass), CDOS_TYPE_WORKSPACE, CdosWorkspaceClass))
#define CDOS_IS_WORKSPACE_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), CDOS_TYPE_WORKSPACE))
#define CDOS_WORKSPACE_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), CDOS_TYPE_WORKSPACE, CdosWorkspaceClass))

typedef struct _CdosWorkspace              CdosWorkspace;
typedef struct _CdosWorkspaceMonitor       CdosWorkspaceMonitor;
typedef struct _CdosWorkspacePrivate       CdosWorkspacePrivate;
typedef struct _CdosWorkspaceClass         CdosWorkspaceClass;

struct _CdosWorkspace
{
  ClutterActor parent;
  MetaWorkspace *metaWorkspace;

  CdosWorkspacePrivate *priv;
};

struct _CdosWorkspaceClass
{
  ClutterActorClass  parent_class;
  /* signals */
};

struct _CdosWorkspaceMonitor
{
    CdosWorkspace *myWorkspace;
    MetaWorkspace *metaWorkspace;
    guint x;
    guint y;
    guint width;
    guint height;
    guint margin;
    guint slotWidth;

    guint monitorIndex;
    MetaRectangle *monitor;
    //clutter_group_new ()
    ClutterActor *windowOverlaysGroup;
    ClutterActor *actor;
    ClutterActor *dropRect;

    GList *windows; //成员类型为 CdosWindowClone

    GPtrArray *add_window_ids;
    gulong windowAddedId;
    gulong windowRemovedId;
    gulong windowEnteredMonitorId;
    gulong windowLeftMonitorId;
    gulong stickyCallbackId;
    gulong overviewHiddenId; // zoomFromOverview 中
    gulong initial_position_idle_id;
    gboolean leavingOverview;

    guint kbWindowIndex;
    gboolean onInitialPositionWindows;
    gboolean stackedOnce;

    MetaWindow *mwindow; // 增加的，idle_add 的参数
};

typedef enum {
    WINDOW_POSITION_INITIAL,
    WINDOW_POSITION_ANIMATE,
} WindowPositionFlags;

GType cdos_workspace_get_type (void);
void
cdos_workspace_show_windows_overlays (CdosWorkspace *self);

void
cdos_workspace_hide_windows_overlays (CdosWorkspace *self);

gboolean
cdos_workspace_is_empty (CdosWorkspace *self);

void cdos_workspace_zoom_to_overview (CdosWorkspace *self);
void cdos_workspace_zoom_from_overview (CdosWorkspace *self);
gboolean cdos_workspace_on_key_press (CdosWorkspace *self, ClutterActor *actor, ClutterEvent *event);

void cdos_workspace_destroy (CdosWorkspace *self);

guint grid_navigator_next_index (guint itemCount, guint numCols, guint currentIndex, guint symbol);

gboolean cdos_workspace_monitor_activate_selected_window (CdosWorkspaceMonitor *cwm);

void cdos_workspace_position_windows (CdosWorkspace *self , guint flag);

CdosWorkspace *
cdos_workspace_new (MetaWorkspace *metaWorkspace, CdosWorkspacesView *view);
#endif /* __CDOS_WORKSPACE_H__ */
